/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

































#include "../P2VectorElementwiseEpsilonP0Viscosity.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilonP0Viscosity::toMatrix_P2VectorElementwiseEpsilonP0Viscosity_macro_3D( idx_t * RESTRICT  _data_dst_edge_0, idx_t * RESTRICT  _data_dst_edge_1, idx_t * RESTRICT  _data_dst_edge_2, idx_t * RESTRICT  _data_dst_vertex_0, idx_t * RESTRICT  _data_dst_vertex_1, idx_t * RESTRICT  _data_dst_vertex_2, real_t * RESTRICT  _data_mu, idx_t * RESTRICT  _data_src_edge_0, idx_t * RESTRICT  _data_src_edge_1, idx_t * RESTRICT  _data_src_edge_2, idx_t * RESTRICT  _data_src_vertex_0, idx_t * RESTRICT  _data_src_vertex_1, idx_t * RESTRICT  _data_src_vertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.041666666666666657, 0.041666666666666657, 0.041666666666666657, 0.041666666666666657};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_WHITE_UP[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_0_12 = q_acc_0_12;
             const real_t elMat_0_13 = q_acc_0_13;
             const real_t elMat_0_14 = q_acc_0_14;
             const real_t elMat_0_15 = q_acc_0_15;
             const real_t elMat_0_16 = q_acc_0_16;
             const real_t elMat_0_17 = q_acc_0_17;
             const real_t elMat_0_18 = q_acc_0_18;
             const real_t elMat_0_19 = q_acc_0_19;
             const real_t elMat_0_20 = q_acc_0_20;
             const real_t elMat_0_21 = q_acc_0_21;
             const real_t elMat_0_22 = q_acc_0_22;
             const real_t elMat_0_23 = q_acc_0_23;
             const real_t elMat_0_24 = q_acc_0_24;
             const real_t elMat_0_25 = q_acc_0_25;
             const real_t elMat_0_26 = q_acc_0_26;
             const real_t elMat_0_27 = q_acc_0_27;
             const real_t elMat_0_28 = q_acc_0_28;
             const real_t elMat_0_29 = q_acc_0_29;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_1_12 = q_acc_1_12;
             const real_t elMat_1_13 = q_acc_1_13;
             const real_t elMat_1_14 = q_acc_1_14;
             const real_t elMat_1_15 = q_acc_1_15;
             const real_t elMat_1_16 = q_acc_1_16;
             const real_t elMat_1_17 = q_acc_1_17;
             const real_t elMat_1_18 = q_acc_1_18;
             const real_t elMat_1_19 = q_acc_1_19;
             const real_t elMat_1_20 = q_acc_1_20;
             const real_t elMat_1_21 = q_acc_1_21;
             const real_t elMat_1_22 = q_acc_1_22;
             const real_t elMat_1_23 = q_acc_1_23;
             const real_t elMat_1_24 = q_acc_1_24;
             const real_t elMat_1_25 = q_acc_1_25;
             const real_t elMat_1_26 = q_acc_1_26;
             const real_t elMat_1_27 = q_acc_1_27;
             const real_t elMat_1_28 = q_acc_1_28;
             const real_t elMat_1_29 = q_acc_1_29;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_2_12 = q_acc_2_12;
             const real_t elMat_2_13 = q_acc_2_13;
             const real_t elMat_2_14 = q_acc_2_14;
             const real_t elMat_2_15 = q_acc_2_15;
             const real_t elMat_2_16 = q_acc_2_16;
             const real_t elMat_2_17 = q_acc_2_17;
             const real_t elMat_2_18 = q_acc_2_18;
             const real_t elMat_2_19 = q_acc_2_19;
             const real_t elMat_2_20 = q_acc_2_20;
             const real_t elMat_2_21 = q_acc_2_21;
             const real_t elMat_2_22 = q_acc_2_22;
             const real_t elMat_2_23 = q_acc_2_23;
             const real_t elMat_2_24 = q_acc_2_24;
             const real_t elMat_2_25 = q_acc_2_25;
             const real_t elMat_2_26 = q_acc_2_26;
             const real_t elMat_2_27 = q_acc_2_27;
             const real_t elMat_2_28 = q_acc_2_28;
             const real_t elMat_2_29 = q_acc_2_29;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_3_12 = q_acc_3_12;
             const real_t elMat_3_13 = q_acc_3_13;
             const real_t elMat_3_14 = q_acc_3_14;
             const real_t elMat_3_15 = q_acc_3_15;
             const real_t elMat_3_16 = q_acc_3_16;
             const real_t elMat_3_17 = q_acc_3_17;
             const real_t elMat_3_18 = q_acc_3_18;
             const real_t elMat_3_19 = q_acc_3_19;
             const real_t elMat_3_20 = q_acc_3_20;
             const real_t elMat_3_21 = q_acc_3_21;
             const real_t elMat_3_22 = q_acc_3_22;
             const real_t elMat_3_23 = q_acc_3_23;
             const real_t elMat_3_24 = q_acc_3_24;
             const real_t elMat_3_25 = q_acc_3_25;
             const real_t elMat_3_26 = q_acc_3_26;
             const real_t elMat_3_27 = q_acc_3_27;
             const real_t elMat_3_28 = q_acc_3_28;
             const real_t elMat_3_29 = q_acc_3_29;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_4_12 = q_acc_4_12;
             const real_t elMat_4_13 = q_acc_4_13;
             const real_t elMat_4_14 = q_acc_4_14;
             const real_t elMat_4_15 = q_acc_4_15;
             const real_t elMat_4_16 = q_acc_4_16;
             const real_t elMat_4_17 = q_acc_4_17;
             const real_t elMat_4_18 = q_acc_4_18;
             const real_t elMat_4_19 = q_acc_4_19;
             const real_t elMat_4_20 = q_acc_4_20;
             const real_t elMat_4_21 = q_acc_4_21;
             const real_t elMat_4_22 = q_acc_4_22;
             const real_t elMat_4_23 = q_acc_4_23;
             const real_t elMat_4_24 = q_acc_4_24;
             const real_t elMat_4_25 = q_acc_4_25;
             const real_t elMat_4_26 = q_acc_4_26;
             const real_t elMat_4_27 = q_acc_4_27;
             const real_t elMat_4_28 = q_acc_4_28;
             const real_t elMat_4_29 = q_acc_4_29;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_5_12 = q_acc_5_12;
             const real_t elMat_5_13 = q_acc_5_13;
             const real_t elMat_5_14 = q_acc_5_14;
             const real_t elMat_5_15 = q_acc_5_15;
             const real_t elMat_5_16 = q_acc_5_16;
             const real_t elMat_5_17 = q_acc_5_17;
             const real_t elMat_5_18 = q_acc_5_18;
             const real_t elMat_5_19 = q_acc_5_19;
             const real_t elMat_5_20 = q_acc_5_20;
             const real_t elMat_5_21 = q_acc_5_21;
             const real_t elMat_5_22 = q_acc_5_22;
             const real_t elMat_5_23 = q_acc_5_23;
             const real_t elMat_5_24 = q_acc_5_24;
             const real_t elMat_5_25 = q_acc_5_25;
             const real_t elMat_5_26 = q_acc_5_26;
             const real_t elMat_5_27 = q_acc_5_27;
             const real_t elMat_5_28 = q_acc_5_28;
             const real_t elMat_5_29 = q_acc_5_29;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_6_12 = q_acc_6_12;
             const real_t elMat_6_13 = q_acc_6_13;
             const real_t elMat_6_14 = q_acc_6_14;
             const real_t elMat_6_15 = q_acc_6_15;
             const real_t elMat_6_16 = q_acc_6_16;
             const real_t elMat_6_17 = q_acc_6_17;
             const real_t elMat_6_18 = q_acc_6_18;
             const real_t elMat_6_19 = q_acc_6_19;
             const real_t elMat_6_20 = q_acc_6_20;
             const real_t elMat_6_21 = q_acc_6_21;
             const real_t elMat_6_22 = q_acc_6_22;
             const real_t elMat_6_23 = q_acc_6_23;
             const real_t elMat_6_24 = q_acc_6_24;
             const real_t elMat_6_25 = q_acc_6_25;
             const real_t elMat_6_26 = q_acc_6_26;
             const real_t elMat_6_27 = q_acc_6_27;
             const real_t elMat_6_28 = q_acc_6_28;
             const real_t elMat_6_29 = q_acc_6_29;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_7_12 = q_acc_7_12;
             const real_t elMat_7_13 = q_acc_7_13;
             const real_t elMat_7_14 = q_acc_7_14;
             const real_t elMat_7_15 = q_acc_7_15;
             const real_t elMat_7_16 = q_acc_7_16;
             const real_t elMat_7_17 = q_acc_7_17;
             const real_t elMat_7_18 = q_acc_7_18;
             const real_t elMat_7_19 = q_acc_7_19;
             const real_t elMat_7_20 = q_acc_7_20;
             const real_t elMat_7_21 = q_acc_7_21;
             const real_t elMat_7_22 = q_acc_7_22;
             const real_t elMat_7_23 = q_acc_7_23;
             const real_t elMat_7_24 = q_acc_7_24;
             const real_t elMat_7_25 = q_acc_7_25;
             const real_t elMat_7_26 = q_acc_7_26;
             const real_t elMat_7_27 = q_acc_7_27;
             const real_t elMat_7_28 = q_acc_7_28;
             const real_t elMat_7_29 = q_acc_7_29;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_8_12 = q_acc_8_12;
             const real_t elMat_8_13 = q_acc_8_13;
             const real_t elMat_8_14 = q_acc_8_14;
             const real_t elMat_8_15 = q_acc_8_15;
             const real_t elMat_8_16 = q_acc_8_16;
             const real_t elMat_8_17 = q_acc_8_17;
             const real_t elMat_8_18 = q_acc_8_18;
             const real_t elMat_8_19 = q_acc_8_19;
             const real_t elMat_8_20 = q_acc_8_20;
             const real_t elMat_8_21 = q_acc_8_21;
             const real_t elMat_8_22 = q_acc_8_22;
             const real_t elMat_8_23 = q_acc_8_23;
             const real_t elMat_8_24 = q_acc_8_24;
             const real_t elMat_8_25 = q_acc_8_25;
             const real_t elMat_8_26 = q_acc_8_26;
             const real_t elMat_8_27 = q_acc_8_27;
             const real_t elMat_8_28 = q_acc_8_28;
             const real_t elMat_8_29 = q_acc_8_29;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_9_12 = q_acc_9_12;
             const real_t elMat_9_13 = q_acc_9_13;
             const real_t elMat_9_14 = q_acc_9_14;
             const real_t elMat_9_15 = q_acc_9_15;
             const real_t elMat_9_16 = q_acc_9_16;
             const real_t elMat_9_17 = q_acc_9_17;
             const real_t elMat_9_18 = q_acc_9_18;
             const real_t elMat_9_19 = q_acc_9_19;
             const real_t elMat_9_20 = q_acc_9_20;
             const real_t elMat_9_21 = q_acc_9_21;
             const real_t elMat_9_22 = q_acc_9_22;
             const real_t elMat_9_23 = q_acc_9_23;
             const real_t elMat_9_24 = q_acc_9_24;
             const real_t elMat_9_25 = q_acc_9_25;
             const real_t elMat_9_26 = q_acc_9_26;
             const real_t elMat_9_27 = q_acc_9_27;
             const real_t elMat_9_28 = q_acc_9_28;
             const real_t elMat_9_29 = q_acc_9_29;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_10_12 = q_acc_10_12;
             const real_t elMat_10_13 = q_acc_10_13;
             const real_t elMat_10_14 = q_acc_10_14;
             const real_t elMat_10_15 = q_acc_10_15;
             const real_t elMat_10_16 = q_acc_10_16;
             const real_t elMat_10_17 = q_acc_10_17;
             const real_t elMat_10_18 = q_acc_10_18;
             const real_t elMat_10_19 = q_acc_10_19;
             const real_t elMat_10_20 = q_acc_10_20;
             const real_t elMat_10_21 = q_acc_10_21;
             const real_t elMat_10_22 = q_acc_10_22;
             const real_t elMat_10_23 = q_acc_10_23;
             const real_t elMat_10_24 = q_acc_10_24;
             const real_t elMat_10_25 = q_acc_10_25;
             const real_t elMat_10_26 = q_acc_10_26;
             const real_t elMat_10_27 = q_acc_10_27;
             const real_t elMat_10_28 = q_acc_10_28;
             const real_t elMat_10_29 = q_acc_10_29;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
             const real_t elMat_11_12 = q_acc_11_12;
             const real_t elMat_11_13 = q_acc_11_13;
             const real_t elMat_11_14 = q_acc_11_14;
             const real_t elMat_11_15 = q_acc_11_15;
             const real_t elMat_11_16 = q_acc_11_16;
             const real_t elMat_11_17 = q_acc_11_17;
             const real_t elMat_11_18 = q_acc_11_18;
             const real_t elMat_11_19 = q_acc_11_19;
             const real_t elMat_11_20 = q_acc_11_20;
             const real_t elMat_11_21 = q_acc_11_21;
             const real_t elMat_11_22 = q_acc_11_22;
             const real_t elMat_11_23 = q_acc_11_23;
             const real_t elMat_11_24 = q_acc_11_24;
             const real_t elMat_11_25 = q_acc_11_25;
             const real_t elMat_11_26 = q_acc_11_26;
             const real_t elMat_11_27 = q_acc_11_27;
             const real_t elMat_11_28 = q_acc_11_28;
             const real_t elMat_11_29 = q_acc_11_29;
             const real_t elMat_12_0 = q_acc_0_12;
             const real_t elMat_12_1 = q_acc_1_12;
             const real_t elMat_12_2 = q_acc_2_12;
             const real_t elMat_12_3 = q_acc_3_12;
             const real_t elMat_12_4 = q_acc_4_12;
             const real_t elMat_12_5 = q_acc_5_12;
             const real_t elMat_12_6 = q_acc_6_12;
             const real_t elMat_12_7 = q_acc_7_12;
             const real_t elMat_12_8 = q_acc_8_12;
             const real_t elMat_12_9 = q_acc_9_12;
             const real_t elMat_12_10 = q_acc_10_12;
             const real_t elMat_12_11 = q_acc_11_12;
             const real_t elMat_12_12 = q_acc_12_12;
             const real_t elMat_12_13 = q_acc_12_13;
             const real_t elMat_12_14 = q_acc_12_14;
             const real_t elMat_12_15 = q_acc_12_15;
             const real_t elMat_12_16 = q_acc_12_16;
             const real_t elMat_12_17 = q_acc_12_17;
             const real_t elMat_12_18 = q_acc_12_18;
             const real_t elMat_12_19 = q_acc_12_19;
             const real_t elMat_12_20 = q_acc_12_20;
             const real_t elMat_12_21 = q_acc_12_21;
             const real_t elMat_12_22 = q_acc_12_22;
             const real_t elMat_12_23 = q_acc_12_23;
             const real_t elMat_12_24 = q_acc_12_24;
             const real_t elMat_12_25 = q_acc_12_25;
             const real_t elMat_12_26 = q_acc_12_26;
             const real_t elMat_12_27 = q_acc_12_27;
             const real_t elMat_12_28 = q_acc_12_28;
             const real_t elMat_12_29 = q_acc_12_29;
             const real_t elMat_13_0 = q_acc_0_13;
             const real_t elMat_13_1 = q_acc_1_13;
             const real_t elMat_13_2 = q_acc_2_13;
             const real_t elMat_13_3 = q_acc_3_13;
             const real_t elMat_13_4 = q_acc_4_13;
             const real_t elMat_13_5 = q_acc_5_13;
             const real_t elMat_13_6 = q_acc_6_13;
             const real_t elMat_13_7 = q_acc_7_13;
             const real_t elMat_13_8 = q_acc_8_13;
             const real_t elMat_13_9 = q_acc_9_13;
             const real_t elMat_13_10 = q_acc_10_13;
             const real_t elMat_13_11 = q_acc_11_13;
             const real_t elMat_13_12 = q_acc_12_13;
             const real_t elMat_13_13 = q_acc_13_13;
             const real_t elMat_13_14 = q_acc_13_14;
             const real_t elMat_13_15 = q_acc_13_15;
             const real_t elMat_13_16 = q_acc_13_16;
             const real_t elMat_13_17 = q_acc_13_17;
             const real_t elMat_13_18 = q_acc_13_18;
             const real_t elMat_13_19 = q_acc_13_19;
             const real_t elMat_13_20 = q_acc_13_20;
             const real_t elMat_13_21 = q_acc_13_21;
             const real_t elMat_13_22 = q_acc_13_22;
             const real_t elMat_13_23 = q_acc_13_23;
             const real_t elMat_13_24 = q_acc_13_24;
             const real_t elMat_13_25 = q_acc_13_25;
             const real_t elMat_13_26 = q_acc_13_26;
             const real_t elMat_13_27 = q_acc_13_27;
             const real_t elMat_13_28 = q_acc_13_28;
             const real_t elMat_13_29 = q_acc_13_29;
             const real_t elMat_14_0 = q_acc_0_14;
             const real_t elMat_14_1 = q_acc_1_14;
             const real_t elMat_14_2 = q_acc_2_14;
             const real_t elMat_14_3 = q_acc_3_14;
             const real_t elMat_14_4 = q_acc_4_14;
             const real_t elMat_14_5 = q_acc_5_14;
             const real_t elMat_14_6 = q_acc_6_14;
             const real_t elMat_14_7 = q_acc_7_14;
             const real_t elMat_14_8 = q_acc_8_14;
             const real_t elMat_14_9 = q_acc_9_14;
             const real_t elMat_14_10 = q_acc_10_14;
             const real_t elMat_14_11 = q_acc_11_14;
             const real_t elMat_14_12 = q_acc_12_14;
             const real_t elMat_14_13 = q_acc_13_14;
             const real_t elMat_14_14 = q_acc_14_14;
             const real_t elMat_14_15 = q_acc_14_15;
             const real_t elMat_14_16 = q_acc_14_16;
             const real_t elMat_14_17 = q_acc_14_17;
             const real_t elMat_14_18 = q_acc_14_18;
             const real_t elMat_14_19 = q_acc_14_19;
             const real_t elMat_14_20 = q_acc_14_20;
             const real_t elMat_14_21 = q_acc_14_21;
             const real_t elMat_14_22 = q_acc_14_22;
             const real_t elMat_14_23 = q_acc_14_23;
             const real_t elMat_14_24 = q_acc_14_24;
             const real_t elMat_14_25 = q_acc_14_25;
             const real_t elMat_14_26 = q_acc_14_26;
             const real_t elMat_14_27 = q_acc_14_27;
             const real_t elMat_14_28 = q_acc_14_28;
             const real_t elMat_14_29 = q_acc_14_29;
             const real_t elMat_15_0 = q_acc_0_15;
             const real_t elMat_15_1 = q_acc_1_15;
             const real_t elMat_15_2 = q_acc_2_15;
             const real_t elMat_15_3 = q_acc_3_15;
             const real_t elMat_15_4 = q_acc_4_15;
             const real_t elMat_15_5 = q_acc_5_15;
             const real_t elMat_15_6 = q_acc_6_15;
             const real_t elMat_15_7 = q_acc_7_15;
             const real_t elMat_15_8 = q_acc_8_15;
             const real_t elMat_15_9 = q_acc_9_15;
             const real_t elMat_15_10 = q_acc_10_15;
             const real_t elMat_15_11 = q_acc_11_15;
             const real_t elMat_15_12 = q_acc_12_15;
             const real_t elMat_15_13 = q_acc_13_15;
             const real_t elMat_15_14 = q_acc_14_15;
             const real_t elMat_15_15 = q_acc_15_15;
             const real_t elMat_15_16 = q_acc_15_16;
             const real_t elMat_15_17 = q_acc_15_17;
             const real_t elMat_15_18 = q_acc_15_18;
             const real_t elMat_15_19 = q_acc_15_19;
             const real_t elMat_15_20 = q_acc_15_20;
             const real_t elMat_15_21 = q_acc_15_21;
             const real_t elMat_15_22 = q_acc_15_22;
             const real_t elMat_15_23 = q_acc_15_23;
             const real_t elMat_15_24 = q_acc_15_24;
             const real_t elMat_15_25 = q_acc_15_25;
             const real_t elMat_15_26 = q_acc_15_26;
             const real_t elMat_15_27 = q_acc_15_27;
             const real_t elMat_15_28 = q_acc_15_28;
             const real_t elMat_15_29 = q_acc_15_29;
             const real_t elMat_16_0 = q_acc_0_16;
             const real_t elMat_16_1 = q_acc_1_16;
             const real_t elMat_16_2 = q_acc_2_16;
             const real_t elMat_16_3 = q_acc_3_16;
             const real_t elMat_16_4 = q_acc_4_16;
             const real_t elMat_16_5 = q_acc_5_16;
             const real_t elMat_16_6 = q_acc_6_16;
             const real_t elMat_16_7 = q_acc_7_16;
             const real_t elMat_16_8 = q_acc_8_16;
             const real_t elMat_16_9 = q_acc_9_16;
             const real_t elMat_16_10 = q_acc_10_16;
             const real_t elMat_16_11 = q_acc_11_16;
             const real_t elMat_16_12 = q_acc_12_16;
             const real_t elMat_16_13 = q_acc_13_16;
             const real_t elMat_16_14 = q_acc_14_16;
             const real_t elMat_16_15 = q_acc_15_16;
             const real_t elMat_16_16 = q_acc_16_16;
             const real_t elMat_16_17 = q_acc_16_17;
             const real_t elMat_16_18 = q_acc_16_18;
             const real_t elMat_16_19 = q_acc_16_19;
             const real_t elMat_16_20 = q_acc_16_20;
             const real_t elMat_16_21 = q_acc_16_21;
             const real_t elMat_16_22 = q_acc_16_22;
             const real_t elMat_16_23 = q_acc_16_23;
             const real_t elMat_16_24 = q_acc_16_24;
             const real_t elMat_16_25 = q_acc_16_25;
             const real_t elMat_16_26 = q_acc_16_26;
             const real_t elMat_16_27 = q_acc_16_27;
             const real_t elMat_16_28 = q_acc_16_28;
             const real_t elMat_16_29 = q_acc_16_29;
             const real_t elMat_17_0 = q_acc_0_17;
             const real_t elMat_17_1 = q_acc_1_17;
             const real_t elMat_17_2 = q_acc_2_17;
             const real_t elMat_17_3 = q_acc_3_17;
             const real_t elMat_17_4 = q_acc_4_17;
             const real_t elMat_17_5 = q_acc_5_17;
             const real_t elMat_17_6 = q_acc_6_17;
             const real_t elMat_17_7 = q_acc_7_17;
             const real_t elMat_17_8 = q_acc_8_17;
             const real_t elMat_17_9 = q_acc_9_17;
             const real_t elMat_17_10 = q_acc_10_17;
             const real_t elMat_17_11 = q_acc_11_17;
             const real_t elMat_17_12 = q_acc_12_17;
             const real_t elMat_17_13 = q_acc_13_17;
             const real_t elMat_17_14 = q_acc_14_17;
             const real_t elMat_17_15 = q_acc_15_17;
             const real_t elMat_17_16 = q_acc_16_17;
             const real_t elMat_17_17 = q_acc_17_17;
             const real_t elMat_17_18 = q_acc_17_18;
             const real_t elMat_17_19 = q_acc_17_19;
             const real_t elMat_17_20 = q_acc_17_20;
             const real_t elMat_17_21 = q_acc_17_21;
             const real_t elMat_17_22 = q_acc_17_22;
             const real_t elMat_17_23 = q_acc_17_23;
             const real_t elMat_17_24 = q_acc_17_24;
             const real_t elMat_17_25 = q_acc_17_25;
             const real_t elMat_17_26 = q_acc_17_26;
             const real_t elMat_17_27 = q_acc_17_27;
             const real_t elMat_17_28 = q_acc_17_28;
             const real_t elMat_17_29 = q_acc_17_29;
             const real_t elMat_18_0 = q_acc_0_18;
             const real_t elMat_18_1 = q_acc_1_18;
             const real_t elMat_18_2 = q_acc_2_18;
             const real_t elMat_18_3 = q_acc_3_18;
             const real_t elMat_18_4 = q_acc_4_18;
             const real_t elMat_18_5 = q_acc_5_18;
             const real_t elMat_18_6 = q_acc_6_18;
             const real_t elMat_18_7 = q_acc_7_18;
             const real_t elMat_18_8 = q_acc_8_18;
             const real_t elMat_18_9 = q_acc_9_18;
             const real_t elMat_18_10 = q_acc_10_18;
             const real_t elMat_18_11 = q_acc_11_18;
             const real_t elMat_18_12 = q_acc_12_18;
             const real_t elMat_18_13 = q_acc_13_18;
             const real_t elMat_18_14 = q_acc_14_18;
             const real_t elMat_18_15 = q_acc_15_18;
             const real_t elMat_18_16 = q_acc_16_18;
             const real_t elMat_18_17 = q_acc_17_18;
             const real_t elMat_18_18 = q_acc_18_18;
             const real_t elMat_18_19 = q_acc_18_19;
             const real_t elMat_18_20 = q_acc_18_20;
             const real_t elMat_18_21 = q_acc_18_21;
             const real_t elMat_18_22 = q_acc_18_22;
             const real_t elMat_18_23 = q_acc_18_23;
             const real_t elMat_18_24 = q_acc_18_24;
             const real_t elMat_18_25 = q_acc_18_25;
             const real_t elMat_18_26 = q_acc_18_26;
             const real_t elMat_18_27 = q_acc_18_27;
             const real_t elMat_18_28 = q_acc_18_28;
             const real_t elMat_18_29 = q_acc_18_29;
             const real_t elMat_19_0 = q_acc_0_19;
             const real_t elMat_19_1 = q_acc_1_19;
             const real_t elMat_19_2 = q_acc_2_19;
             const real_t elMat_19_3 = q_acc_3_19;
             const real_t elMat_19_4 = q_acc_4_19;
             const real_t elMat_19_5 = q_acc_5_19;
             const real_t elMat_19_6 = q_acc_6_19;
             const real_t elMat_19_7 = q_acc_7_19;
             const real_t elMat_19_8 = q_acc_8_19;
             const real_t elMat_19_9 = q_acc_9_19;
             const real_t elMat_19_10 = q_acc_10_19;
             const real_t elMat_19_11 = q_acc_11_19;
             const real_t elMat_19_12 = q_acc_12_19;
             const real_t elMat_19_13 = q_acc_13_19;
             const real_t elMat_19_14 = q_acc_14_19;
             const real_t elMat_19_15 = q_acc_15_19;
             const real_t elMat_19_16 = q_acc_16_19;
             const real_t elMat_19_17 = q_acc_17_19;
             const real_t elMat_19_18 = q_acc_18_19;
             const real_t elMat_19_19 = q_acc_19_19;
             const real_t elMat_19_20 = q_acc_19_20;
             const real_t elMat_19_21 = q_acc_19_21;
             const real_t elMat_19_22 = q_acc_19_22;
             const real_t elMat_19_23 = q_acc_19_23;
             const real_t elMat_19_24 = q_acc_19_24;
             const real_t elMat_19_25 = q_acc_19_25;
             const real_t elMat_19_26 = q_acc_19_26;
             const real_t elMat_19_27 = q_acc_19_27;
             const real_t elMat_19_28 = q_acc_19_28;
             const real_t elMat_19_29 = q_acc_19_29;
             const real_t elMat_20_0 = q_acc_0_20;
             const real_t elMat_20_1 = q_acc_1_20;
             const real_t elMat_20_2 = q_acc_2_20;
             const real_t elMat_20_3 = q_acc_3_20;
             const real_t elMat_20_4 = q_acc_4_20;
             const real_t elMat_20_5 = q_acc_5_20;
             const real_t elMat_20_6 = q_acc_6_20;
             const real_t elMat_20_7 = q_acc_7_20;
             const real_t elMat_20_8 = q_acc_8_20;
             const real_t elMat_20_9 = q_acc_9_20;
             const real_t elMat_20_10 = q_acc_10_20;
             const real_t elMat_20_11 = q_acc_11_20;
             const real_t elMat_20_12 = q_acc_12_20;
             const real_t elMat_20_13 = q_acc_13_20;
             const real_t elMat_20_14 = q_acc_14_20;
             const real_t elMat_20_15 = q_acc_15_20;
             const real_t elMat_20_16 = q_acc_16_20;
             const real_t elMat_20_17 = q_acc_17_20;
             const real_t elMat_20_18 = q_acc_18_20;
             const real_t elMat_20_19 = q_acc_19_20;
             const real_t elMat_20_20 = q_acc_20_20;
             const real_t elMat_20_21 = q_acc_20_21;
             const real_t elMat_20_22 = q_acc_20_22;
             const real_t elMat_20_23 = q_acc_20_23;
             const real_t elMat_20_24 = q_acc_20_24;
             const real_t elMat_20_25 = q_acc_20_25;
             const real_t elMat_20_26 = q_acc_20_26;
             const real_t elMat_20_27 = q_acc_20_27;
             const real_t elMat_20_28 = q_acc_20_28;
             const real_t elMat_20_29 = q_acc_20_29;
             const real_t elMat_21_0 = q_acc_0_21;
             const real_t elMat_21_1 = q_acc_1_21;
             const real_t elMat_21_2 = q_acc_2_21;
             const real_t elMat_21_3 = q_acc_3_21;
             const real_t elMat_21_4 = q_acc_4_21;
             const real_t elMat_21_5 = q_acc_5_21;
             const real_t elMat_21_6 = q_acc_6_21;
             const real_t elMat_21_7 = q_acc_7_21;
             const real_t elMat_21_8 = q_acc_8_21;
             const real_t elMat_21_9 = q_acc_9_21;
             const real_t elMat_21_10 = q_acc_10_21;
             const real_t elMat_21_11 = q_acc_11_21;
             const real_t elMat_21_12 = q_acc_12_21;
             const real_t elMat_21_13 = q_acc_13_21;
             const real_t elMat_21_14 = q_acc_14_21;
             const real_t elMat_21_15 = q_acc_15_21;
             const real_t elMat_21_16 = q_acc_16_21;
             const real_t elMat_21_17 = q_acc_17_21;
             const real_t elMat_21_18 = q_acc_18_21;
             const real_t elMat_21_19 = q_acc_19_21;
             const real_t elMat_21_20 = q_acc_20_21;
             const real_t elMat_21_21 = q_acc_21_21;
             const real_t elMat_21_22 = q_acc_21_22;
             const real_t elMat_21_23 = q_acc_21_23;
             const real_t elMat_21_24 = q_acc_21_24;
             const real_t elMat_21_25 = q_acc_21_25;
             const real_t elMat_21_26 = q_acc_21_26;
             const real_t elMat_21_27 = q_acc_21_27;
             const real_t elMat_21_28 = q_acc_21_28;
             const real_t elMat_21_29 = q_acc_21_29;
             const real_t elMat_22_0 = q_acc_0_22;
             const real_t elMat_22_1 = q_acc_1_22;
             const real_t elMat_22_2 = q_acc_2_22;
             const real_t elMat_22_3 = q_acc_3_22;
             const real_t elMat_22_4 = q_acc_4_22;
             const real_t elMat_22_5 = q_acc_5_22;
             const real_t elMat_22_6 = q_acc_6_22;
             const real_t elMat_22_7 = q_acc_7_22;
             const real_t elMat_22_8 = q_acc_8_22;
             const real_t elMat_22_9 = q_acc_9_22;
             const real_t elMat_22_10 = q_acc_10_22;
             const real_t elMat_22_11 = q_acc_11_22;
             const real_t elMat_22_12 = q_acc_12_22;
             const real_t elMat_22_13 = q_acc_13_22;
             const real_t elMat_22_14 = q_acc_14_22;
             const real_t elMat_22_15 = q_acc_15_22;
             const real_t elMat_22_16 = q_acc_16_22;
             const real_t elMat_22_17 = q_acc_17_22;
             const real_t elMat_22_18 = q_acc_18_22;
             const real_t elMat_22_19 = q_acc_19_22;
             const real_t elMat_22_20 = q_acc_20_22;
             const real_t elMat_22_21 = q_acc_21_22;
             const real_t elMat_22_22 = q_acc_22_22;
             const real_t elMat_22_23 = q_acc_22_23;
             const real_t elMat_22_24 = q_acc_22_24;
             const real_t elMat_22_25 = q_acc_22_25;
             const real_t elMat_22_26 = q_acc_22_26;
             const real_t elMat_22_27 = q_acc_22_27;
             const real_t elMat_22_28 = q_acc_22_28;
             const real_t elMat_22_29 = q_acc_22_29;
             const real_t elMat_23_0 = q_acc_0_23;
             const real_t elMat_23_1 = q_acc_1_23;
             const real_t elMat_23_2 = q_acc_2_23;
             const real_t elMat_23_3 = q_acc_3_23;
             const real_t elMat_23_4 = q_acc_4_23;
             const real_t elMat_23_5 = q_acc_5_23;
             const real_t elMat_23_6 = q_acc_6_23;
             const real_t elMat_23_7 = q_acc_7_23;
             const real_t elMat_23_8 = q_acc_8_23;
             const real_t elMat_23_9 = q_acc_9_23;
             const real_t elMat_23_10 = q_acc_10_23;
             const real_t elMat_23_11 = q_acc_11_23;
             const real_t elMat_23_12 = q_acc_12_23;
             const real_t elMat_23_13 = q_acc_13_23;
             const real_t elMat_23_14 = q_acc_14_23;
             const real_t elMat_23_15 = q_acc_15_23;
             const real_t elMat_23_16 = q_acc_16_23;
             const real_t elMat_23_17 = q_acc_17_23;
             const real_t elMat_23_18 = q_acc_18_23;
             const real_t elMat_23_19 = q_acc_19_23;
             const real_t elMat_23_20 = q_acc_20_23;
             const real_t elMat_23_21 = q_acc_21_23;
             const real_t elMat_23_22 = q_acc_22_23;
             const real_t elMat_23_23 = q_acc_23_23;
             const real_t elMat_23_24 = q_acc_23_24;
             const real_t elMat_23_25 = q_acc_23_25;
             const real_t elMat_23_26 = q_acc_23_26;
             const real_t elMat_23_27 = q_acc_23_27;
             const real_t elMat_23_28 = q_acc_23_28;
             const real_t elMat_23_29 = q_acc_23_29;
             const real_t elMat_24_0 = q_acc_0_24;
             const real_t elMat_24_1 = q_acc_1_24;
             const real_t elMat_24_2 = q_acc_2_24;
             const real_t elMat_24_3 = q_acc_3_24;
             const real_t elMat_24_4 = q_acc_4_24;
             const real_t elMat_24_5 = q_acc_5_24;
             const real_t elMat_24_6 = q_acc_6_24;
             const real_t elMat_24_7 = q_acc_7_24;
             const real_t elMat_24_8 = q_acc_8_24;
             const real_t elMat_24_9 = q_acc_9_24;
             const real_t elMat_24_10 = q_acc_10_24;
             const real_t elMat_24_11 = q_acc_11_24;
             const real_t elMat_24_12 = q_acc_12_24;
             const real_t elMat_24_13 = q_acc_13_24;
             const real_t elMat_24_14 = q_acc_14_24;
             const real_t elMat_24_15 = q_acc_15_24;
             const real_t elMat_24_16 = q_acc_16_24;
             const real_t elMat_24_17 = q_acc_17_24;
             const real_t elMat_24_18 = q_acc_18_24;
             const real_t elMat_24_19 = q_acc_19_24;
             const real_t elMat_24_20 = q_acc_20_24;
             const real_t elMat_24_21 = q_acc_21_24;
             const real_t elMat_24_22 = q_acc_22_24;
             const real_t elMat_24_23 = q_acc_23_24;
             const real_t elMat_24_24 = q_acc_24_24;
             const real_t elMat_24_25 = q_acc_24_25;
             const real_t elMat_24_26 = q_acc_24_26;
             const real_t elMat_24_27 = q_acc_24_27;
             const real_t elMat_24_28 = q_acc_24_28;
             const real_t elMat_24_29 = q_acc_24_29;
             const real_t elMat_25_0 = q_acc_0_25;
             const real_t elMat_25_1 = q_acc_1_25;
             const real_t elMat_25_2 = q_acc_2_25;
             const real_t elMat_25_3 = q_acc_3_25;
             const real_t elMat_25_4 = q_acc_4_25;
             const real_t elMat_25_5 = q_acc_5_25;
             const real_t elMat_25_6 = q_acc_6_25;
             const real_t elMat_25_7 = q_acc_7_25;
             const real_t elMat_25_8 = q_acc_8_25;
             const real_t elMat_25_9 = q_acc_9_25;
             const real_t elMat_25_10 = q_acc_10_25;
             const real_t elMat_25_11 = q_acc_11_25;
             const real_t elMat_25_12 = q_acc_12_25;
             const real_t elMat_25_13 = q_acc_13_25;
             const real_t elMat_25_14 = q_acc_14_25;
             const real_t elMat_25_15 = q_acc_15_25;
             const real_t elMat_25_16 = q_acc_16_25;
             const real_t elMat_25_17 = q_acc_17_25;
             const real_t elMat_25_18 = q_acc_18_25;
             const real_t elMat_25_19 = q_acc_19_25;
             const real_t elMat_25_20 = q_acc_20_25;
             const real_t elMat_25_21 = q_acc_21_25;
             const real_t elMat_25_22 = q_acc_22_25;
             const real_t elMat_25_23 = q_acc_23_25;
             const real_t elMat_25_24 = q_acc_24_25;
             const real_t elMat_25_25 = q_acc_25_25;
             const real_t elMat_25_26 = q_acc_25_26;
             const real_t elMat_25_27 = q_acc_25_27;
             const real_t elMat_25_28 = q_acc_25_28;
             const real_t elMat_25_29 = q_acc_25_29;
             const real_t elMat_26_0 = q_acc_0_26;
             const real_t elMat_26_1 = q_acc_1_26;
             const real_t elMat_26_2 = q_acc_2_26;
             const real_t elMat_26_3 = q_acc_3_26;
             const real_t elMat_26_4 = q_acc_4_26;
             const real_t elMat_26_5 = q_acc_5_26;
             const real_t elMat_26_6 = q_acc_6_26;
             const real_t elMat_26_7 = q_acc_7_26;
             const real_t elMat_26_8 = q_acc_8_26;
             const real_t elMat_26_9 = q_acc_9_26;
             const real_t elMat_26_10 = q_acc_10_26;
             const real_t elMat_26_11 = q_acc_11_26;
             const real_t elMat_26_12 = q_acc_12_26;
             const real_t elMat_26_13 = q_acc_13_26;
             const real_t elMat_26_14 = q_acc_14_26;
             const real_t elMat_26_15 = q_acc_15_26;
             const real_t elMat_26_16 = q_acc_16_26;
             const real_t elMat_26_17 = q_acc_17_26;
             const real_t elMat_26_18 = q_acc_18_26;
             const real_t elMat_26_19 = q_acc_19_26;
             const real_t elMat_26_20 = q_acc_20_26;
             const real_t elMat_26_21 = q_acc_21_26;
             const real_t elMat_26_22 = q_acc_22_26;
             const real_t elMat_26_23 = q_acc_23_26;
             const real_t elMat_26_24 = q_acc_24_26;
             const real_t elMat_26_25 = q_acc_25_26;
             const real_t elMat_26_26 = q_acc_26_26;
             const real_t elMat_26_27 = q_acc_26_27;
             const real_t elMat_26_28 = q_acc_26_28;
             const real_t elMat_26_29 = q_acc_26_29;
             const real_t elMat_27_0 = q_acc_0_27;
             const real_t elMat_27_1 = q_acc_1_27;
             const real_t elMat_27_2 = q_acc_2_27;
             const real_t elMat_27_3 = q_acc_3_27;
             const real_t elMat_27_4 = q_acc_4_27;
             const real_t elMat_27_5 = q_acc_5_27;
             const real_t elMat_27_6 = q_acc_6_27;
             const real_t elMat_27_7 = q_acc_7_27;
             const real_t elMat_27_8 = q_acc_8_27;
             const real_t elMat_27_9 = q_acc_9_27;
             const real_t elMat_27_10 = q_acc_10_27;
             const real_t elMat_27_11 = q_acc_11_27;
             const real_t elMat_27_12 = q_acc_12_27;
             const real_t elMat_27_13 = q_acc_13_27;
             const real_t elMat_27_14 = q_acc_14_27;
             const real_t elMat_27_15 = q_acc_15_27;
             const real_t elMat_27_16 = q_acc_16_27;
             const real_t elMat_27_17 = q_acc_17_27;
             const real_t elMat_27_18 = q_acc_18_27;
             const real_t elMat_27_19 = q_acc_19_27;
             const real_t elMat_27_20 = q_acc_20_27;
             const real_t elMat_27_21 = q_acc_21_27;
             const real_t elMat_27_22 = q_acc_22_27;
             const real_t elMat_27_23 = q_acc_23_27;
             const real_t elMat_27_24 = q_acc_24_27;
             const real_t elMat_27_25 = q_acc_25_27;
             const real_t elMat_27_26 = q_acc_26_27;
             const real_t elMat_27_27 = q_acc_27_27;
             const real_t elMat_27_28 = q_acc_27_28;
             const real_t elMat_27_29 = q_acc_27_29;
             const real_t elMat_28_0 = q_acc_0_28;
             const real_t elMat_28_1 = q_acc_1_28;
             const real_t elMat_28_2 = q_acc_2_28;
             const real_t elMat_28_3 = q_acc_3_28;
             const real_t elMat_28_4 = q_acc_4_28;
             const real_t elMat_28_5 = q_acc_5_28;
             const real_t elMat_28_6 = q_acc_6_28;
             const real_t elMat_28_7 = q_acc_7_28;
             const real_t elMat_28_8 = q_acc_8_28;
             const real_t elMat_28_9 = q_acc_9_28;
             const real_t elMat_28_10 = q_acc_10_28;
             const real_t elMat_28_11 = q_acc_11_28;
             const real_t elMat_28_12 = q_acc_12_28;
             const real_t elMat_28_13 = q_acc_13_28;
             const real_t elMat_28_14 = q_acc_14_28;
             const real_t elMat_28_15 = q_acc_15_28;
             const real_t elMat_28_16 = q_acc_16_28;
             const real_t elMat_28_17 = q_acc_17_28;
             const real_t elMat_28_18 = q_acc_18_28;
             const real_t elMat_28_19 = q_acc_19_28;
             const real_t elMat_28_20 = q_acc_20_28;
             const real_t elMat_28_21 = q_acc_21_28;
             const real_t elMat_28_22 = q_acc_22_28;
             const real_t elMat_28_23 = q_acc_23_28;
             const real_t elMat_28_24 = q_acc_24_28;
             const real_t elMat_28_25 = q_acc_25_28;
             const real_t elMat_28_26 = q_acc_26_28;
             const real_t elMat_28_27 = q_acc_27_28;
             const real_t elMat_28_28 = q_acc_28_28;
             const real_t elMat_28_29 = q_acc_28_29;
             const real_t elMat_29_0 = q_acc_0_29;
             const real_t elMat_29_1 = q_acc_1_29;
             const real_t elMat_29_2 = q_acc_2_29;
             const real_t elMat_29_3 = q_acc_3_29;
             const real_t elMat_29_4 = q_acc_4_29;
             const real_t elMat_29_5 = q_acc_5_29;
             const real_t elMat_29_6 = q_acc_6_29;
             const real_t elMat_29_7 = q_acc_7_29;
             const real_t elMat_29_8 = q_acc_8_29;
             const real_t elMat_29_9 = q_acc_9_29;
             const real_t elMat_29_10 = q_acc_10_29;
             const real_t elMat_29_11 = q_acc_11_29;
             const real_t elMat_29_12 = q_acc_12_29;
             const real_t elMat_29_13 = q_acc_13_29;
             const real_t elMat_29_14 = q_acc_14_29;
             const real_t elMat_29_15 = q_acc_15_29;
             const real_t elMat_29_16 = q_acc_16_29;
             const real_t elMat_29_17 = q_acc_17_29;
             const real_t elMat_29_18 = q_acc_18_29;
             const real_t elMat_29_19 = q_acc_19_29;
             const real_t elMat_29_20 = q_acc_20_29;
             const real_t elMat_29_21 = q_acc_21_29;
             const real_t elMat_29_22 = q_acc_22_29;
             const real_t elMat_29_23 = q_acc_23_29;
             const real_t elMat_29_24 = q_acc_24_29;
             const real_t elMat_29_25 = q_acc_25_29;
             const real_t elMat_29_26 = q_acc_26_29;
             const real_t elMat_29_27 = q_acc_27_29;
             const real_t elMat_29_28 = q_acc_28_29;
             const real_t elMat_29_29 = q_acc_29_29;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 30 );
             std::vector< real_t > _data_mat( 900 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[11] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[12] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[13] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[14] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[15] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[16] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[17] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[18] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[19] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[20] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[21] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[22] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[23] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[24] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[25] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[26] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[27] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[28] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[29] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_0_12));
             _data_mat[13] = ((real_t)(elMat_0_13));
             _data_mat[14] = ((real_t)(elMat_0_14));
             _data_mat[15] = ((real_t)(elMat_0_15));
             _data_mat[16] = ((real_t)(elMat_0_16));
             _data_mat[17] = ((real_t)(elMat_0_17));
             _data_mat[18] = ((real_t)(elMat_0_18));
             _data_mat[19] = ((real_t)(elMat_0_19));
             _data_mat[20] = ((real_t)(elMat_0_20));
             _data_mat[21] = ((real_t)(elMat_0_21));
             _data_mat[22] = ((real_t)(elMat_0_22));
             _data_mat[23] = ((real_t)(elMat_0_23));
             _data_mat[24] = ((real_t)(elMat_0_24));
             _data_mat[25] = ((real_t)(elMat_0_25));
             _data_mat[26] = ((real_t)(elMat_0_26));
             _data_mat[27] = ((real_t)(elMat_0_27));
             _data_mat[28] = ((real_t)(elMat_0_28));
             _data_mat[29] = ((real_t)(elMat_0_29));
             _data_mat[30] = ((real_t)(elMat_1_0));
             _data_mat[31] = ((real_t)(elMat_1_1));
             _data_mat[32] = ((real_t)(elMat_1_2));
             _data_mat[33] = ((real_t)(elMat_1_3));
             _data_mat[34] = ((real_t)(elMat_1_4));
             _data_mat[35] = ((real_t)(elMat_1_5));
             _data_mat[36] = ((real_t)(elMat_1_6));
             _data_mat[37] = ((real_t)(elMat_1_7));
             _data_mat[38] = ((real_t)(elMat_1_8));
             _data_mat[39] = ((real_t)(elMat_1_9));
             _data_mat[40] = ((real_t)(elMat_1_10));
             _data_mat[41] = ((real_t)(elMat_1_11));
             _data_mat[42] = ((real_t)(elMat_1_12));
             _data_mat[43] = ((real_t)(elMat_1_13));
             _data_mat[44] = ((real_t)(elMat_1_14));
             _data_mat[45] = ((real_t)(elMat_1_15));
             _data_mat[46] = ((real_t)(elMat_1_16));
             _data_mat[47] = ((real_t)(elMat_1_17));
             _data_mat[48] = ((real_t)(elMat_1_18));
             _data_mat[49] = ((real_t)(elMat_1_19));
             _data_mat[50] = ((real_t)(elMat_1_20));
             _data_mat[51] = ((real_t)(elMat_1_21));
             _data_mat[52] = ((real_t)(elMat_1_22));
             _data_mat[53] = ((real_t)(elMat_1_23));
             _data_mat[54] = ((real_t)(elMat_1_24));
             _data_mat[55] = ((real_t)(elMat_1_25));
             _data_mat[56] = ((real_t)(elMat_1_26));
             _data_mat[57] = ((real_t)(elMat_1_27));
             _data_mat[58] = ((real_t)(elMat_1_28));
             _data_mat[59] = ((real_t)(elMat_1_29));
             _data_mat[60] = ((real_t)(elMat_2_0));
             _data_mat[61] = ((real_t)(elMat_2_1));
             _data_mat[62] = ((real_t)(elMat_2_2));
             _data_mat[63] = ((real_t)(elMat_2_3));
             _data_mat[64] = ((real_t)(elMat_2_4));
             _data_mat[65] = ((real_t)(elMat_2_5));
             _data_mat[66] = ((real_t)(elMat_2_6));
             _data_mat[67] = ((real_t)(elMat_2_7));
             _data_mat[68] = ((real_t)(elMat_2_8));
             _data_mat[69] = ((real_t)(elMat_2_9));
             _data_mat[70] = ((real_t)(elMat_2_10));
             _data_mat[71] = ((real_t)(elMat_2_11));
             _data_mat[72] = ((real_t)(elMat_2_12));
             _data_mat[73] = ((real_t)(elMat_2_13));
             _data_mat[74] = ((real_t)(elMat_2_14));
             _data_mat[75] = ((real_t)(elMat_2_15));
             _data_mat[76] = ((real_t)(elMat_2_16));
             _data_mat[77] = ((real_t)(elMat_2_17));
             _data_mat[78] = ((real_t)(elMat_2_18));
             _data_mat[79] = ((real_t)(elMat_2_19));
             _data_mat[80] = ((real_t)(elMat_2_20));
             _data_mat[81] = ((real_t)(elMat_2_21));
             _data_mat[82] = ((real_t)(elMat_2_22));
             _data_mat[83] = ((real_t)(elMat_2_23));
             _data_mat[84] = ((real_t)(elMat_2_24));
             _data_mat[85] = ((real_t)(elMat_2_25));
             _data_mat[86] = ((real_t)(elMat_2_26));
             _data_mat[87] = ((real_t)(elMat_2_27));
             _data_mat[88] = ((real_t)(elMat_2_28));
             _data_mat[89] = ((real_t)(elMat_2_29));
             _data_mat[90] = ((real_t)(elMat_3_0));
             _data_mat[91] = ((real_t)(elMat_3_1));
             _data_mat[92] = ((real_t)(elMat_3_2));
             _data_mat[93] = ((real_t)(elMat_3_3));
             _data_mat[94] = ((real_t)(elMat_3_4));
             _data_mat[95] = ((real_t)(elMat_3_5));
             _data_mat[96] = ((real_t)(elMat_3_6));
             _data_mat[97] = ((real_t)(elMat_3_7));
             _data_mat[98] = ((real_t)(elMat_3_8));
             _data_mat[99] = ((real_t)(elMat_3_9));
             _data_mat[100] = ((real_t)(elMat_3_10));
             _data_mat[101] = ((real_t)(elMat_3_11));
             _data_mat[102] = ((real_t)(elMat_3_12));
             _data_mat[103] = ((real_t)(elMat_3_13));
             _data_mat[104] = ((real_t)(elMat_3_14));
             _data_mat[105] = ((real_t)(elMat_3_15));
             _data_mat[106] = ((real_t)(elMat_3_16));
             _data_mat[107] = ((real_t)(elMat_3_17));
             _data_mat[108] = ((real_t)(elMat_3_18));
             _data_mat[109] = ((real_t)(elMat_3_19));
             _data_mat[110] = ((real_t)(elMat_3_20));
             _data_mat[111] = ((real_t)(elMat_3_21));
             _data_mat[112] = ((real_t)(elMat_3_22));
             _data_mat[113] = ((real_t)(elMat_3_23));
             _data_mat[114] = ((real_t)(elMat_3_24));
             _data_mat[115] = ((real_t)(elMat_3_25));
             _data_mat[116] = ((real_t)(elMat_3_26));
             _data_mat[117] = ((real_t)(elMat_3_27));
             _data_mat[118] = ((real_t)(elMat_3_28));
             _data_mat[119] = ((real_t)(elMat_3_29));
             _data_mat[120] = ((real_t)(elMat_4_0));
             _data_mat[121] = ((real_t)(elMat_4_1));
             _data_mat[122] = ((real_t)(elMat_4_2));
             _data_mat[123] = ((real_t)(elMat_4_3));
             _data_mat[124] = ((real_t)(elMat_4_4));
             _data_mat[125] = ((real_t)(elMat_4_5));
             _data_mat[126] = ((real_t)(elMat_4_6));
             _data_mat[127] = ((real_t)(elMat_4_7));
             _data_mat[128] = ((real_t)(elMat_4_8));
             _data_mat[129] = ((real_t)(elMat_4_9));
             _data_mat[130] = ((real_t)(elMat_4_10));
             _data_mat[131] = ((real_t)(elMat_4_11));
             _data_mat[132] = ((real_t)(elMat_4_12));
             _data_mat[133] = ((real_t)(elMat_4_13));
             _data_mat[134] = ((real_t)(elMat_4_14));
             _data_mat[135] = ((real_t)(elMat_4_15));
             _data_mat[136] = ((real_t)(elMat_4_16));
             _data_mat[137] = ((real_t)(elMat_4_17));
             _data_mat[138] = ((real_t)(elMat_4_18));
             _data_mat[139] = ((real_t)(elMat_4_19));
             _data_mat[140] = ((real_t)(elMat_4_20));
             _data_mat[141] = ((real_t)(elMat_4_21));
             _data_mat[142] = ((real_t)(elMat_4_22));
             _data_mat[143] = ((real_t)(elMat_4_23));
             _data_mat[144] = ((real_t)(elMat_4_24));
             _data_mat[145] = ((real_t)(elMat_4_25));
             _data_mat[146] = ((real_t)(elMat_4_26));
             _data_mat[147] = ((real_t)(elMat_4_27));
             _data_mat[148] = ((real_t)(elMat_4_28));
             _data_mat[149] = ((real_t)(elMat_4_29));
             _data_mat[150] = ((real_t)(elMat_5_0));
             _data_mat[151] = ((real_t)(elMat_5_1));
             _data_mat[152] = ((real_t)(elMat_5_2));
             _data_mat[153] = ((real_t)(elMat_5_3));
             _data_mat[154] = ((real_t)(elMat_5_4));
             _data_mat[155] = ((real_t)(elMat_5_5));
             _data_mat[156] = ((real_t)(elMat_5_6));
             _data_mat[157] = ((real_t)(elMat_5_7));
             _data_mat[158] = ((real_t)(elMat_5_8));
             _data_mat[159] = ((real_t)(elMat_5_9));
             _data_mat[160] = ((real_t)(elMat_5_10));
             _data_mat[161] = ((real_t)(elMat_5_11));
             _data_mat[162] = ((real_t)(elMat_5_12));
             _data_mat[163] = ((real_t)(elMat_5_13));
             _data_mat[164] = ((real_t)(elMat_5_14));
             _data_mat[165] = ((real_t)(elMat_5_15));
             _data_mat[166] = ((real_t)(elMat_5_16));
             _data_mat[167] = ((real_t)(elMat_5_17));
             _data_mat[168] = ((real_t)(elMat_5_18));
             _data_mat[169] = ((real_t)(elMat_5_19));
             _data_mat[170] = ((real_t)(elMat_5_20));
             _data_mat[171] = ((real_t)(elMat_5_21));
             _data_mat[172] = ((real_t)(elMat_5_22));
             _data_mat[173] = ((real_t)(elMat_5_23));
             _data_mat[174] = ((real_t)(elMat_5_24));
             _data_mat[175] = ((real_t)(elMat_5_25));
             _data_mat[176] = ((real_t)(elMat_5_26));
             _data_mat[177] = ((real_t)(elMat_5_27));
             _data_mat[178] = ((real_t)(elMat_5_28));
             _data_mat[179] = ((real_t)(elMat_5_29));
             _data_mat[180] = ((real_t)(elMat_6_0));
             _data_mat[181] = ((real_t)(elMat_6_1));
             _data_mat[182] = ((real_t)(elMat_6_2));
             _data_mat[183] = ((real_t)(elMat_6_3));
             _data_mat[184] = ((real_t)(elMat_6_4));
             _data_mat[185] = ((real_t)(elMat_6_5));
             _data_mat[186] = ((real_t)(elMat_6_6));
             _data_mat[187] = ((real_t)(elMat_6_7));
             _data_mat[188] = ((real_t)(elMat_6_8));
             _data_mat[189] = ((real_t)(elMat_6_9));
             _data_mat[190] = ((real_t)(elMat_6_10));
             _data_mat[191] = ((real_t)(elMat_6_11));
             _data_mat[192] = ((real_t)(elMat_6_12));
             _data_mat[193] = ((real_t)(elMat_6_13));
             _data_mat[194] = ((real_t)(elMat_6_14));
             _data_mat[195] = ((real_t)(elMat_6_15));
             _data_mat[196] = ((real_t)(elMat_6_16));
             _data_mat[197] = ((real_t)(elMat_6_17));
             _data_mat[198] = ((real_t)(elMat_6_18));
             _data_mat[199] = ((real_t)(elMat_6_19));
             _data_mat[200] = ((real_t)(elMat_6_20));
             _data_mat[201] = ((real_t)(elMat_6_21));
             _data_mat[202] = ((real_t)(elMat_6_22));
             _data_mat[203] = ((real_t)(elMat_6_23));
             _data_mat[204] = ((real_t)(elMat_6_24));
             _data_mat[205] = ((real_t)(elMat_6_25));
             _data_mat[206] = ((real_t)(elMat_6_26));
             _data_mat[207] = ((real_t)(elMat_6_27));
             _data_mat[208] = ((real_t)(elMat_6_28));
             _data_mat[209] = ((real_t)(elMat_6_29));
             _data_mat[210] = ((real_t)(elMat_7_0));
             _data_mat[211] = ((real_t)(elMat_7_1));
             _data_mat[212] = ((real_t)(elMat_7_2));
             _data_mat[213] = ((real_t)(elMat_7_3));
             _data_mat[214] = ((real_t)(elMat_7_4));
             _data_mat[215] = ((real_t)(elMat_7_5));
             _data_mat[216] = ((real_t)(elMat_7_6));
             _data_mat[217] = ((real_t)(elMat_7_7));
             _data_mat[218] = ((real_t)(elMat_7_8));
             _data_mat[219] = ((real_t)(elMat_7_9));
             _data_mat[220] = ((real_t)(elMat_7_10));
             _data_mat[221] = ((real_t)(elMat_7_11));
             _data_mat[222] = ((real_t)(elMat_7_12));
             _data_mat[223] = ((real_t)(elMat_7_13));
             _data_mat[224] = ((real_t)(elMat_7_14));
             _data_mat[225] = ((real_t)(elMat_7_15));
             _data_mat[226] = ((real_t)(elMat_7_16));
             _data_mat[227] = ((real_t)(elMat_7_17));
             _data_mat[228] = ((real_t)(elMat_7_18));
             _data_mat[229] = ((real_t)(elMat_7_19));
             _data_mat[230] = ((real_t)(elMat_7_20));
             _data_mat[231] = ((real_t)(elMat_7_21));
             _data_mat[232] = ((real_t)(elMat_7_22));
             _data_mat[233] = ((real_t)(elMat_7_23));
             _data_mat[234] = ((real_t)(elMat_7_24));
             _data_mat[235] = ((real_t)(elMat_7_25));
             _data_mat[236] = ((real_t)(elMat_7_26));
             _data_mat[237] = ((real_t)(elMat_7_27));
             _data_mat[238] = ((real_t)(elMat_7_28));
             _data_mat[239] = ((real_t)(elMat_7_29));
             _data_mat[240] = ((real_t)(elMat_8_0));
             _data_mat[241] = ((real_t)(elMat_8_1));
             _data_mat[242] = ((real_t)(elMat_8_2));
             _data_mat[243] = ((real_t)(elMat_8_3));
             _data_mat[244] = ((real_t)(elMat_8_4));
             _data_mat[245] = ((real_t)(elMat_8_5));
             _data_mat[246] = ((real_t)(elMat_8_6));
             _data_mat[247] = ((real_t)(elMat_8_7));
             _data_mat[248] = ((real_t)(elMat_8_8));
             _data_mat[249] = ((real_t)(elMat_8_9));
             _data_mat[250] = ((real_t)(elMat_8_10));
             _data_mat[251] = ((real_t)(elMat_8_11));
             _data_mat[252] = ((real_t)(elMat_8_12));
             _data_mat[253] = ((real_t)(elMat_8_13));
             _data_mat[254] = ((real_t)(elMat_8_14));
             _data_mat[255] = ((real_t)(elMat_8_15));
             _data_mat[256] = ((real_t)(elMat_8_16));
             _data_mat[257] = ((real_t)(elMat_8_17));
             _data_mat[258] = ((real_t)(elMat_8_18));
             _data_mat[259] = ((real_t)(elMat_8_19));
             _data_mat[260] = ((real_t)(elMat_8_20));
             _data_mat[261] = ((real_t)(elMat_8_21));
             _data_mat[262] = ((real_t)(elMat_8_22));
             _data_mat[263] = ((real_t)(elMat_8_23));
             _data_mat[264] = ((real_t)(elMat_8_24));
             _data_mat[265] = ((real_t)(elMat_8_25));
             _data_mat[266] = ((real_t)(elMat_8_26));
             _data_mat[267] = ((real_t)(elMat_8_27));
             _data_mat[268] = ((real_t)(elMat_8_28));
             _data_mat[269] = ((real_t)(elMat_8_29));
             _data_mat[270] = ((real_t)(elMat_9_0));
             _data_mat[271] = ((real_t)(elMat_9_1));
             _data_mat[272] = ((real_t)(elMat_9_2));
             _data_mat[273] = ((real_t)(elMat_9_3));
             _data_mat[274] = ((real_t)(elMat_9_4));
             _data_mat[275] = ((real_t)(elMat_9_5));
             _data_mat[276] = ((real_t)(elMat_9_6));
             _data_mat[277] = ((real_t)(elMat_9_7));
             _data_mat[278] = ((real_t)(elMat_9_8));
             _data_mat[279] = ((real_t)(elMat_9_9));
             _data_mat[280] = ((real_t)(elMat_9_10));
             _data_mat[281] = ((real_t)(elMat_9_11));
             _data_mat[282] = ((real_t)(elMat_9_12));
             _data_mat[283] = ((real_t)(elMat_9_13));
             _data_mat[284] = ((real_t)(elMat_9_14));
             _data_mat[285] = ((real_t)(elMat_9_15));
             _data_mat[286] = ((real_t)(elMat_9_16));
             _data_mat[287] = ((real_t)(elMat_9_17));
             _data_mat[288] = ((real_t)(elMat_9_18));
             _data_mat[289] = ((real_t)(elMat_9_19));
             _data_mat[290] = ((real_t)(elMat_9_20));
             _data_mat[291] = ((real_t)(elMat_9_21));
             _data_mat[292] = ((real_t)(elMat_9_22));
             _data_mat[293] = ((real_t)(elMat_9_23));
             _data_mat[294] = ((real_t)(elMat_9_24));
             _data_mat[295] = ((real_t)(elMat_9_25));
             _data_mat[296] = ((real_t)(elMat_9_26));
             _data_mat[297] = ((real_t)(elMat_9_27));
             _data_mat[298] = ((real_t)(elMat_9_28));
             _data_mat[299] = ((real_t)(elMat_9_29));
             _data_mat[300] = ((real_t)(elMat_10_0));
             _data_mat[301] = ((real_t)(elMat_10_1));
             _data_mat[302] = ((real_t)(elMat_10_2));
             _data_mat[303] = ((real_t)(elMat_10_3));
             _data_mat[304] = ((real_t)(elMat_10_4));
             _data_mat[305] = ((real_t)(elMat_10_5));
             _data_mat[306] = ((real_t)(elMat_10_6));
             _data_mat[307] = ((real_t)(elMat_10_7));
             _data_mat[308] = ((real_t)(elMat_10_8));
             _data_mat[309] = ((real_t)(elMat_10_9));
             _data_mat[310] = ((real_t)(elMat_10_10));
             _data_mat[311] = ((real_t)(elMat_10_11));
             _data_mat[312] = ((real_t)(elMat_10_12));
             _data_mat[313] = ((real_t)(elMat_10_13));
             _data_mat[314] = ((real_t)(elMat_10_14));
             _data_mat[315] = ((real_t)(elMat_10_15));
             _data_mat[316] = ((real_t)(elMat_10_16));
             _data_mat[317] = ((real_t)(elMat_10_17));
             _data_mat[318] = ((real_t)(elMat_10_18));
             _data_mat[319] = ((real_t)(elMat_10_19));
             _data_mat[320] = ((real_t)(elMat_10_20));
             _data_mat[321] = ((real_t)(elMat_10_21));
             _data_mat[322] = ((real_t)(elMat_10_22));
             _data_mat[323] = ((real_t)(elMat_10_23));
             _data_mat[324] = ((real_t)(elMat_10_24));
             _data_mat[325] = ((real_t)(elMat_10_25));
             _data_mat[326] = ((real_t)(elMat_10_26));
             _data_mat[327] = ((real_t)(elMat_10_27));
             _data_mat[328] = ((real_t)(elMat_10_28));
             _data_mat[329] = ((real_t)(elMat_10_29));
             _data_mat[330] = ((real_t)(elMat_11_0));
             _data_mat[331] = ((real_t)(elMat_11_1));
             _data_mat[332] = ((real_t)(elMat_11_2));
             _data_mat[333] = ((real_t)(elMat_11_3));
             _data_mat[334] = ((real_t)(elMat_11_4));
             _data_mat[335] = ((real_t)(elMat_11_5));
             _data_mat[336] = ((real_t)(elMat_11_6));
             _data_mat[337] = ((real_t)(elMat_11_7));
             _data_mat[338] = ((real_t)(elMat_11_8));
             _data_mat[339] = ((real_t)(elMat_11_9));
             _data_mat[340] = ((real_t)(elMat_11_10));
             _data_mat[341] = ((real_t)(elMat_11_11));
             _data_mat[342] = ((real_t)(elMat_11_12));
             _data_mat[343] = ((real_t)(elMat_11_13));
             _data_mat[344] = ((real_t)(elMat_11_14));
             _data_mat[345] = ((real_t)(elMat_11_15));
             _data_mat[346] = ((real_t)(elMat_11_16));
             _data_mat[347] = ((real_t)(elMat_11_17));
             _data_mat[348] = ((real_t)(elMat_11_18));
             _data_mat[349] = ((real_t)(elMat_11_19));
             _data_mat[350] = ((real_t)(elMat_11_20));
             _data_mat[351] = ((real_t)(elMat_11_21));
             _data_mat[352] = ((real_t)(elMat_11_22));
             _data_mat[353] = ((real_t)(elMat_11_23));
             _data_mat[354] = ((real_t)(elMat_11_24));
             _data_mat[355] = ((real_t)(elMat_11_25));
             _data_mat[356] = ((real_t)(elMat_11_26));
             _data_mat[357] = ((real_t)(elMat_11_27));
             _data_mat[358] = ((real_t)(elMat_11_28));
             _data_mat[359] = ((real_t)(elMat_11_29));
             _data_mat[360] = ((real_t)(elMat_12_0));
             _data_mat[361] = ((real_t)(elMat_12_1));
             _data_mat[362] = ((real_t)(elMat_12_2));
             _data_mat[363] = ((real_t)(elMat_12_3));
             _data_mat[364] = ((real_t)(elMat_12_4));
             _data_mat[365] = ((real_t)(elMat_12_5));
             _data_mat[366] = ((real_t)(elMat_12_6));
             _data_mat[367] = ((real_t)(elMat_12_7));
             _data_mat[368] = ((real_t)(elMat_12_8));
             _data_mat[369] = ((real_t)(elMat_12_9));
             _data_mat[370] = ((real_t)(elMat_12_10));
             _data_mat[371] = ((real_t)(elMat_12_11));
             _data_mat[372] = ((real_t)(elMat_12_12));
             _data_mat[373] = ((real_t)(elMat_12_13));
             _data_mat[374] = ((real_t)(elMat_12_14));
             _data_mat[375] = ((real_t)(elMat_12_15));
             _data_mat[376] = ((real_t)(elMat_12_16));
             _data_mat[377] = ((real_t)(elMat_12_17));
             _data_mat[378] = ((real_t)(elMat_12_18));
             _data_mat[379] = ((real_t)(elMat_12_19));
             _data_mat[380] = ((real_t)(elMat_12_20));
             _data_mat[381] = ((real_t)(elMat_12_21));
             _data_mat[382] = ((real_t)(elMat_12_22));
             _data_mat[383] = ((real_t)(elMat_12_23));
             _data_mat[384] = ((real_t)(elMat_12_24));
             _data_mat[385] = ((real_t)(elMat_12_25));
             _data_mat[386] = ((real_t)(elMat_12_26));
             _data_mat[387] = ((real_t)(elMat_12_27));
             _data_mat[388] = ((real_t)(elMat_12_28));
             _data_mat[389] = ((real_t)(elMat_12_29));
             _data_mat[390] = ((real_t)(elMat_13_0));
             _data_mat[391] = ((real_t)(elMat_13_1));
             _data_mat[392] = ((real_t)(elMat_13_2));
             _data_mat[393] = ((real_t)(elMat_13_3));
             _data_mat[394] = ((real_t)(elMat_13_4));
             _data_mat[395] = ((real_t)(elMat_13_5));
             _data_mat[396] = ((real_t)(elMat_13_6));
             _data_mat[397] = ((real_t)(elMat_13_7));
             _data_mat[398] = ((real_t)(elMat_13_8));
             _data_mat[399] = ((real_t)(elMat_13_9));
             _data_mat[400] = ((real_t)(elMat_13_10));
             _data_mat[401] = ((real_t)(elMat_13_11));
             _data_mat[402] = ((real_t)(elMat_13_12));
             _data_mat[403] = ((real_t)(elMat_13_13));
             _data_mat[404] = ((real_t)(elMat_13_14));
             _data_mat[405] = ((real_t)(elMat_13_15));
             _data_mat[406] = ((real_t)(elMat_13_16));
             _data_mat[407] = ((real_t)(elMat_13_17));
             _data_mat[408] = ((real_t)(elMat_13_18));
             _data_mat[409] = ((real_t)(elMat_13_19));
             _data_mat[410] = ((real_t)(elMat_13_20));
             _data_mat[411] = ((real_t)(elMat_13_21));
             _data_mat[412] = ((real_t)(elMat_13_22));
             _data_mat[413] = ((real_t)(elMat_13_23));
             _data_mat[414] = ((real_t)(elMat_13_24));
             _data_mat[415] = ((real_t)(elMat_13_25));
             _data_mat[416] = ((real_t)(elMat_13_26));
             _data_mat[417] = ((real_t)(elMat_13_27));
             _data_mat[418] = ((real_t)(elMat_13_28));
             _data_mat[419] = ((real_t)(elMat_13_29));
             _data_mat[420] = ((real_t)(elMat_14_0));
             _data_mat[421] = ((real_t)(elMat_14_1));
             _data_mat[422] = ((real_t)(elMat_14_2));
             _data_mat[423] = ((real_t)(elMat_14_3));
             _data_mat[424] = ((real_t)(elMat_14_4));
             _data_mat[425] = ((real_t)(elMat_14_5));
             _data_mat[426] = ((real_t)(elMat_14_6));
             _data_mat[427] = ((real_t)(elMat_14_7));
             _data_mat[428] = ((real_t)(elMat_14_8));
             _data_mat[429] = ((real_t)(elMat_14_9));
             _data_mat[430] = ((real_t)(elMat_14_10));
             _data_mat[431] = ((real_t)(elMat_14_11));
             _data_mat[432] = ((real_t)(elMat_14_12));
             _data_mat[433] = ((real_t)(elMat_14_13));
             _data_mat[434] = ((real_t)(elMat_14_14));
             _data_mat[435] = ((real_t)(elMat_14_15));
             _data_mat[436] = ((real_t)(elMat_14_16));
             _data_mat[437] = ((real_t)(elMat_14_17));
             _data_mat[438] = ((real_t)(elMat_14_18));
             _data_mat[439] = ((real_t)(elMat_14_19));
             _data_mat[440] = ((real_t)(elMat_14_20));
             _data_mat[441] = ((real_t)(elMat_14_21));
             _data_mat[442] = ((real_t)(elMat_14_22));
             _data_mat[443] = ((real_t)(elMat_14_23));
             _data_mat[444] = ((real_t)(elMat_14_24));
             _data_mat[445] = ((real_t)(elMat_14_25));
             _data_mat[446] = ((real_t)(elMat_14_26));
             _data_mat[447] = ((real_t)(elMat_14_27));
             _data_mat[448] = ((real_t)(elMat_14_28));
             _data_mat[449] = ((real_t)(elMat_14_29));
             _data_mat[450] = ((real_t)(elMat_15_0));
             _data_mat[451] = ((real_t)(elMat_15_1));
             _data_mat[452] = ((real_t)(elMat_15_2));
             _data_mat[453] = ((real_t)(elMat_15_3));
             _data_mat[454] = ((real_t)(elMat_15_4));
             _data_mat[455] = ((real_t)(elMat_15_5));
             _data_mat[456] = ((real_t)(elMat_15_6));
             _data_mat[457] = ((real_t)(elMat_15_7));
             _data_mat[458] = ((real_t)(elMat_15_8));
             _data_mat[459] = ((real_t)(elMat_15_9));
             _data_mat[460] = ((real_t)(elMat_15_10));
             _data_mat[461] = ((real_t)(elMat_15_11));
             _data_mat[462] = ((real_t)(elMat_15_12));
             _data_mat[463] = ((real_t)(elMat_15_13));
             _data_mat[464] = ((real_t)(elMat_15_14));
             _data_mat[465] = ((real_t)(elMat_15_15));
             _data_mat[466] = ((real_t)(elMat_15_16));
             _data_mat[467] = ((real_t)(elMat_15_17));
             _data_mat[468] = ((real_t)(elMat_15_18));
             _data_mat[469] = ((real_t)(elMat_15_19));
             _data_mat[470] = ((real_t)(elMat_15_20));
             _data_mat[471] = ((real_t)(elMat_15_21));
             _data_mat[472] = ((real_t)(elMat_15_22));
             _data_mat[473] = ((real_t)(elMat_15_23));
             _data_mat[474] = ((real_t)(elMat_15_24));
             _data_mat[475] = ((real_t)(elMat_15_25));
             _data_mat[476] = ((real_t)(elMat_15_26));
             _data_mat[477] = ((real_t)(elMat_15_27));
             _data_mat[478] = ((real_t)(elMat_15_28));
             _data_mat[479] = ((real_t)(elMat_15_29));
             _data_mat[480] = ((real_t)(elMat_16_0));
             _data_mat[481] = ((real_t)(elMat_16_1));
             _data_mat[482] = ((real_t)(elMat_16_2));
             _data_mat[483] = ((real_t)(elMat_16_3));
             _data_mat[484] = ((real_t)(elMat_16_4));
             _data_mat[485] = ((real_t)(elMat_16_5));
             _data_mat[486] = ((real_t)(elMat_16_6));
             _data_mat[487] = ((real_t)(elMat_16_7));
             _data_mat[488] = ((real_t)(elMat_16_8));
             _data_mat[489] = ((real_t)(elMat_16_9));
             _data_mat[490] = ((real_t)(elMat_16_10));
             _data_mat[491] = ((real_t)(elMat_16_11));
             _data_mat[492] = ((real_t)(elMat_16_12));
             _data_mat[493] = ((real_t)(elMat_16_13));
             _data_mat[494] = ((real_t)(elMat_16_14));
             _data_mat[495] = ((real_t)(elMat_16_15));
             _data_mat[496] = ((real_t)(elMat_16_16));
             _data_mat[497] = ((real_t)(elMat_16_17));
             _data_mat[498] = ((real_t)(elMat_16_18));
             _data_mat[499] = ((real_t)(elMat_16_19));
             _data_mat[500] = ((real_t)(elMat_16_20));
             _data_mat[501] = ((real_t)(elMat_16_21));
             _data_mat[502] = ((real_t)(elMat_16_22));
             _data_mat[503] = ((real_t)(elMat_16_23));
             _data_mat[504] = ((real_t)(elMat_16_24));
             _data_mat[505] = ((real_t)(elMat_16_25));
             _data_mat[506] = ((real_t)(elMat_16_26));
             _data_mat[507] = ((real_t)(elMat_16_27));
             _data_mat[508] = ((real_t)(elMat_16_28));
             _data_mat[509] = ((real_t)(elMat_16_29));
             _data_mat[510] = ((real_t)(elMat_17_0));
             _data_mat[511] = ((real_t)(elMat_17_1));
             _data_mat[512] = ((real_t)(elMat_17_2));
             _data_mat[513] = ((real_t)(elMat_17_3));
             _data_mat[514] = ((real_t)(elMat_17_4));
             _data_mat[515] = ((real_t)(elMat_17_5));
             _data_mat[516] = ((real_t)(elMat_17_6));
             _data_mat[517] = ((real_t)(elMat_17_7));
             _data_mat[518] = ((real_t)(elMat_17_8));
             _data_mat[519] = ((real_t)(elMat_17_9));
             _data_mat[520] = ((real_t)(elMat_17_10));
             _data_mat[521] = ((real_t)(elMat_17_11));
             _data_mat[522] = ((real_t)(elMat_17_12));
             _data_mat[523] = ((real_t)(elMat_17_13));
             _data_mat[524] = ((real_t)(elMat_17_14));
             _data_mat[525] = ((real_t)(elMat_17_15));
             _data_mat[526] = ((real_t)(elMat_17_16));
             _data_mat[527] = ((real_t)(elMat_17_17));
             _data_mat[528] = ((real_t)(elMat_17_18));
             _data_mat[529] = ((real_t)(elMat_17_19));
             _data_mat[530] = ((real_t)(elMat_17_20));
             _data_mat[531] = ((real_t)(elMat_17_21));
             _data_mat[532] = ((real_t)(elMat_17_22));
             _data_mat[533] = ((real_t)(elMat_17_23));
             _data_mat[534] = ((real_t)(elMat_17_24));
             _data_mat[535] = ((real_t)(elMat_17_25));
             _data_mat[536] = ((real_t)(elMat_17_26));
             _data_mat[537] = ((real_t)(elMat_17_27));
             _data_mat[538] = ((real_t)(elMat_17_28));
             _data_mat[539] = ((real_t)(elMat_17_29));
             _data_mat[540] = ((real_t)(elMat_18_0));
             _data_mat[541] = ((real_t)(elMat_18_1));
             _data_mat[542] = ((real_t)(elMat_18_2));
             _data_mat[543] = ((real_t)(elMat_18_3));
             _data_mat[544] = ((real_t)(elMat_18_4));
             _data_mat[545] = ((real_t)(elMat_18_5));
             _data_mat[546] = ((real_t)(elMat_18_6));
             _data_mat[547] = ((real_t)(elMat_18_7));
             _data_mat[548] = ((real_t)(elMat_18_8));
             _data_mat[549] = ((real_t)(elMat_18_9));
             _data_mat[550] = ((real_t)(elMat_18_10));
             _data_mat[551] = ((real_t)(elMat_18_11));
             _data_mat[552] = ((real_t)(elMat_18_12));
             _data_mat[553] = ((real_t)(elMat_18_13));
             _data_mat[554] = ((real_t)(elMat_18_14));
             _data_mat[555] = ((real_t)(elMat_18_15));
             _data_mat[556] = ((real_t)(elMat_18_16));
             _data_mat[557] = ((real_t)(elMat_18_17));
             _data_mat[558] = ((real_t)(elMat_18_18));
             _data_mat[559] = ((real_t)(elMat_18_19));
             _data_mat[560] = ((real_t)(elMat_18_20));
             _data_mat[561] = ((real_t)(elMat_18_21));
             _data_mat[562] = ((real_t)(elMat_18_22));
             _data_mat[563] = ((real_t)(elMat_18_23));
             _data_mat[564] = ((real_t)(elMat_18_24));
             _data_mat[565] = ((real_t)(elMat_18_25));
             _data_mat[566] = ((real_t)(elMat_18_26));
             _data_mat[567] = ((real_t)(elMat_18_27));
             _data_mat[568] = ((real_t)(elMat_18_28));
             _data_mat[569] = ((real_t)(elMat_18_29));
             _data_mat[570] = ((real_t)(elMat_19_0));
             _data_mat[571] = ((real_t)(elMat_19_1));
             _data_mat[572] = ((real_t)(elMat_19_2));
             _data_mat[573] = ((real_t)(elMat_19_3));
             _data_mat[574] = ((real_t)(elMat_19_4));
             _data_mat[575] = ((real_t)(elMat_19_5));
             _data_mat[576] = ((real_t)(elMat_19_6));
             _data_mat[577] = ((real_t)(elMat_19_7));
             _data_mat[578] = ((real_t)(elMat_19_8));
             _data_mat[579] = ((real_t)(elMat_19_9));
             _data_mat[580] = ((real_t)(elMat_19_10));
             _data_mat[581] = ((real_t)(elMat_19_11));
             _data_mat[582] = ((real_t)(elMat_19_12));
             _data_mat[583] = ((real_t)(elMat_19_13));
             _data_mat[584] = ((real_t)(elMat_19_14));
             _data_mat[585] = ((real_t)(elMat_19_15));
             _data_mat[586] = ((real_t)(elMat_19_16));
             _data_mat[587] = ((real_t)(elMat_19_17));
             _data_mat[588] = ((real_t)(elMat_19_18));
             _data_mat[589] = ((real_t)(elMat_19_19));
             _data_mat[590] = ((real_t)(elMat_19_20));
             _data_mat[591] = ((real_t)(elMat_19_21));
             _data_mat[592] = ((real_t)(elMat_19_22));
             _data_mat[593] = ((real_t)(elMat_19_23));
             _data_mat[594] = ((real_t)(elMat_19_24));
             _data_mat[595] = ((real_t)(elMat_19_25));
             _data_mat[596] = ((real_t)(elMat_19_26));
             _data_mat[597] = ((real_t)(elMat_19_27));
             _data_mat[598] = ((real_t)(elMat_19_28));
             _data_mat[599] = ((real_t)(elMat_19_29));
             _data_mat[600] = ((real_t)(elMat_20_0));
             _data_mat[601] = ((real_t)(elMat_20_1));
             _data_mat[602] = ((real_t)(elMat_20_2));
             _data_mat[603] = ((real_t)(elMat_20_3));
             _data_mat[604] = ((real_t)(elMat_20_4));
             _data_mat[605] = ((real_t)(elMat_20_5));
             _data_mat[606] = ((real_t)(elMat_20_6));
             _data_mat[607] = ((real_t)(elMat_20_7));
             _data_mat[608] = ((real_t)(elMat_20_8));
             _data_mat[609] = ((real_t)(elMat_20_9));
             _data_mat[610] = ((real_t)(elMat_20_10));
             _data_mat[611] = ((real_t)(elMat_20_11));
             _data_mat[612] = ((real_t)(elMat_20_12));
             _data_mat[613] = ((real_t)(elMat_20_13));
             _data_mat[614] = ((real_t)(elMat_20_14));
             _data_mat[615] = ((real_t)(elMat_20_15));
             _data_mat[616] = ((real_t)(elMat_20_16));
             _data_mat[617] = ((real_t)(elMat_20_17));
             _data_mat[618] = ((real_t)(elMat_20_18));
             _data_mat[619] = ((real_t)(elMat_20_19));
             _data_mat[620] = ((real_t)(elMat_20_20));
             _data_mat[621] = ((real_t)(elMat_20_21));
             _data_mat[622] = ((real_t)(elMat_20_22));
             _data_mat[623] = ((real_t)(elMat_20_23));
             _data_mat[624] = ((real_t)(elMat_20_24));
             _data_mat[625] = ((real_t)(elMat_20_25));
             _data_mat[626] = ((real_t)(elMat_20_26));
             _data_mat[627] = ((real_t)(elMat_20_27));
             _data_mat[628] = ((real_t)(elMat_20_28));
             _data_mat[629] = ((real_t)(elMat_20_29));
             _data_mat[630] = ((real_t)(elMat_21_0));
             _data_mat[631] = ((real_t)(elMat_21_1));
             _data_mat[632] = ((real_t)(elMat_21_2));
             _data_mat[633] = ((real_t)(elMat_21_3));
             _data_mat[634] = ((real_t)(elMat_21_4));
             _data_mat[635] = ((real_t)(elMat_21_5));
             _data_mat[636] = ((real_t)(elMat_21_6));
             _data_mat[637] = ((real_t)(elMat_21_7));
             _data_mat[638] = ((real_t)(elMat_21_8));
             _data_mat[639] = ((real_t)(elMat_21_9));
             _data_mat[640] = ((real_t)(elMat_21_10));
             _data_mat[641] = ((real_t)(elMat_21_11));
             _data_mat[642] = ((real_t)(elMat_21_12));
             _data_mat[643] = ((real_t)(elMat_21_13));
             _data_mat[644] = ((real_t)(elMat_21_14));
             _data_mat[645] = ((real_t)(elMat_21_15));
             _data_mat[646] = ((real_t)(elMat_21_16));
             _data_mat[647] = ((real_t)(elMat_21_17));
             _data_mat[648] = ((real_t)(elMat_21_18));
             _data_mat[649] = ((real_t)(elMat_21_19));
             _data_mat[650] = ((real_t)(elMat_21_20));
             _data_mat[651] = ((real_t)(elMat_21_21));
             _data_mat[652] = ((real_t)(elMat_21_22));
             _data_mat[653] = ((real_t)(elMat_21_23));
             _data_mat[654] = ((real_t)(elMat_21_24));
             _data_mat[655] = ((real_t)(elMat_21_25));
             _data_mat[656] = ((real_t)(elMat_21_26));
             _data_mat[657] = ((real_t)(elMat_21_27));
             _data_mat[658] = ((real_t)(elMat_21_28));
             _data_mat[659] = ((real_t)(elMat_21_29));
             _data_mat[660] = ((real_t)(elMat_22_0));
             _data_mat[661] = ((real_t)(elMat_22_1));
             _data_mat[662] = ((real_t)(elMat_22_2));
             _data_mat[663] = ((real_t)(elMat_22_3));
             _data_mat[664] = ((real_t)(elMat_22_4));
             _data_mat[665] = ((real_t)(elMat_22_5));
             _data_mat[666] = ((real_t)(elMat_22_6));
             _data_mat[667] = ((real_t)(elMat_22_7));
             _data_mat[668] = ((real_t)(elMat_22_8));
             _data_mat[669] = ((real_t)(elMat_22_9));
             _data_mat[670] = ((real_t)(elMat_22_10));
             _data_mat[671] = ((real_t)(elMat_22_11));
             _data_mat[672] = ((real_t)(elMat_22_12));
             _data_mat[673] = ((real_t)(elMat_22_13));
             _data_mat[674] = ((real_t)(elMat_22_14));
             _data_mat[675] = ((real_t)(elMat_22_15));
             _data_mat[676] = ((real_t)(elMat_22_16));
             _data_mat[677] = ((real_t)(elMat_22_17));
             _data_mat[678] = ((real_t)(elMat_22_18));
             _data_mat[679] = ((real_t)(elMat_22_19));
             _data_mat[680] = ((real_t)(elMat_22_20));
             _data_mat[681] = ((real_t)(elMat_22_21));
             _data_mat[682] = ((real_t)(elMat_22_22));
             _data_mat[683] = ((real_t)(elMat_22_23));
             _data_mat[684] = ((real_t)(elMat_22_24));
             _data_mat[685] = ((real_t)(elMat_22_25));
             _data_mat[686] = ((real_t)(elMat_22_26));
             _data_mat[687] = ((real_t)(elMat_22_27));
             _data_mat[688] = ((real_t)(elMat_22_28));
             _data_mat[689] = ((real_t)(elMat_22_29));
             _data_mat[690] = ((real_t)(elMat_23_0));
             _data_mat[691] = ((real_t)(elMat_23_1));
             _data_mat[692] = ((real_t)(elMat_23_2));
             _data_mat[693] = ((real_t)(elMat_23_3));
             _data_mat[694] = ((real_t)(elMat_23_4));
             _data_mat[695] = ((real_t)(elMat_23_5));
             _data_mat[696] = ((real_t)(elMat_23_6));
             _data_mat[697] = ((real_t)(elMat_23_7));
             _data_mat[698] = ((real_t)(elMat_23_8));
             _data_mat[699] = ((real_t)(elMat_23_9));
             _data_mat[700] = ((real_t)(elMat_23_10));
             _data_mat[701] = ((real_t)(elMat_23_11));
             _data_mat[702] = ((real_t)(elMat_23_12));
             _data_mat[703] = ((real_t)(elMat_23_13));
             _data_mat[704] = ((real_t)(elMat_23_14));
             _data_mat[705] = ((real_t)(elMat_23_15));
             _data_mat[706] = ((real_t)(elMat_23_16));
             _data_mat[707] = ((real_t)(elMat_23_17));
             _data_mat[708] = ((real_t)(elMat_23_18));
             _data_mat[709] = ((real_t)(elMat_23_19));
             _data_mat[710] = ((real_t)(elMat_23_20));
             _data_mat[711] = ((real_t)(elMat_23_21));
             _data_mat[712] = ((real_t)(elMat_23_22));
             _data_mat[713] = ((real_t)(elMat_23_23));
             _data_mat[714] = ((real_t)(elMat_23_24));
             _data_mat[715] = ((real_t)(elMat_23_25));
             _data_mat[716] = ((real_t)(elMat_23_26));
             _data_mat[717] = ((real_t)(elMat_23_27));
             _data_mat[718] = ((real_t)(elMat_23_28));
             _data_mat[719] = ((real_t)(elMat_23_29));
             _data_mat[720] = ((real_t)(elMat_24_0));
             _data_mat[721] = ((real_t)(elMat_24_1));
             _data_mat[722] = ((real_t)(elMat_24_2));
             _data_mat[723] = ((real_t)(elMat_24_3));
             _data_mat[724] = ((real_t)(elMat_24_4));
             _data_mat[725] = ((real_t)(elMat_24_5));
             _data_mat[726] = ((real_t)(elMat_24_6));
             _data_mat[727] = ((real_t)(elMat_24_7));
             _data_mat[728] = ((real_t)(elMat_24_8));
             _data_mat[729] = ((real_t)(elMat_24_9));
             _data_mat[730] = ((real_t)(elMat_24_10));
             _data_mat[731] = ((real_t)(elMat_24_11));
             _data_mat[732] = ((real_t)(elMat_24_12));
             _data_mat[733] = ((real_t)(elMat_24_13));
             _data_mat[734] = ((real_t)(elMat_24_14));
             _data_mat[735] = ((real_t)(elMat_24_15));
             _data_mat[736] = ((real_t)(elMat_24_16));
             _data_mat[737] = ((real_t)(elMat_24_17));
             _data_mat[738] = ((real_t)(elMat_24_18));
             _data_mat[739] = ((real_t)(elMat_24_19));
             _data_mat[740] = ((real_t)(elMat_24_20));
             _data_mat[741] = ((real_t)(elMat_24_21));
             _data_mat[742] = ((real_t)(elMat_24_22));
             _data_mat[743] = ((real_t)(elMat_24_23));
             _data_mat[744] = ((real_t)(elMat_24_24));
             _data_mat[745] = ((real_t)(elMat_24_25));
             _data_mat[746] = ((real_t)(elMat_24_26));
             _data_mat[747] = ((real_t)(elMat_24_27));
             _data_mat[748] = ((real_t)(elMat_24_28));
             _data_mat[749] = ((real_t)(elMat_24_29));
             _data_mat[750] = ((real_t)(elMat_25_0));
             _data_mat[751] = ((real_t)(elMat_25_1));
             _data_mat[752] = ((real_t)(elMat_25_2));
             _data_mat[753] = ((real_t)(elMat_25_3));
             _data_mat[754] = ((real_t)(elMat_25_4));
             _data_mat[755] = ((real_t)(elMat_25_5));
             _data_mat[756] = ((real_t)(elMat_25_6));
             _data_mat[757] = ((real_t)(elMat_25_7));
             _data_mat[758] = ((real_t)(elMat_25_8));
             _data_mat[759] = ((real_t)(elMat_25_9));
             _data_mat[760] = ((real_t)(elMat_25_10));
             _data_mat[761] = ((real_t)(elMat_25_11));
             _data_mat[762] = ((real_t)(elMat_25_12));
             _data_mat[763] = ((real_t)(elMat_25_13));
             _data_mat[764] = ((real_t)(elMat_25_14));
             _data_mat[765] = ((real_t)(elMat_25_15));
             _data_mat[766] = ((real_t)(elMat_25_16));
             _data_mat[767] = ((real_t)(elMat_25_17));
             _data_mat[768] = ((real_t)(elMat_25_18));
             _data_mat[769] = ((real_t)(elMat_25_19));
             _data_mat[770] = ((real_t)(elMat_25_20));
             _data_mat[771] = ((real_t)(elMat_25_21));
             _data_mat[772] = ((real_t)(elMat_25_22));
             _data_mat[773] = ((real_t)(elMat_25_23));
             _data_mat[774] = ((real_t)(elMat_25_24));
             _data_mat[775] = ((real_t)(elMat_25_25));
             _data_mat[776] = ((real_t)(elMat_25_26));
             _data_mat[777] = ((real_t)(elMat_25_27));
             _data_mat[778] = ((real_t)(elMat_25_28));
             _data_mat[779] = ((real_t)(elMat_25_29));
             _data_mat[780] = ((real_t)(elMat_26_0));
             _data_mat[781] = ((real_t)(elMat_26_1));
             _data_mat[782] = ((real_t)(elMat_26_2));
             _data_mat[783] = ((real_t)(elMat_26_3));
             _data_mat[784] = ((real_t)(elMat_26_4));
             _data_mat[785] = ((real_t)(elMat_26_5));
             _data_mat[786] = ((real_t)(elMat_26_6));
             _data_mat[787] = ((real_t)(elMat_26_7));
             _data_mat[788] = ((real_t)(elMat_26_8));
             _data_mat[789] = ((real_t)(elMat_26_9));
             _data_mat[790] = ((real_t)(elMat_26_10));
             _data_mat[791] = ((real_t)(elMat_26_11));
             _data_mat[792] = ((real_t)(elMat_26_12));
             _data_mat[793] = ((real_t)(elMat_26_13));
             _data_mat[794] = ((real_t)(elMat_26_14));
             _data_mat[795] = ((real_t)(elMat_26_15));
             _data_mat[796] = ((real_t)(elMat_26_16));
             _data_mat[797] = ((real_t)(elMat_26_17));
             _data_mat[798] = ((real_t)(elMat_26_18));
             _data_mat[799] = ((real_t)(elMat_26_19));
             _data_mat[800] = ((real_t)(elMat_26_20));
             _data_mat[801] = ((real_t)(elMat_26_21));
             _data_mat[802] = ((real_t)(elMat_26_22));
             _data_mat[803] = ((real_t)(elMat_26_23));
             _data_mat[804] = ((real_t)(elMat_26_24));
             _data_mat[805] = ((real_t)(elMat_26_25));
             _data_mat[806] = ((real_t)(elMat_26_26));
             _data_mat[807] = ((real_t)(elMat_26_27));
             _data_mat[808] = ((real_t)(elMat_26_28));
             _data_mat[809] = ((real_t)(elMat_26_29));
             _data_mat[810] = ((real_t)(elMat_27_0));
             _data_mat[811] = ((real_t)(elMat_27_1));
             _data_mat[812] = ((real_t)(elMat_27_2));
             _data_mat[813] = ((real_t)(elMat_27_3));
             _data_mat[814] = ((real_t)(elMat_27_4));
             _data_mat[815] = ((real_t)(elMat_27_5));
             _data_mat[816] = ((real_t)(elMat_27_6));
             _data_mat[817] = ((real_t)(elMat_27_7));
             _data_mat[818] = ((real_t)(elMat_27_8));
             _data_mat[819] = ((real_t)(elMat_27_9));
             _data_mat[820] = ((real_t)(elMat_27_10));
             _data_mat[821] = ((real_t)(elMat_27_11));
             _data_mat[822] = ((real_t)(elMat_27_12));
             _data_mat[823] = ((real_t)(elMat_27_13));
             _data_mat[824] = ((real_t)(elMat_27_14));
             _data_mat[825] = ((real_t)(elMat_27_15));
             _data_mat[826] = ((real_t)(elMat_27_16));
             _data_mat[827] = ((real_t)(elMat_27_17));
             _data_mat[828] = ((real_t)(elMat_27_18));
             _data_mat[829] = ((real_t)(elMat_27_19));
             _data_mat[830] = ((real_t)(elMat_27_20));
             _data_mat[831] = ((real_t)(elMat_27_21));
             _data_mat[832] = ((real_t)(elMat_27_22));
             _data_mat[833] = ((real_t)(elMat_27_23));
             _data_mat[834] = ((real_t)(elMat_27_24));
             _data_mat[835] = ((real_t)(elMat_27_25));
             _data_mat[836] = ((real_t)(elMat_27_26));
             _data_mat[837] = ((real_t)(elMat_27_27));
             _data_mat[838] = ((real_t)(elMat_27_28));
             _data_mat[839] = ((real_t)(elMat_27_29));
             _data_mat[840] = ((real_t)(elMat_28_0));
             _data_mat[841] = ((real_t)(elMat_28_1));
             _data_mat[842] = ((real_t)(elMat_28_2));
             _data_mat[843] = ((real_t)(elMat_28_3));
             _data_mat[844] = ((real_t)(elMat_28_4));
             _data_mat[845] = ((real_t)(elMat_28_5));
             _data_mat[846] = ((real_t)(elMat_28_6));
             _data_mat[847] = ((real_t)(elMat_28_7));
             _data_mat[848] = ((real_t)(elMat_28_8));
             _data_mat[849] = ((real_t)(elMat_28_9));
             _data_mat[850] = ((real_t)(elMat_28_10));
             _data_mat[851] = ((real_t)(elMat_28_11));
             _data_mat[852] = ((real_t)(elMat_28_12));
             _data_mat[853] = ((real_t)(elMat_28_13));
             _data_mat[854] = ((real_t)(elMat_28_14));
             _data_mat[855] = ((real_t)(elMat_28_15));
             _data_mat[856] = ((real_t)(elMat_28_16));
             _data_mat[857] = ((real_t)(elMat_28_17));
             _data_mat[858] = ((real_t)(elMat_28_18));
             _data_mat[859] = ((real_t)(elMat_28_19));
             _data_mat[860] = ((real_t)(elMat_28_20));
             _data_mat[861] = ((real_t)(elMat_28_21));
             _data_mat[862] = ((real_t)(elMat_28_22));
             _data_mat[863] = ((real_t)(elMat_28_23));
             _data_mat[864] = ((real_t)(elMat_28_24));
             _data_mat[865] = ((real_t)(elMat_28_25));
             _data_mat[866] = ((real_t)(elMat_28_26));
             _data_mat[867] = ((real_t)(elMat_28_27));
             _data_mat[868] = ((real_t)(elMat_28_28));
             _data_mat[869] = ((real_t)(elMat_28_29));
             _data_mat[870] = ((real_t)(elMat_29_0));
             _data_mat[871] = ((real_t)(elMat_29_1));
             _data_mat[872] = ((real_t)(elMat_29_2));
             _data_mat[873] = ((real_t)(elMat_29_3));
             _data_mat[874] = ((real_t)(elMat_29_4));
             _data_mat[875] = ((real_t)(elMat_29_5));
             _data_mat[876] = ((real_t)(elMat_29_6));
             _data_mat[877] = ((real_t)(elMat_29_7));
             _data_mat[878] = ((real_t)(elMat_29_8));
             _data_mat[879] = ((real_t)(elMat_29_9));
             _data_mat[880] = ((real_t)(elMat_29_10));
             _data_mat[881] = ((real_t)(elMat_29_11));
             _data_mat[882] = ((real_t)(elMat_29_12));
             _data_mat[883] = ((real_t)(elMat_29_13));
             _data_mat[884] = ((real_t)(elMat_29_14));
             _data_mat[885] = ((real_t)(elMat_29_15));
             _data_mat[886] = ((real_t)(elMat_29_16));
             _data_mat[887] = ((real_t)(elMat_29_17));
             _data_mat[888] = ((real_t)(elMat_29_18));
             _data_mat[889] = ((real_t)(elMat_29_19));
             _data_mat[890] = ((real_t)(elMat_29_20));
             _data_mat[891] = ((real_t)(elMat_29_21));
             _data_mat[892] = ((real_t)(elMat_29_22));
             _data_mat[893] = ((real_t)(elMat_29_23));
             _data_mat[894] = ((real_t)(elMat_29_24));
             _data_mat[895] = ((real_t)(elMat_29_25));
             _data_mat[896] = ((real_t)(elMat_29_26));
             _data_mat[897] = ((real_t)(elMat_29_27));
             _data_mat[898] = ((real_t)(elMat_29_28));
             _data_mat[899] = ((real_t)(elMat_29_29));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge - 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 2)*(micro_edges_per_macro_edge - 1)) / (6)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 2)*(-ctr_2 + micro_edges_per_macro_edge - 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_WHITE_DOWN[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_0_12 = q_acc_0_12;
             const real_t elMat_0_13 = q_acc_0_13;
             const real_t elMat_0_14 = q_acc_0_14;
             const real_t elMat_0_15 = q_acc_0_15;
             const real_t elMat_0_16 = q_acc_0_16;
             const real_t elMat_0_17 = q_acc_0_17;
             const real_t elMat_0_18 = q_acc_0_18;
             const real_t elMat_0_19 = q_acc_0_19;
             const real_t elMat_0_20 = q_acc_0_20;
             const real_t elMat_0_21 = q_acc_0_21;
             const real_t elMat_0_22 = q_acc_0_22;
             const real_t elMat_0_23 = q_acc_0_23;
             const real_t elMat_0_24 = q_acc_0_24;
             const real_t elMat_0_25 = q_acc_0_25;
             const real_t elMat_0_26 = q_acc_0_26;
             const real_t elMat_0_27 = q_acc_0_27;
             const real_t elMat_0_28 = q_acc_0_28;
             const real_t elMat_0_29 = q_acc_0_29;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_1_12 = q_acc_1_12;
             const real_t elMat_1_13 = q_acc_1_13;
             const real_t elMat_1_14 = q_acc_1_14;
             const real_t elMat_1_15 = q_acc_1_15;
             const real_t elMat_1_16 = q_acc_1_16;
             const real_t elMat_1_17 = q_acc_1_17;
             const real_t elMat_1_18 = q_acc_1_18;
             const real_t elMat_1_19 = q_acc_1_19;
             const real_t elMat_1_20 = q_acc_1_20;
             const real_t elMat_1_21 = q_acc_1_21;
             const real_t elMat_1_22 = q_acc_1_22;
             const real_t elMat_1_23 = q_acc_1_23;
             const real_t elMat_1_24 = q_acc_1_24;
             const real_t elMat_1_25 = q_acc_1_25;
             const real_t elMat_1_26 = q_acc_1_26;
             const real_t elMat_1_27 = q_acc_1_27;
             const real_t elMat_1_28 = q_acc_1_28;
             const real_t elMat_1_29 = q_acc_1_29;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_2_12 = q_acc_2_12;
             const real_t elMat_2_13 = q_acc_2_13;
             const real_t elMat_2_14 = q_acc_2_14;
             const real_t elMat_2_15 = q_acc_2_15;
             const real_t elMat_2_16 = q_acc_2_16;
             const real_t elMat_2_17 = q_acc_2_17;
             const real_t elMat_2_18 = q_acc_2_18;
             const real_t elMat_2_19 = q_acc_2_19;
             const real_t elMat_2_20 = q_acc_2_20;
             const real_t elMat_2_21 = q_acc_2_21;
             const real_t elMat_2_22 = q_acc_2_22;
             const real_t elMat_2_23 = q_acc_2_23;
             const real_t elMat_2_24 = q_acc_2_24;
             const real_t elMat_2_25 = q_acc_2_25;
             const real_t elMat_2_26 = q_acc_2_26;
             const real_t elMat_2_27 = q_acc_2_27;
             const real_t elMat_2_28 = q_acc_2_28;
             const real_t elMat_2_29 = q_acc_2_29;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_3_12 = q_acc_3_12;
             const real_t elMat_3_13 = q_acc_3_13;
             const real_t elMat_3_14 = q_acc_3_14;
             const real_t elMat_3_15 = q_acc_3_15;
             const real_t elMat_3_16 = q_acc_3_16;
             const real_t elMat_3_17 = q_acc_3_17;
             const real_t elMat_3_18 = q_acc_3_18;
             const real_t elMat_3_19 = q_acc_3_19;
             const real_t elMat_3_20 = q_acc_3_20;
             const real_t elMat_3_21 = q_acc_3_21;
             const real_t elMat_3_22 = q_acc_3_22;
             const real_t elMat_3_23 = q_acc_3_23;
             const real_t elMat_3_24 = q_acc_3_24;
             const real_t elMat_3_25 = q_acc_3_25;
             const real_t elMat_3_26 = q_acc_3_26;
             const real_t elMat_3_27 = q_acc_3_27;
             const real_t elMat_3_28 = q_acc_3_28;
             const real_t elMat_3_29 = q_acc_3_29;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_4_12 = q_acc_4_12;
             const real_t elMat_4_13 = q_acc_4_13;
             const real_t elMat_4_14 = q_acc_4_14;
             const real_t elMat_4_15 = q_acc_4_15;
             const real_t elMat_4_16 = q_acc_4_16;
             const real_t elMat_4_17 = q_acc_4_17;
             const real_t elMat_4_18 = q_acc_4_18;
             const real_t elMat_4_19 = q_acc_4_19;
             const real_t elMat_4_20 = q_acc_4_20;
             const real_t elMat_4_21 = q_acc_4_21;
             const real_t elMat_4_22 = q_acc_4_22;
             const real_t elMat_4_23 = q_acc_4_23;
             const real_t elMat_4_24 = q_acc_4_24;
             const real_t elMat_4_25 = q_acc_4_25;
             const real_t elMat_4_26 = q_acc_4_26;
             const real_t elMat_4_27 = q_acc_4_27;
             const real_t elMat_4_28 = q_acc_4_28;
             const real_t elMat_4_29 = q_acc_4_29;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_5_12 = q_acc_5_12;
             const real_t elMat_5_13 = q_acc_5_13;
             const real_t elMat_5_14 = q_acc_5_14;
             const real_t elMat_5_15 = q_acc_5_15;
             const real_t elMat_5_16 = q_acc_5_16;
             const real_t elMat_5_17 = q_acc_5_17;
             const real_t elMat_5_18 = q_acc_5_18;
             const real_t elMat_5_19 = q_acc_5_19;
             const real_t elMat_5_20 = q_acc_5_20;
             const real_t elMat_5_21 = q_acc_5_21;
             const real_t elMat_5_22 = q_acc_5_22;
             const real_t elMat_5_23 = q_acc_5_23;
             const real_t elMat_5_24 = q_acc_5_24;
             const real_t elMat_5_25 = q_acc_5_25;
             const real_t elMat_5_26 = q_acc_5_26;
             const real_t elMat_5_27 = q_acc_5_27;
             const real_t elMat_5_28 = q_acc_5_28;
             const real_t elMat_5_29 = q_acc_5_29;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_6_12 = q_acc_6_12;
             const real_t elMat_6_13 = q_acc_6_13;
             const real_t elMat_6_14 = q_acc_6_14;
             const real_t elMat_6_15 = q_acc_6_15;
             const real_t elMat_6_16 = q_acc_6_16;
             const real_t elMat_6_17 = q_acc_6_17;
             const real_t elMat_6_18 = q_acc_6_18;
             const real_t elMat_6_19 = q_acc_6_19;
             const real_t elMat_6_20 = q_acc_6_20;
             const real_t elMat_6_21 = q_acc_6_21;
             const real_t elMat_6_22 = q_acc_6_22;
             const real_t elMat_6_23 = q_acc_6_23;
             const real_t elMat_6_24 = q_acc_6_24;
             const real_t elMat_6_25 = q_acc_6_25;
             const real_t elMat_6_26 = q_acc_6_26;
             const real_t elMat_6_27 = q_acc_6_27;
             const real_t elMat_6_28 = q_acc_6_28;
             const real_t elMat_6_29 = q_acc_6_29;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_7_12 = q_acc_7_12;
             const real_t elMat_7_13 = q_acc_7_13;
             const real_t elMat_7_14 = q_acc_7_14;
             const real_t elMat_7_15 = q_acc_7_15;
             const real_t elMat_7_16 = q_acc_7_16;
             const real_t elMat_7_17 = q_acc_7_17;
             const real_t elMat_7_18 = q_acc_7_18;
             const real_t elMat_7_19 = q_acc_7_19;
             const real_t elMat_7_20 = q_acc_7_20;
             const real_t elMat_7_21 = q_acc_7_21;
             const real_t elMat_7_22 = q_acc_7_22;
             const real_t elMat_7_23 = q_acc_7_23;
             const real_t elMat_7_24 = q_acc_7_24;
             const real_t elMat_7_25 = q_acc_7_25;
             const real_t elMat_7_26 = q_acc_7_26;
             const real_t elMat_7_27 = q_acc_7_27;
             const real_t elMat_7_28 = q_acc_7_28;
             const real_t elMat_7_29 = q_acc_7_29;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_8_12 = q_acc_8_12;
             const real_t elMat_8_13 = q_acc_8_13;
             const real_t elMat_8_14 = q_acc_8_14;
             const real_t elMat_8_15 = q_acc_8_15;
             const real_t elMat_8_16 = q_acc_8_16;
             const real_t elMat_8_17 = q_acc_8_17;
             const real_t elMat_8_18 = q_acc_8_18;
             const real_t elMat_8_19 = q_acc_8_19;
             const real_t elMat_8_20 = q_acc_8_20;
             const real_t elMat_8_21 = q_acc_8_21;
             const real_t elMat_8_22 = q_acc_8_22;
             const real_t elMat_8_23 = q_acc_8_23;
             const real_t elMat_8_24 = q_acc_8_24;
             const real_t elMat_8_25 = q_acc_8_25;
             const real_t elMat_8_26 = q_acc_8_26;
             const real_t elMat_8_27 = q_acc_8_27;
             const real_t elMat_8_28 = q_acc_8_28;
             const real_t elMat_8_29 = q_acc_8_29;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_9_12 = q_acc_9_12;
             const real_t elMat_9_13 = q_acc_9_13;
             const real_t elMat_9_14 = q_acc_9_14;
             const real_t elMat_9_15 = q_acc_9_15;
             const real_t elMat_9_16 = q_acc_9_16;
             const real_t elMat_9_17 = q_acc_9_17;
             const real_t elMat_9_18 = q_acc_9_18;
             const real_t elMat_9_19 = q_acc_9_19;
             const real_t elMat_9_20 = q_acc_9_20;
             const real_t elMat_9_21 = q_acc_9_21;
             const real_t elMat_9_22 = q_acc_9_22;
             const real_t elMat_9_23 = q_acc_9_23;
             const real_t elMat_9_24 = q_acc_9_24;
             const real_t elMat_9_25 = q_acc_9_25;
             const real_t elMat_9_26 = q_acc_9_26;
             const real_t elMat_9_27 = q_acc_9_27;
             const real_t elMat_9_28 = q_acc_9_28;
             const real_t elMat_9_29 = q_acc_9_29;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_10_12 = q_acc_10_12;
             const real_t elMat_10_13 = q_acc_10_13;
             const real_t elMat_10_14 = q_acc_10_14;
             const real_t elMat_10_15 = q_acc_10_15;
             const real_t elMat_10_16 = q_acc_10_16;
             const real_t elMat_10_17 = q_acc_10_17;
             const real_t elMat_10_18 = q_acc_10_18;
             const real_t elMat_10_19 = q_acc_10_19;
             const real_t elMat_10_20 = q_acc_10_20;
             const real_t elMat_10_21 = q_acc_10_21;
             const real_t elMat_10_22 = q_acc_10_22;
             const real_t elMat_10_23 = q_acc_10_23;
             const real_t elMat_10_24 = q_acc_10_24;
             const real_t elMat_10_25 = q_acc_10_25;
             const real_t elMat_10_26 = q_acc_10_26;
             const real_t elMat_10_27 = q_acc_10_27;
             const real_t elMat_10_28 = q_acc_10_28;
             const real_t elMat_10_29 = q_acc_10_29;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
             const real_t elMat_11_12 = q_acc_11_12;
             const real_t elMat_11_13 = q_acc_11_13;
             const real_t elMat_11_14 = q_acc_11_14;
             const real_t elMat_11_15 = q_acc_11_15;
             const real_t elMat_11_16 = q_acc_11_16;
             const real_t elMat_11_17 = q_acc_11_17;
             const real_t elMat_11_18 = q_acc_11_18;
             const real_t elMat_11_19 = q_acc_11_19;
             const real_t elMat_11_20 = q_acc_11_20;
             const real_t elMat_11_21 = q_acc_11_21;
             const real_t elMat_11_22 = q_acc_11_22;
             const real_t elMat_11_23 = q_acc_11_23;
             const real_t elMat_11_24 = q_acc_11_24;
             const real_t elMat_11_25 = q_acc_11_25;
             const real_t elMat_11_26 = q_acc_11_26;
             const real_t elMat_11_27 = q_acc_11_27;
             const real_t elMat_11_28 = q_acc_11_28;
             const real_t elMat_11_29 = q_acc_11_29;
             const real_t elMat_12_0 = q_acc_0_12;
             const real_t elMat_12_1 = q_acc_1_12;
             const real_t elMat_12_2 = q_acc_2_12;
             const real_t elMat_12_3 = q_acc_3_12;
             const real_t elMat_12_4 = q_acc_4_12;
             const real_t elMat_12_5 = q_acc_5_12;
             const real_t elMat_12_6 = q_acc_6_12;
             const real_t elMat_12_7 = q_acc_7_12;
             const real_t elMat_12_8 = q_acc_8_12;
             const real_t elMat_12_9 = q_acc_9_12;
             const real_t elMat_12_10 = q_acc_10_12;
             const real_t elMat_12_11 = q_acc_11_12;
             const real_t elMat_12_12 = q_acc_12_12;
             const real_t elMat_12_13 = q_acc_12_13;
             const real_t elMat_12_14 = q_acc_12_14;
             const real_t elMat_12_15 = q_acc_12_15;
             const real_t elMat_12_16 = q_acc_12_16;
             const real_t elMat_12_17 = q_acc_12_17;
             const real_t elMat_12_18 = q_acc_12_18;
             const real_t elMat_12_19 = q_acc_12_19;
             const real_t elMat_12_20 = q_acc_12_20;
             const real_t elMat_12_21 = q_acc_12_21;
             const real_t elMat_12_22 = q_acc_12_22;
             const real_t elMat_12_23 = q_acc_12_23;
             const real_t elMat_12_24 = q_acc_12_24;
             const real_t elMat_12_25 = q_acc_12_25;
             const real_t elMat_12_26 = q_acc_12_26;
             const real_t elMat_12_27 = q_acc_12_27;
             const real_t elMat_12_28 = q_acc_12_28;
             const real_t elMat_12_29 = q_acc_12_29;
             const real_t elMat_13_0 = q_acc_0_13;
             const real_t elMat_13_1 = q_acc_1_13;
             const real_t elMat_13_2 = q_acc_2_13;
             const real_t elMat_13_3 = q_acc_3_13;
             const real_t elMat_13_4 = q_acc_4_13;
             const real_t elMat_13_5 = q_acc_5_13;
             const real_t elMat_13_6 = q_acc_6_13;
             const real_t elMat_13_7 = q_acc_7_13;
             const real_t elMat_13_8 = q_acc_8_13;
             const real_t elMat_13_9 = q_acc_9_13;
             const real_t elMat_13_10 = q_acc_10_13;
             const real_t elMat_13_11 = q_acc_11_13;
             const real_t elMat_13_12 = q_acc_12_13;
             const real_t elMat_13_13 = q_acc_13_13;
             const real_t elMat_13_14 = q_acc_13_14;
             const real_t elMat_13_15 = q_acc_13_15;
             const real_t elMat_13_16 = q_acc_13_16;
             const real_t elMat_13_17 = q_acc_13_17;
             const real_t elMat_13_18 = q_acc_13_18;
             const real_t elMat_13_19 = q_acc_13_19;
             const real_t elMat_13_20 = q_acc_13_20;
             const real_t elMat_13_21 = q_acc_13_21;
             const real_t elMat_13_22 = q_acc_13_22;
             const real_t elMat_13_23 = q_acc_13_23;
             const real_t elMat_13_24 = q_acc_13_24;
             const real_t elMat_13_25 = q_acc_13_25;
             const real_t elMat_13_26 = q_acc_13_26;
             const real_t elMat_13_27 = q_acc_13_27;
             const real_t elMat_13_28 = q_acc_13_28;
             const real_t elMat_13_29 = q_acc_13_29;
             const real_t elMat_14_0 = q_acc_0_14;
             const real_t elMat_14_1 = q_acc_1_14;
             const real_t elMat_14_2 = q_acc_2_14;
             const real_t elMat_14_3 = q_acc_3_14;
             const real_t elMat_14_4 = q_acc_4_14;
             const real_t elMat_14_5 = q_acc_5_14;
             const real_t elMat_14_6 = q_acc_6_14;
             const real_t elMat_14_7 = q_acc_7_14;
             const real_t elMat_14_8 = q_acc_8_14;
             const real_t elMat_14_9 = q_acc_9_14;
             const real_t elMat_14_10 = q_acc_10_14;
             const real_t elMat_14_11 = q_acc_11_14;
             const real_t elMat_14_12 = q_acc_12_14;
             const real_t elMat_14_13 = q_acc_13_14;
             const real_t elMat_14_14 = q_acc_14_14;
             const real_t elMat_14_15 = q_acc_14_15;
             const real_t elMat_14_16 = q_acc_14_16;
             const real_t elMat_14_17 = q_acc_14_17;
             const real_t elMat_14_18 = q_acc_14_18;
             const real_t elMat_14_19 = q_acc_14_19;
             const real_t elMat_14_20 = q_acc_14_20;
             const real_t elMat_14_21 = q_acc_14_21;
             const real_t elMat_14_22 = q_acc_14_22;
             const real_t elMat_14_23 = q_acc_14_23;
             const real_t elMat_14_24 = q_acc_14_24;
             const real_t elMat_14_25 = q_acc_14_25;
             const real_t elMat_14_26 = q_acc_14_26;
             const real_t elMat_14_27 = q_acc_14_27;
             const real_t elMat_14_28 = q_acc_14_28;
             const real_t elMat_14_29 = q_acc_14_29;
             const real_t elMat_15_0 = q_acc_0_15;
             const real_t elMat_15_1 = q_acc_1_15;
             const real_t elMat_15_2 = q_acc_2_15;
             const real_t elMat_15_3 = q_acc_3_15;
             const real_t elMat_15_4 = q_acc_4_15;
             const real_t elMat_15_5 = q_acc_5_15;
             const real_t elMat_15_6 = q_acc_6_15;
             const real_t elMat_15_7 = q_acc_7_15;
             const real_t elMat_15_8 = q_acc_8_15;
             const real_t elMat_15_9 = q_acc_9_15;
             const real_t elMat_15_10 = q_acc_10_15;
             const real_t elMat_15_11 = q_acc_11_15;
             const real_t elMat_15_12 = q_acc_12_15;
             const real_t elMat_15_13 = q_acc_13_15;
             const real_t elMat_15_14 = q_acc_14_15;
             const real_t elMat_15_15 = q_acc_15_15;
             const real_t elMat_15_16 = q_acc_15_16;
             const real_t elMat_15_17 = q_acc_15_17;
             const real_t elMat_15_18 = q_acc_15_18;
             const real_t elMat_15_19 = q_acc_15_19;
             const real_t elMat_15_20 = q_acc_15_20;
             const real_t elMat_15_21 = q_acc_15_21;
             const real_t elMat_15_22 = q_acc_15_22;
             const real_t elMat_15_23 = q_acc_15_23;
             const real_t elMat_15_24 = q_acc_15_24;
             const real_t elMat_15_25 = q_acc_15_25;
             const real_t elMat_15_26 = q_acc_15_26;
             const real_t elMat_15_27 = q_acc_15_27;
             const real_t elMat_15_28 = q_acc_15_28;
             const real_t elMat_15_29 = q_acc_15_29;
             const real_t elMat_16_0 = q_acc_0_16;
             const real_t elMat_16_1 = q_acc_1_16;
             const real_t elMat_16_2 = q_acc_2_16;
             const real_t elMat_16_3 = q_acc_3_16;
             const real_t elMat_16_4 = q_acc_4_16;
             const real_t elMat_16_5 = q_acc_5_16;
             const real_t elMat_16_6 = q_acc_6_16;
             const real_t elMat_16_7 = q_acc_7_16;
             const real_t elMat_16_8 = q_acc_8_16;
             const real_t elMat_16_9 = q_acc_9_16;
             const real_t elMat_16_10 = q_acc_10_16;
             const real_t elMat_16_11 = q_acc_11_16;
             const real_t elMat_16_12 = q_acc_12_16;
             const real_t elMat_16_13 = q_acc_13_16;
             const real_t elMat_16_14 = q_acc_14_16;
             const real_t elMat_16_15 = q_acc_15_16;
             const real_t elMat_16_16 = q_acc_16_16;
             const real_t elMat_16_17 = q_acc_16_17;
             const real_t elMat_16_18 = q_acc_16_18;
             const real_t elMat_16_19 = q_acc_16_19;
             const real_t elMat_16_20 = q_acc_16_20;
             const real_t elMat_16_21 = q_acc_16_21;
             const real_t elMat_16_22 = q_acc_16_22;
             const real_t elMat_16_23 = q_acc_16_23;
             const real_t elMat_16_24 = q_acc_16_24;
             const real_t elMat_16_25 = q_acc_16_25;
             const real_t elMat_16_26 = q_acc_16_26;
             const real_t elMat_16_27 = q_acc_16_27;
             const real_t elMat_16_28 = q_acc_16_28;
             const real_t elMat_16_29 = q_acc_16_29;
             const real_t elMat_17_0 = q_acc_0_17;
             const real_t elMat_17_1 = q_acc_1_17;
             const real_t elMat_17_2 = q_acc_2_17;
             const real_t elMat_17_3 = q_acc_3_17;
             const real_t elMat_17_4 = q_acc_4_17;
             const real_t elMat_17_5 = q_acc_5_17;
             const real_t elMat_17_6 = q_acc_6_17;
             const real_t elMat_17_7 = q_acc_7_17;
             const real_t elMat_17_8 = q_acc_8_17;
             const real_t elMat_17_9 = q_acc_9_17;
             const real_t elMat_17_10 = q_acc_10_17;
             const real_t elMat_17_11 = q_acc_11_17;
             const real_t elMat_17_12 = q_acc_12_17;
             const real_t elMat_17_13 = q_acc_13_17;
             const real_t elMat_17_14 = q_acc_14_17;
             const real_t elMat_17_15 = q_acc_15_17;
             const real_t elMat_17_16 = q_acc_16_17;
             const real_t elMat_17_17 = q_acc_17_17;
             const real_t elMat_17_18 = q_acc_17_18;
             const real_t elMat_17_19 = q_acc_17_19;
             const real_t elMat_17_20 = q_acc_17_20;
             const real_t elMat_17_21 = q_acc_17_21;
             const real_t elMat_17_22 = q_acc_17_22;
             const real_t elMat_17_23 = q_acc_17_23;
             const real_t elMat_17_24 = q_acc_17_24;
             const real_t elMat_17_25 = q_acc_17_25;
             const real_t elMat_17_26 = q_acc_17_26;
             const real_t elMat_17_27 = q_acc_17_27;
             const real_t elMat_17_28 = q_acc_17_28;
             const real_t elMat_17_29 = q_acc_17_29;
             const real_t elMat_18_0 = q_acc_0_18;
             const real_t elMat_18_1 = q_acc_1_18;
             const real_t elMat_18_2 = q_acc_2_18;
             const real_t elMat_18_3 = q_acc_3_18;
             const real_t elMat_18_4 = q_acc_4_18;
             const real_t elMat_18_5 = q_acc_5_18;
             const real_t elMat_18_6 = q_acc_6_18;
             const real_t elMat_18_7 = q_acc_7_18;
             const real_t elMat_18_8 = q_acc_8_18;
             const real_t elMat_18_9 = q_acc_9_18;
             const real_t elMat_18_10 = q_acc_10_18;
             const real_t elMat_18_11 = q_acc_11_18;
             const real_t elMat_18_12 = q_acc_12_18;
             const real_t elMat_18_13 = q_acc_13_18;
             const real_t elMat_18_14 = q_acc_14_18;
             const real_t elMat_18_15 = q_acc_15_18;
             const real_t elMat_18_16 = q_acc_16_18;
             const real_t elMat_18_17 = q_acc_17_18;
             const real_t elMat_18_18 = q_acc_18_18;
             const real_t elMat_18_19 = q_acc_18_19;
             const real_t elMat_18_20 = q_acc_18_20;
             const real_t elMat_18_21 = q_acc_18_21;
             const real_t elMat_18_22 = q_acc_18_22;
             const real_t elMat_18_23 = q_acc_18_23;
             const real_t elMat_18_24 = q_acc_18_24;
             const real_t elMat_18_25 = q_acc_18_25;
             const real_t elMat_18_26 = q_acc_18_26;
             const real_t elMat_18_27 = q_acc_18_27;
             const real_t elMat_18_28 = q_acc_18_28;
             const real_t elMat_18_29 = q_acc_18_29;
             const real_t elMat_19_0 = q_acc_0_19;
             const real_t elMat_19_1 = q_acc_1_19;
             const real_t elMat_19_2 = q_acc_2_19;
             const real_t elMat_19_3 = q_acc_3_19;
             const real_t elMat_19_4 = q_acc_4_19;
             const real_t elMat_19_5 = q_acc_5_19;
             const real_t elMat_19_6 = q_acc_6_19;
             const real_t elMat_19_7 = q_acc_7_19;
             const real_t elMat_19_8 = q_acc_8_19;
             const real_t elMat_19_9 = q_acc_9_19;
             const real_t elMat_19_10 = q_acc_10_19;
             const real_t elMat_19_11 = q_acc_11_19;
             const real_t elMat_19_12 = q_acc_12_19;
             const real_t elMat_19_13 = q_acc_13_19;
             const real_t elMat_19_14 = q_acc_14_19;
             const real_t elMat_19_15 = q_acc_15_19;
             const real_t elMat_19_16 = q_acc_16_19;
             const real_t elMat_19_17 = q_acc_17_19;
             const real_t elMat_19_18 = q_acc_18_19;
             const real_t elMat_19_19 = q_acc_19_19;
             const real_t elMat_19_20 = q_acc_19_20;
             const real_t elMat_19_21 = q_acc_19_21;
             const real_t elMat_19_22 = q_acc_19_22;
             const real_t elMat_19_23 = q_acc_19_23;
             const real_t elMat_19_24 = q_acc_19_24;
             const real_t elMat_19_25 = q_acc_19_25;
             const real_t elMat_19_26 = q_acc_19_26;
             const real_t elMat_19_27 = q_acc_19_27;
             const real_t elMat_19_28 = q_acc_19_28;
             const real_t elMat_19_29 = q_acc_19_29;
             const real_t elMat_20_0 = q_acc_0_20;
             const real_t elMat_20_1 = q_acc_1_20;
             const real_t elMat_20_2 = q_acc_2_20;
             const real_t elMat_20_3 = q_acc_3_20;
             const real_t elMat_20_4 = q_acc_4_20;
             const real_t elMat_20_5 = q_acc_5_20;
             const real_t elMat_20_6 = q_acc_6_20;
             const real_t elMat_20_7 = q_acc_7_20;
             const real_t elMat_20_8 = q_acc_8_20;
             const real_t elMat_20_9 = q_acc_9_20;
             const real_t elMat_20_10 = q_acc_10_20;
             const real_t elMat_20_11 = q_acc_11_20;
             const real_t elMat_20_12 = q_acc_12_20;
             const real_t elMat_20_13 = q_acc_13_20;
             const real_t elMat_20_14 = q_acc_14_20;
             const real_t elMat_20_15 = q_acc_15_20;
             const real_t elMat_20_16 = q_acc_16_20;
             const real_t elMat_20_17 = q_acc_17_20;
             const real_t elMat_20_18 = q_acc_18_20;
             const real_t elMat_20_19 = q_acc_19_20;
             const real_t elMat_20_20 = q_acc_20_20;
             const real_t elMat_20_21 = q_acc_20_21;
             const real_t elMat_20_22 = q_acc_20_22;
             const real_t elMat_20_23 = q_acc_20_23;
             const real_t elMat_20_24 = q_acc_20_24;
             const real_t elMat_20_25 = q_acc_20_25;
             const real_t elMat_20_26 = q_acc_20_26;
             const real_t elMat_20_27 = q_acc_20_27;
             const real_t elMat_20_28 = q_acc_20_28;
             const real_t elMat_20_29 = q_acc_20_29;
             const real_t elMat_21_0 = q_acc_0_21;
             const real_t elMat_21_1 = q_acc_1_21;
             const real_t elMat_21_2 = q_acc_2_21;
             const real_t elMat_21_3 = q_acc_3_21;
             const real_t elMat_21_4 = q_acc_4_21;
             const real_t elMat_21_5 = q_acc_5_21;
             const real_t elMat_21_6 = q_acc_6_21;
             const real_t elMat_21_7 = q_acc_7_21;
             const real_t elMat_21_8 = q_acc_8_21;
             const real_t elMat_21_9 = q_acc_9_21;
             const real_t elMat_21_10 = q_acc_10_21;
             const real_t elMat_21_11 = q_acc_11_21;
             const real_t elMat_21_12 = q_acc_12_21;
             const real_t elMat_21_13 = q_acc_13_21;
             const real_t elMat_21_14 = q_acc_14_21;
             const real_t elMat_21_15 = q_acc_15_21;
             const real_t elMat_21_16 = q_acc_16_21;
             const real_t elMat_21_17 = q_acc_17_21;
             const real_t elMat_21_18 = q_acc_18_21;
             const real_t elMat_21_19 = q_acc_19_21;
             const real_t elMat_21_20 = q_acc_20_21;
             const real_t elMat_21_21 = q_acc_21_21;
             const real_t elMat_21_22 = q_acc_21_22;
             const real_t elMat_21_23 = q_acc_21_23;
             const real_t elMat_21_24 = q_acc_21_24;
             const real_t elMat_21_25 = q_acc_21_25;
             const real_t elMat_21_26 = q_acc_21_26;
             const real_t elMat_21_27 = q_acc_21_27;
             const real_t elMat_21_28 = q_acc_21_28;
             const real_t elMat_21_29 = q_acc_21_29;
             const real_t elMat_22_0 = q_acc_0_22;
             const real_t elMat_22_1 = q_acc_1_22;
             const real_t elMat_22_2 = q_acc_2_22;
             const real_t elMat_22_3 = q_acc_3_22;
             const real_t elMat_22_4 = q_acc_4_22;
             const real_t elMat_22_5 = q_acc_5_22;
             const real_t elMat_22_6 = q_acc_6_22;
             const real_t elMat_22_7 = q_acc_7_22;
             const real_t elMat_22_8 = q_acc_8_22;
             const real_t elMat_22_9 = q_acc_9_22;
             const real_t elMat_22_10 = q_acc_10_22;
             const real_t elMat_22_11 = q_acc_11_22;
             const real_t elMat_22_12 = q_acc_12_22;
             const real_t elMat_22_13 = q_acc_13_22;
             const real_t elMat_22_14 = q_acc_14_22;
             const real_t elMat_22_15 = q_acc_15_22;
             const real_t elMat_22_16 = q_acc_16_22;
             const real_t elMat_22_17 = q_acc_17_22;
             const real_t elMat_22_18 = q_acc_18_22;
             const real_t elMat_22_19 = q_acc_19_22;
             const real_t elMat_22_20 = q_acc_20_22;
             const real_t elMat_22_21 = q_acc_21_22;
             const real_t elMat_22_22 = q_acc_22_22;
             const real_t elMat_22_23 = q_acc_22_23;
             const real_t elMat_22_24 = q_acc_22_24;
             const real_t elMat_22_25 = q_acc_22_25;
             const real_t elMat_22_26 = q_acc_22_26;
             const real_t elMat_22_27 = q_acc_22_27;
             const real_t elMat_22_28 = q_acc_22_28;
             const real_t elMat_22_29 = q_acc_22_29;
             const real_t elMat_23_0 = q_acc_0_23;
             const real_t elMat_23_1 = q_acc_1_23;
             const real_t elMat_23_2 = q_acc_2_23;
             const real_t elMat_23_3 = q_acc_3_23;
             const real_t elMat_23_4 = q_acc_4_23;
             const real_t elMat_23_5 = q_acc_5_23;
             const real_t elMat_23_6 = q_acc_6_23;
             const real_t elMat_23_7 = q_acc_7_23;
             const real_t elMat_23_8 = q_acc_8_23;
             const real_t elMat_23_9 = q_acc_9_23;
             const real_t elMat_23_10 = q_acc_10_23;
             const real_t elMat_23_11 = q_acc_11_23;
             const real_t elMat_23_12 = q_acc_12_23;
             const real_t elMat_23_13 = q_acc_13_23;
             const real_t elMat_23_14 = q_acc_14_23;
             const real_t elMat_23_15 = q_acc_15_23;
             const real_t elMat_23_16 = q_acc_16_23;
             const real_t elMat_23_17 = q_acc_17_23;
             const real_t elMat_23_18 = q_acc_18_23;
             const real_t elMat_23_19 = q_acc_19_23;
             const real_t elMat_23_20 = q_acc_20_23;
             const real_t elMat_23_21 = q_acc_21_23;
             const real_t elMat_23_22 = q_acc_22_23;
             const real_t elMat_23_23 = q_acc_23_23;
             const real_t elMat_23_24 = q_acc_23_24;
             const real_t elMat_23_25 = q_acc_23_25;
             const real_t elMat_23_26 = q_acc_23_26;
             const real_t elMat_23_27 = q_acc_23_27;
             const real_t elMat_23_28 = q_acc_23_28;
             const real_t elMat_23_29 = q_acc_23_29;
             const real_t elMat_24_0 = q_acc_0_24;
             const real_t elMat_24_1 = q_acc_1_24;
             const real_t elMat_24_2 = q_acc_2_24;
             const real_t elMat_24_3 = q_acc_3_24;
             const real_t elMat_24_4 = q_acc_4_24;
             const real_t elMat_24_5 = q_acc_5_24;
             const real_t elMat_24_6 = q_acc_6_24;
             const real_t elMat_24_7 = q_acc_7_24;
             const real_t elMat_24_8 = q_acc_8_24;
             const real_t elMat_24_9 = q_acc_9_24;
             const real_t elMat_24_10 = q_acc_10_24;
             const real_t elMat_24_11 = q_acc_11_24;
             const real_t elMat_24_12 = q_acc_12_24;
             const real_t elMat_24_13 = q_acc_13_24;
             const real_t elMat_24_14 = q_acc_14_24;
             const real_t elMat_24_15 = q_acc_15_24;
             const real_t elMat_24_16 = q_acc_16_24;
             const real_t elMat_24_17 = q_acc_17_24;
             const real_t elMat_24_18 = q_acc_18_24;
             const real_t elMat_24_19 = q_acc_19_24;
             const real_t elMat_24_20 = q_acc_20_24;
             const real_t elMat_24_21 = q_acc_21_24;
             const real_t elMat_24_22 = q_acc_22_24;
             const real_t elMat_24_23 = q_acc_23_24;
             const real_t elMat_24_24 = q_acc_24_24;
             const real_t elMat_24_25 = q_acc_24_25;
             const real_t elMat_24_26 = q_acc_24_26;
             const real_t elMat_24_27 = q_acc_24_27;
             const real_t elMat_24_28 = q_acc_24_28;
             const real_t elMat_24_29 = q_acc_24_29;
             const real_t elMat_25_0 = q_acc_0_25;
             const real_t elMat_25_1 = q_acc_1_25;
             const real_t elMat_25_2 = q_acc_2_25;
             const real_t elMat_25_3 = q_acc_3_25;
             const real_t elMat_25_4 = q_acc_4_25;
             const real_t elMat_25_5 = q_acc_5_25;
             const real_t elMat_25_6 = q_acc_6_25;
             const real_t elMat_25_7 = q_acc_7_25;
             const real_t elMat_25_8 = q_acc_8_25;
             const real_t elMat_25_9 = q_acc_9_25;
             const real_t elMat_25_10 = q_acc_10_25;
             const real_t elMat_25_11 = q_acc_11_25;
             const real_t elMat_25_12 = q_acc_12_25;
             const real_t elMat_25_13 = q_acc_13_25;
             const real_t elMat_25_14 = q_acc_14_25;
             const real_t elMat_25_15 = q_acc_15_25;
             const real_t elMat_25_16 = q_acc_16_25;
             const real_t elMat_25_17 = q_acc_17_25;
             const real_t elMat_25_18 = q_acc_18_25;
             const real_t elMat_25_19 = q_acc_19_25;
             const real_t elMat_25_20 = q_acc_20_25;
             const real_t elMat_25_21 = q_acc_21_25;
             const real_t elMat_25_22 = q_acc_22_25;
             const real_t elMat_25_23 = q_acc_23_25;
             const real_t elMat_25_24 = q_acc_24_25;
             const real_t elMat_25_25 = q_acc_25_25;
             const real_t elMat_25_26 = q_acc_25_26;
             const real_t elMat_25_27 = q_acc_25_27;
             const real_t elMat_25_28 = q_acc_25_28;
             const real_t elMat_25_29 = q_acc_25_29;
             const real_t elMat_26_0 = q_acc_0_26;
             const real_t elMat_26_1 = q_acc_1_26;
             const real_t elMat_26_2 = q_acc_2_26;
             const real_t elMat_26_3 = q_acc_3_26;
             const real_t elMat_26_4 = q_acc_4_26;
             const real_t elMat_26_5 = q_acc_5_26;
             const real_t elMat_26_6 = q_acc_6_26;
             const real_t elMat_26_7 = q_acc_7_26;
             const real_t elMat_26_8 = q_acc_8_26;
             const real_t elMat_26_9 = q_acc_9_26;
             const real_t elMat_26_10 = q_acc_10_26;
             const real_t elMat_26_11 = q_acc_11_26;
             const real_t elMat_26_12 = q_acc_12_26;
             const real_t elMat_26_13 = q_acc_13_26;
             const real_t elMat_26_14 = q_acc_14_26;
             const real_t elMat_26_15 = q_acc_15_26;
             const real_t elMat_26_16 = q_acc_16_26;
             const real_t elMat_26_17 = q_acc_17_26;
             const real_t elMat_26_18 = q_acc_18_26;
             const real_t elMat_26_19 = q_acc_19_26;
             const real_t elMat_26_20 = q_acc_20_26;
             const real_t elMat_26_21 = q_acc_21_26;
             const real_t elMat_26_22 = q_acc_22_26;
             const real_t elMat_26_23 = q_acc_23_26;
             const real_t elMat_26_24 = q_acc_24_26;
             const real_t elMat_26_25 = q_acc_25_26;
             const real_t elMat_26_26 = q_acc_26_26;
             const real_t elMat_26_27 = q_acc_26_27;
             const real_t elMat_26_28 = q_acc_26_28;
             const real_t elMat_26_29 = q_acc_26_29;
             const real_t elMat_27_0 = q_acc_0_27;
             const real_t elMat_27_1 = q_acc_1_27;
             const real_t elMat_27_2 = q_acc_2_27;
             const real_t elMat_27_3 = q_acc_3_27;
             const real_t elMat_27_4 = q_acc_4_27;
             const real_t elMat_27_5 = q_acc_5_27;
             const real_t elMat_27_6 = q_acc_6_27;
             const real_t elMat_27_7 = q_acc_7_27;
             const real_t elMat_27_8 = q_acc_8_27;
             const real_t elMat_27_9 = q_acc_9_27;
             const real_t elMat_27_10 = q_acc_10_27;
             const real_t elMat_27_11 = q_acc_11_27;
             const real_t elMat_27_12 = q_acc_12_27;
             const real_t elMat_27_13 = q_acc_13_27;
             const real_t elMat_27_14 = q_acc_14_27;
             const real_t elMat_27_15 = q_acc_15_27;
             const real_t elMat_27_16 = q_acc_16_27;
             const real_t elMat_27_17 = q_acc_17_27;
             const real_t elMat_27_18 = q_acc_18_27;
             const real_t elMat_27_19 = q_acc_19_27;
             const real_t elMat_27_20 = q_acc_20_27;
             const real_t elMat_27_21 = q_acc_21_27;
             const real_t elMat_27_22 = q_acc_22_27;
             const real_t elMat_27_23 = q_acc_23_27;
             const real_t elMat_27_24 = q_acc_24_27;
             const real_t elMat_27_25 = q_acc_25_27;
             const real_t elMat_27_26 = q_acc_26_27;
             const real_t elMat_27_27 = q_acc_27_27;
             const real_t elMat_27_28 = q_acc_27_28;
             const real_t elMat_27_29 = q_acc_27_29;
             const real_t elMat_28_0 = q_acc_0_28;
             const real_t elMat_28_1 = q_acc_1_28;
             const real_t elMat_28_2 = q_acc_2_28;
             const real_t elMat_28_3 = q_acc_3_28;
             const real_t elMat_28_4 = q_acc_4_28;
             const real_t elMat_28_5 = q_acc_5_28;
             const real_t elMat_28_6 = q_acc_6_28;
             const real_t elMat_28_7 = q_acc_7_28;
             const real_t elMat_28_8 = q_acc_8_28;
             const real_t elMat_28_9 = q_acc_9_28;
             const real_t elMat_28_10 = q_acc_10_28;
             const real_t elMat_28_11 = q_acc_11_28;
             const real_t elMat_28_12 = q_acc_12_28;
             const real_t elMat_28_13 = q_acc_13_28;
             const real_t elMat_28_14 = q_acc_14_28;
             const real_t elMat_28_15 = q_acc_15_28;
             const real_t elMat_28_16 = q_acc_16_28;
             const real_t elMat_28_17 = q_acc_17_28;
             const real_t elMat_28_18 = q_acc_18_28;
             const real_t elMat_28_19 = q_acc_19_28;
             const real_t elMat_28_20 = q_acc_20_28;
             const real_t elMat_28_21 = q_acc_21_28;
             const real_t elMat_28_22 = q_acc_22_28;
             const real_t elMat_28_23 = q_acc_23_28;
             const real_t elMat_28_24 = q_acc_24_28;
             const real_t elMat_28_25 = q_acc_25_28;
             const real_t elMat_28_26 = q_acc_26_28;
             const real_t elMat_28_27 = q_acc_27_28;
             const real_t elMat_28_28 = q_acc_28_28;
             const real_t elMat_28_29 = q_acc_28_29;
             const real_t elMat_29_0 = q_acc_0_29;
             const real_t elMat_29_1 = q_acc_1_29;
             const real_t elMat_29_2 = q_acc_2_29;
             const real_t elMat_29_3 = q_acc_3_29;
             const real_t elMat_29_4 = q_acc_4_29;
             const real_t elMat_29_5 = q_acc_5_29;
             const real_t elMat_29_6 = q_acc_6_29;
             const real_t elMat_29_7 = q_acc_7_29;
             const real_t elMat_29_8 = q_acc_8_29;
             const real_t elMat_29_9 = q_acc_9_29;
             const real_t elMat_29_10 = q_acc_10_29;
             const real_t elMat_29_11 = q_acc_11_29;
             const real_t elMat_29_12 = q_acc_12_29;
             const real_t elMat_29_13 = q_acc_13_29;
             const real_t elMat_29_14 = q_acc_14_29;
             const real_t elMat_29_15 = q_acc_15_29;
             const real_t elMat_29_16 = q_acc_16_29;
             const real_t elMat_29_17 = q_acc_17_29;
             const real_t elMat_29_18 = q_acc_18_29;
             const real_t elMat_29_19 = q_acc_19_29;
             const real_t elMat_29_20 = q_acc_20_29;
             const real_t elMat_29_21 = q_acc_21_29;
             const real_t elMat_29_22 = q_acc_22_29;
             const real_t elMat_29_23 = q_acc_23_29;
             const real_t elMat_29_24 = q_acc_24_29;
             const real_t elMat_29_25 = q_acc_25_29;
             const real_t elMat_29_26 = q_acc_26_29;
             const real_t elMat_29_27 = q_acc_27_29;
             const real_t elMat_29_28 = q_acc_28_29;
             const real_t elMat_29_29 = q_acc_29_29;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 30 );
             std::vector< real_t > _data_mat( 900 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_colIdx[6] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[10] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[11] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[12] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[13] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[14] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[15] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_colIdx[16] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[17] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[18] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[19] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[20] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[21] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[22] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[23] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[24] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[25] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_colIdx[26] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[27] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[28] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[29] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_0_12));
             _data_mat[13] = ((real_t)(elMat_0_13));
             _data_mat[14] = ((real_t)(elMat_0_14));
             _data_mat[15] = ((real_t)(elMat_0_15));
             _data_mat[16] = ((real_t)(elMat_0_16));
             _data_mat[17] = ((real_t)(elMat_0_17));
             _data_mat[18] = ((real_t)(elMat_0_18));
             _data_mat[19] = ((real_t)(elMat_0_19));
             _data_mat[20] = ((real_t)(elMat_0_20));
             _data_mat[21] = ((real_t)(elMat_0_21));
             _data_mat[22] = ((real_t)(elMat_0_22));
             _data_mat[23] = ((real_t)(elMat_0_23));
             _data_mat[24] = ((real_t)(elMat_0_24));
             _data_mat[25] = ((real_t)(elMat_0_25));
             _data_mat[26] = ((real_t)(elMat_0_26));
             _data_mat[27] = ((real_t)(elMat_0_27));
             _data_mat[28] = ((real_t)(elMat_0_28));
             _data_mat[29] = ((real_t)(elMat_0_29));
             _data_mat[30] = ((real_t)(elMat_1_0));
             _data_mat[31] = ((real_t)(elMat_1_1));
             _data_mat[32] = ((real_t)(elMat_1_2));
             _data_mat[33] = ((real_t)(elMat_1_3));
             _data_mat[34] = ((real_t)(elMat_1_4));
             _data_mat[35] = ((real_t)(elMat_1_5));
             _data_mat[36] = ((real_t)(elMat_1_6));
             _data_mat[37] = ((real_t)(elMat_1_7));
             _data_mat[38] = ((real_t)(elMat_1_8));
             _data_mat[39] = ((real_t)(elMat_1_9));
             _data_mat[40] = ((real_t)(elMat_1_10));
             _data_mat[41] = ((real_t)(elMat_1_11));
             _data_mat[42] = ((real_t)(elMat_1_12));
             _data_mat[43] = ((real_t)(elMat_1_13));
             _data_mat[44] = ((real_t)(elMat_1_14));
             _data_mat[45] = ((real_t)(elMat_1_15));
             _data_mat[46] = ((real_t)(elMat_1_16));
             _data_mat[47] = ((real_t)(elMat_1_17));
             _data_mat[48] = ((real_t)(elMat_1_18));
             _data_mat[49] = ((real_t)(elMat_1_19));
             _data_mat[50] = ((real_t)(elMat_1_20));
             _data_mat[51] = ((real_t)(elMat_1_21));
             _data_mat[52] = ((real_t)(elMat_1_22));
             _data_mat[53] = ((real_t)(elMat_1_23));
             _data_mat[54] = ((real_t)(elMat_1_24));
             _data_mat[55] = ((real_t)(elMat_1_25));
             _data_mat[56] = ((real_t)(elMat_1_26));
             _data_mat[57] = ((real_t)(elMat_1_27));
             _data_mat[58] = ((real_t)(elMat_1_28));
             _data_mat[59] = ((real_t)(elMat_1_29));
             _data_mat[60] = ((real_t)(elMat_2_0));
             _data_mat[61] = ((real_t)(elMat_2_1));
             _data_mat[62] = ((real_t)(elMat_2_2));
             _data_mat[63] = ((real_t)(elMat_2_3));
             _data_mat[64] = ((real_t)(elMat_2_4));
             _data_mat[65] = ((real_t)(elMat_2_5));
             _data_mat[66] = ((real_t)(elMat_2_6));
             _data_mat[67] = ((real_t)(elMat_2_7));
             _data_mat[68] = ((real_t)(elMat_2_8));
             _data_mat[69] = ((real_t)(elMat_2_9));
             _data_mat[70] = ((real_t)(elMat_2_10));
             _data_mat[71] = ((real_t)(elMat_2_11));
             _data_mat[72] = ((real_t)(elMat_2_12));
             _data_mat[73] = ((real_t)(elMat_2_13));
             _data_mat[74] = ((real_t)(elMat_2_14));
             _data_mat[75] = ((real_t)(elMat_2_15));
             _data_mat[76] = ((real_t)(elMat_2_16));
             _data_mat[77] = ((real_t)(elMat_2_17));
             _data_mat[78] = ((real_t)(elMat_2_18));
             _data_mat[79] = ((real_t)(elMat_2_19));
             _data_mat[80] = ((real_t)(elMat_2_20));
             _data_mat[81] = ((real_t)(elMat_2_21));
             _data_mat[82] = ((real_t)(elMat_2_22));
             _data_mat[83] = ((real_t)(elMat_2_23));
             _data_mat[84] = ((real_t)(elMat_2_24));
             _data_mat[85] = ((real_t)(elMat_2_25));
             _data_mat[86] = ((real_t)(elMat_2_26));
             _data_mat[87] = ((real_t)(elMat_2_27));
             _data_mat[88] = ((real_t)(elMat_2_28));
             _data_mat[89] = ((real_t)(elMat_2_29));
             _data_mat[90] = ((real_t)(elMat_3_0));
             _data_mat[91] = ((real_t)(elMat_3_1));
             _data_mat[92] = ((real_t)(elMat_3_2));
             _data_mat[93] = ((real_t)(elMat_3_3));
             _data_mat[94] = ((real_t)(elMat_3_4));
             _data_mat[95] = ((real_t)(elMat_3_5));
             _data_mat[96] = ((real_t)(elMat_3_6));
             _data_mat[97] = ((real_t)(elMat_3_7));
             _data_mat[98] = ((real_t)(elMat_3_8));
             _data_mat[99] = ((real_t)(elMat_3_9));
             _data_mat[100] = ((real_t)(elMat_3_10));
             _data_mat[101] = ((real_t)(elMat_3_11));
             _data_mat[102] = ((real_t)(elMat_3_12));
             _data_mat[103] = ((real_t)(elMat_3_13));
             _data_mat[104] = ((real_t)(elMat_3_14));
             _data_mat[105] = ((real_t)(elMat_3_15));
             _data_mat[106] = ((real_t)(elMat_3_16));
             _data_mat[107] = ((real_t)(elMat_3_17));
             _data_mat[108] = ((real_t)(elMat_3_18));
             _data_mat[109] = ((real_t)(elMat_3_19));
             _data_mat[110] = ((real_t)(elMat_3_20));
             _data_mat[111] = ((real_t)(elMat_3_21));
             _data_mat[112] = ((real_t)(elMat_3_22));
             _data_mat[113] = ((real_t)(elMat_3_23));
             _data_mat[114] = ((real_t)(elMat_3_24));
             _data_mat[115] = ((real_t)(elMat_3_25));
             _data_mat[116] = ((real_t)(elMat_3_26));
             _data_mat[117] = ((real_t)(elMat_3_27));
             _data_mat[118] = ((real_t)(elMat_3_28));
             _data_mat[119] = ((real_t)(elMat_3_29));
             _data_mat[120] = ((real_t)(elMat_4_0));
             _data_mat[121] = ((real_t)(elMat_4_1));
             _data_mat[122] = ((real_t)(elMat_4_2));
             _data_mat[123] = ((real_t)(elMat_4_3));
             _data_mat[124] = ((real_t)(elMat_4_4));
             _data_mat[125] = ((real_t)(elMat_4_5));
             _data_mat[126] = ((real_t)(elMat_4_6));
             _data_mat[127] = ((real_t)(elMat_4_7));
             _data_mat[128] = ((real_t)(elMat_4_8));
             _data_mat[129] = ((real_t)(elMat_4_9));
             _data_mat[130] = ((real_t)(elMat_4_10));
             _data_mat[131] = ((real_t)(elMat_4_11));
             _data_mat[132] = ((real_t)(elMat_4_12));
             _data_mat[133] = ((real_t)(elMat_4_13));
             _data_mat[134] = ((real_t)(elMat_4_14));
             _data_mat[135] = ((real_t)(elMat_4_15));
             _data_mat[136] = ((real_t)(elMat_4_16));
             _data_mat[137] = ((real_t)(elMat_4_17));
             _data_mat[138] = ((real_t)(elMat_4_18));
             _data_mat[139] = ((real_t)(elMat_4_19));
             _data_mat[140] = ((real_t)(elMat_4_20));
             _data_mat[141] = ((real_t)(elMat_4_21));
             _data_mat[142] = ((real_t)(elMat_4_22));
             _data_mat[143] = ((real_t)(elMat_4_23));
             _data_mat[144] = ((real_t)(elMat_4_24));
             _data_mat[145] = ((real_t)(elMat_4_25));
             _data_mat[146] = ((real_t)(elMat_4_26));
             _data_mat[147] = ((real_t)(elMat_4_27));
             _data_mat[148] = ((real_t)(elMat_4_28));
             _data_mat[149] = ((real_t)(elMat_4_29));
             _data_mat[150] = ((real_t)(elMat_5_0));
             _data_mat[151] = ((real_t)(elMat_5_1));
             _data_mat[152] = ((real_t)(elMat_5_2));
             _data_mat[153] = ((real_t)(elMat_5_3));
             _data_mat[154] = ((real_t)(elMat_5_4));
             _data_mat[155] = ((real_t)(elMat_5_5));
             _data_mat[156] = ((real_t)(elMat_5_6));
             _data_mat[157] = ((real_t)(elMat_5_7));
             _data_mat[158] = ((real_t)(elMat_5_8));
             _data_mat[159] = ((real_t)(elMat_5_9));
             _data_mat[160] = ((real_t)(elMat_5_10));
             _data_mat[161] = ((real_t)(elMat_5_11));
             _data_mat[162] = ((real_t)(elMat_5_12));
             _data_mat[163] = ((real_t)(elMat_5_13));
             _data_mat[164] = ((real_t)(elMat_5_14));
             _data_mat[165] = ((real_t)(elMat_5_15));
             _data_mat[166] = ((real_t)(elMat_5_16));
             _data_mat[167] = ((real_t)(elMat_5_17));
             _data_mat[168] = ((real_t)(elMat_5_18));
             _data_mat[169] = ((real_t)(elMat_5_19));
             _data_mat[170] = ((real_t)(elMat_5_20));
             _data_mat[171] = ((real_t)(elMat_5_21));
             _data_mat[172] = ((real_t)(elMat_5_22));
             _data_mat[173] = ((real_t)(elMat_5_23));
             _data_mat[174] = ((real_t)(elMat_5_24));
             _data_mat[175] = ((real_t)(elMat_5_25));
             _data_mat[176] = ((real_t)(elMat_5_26));
             _data_mat[177] = ((real_t)(elMat_5_27));
             _data_mat[178] = ((real_t)(elMat_5_28));
             _data_mat[179] = ((real_t)(elMat_5_29));
             _data_mat[180] = ((real_t)(elMat_6_0));
             _data_mat[181] = ((real_t)(elMat_6_1));
             _data_mat[182] = ((real_t)(elMat_6_2));
             _data_mat[183] = ((real_t)(elMat_6_3));
             _data_mat[184] = ((real_t)(elMat_6_4));
             _data_mat[185] = ((real_t)(elMat_6_5));
             _data_mat[186] = ((real_t)(elMat_6_6));
             _data_mat[187] = ((real_t)(elMat_6_7));
             _data_mat[188] = ((real_t)(elMat_6_8));
             _data_mat[189] = ((real_t)(elMat_6_9));
             _data_mat[190] = ((real_t)(elMat_6_10));
             _data_mat[191] = ((real_t)(elMat_6_11));
             _data_mat[192] = ((real_t)(elMat_6_12));
             _data_mat[193] = ((real_t)(elMat_6_13));
             _data_mat[194] = ((real_t)(elMat_6_14));
             _data_mat[195] = ((real_t)(elMat_6_15));
             _data_mat[196] = ((real_t)(elMat_6_16));
             _data_mat[197] = ((real_t)(elMat_6_17));
             _data_mat[198] = ((real_t)(elMat_6_18));
             _data_mat[199] = ((real_t)(elMat_6_19));
             _data_mat[200] = ((real_t)(elMat_6_20));
             _data_mat[201] = ((real_t)(elMat_6_21));
             _data_mat[202] = ((real_t)(elMat_6_22));
             _data_mat[203] = ((real_t)(elMat_6_23));
             _data_mat[204] = ((real_t)(elMat_6_24));
             _data_mat[205] = ((real_t)(elMat_6_25));
             _data_mat[206] = ((real_t)(elMat_6_26));
             _data_mat[207] = ((real_t)(elMat_6_27));
             _data_mat[208] = ((real_t)(elMat_6_28));
             _data_mat[209] = ((real_t)(elMat_6_29));
             _data_mat[210] = ((real_t)(elMat_7_0));
             _data_mat[211] = ((real_t)(elMat_7_1));
             _data_mat[212] = ((real_t)(elMat_7_2));
             _data_mat[213] = ((real_t)(elMat_7_3));
             _data_mat[214] = ((real_t)(elMat_7_4));
             _data_mat[215] = ((real_t)(elMat_7_5));
             _data_mat[216] = ((real_t)(elMat_7_6));
             _data_mat[217] = ((real_t)(elMat_7_7));
             _data_mat[218] = ((real_t)(elMat_7_8));
             _data_mat[219] = ((real_t)(elMat_7_9));
             _data_mat[220] = ((real_t)(elMat_7_10));
             _data_mat[221] = ((real_t)(elMat_7_11));
             _data_mat[222] = ((real_t)(elMat_7_12));
             _data_mat[223] = ((real_t)(elMat_7_13));
             _data_mat[224] = ((real_t)(elMat_7_14));
             _data_mat[225] = ((real_t)(elMat_7_15));
             _data_mat[226] = ((real_t)(elMat_7_16));
             _data_mat[227] = ((real_t)(elMat_7_17));
             _data_mat[228] = ((real_t)(elMat_7_18));
             _data_mat[229] = ((real_t)(elMat_7_19));
             _data_mat[230] = ((real_t)(elMat_7_20));
             _data_mat[231] = ((real_t)(elMat_7_21));
             _data_mat[232] = ((real_t)(elMat_7_22));
             _data_mat[233] = ((real_t)(elMat_7_23));
             _data_mat[234] = ((real_t)(elMat_7_24));
             _data_mat[235] = ((real_t)(elMat_7_25));
             _data_mat[236] = ((real_t)(elMat_7_26));
             _data_mat[237] = ((real_t)(elMat_7_27));
             _data_mat[238] = ((real_t)(elMat_7_28));
             _data_mat[239] = ((real_t)(elMat_7_29));
             _data_mat[240] = ((real_t)(elMat_8_0));
             _data_mat[241] = ((real_t)(elMat_8_1));
             _data_mat[242] = ((real_t)(elMat_8_2));
             _data_mat[243] = ((real_t)(elMat_8_3));
             _data_mat[244] = ((real_t)(elMat_8_4));
             _data_mat[245] = ((real_t)(elMat_8_5));
             _data_mat[246] = ((real_t)(elMat_8_6));
             _data_mat[247] = ((real_t)(elMat_8_7));
             _data_mat[248] = ((real_t)(elMat_8_8));
             _data_mat[249] = ((real_t)(elMat_8_9));
             _data_mat[250] = ((real_t)(elMat_8_10));
             _data_mat[251] = ((real_t)(elMat_8_11));
             _data_mat[252] = ((real_t)(elMat_8_12));
             _data_mat[253] = ((real_t)(elMat_8_13));
             _data_mat[254] = ((real_t)(elMat_8_14));
             _data_mat[255] = ((real_t)(elMat_8_15));
             _data_mat[256] = ((real_t)(elMat_8_16));
             _data_mat[257] = ((real_t)(elMat_8_17));
             _data_mat[258] = ((real_t)(elMat_8_18));
             _data_mat[259] = ((real_t)(elMat_8_19));
             _data_mat[260] = ((real_t)(elMat_8_20));
             _data_mat[261] = ((real_t)(elMat_8_21));
             _data_mat[262] = ((real_t)(elMat_8_22));
             _data_mat[263] = ((real_t)(elMat_8_23));
             _data_mat[264] = ((real_t)(elMat_8_24));
             _data_mat[265] = ((real_t)(elMat_8_25));
             _data_mat[266] = ((real_t)(elMat_8_26));
             _data_mat[267] = ((real_t)(elMat_8_27));
             _data_mat[268] = ((real_t)(elMat_8_28));
             _data_mat[269] = ((real_t)(elMat_8_29));
             _data_mat[270] = ((real_t)(elMat_9_0));
             _data_mat[271] = ((real_t)(elMat_9_1));
             _data_mat[272] = ((real_t)(elMat_9_2));
             _data_mat[273] = ((real_t)(elMat_9_3));
             _data_mat[274] = ((real_t)(elMat_9_4));
             _data_mat[275] = ((real_t)(elMat_9_5));
             _data_mat[276] = ((real_t)(elMat_9_6));
             _data_mat[277] = ((real_t)(elMat_9_7));
             _data_mat[278] = ((real_t)(elMat_9_8));
             _data_mat[279] = ((real_t)(elMat_9_9));
             _data_mat[280] = ((real_t)(elMat_9_10));
             _data_mat[281] = ((real_t)(elMat_9_11));
             _data_mat[282] = ((real_t)(elMat_9_12));
             _data_mat[283] = ((real_t)(elMat_9_13));
             _data_mat[284] = ((real_t)(elMat_9_14));
             _data_mat[285] = ((real_t)(elMat_9_15));
             _data_mat[286] = ((real_t)(elMat_9_16));
             _data_mat[287] = ((real_t)(elMat_9_17));
             _data_mat[288] = ((real_t)(elMat_9_18));
             _data_mat[289] = ((real_t)(elMat_9_19));
             _data_mat[290] = ((real_t)(elMat_9_20));
             _data_mat[291] = ((real_t)(elMat_9_21));
             _data_mat[292] = ((real_t)(elMat_9_22));
             _data_mat[293] = ((real_t)(elMat_9_23));
             _data_mat[294] = ((real_t)(elMat_9_24));
             _data_mat[295] = ((real_t)(elMat_9_25));
             _data_mat[296] = ((real_t)(elMat_9_26));
             _data_mat[297] = ((real_t)(elMat_9_27));
             _data_mat[298] = ((real_t)(elMat_9_28));
             _data_mat[299] = ((real_t)(elMat_9_29));
             _data_mat[300] = ((real_t)(elMat_10_0));
             _data_mat[301] = ((real_t)(elMat_10_1));
             _data_mat[302] = ((real_t)(elMat_10_2));
             _data_mat[303] = ((real_t)(elMat_10_3));
             _data_mat[304] = ((real_t)(elMat_10_4));
             _data_mat[305] = ((real_t)(elMat_10_5));
             _data_mat[306] = ((real_t)(elMat_10_6));
             _data_mat[307] = ((real_t)(elMat_10_7));
             _data_mat[308] = ((real_t)(elMat_10_8));
             _data_mat[309] = ((real_t)(elMat_10_9));
             _data_mat[310] = ((real_t)(elMat_10_10));
             _data_mat[311] = ((real_t)(elMat_10_11));
             _data_mat[312] = ((real_t)(elMat_10_12));
             _data_mat[313] = ((real_t)(elMat_10_13));
             _data_mat[314] = ((real_t)(elMat_10_14));
             _data_mat[315] = ((real_t)(elMat_10_15));
             _data_mat[316] = ((real_t)(elMat_10_16));
             _data_mat[317] = ((real_t)(elMat_10_17));
             _data_mat[318] = ((real_t)(elMat_10_18));
             _data_mat[319] = ((real_t)(elMat_10_19));
             _data_mat[320] = ((real_t)(elMat_10_20));
             _data_mat[321] = ((real_t)(elMat_10_21));
             _data_mat[322] = ((real_t)(elMat_10_22));
             _data_mat[323] = ((real_t)(elMat_10_23));
             _data_mat[324] = ((real_t)(elMat_10_24));
             _data_mat[325] = ((real_t)(elMat_10_25));
             _data_mat[326] = ((real_t)(elMat_10_26));
             _data_mat[327] = ((real_t)(elMat_10_27));
             _data_mat[328] = ((real_t)(elMat_10_28));
             _data_mat[329] = ((real_t)(elMat_10_29));
             _data_mat[330] = ((real_t)(elMat_11_0));
             _data_mat[331] = ((real_t)(elMat_11_1));
             _data_mat[332] = ((real_t)(elMat_11_2));
             _data_mat[333] = ((real_t)(elMat_11_3));
             _data_mat[334] = ((real_t)(elMat_11_4));
             _data_mat[335] = ((real_t)(elMat_11_5));
             _data_mat[336] = ((real_t)(elMat_11_6));
             _data_mat[337] = ((real_t)(elMat_11_7));
             _data_mat[338] = ((real_t)(elMat_11_8));
             _data_mat[339] = ((real_t)(elMat_11_9));
             _data_mat[340] = ((real_t)(elMat_11_10));
             _data_mat[341] = ((real_t)(elMat_11_11));
             _data_mat[342] = ((real_t)(elMat_11_12));
             _data_mat[343] = ((real_t)(elMat_11_13));
             _data_mat[344] = ((real_t)(elMat_11_14));
             _data_mat[345] = ((real_t)(elMat_11_15));
             _data_mat[346] = ((real_t)(elMat_11_16));
             _data_mat[347] = ((real_t)(elMat_11_17));
             _data_mat[348] = ((real_t)(elMat_11_18));
             _data_mat[349] = ((real_t)(elMat_11_19));
             _data_mat[350] = ((real_t)(elMat_11_20));
             _data_mat[351] = ((real_t)(elMat_11_21));
             _data_mat[352] = ((real_t)(elMat_11_22));
             _data_mat[353] = ((real_t)(elMat_11_23));
             _data_mat[354] = ((real_t)(elMat_11_24));
             _data_mat[355] = ((real_t)(elMat_11_25));
             _data_mat[356] = ((real_t)(elMat_11_26));
             _data_mat[357] = ((real_t)(elMat_11_27));
             _data_mat[358] = ((real_t)(elMat_11_28));
             _data_mat[359] = ((real_t)(elMat_11_29));
             _data_mat[360] = ((real_t)(elMat_12_0));
             _data_mat[361] = ((real_t)(elMat_12_1));
             _data_mat[362] = ((real_t)(elMat_12_2));
             _data_mat[363] = ((real_t)(elMat_12_3));
             _data_mat[364] = ((real_t)(elMat_12_4));
             _data_mat[365] = ((real_t)(elMat_12_5));
             _data_mat[366] = ((real_t)(elMat_12_6));
             _data_mat[367] = ((real_t)(elMat_12_7));
             _data_mat[368] = ((real_t)(elMat_12_8));
             _data_mat[369] = ((real_t)(elMat_12_9));
             _data_mat[370] = ((real_t)(elMat_12_10));
             _data_mat[371] = ((real_t)(elMat_12_11));
             _data_mat[372] = ((real_t)(elMat_12_12));
             _data_mat[373] = ((real_t)(elMat_12_13));
             _data_mat[374] = ((real_t)(elMat_12_14));
             _data_mat[375] = ((real_t)(elMat_12_15));
             _data_mat[376] = ((real_t)(elMat_12_16));
             _data_mat[377] = ((real_t)(elMat_12_17));
             _data_mat[378] = ((real_t)(elMat_12_18));
             _data_mat[379] = ((real_t)(elMat_12_19));
             _data_mat[380] = ((real_t)(elMat_12_20));
             _data_mat[381] = ((real_t)(elMat_12_21));
             _data_mat[382] = ((real_t)(elMat_12_22));
             _data_mat[383] = ((real_t)(elMat_12_23));
             _data_mat[384] = ((real_t)(elMat_12_24));
             _data_mat[385] = ((real_t)(elMat_12_25));
             _data_mat[386] = ((real_t)(elMat_12_26));
             _data_mat[387] = ((real_t)(elMat_12_27));
             _data_mat[388] = ((real_t)(elMat_12_28));
             _data_mat[389] = ((real_t)(elMat_12_29));
             _data_mat[390] = ((real_t)(elMat_13_0));
             _data_mat[391] = ((real_t)(elMat_13_1));
             _data_mat[392] = ((real_t)(elMat_13_2));
             _data_mat[393] = ((real_t)(elMat_13_3));
             _data_mat[394] = ((real_t)(elMat_13_4));
             _data_mat[395] = ((real_t)(elMat_13_5));
             _data_mat[396] = ((real_t)(elMat_13_6));
             _data_mat[397] = ((real_t)(elMat_13_7));
             _data_mat[398] = ((real_t)(elMat_13_8));
             _data_mat[399] = ((real_t)(elMat_13_9));
             _data_mat[400] = ((real_t)(elMat_13_10));
             _data_mat[401] = ((real_t)(elMat_13_11));
             _data_mat[402] = ((real_t)(elMat_13_12));
             _data_mat[403] = ((real_t)(elMat_13_13));
             _data_mat[404] = ((real_t)(elMat_13_14));
             _data_mat[405] = ((real_t)(elMat_13_15));
             _data_mat[406] = ((real_t)(elMat_13_16));
             _data_mat[407] = ((real_t)(elMat_13_17));
             _data_mat[408] = ((real_t)(elMat_13_18));
             _data_mat[409] = ((real_t)(elMat_13_19));
             _data_mat[410] = ((real_t)(elMat_13_20));
             _data_mat[411] = ((real_t)(elMat_13_21));
             _data_mat[412] = ((real_t)(elMat_13_22));
             _data_mat[413] = ((real_t)(elMat_13_23));
             _data_mat[414] = ((real_t)(elMat_13_24));
             _data_mat[415] = ((real_t)(elMat_13_25));
             _data_mat[416] = ((real_t)(elMat_13_26));
             _data_mat[417] = ((real_t)(elMat_13_27));
             _data_mat[418] = ((real_t)(elMat_13_28));
             _data_mat[419] = ((real_t)(elMat_13_29));
             _data_mat[420] = ((real_t)(elMat_14_0));
             _data_mat[421] = ((real_t)(elMat_14_1));
             _data_mat[422] = ((real_t)(elMat_14_2));
             _data_mat[423] = ((real_t)(elMat_14_3));
             _data_mat[424] = ((real_t)(elMat_14_4));
             _data_mat[425] = ((real_t)(elMat_14_5));
             _data_mat[426] = ((real_t)(elMat_14_6));
             _data_mat[427] = ((real_t)(elMat_14_7));
             _data_mat[428] = ((real_t)(elMat_14_8));
             _data_mat[429] = ((real_t)(elMat_14_9));
             _data_mat[430] = ((real_t)(elMat_14_10));
             _data_mat[431] = ((real_t)(elMat_14_11));
             _data_mat[432] = ((real_t)(elMat_14_12));
             _data_mat[433] = ((real_t)(elMat_14_13));
             _data_mat[434] = ((real_t)(elMat_14_14));
             _data_mat[435] = ((real_t)(elMat_14_15));
             _data_mat[436] = ((real_t)(elMat_14_16));
             _data_mat[437] = ((real_t)(elMat_14_17));
             _data_mat[438] = ((real_t)(elMat_14_18));
             _data_mat[439] = ((real_t)(elMat_14_19));
             _data_mat[440] = ((real_t)(elMat_14_20));
             _data_mat[441] = ((real_t)(elMat_14_21));
             _data_mat[442] = ((real_t)(elMat_14_22));
             _data_mat[443] = ((real_t)(elMat_14_23));
             _data_mat[444] = ((real_t)(elMat_14_24));
             _data_mat[445] = ((real_t)(elMat_14_25));
             _data_mat[446] = ((real_t)(elMat_14_26));
             _data_mat[447] = ((real_t)(elMat_14_27));
             _data_mat[448] = ((real_t)(elMat_14_28));
             _data_mat[449] = ((real_t)(elMat_14_29));
             _data_mat[450] = ((real_t)(elMat_15_0));
             _data_mat[451] = ((real_t)(elMat_15_1));
             _data_mat[452] = ((real_t)(elMat_15_2));
             _data_mat[453] = ((real_t)(elMat_15_3));
             _data_mat[454] = ((real_t)(elMat_15_4));
             _data_mat[455] = ((real_t)(elMat_15_5));
             _data_mat[456] = ((real_t)(elMat_15_6));
             _data_mat[457] = ((real_t)(elMat_15_7));
             _data_mat[458] = ((real_t)(elMat_15_8));
             _data_mat[459] = ((real_t)(elMat_15_9));
             _data_mat[460] = ((real_t)(elMat_15_10));
             _data_mat[461] = ((real_t)(elMat_15_11));
             _data_mat[462] = ((real_t)(elMat_15_12));
             _data_mat[463] = ((real_t)(elMat_15_13));
             _data_mat[464] = ((real_t)(elMat_15_14));
             _data_mat[465] = ((real_t)(elMat_15_15));
             _data_mat[466] = ((real_t)(elMat_15_16));
             _data_mat[467] = ((real_t)(elMat_15_17));
             _data_mat[468] = ((real_t)(elMat_15_18));
             _data_mat[469] = ((real_t)(elMat_15_19));
             _data_mat[470] = ((real_t)(elMat_15_20));
             _data_mat[471] = ((real_t)(elMat_15_21));
             _data_mat[472] = ((real_t)(elMat_15_22));
             _data_mat[473] = ((real_t)(elMat_15_23));
             _data_mat[474] = ((real_t)(elMat_15_24));
             _data_mat[475] = ((real_t)(elMat_15_25));
             _data_mat[476] = ((real_t)(elMat_15_26));
             _data_mat[477] = ((real_t)(elMat_15_27));
             _data_mat[478] = ((real_t)(elMat_15_28));
             _data_mat[479] = ((real_t)(elMat_15_29));
             _data_mat[480] = ((real_t)(elMat_16_0));
             _data_mat[481] = ((real_t)(elMat_16_1));
             _data_mat[482] = ((real_t)(elMat_16_2));
             _data_mat[483] = ((real_t)(elMat_16_3));
             _data_mat[484] = ((real_t)(elMat_16_4));
             _data_mat[485] = ((real_t)(elMat_16_5));
             _data_mat[486] = ((real_t)(elMat_16_6));
             _data_mat[487] = ((real_t)(elMat_16_7));
             _data_mat[488] = ((real_t)(elMat_16_8));
             _data_mat[489] = ((real_t)(elMat_16_9));
             _data_mat[490] = ((real_t)(elMat_16_10));
             _data_mat[491] = ((real_t)(elMat_16_11));
             _data_mat[492] = ((real_t)(elMat_16_12));
             _data_mat[493] = ((real_t)(elMat_16_13));
             _data_mat[494] = ((real_t)(elMat_16_14));
             _data_mat[495] = ((real_t)(elMat_16_15));
             _data_mat[496] = ((real_t)(elMat_16_16));
             _data_mat[497] = ((real_t)(elMat_16_17));
             _data_mat[498] = ((real_t)(elMat_16_18));
             _data_mat[499] = ((real_t)(elMat_16_19));
             _data_mat[500] = ((real_t)(elMat_16_20));
             _data_mat[501] = ((real_t)(elMat_16_21));
             _data_mat[502] = ((real_t)(elMat_16_22));
             _data_mat[503] = ((real_t)(elMat_16_23));
             _data_mat[504] = ((real_t)(elMat_16_24));
             _data_mat[505] = ((real_t)(elMat_16_25));
             _data_mat[506] = ((real_t)(elMat_16_26));
             _data_mat[507] = ((real_t)(elMat_16_27));
             _data_mat[508] = ((real_t)(elMat_16_28));
             _data_mat[509] = ((real_t)(elMat_16_29));
             _data_mat[510] = ((real_t)(elMat_17_0));
             _data_mat[511] = ((real_t)(elMat_17_1));
             _data_mat[512] = ((real_t)(elMat_17_2));
             _data_mat[513] = ((real_t)(elMat_17_3));
             _data_mat[514] = ((real_t)(elMat_17_4));
             _data_mat[515] = ((real_t)(elMat_17_5));
             _data_mat[516] = ((real_t)(elMat_17_6));
             _data_mat[517] = ((real_t)(elMat_17_7));
             _data_mat[518] = ((real_t)(elMat_17_8));
             _data_mat[519] = ((real_t)(elMat_17_9));
             _data_mat[520] = ((real_t)(elMat_17_10));
             _data_mat[521] = ((real_t)(elMat_17_11));
             _data_mat[522] = ((real_t)(elMat_17_12));
             _data_mat[523] = ((real_t)(elMat_17_13));
             _data_mat[524] = ((real_t)(elMat_17_14));
             _data_mat[525] = ((real_t)(elMat_17_15));
             _data_mat[526] = ((real_t)(elMat_17_16));
             _data_mat[527] = ((real_t)(elMat_17_17));
             _data_mat[528] = ((real_t)(elMat_17_18));
             _data_mat[529] = ((real_t)(elMat_17_19));
             _data_mat[530] = ((real_t)(elMat_17_20));
             _data_mat[531] = ((real_t)(elMat_17_21));
             _data_mat[532] = ((real_t)(elMat_17_22));
             _data_mat[533] = ((real_t)(elMat_17_23));
             _data_mat[534] = ((real_t)(elMat_17_24));
             _data_mat[535] = ((real_t)(elMat_17_25));
             _data_mat[536] = ((real_t)(elMat_17_26));
             _data_mat[537] = ((real_t)(elMat_17_27));
             _data_mat[538] = ((real_t)(elMat_17_28));
             _data_mat[539] = ((real_t)(elMat_17_29));
             _data_mat[540] = ((real_t)(elMat_18_0));
             _data_mat[541] = ((real_t)(elMat_18_1));
             _data_mat[542] = ((real_t)(elMat_18_2));
             _data_mat[543] = ((real_t)(elMat_18_3));
             _data_mat[544] = ((real_t)(elMat_18_4));
             _data_mat[545] = ((real_t)(elMat_18_5));
             _data_mat[546] = ((real_t)(elMat_18_6));
             _data_mat[547] = ((real_t)(elMat_18_7));
             _data_mat[548] = ((real_t)(elMat_18_8));
             _data_mat[549] = ((real_t)(elMat_18_9));
             _data_mat[550] = ((real_t)(elMat_18_10));
             _data_mat[551] = ((real_t)(elMat_18_11));
             _data_mat[552] = ((real_t)(elMat_18_12));
             _data_mat[553] = ((real_t)(elMat_18_13));
             _data_mat[554] = ((real_t)(elMat_18_14));
             _data_mat[555] = ((real_t)(elMat_18_15));
             _data_mat[556] = ((real_t)(elMat_18_16));
             _data_mat[557] = ((real_t)(elMat_18_17));
             _data_mat[558] = ((real_t)(elMat_18_18));
             _data_mat[559] = ((real_t)(elMat_18_19));
             _data_mat[560] = ((real_t)(elMat_18_20));
             _data_mat[561] = ((real_t)(elMat_18_21));
             _data_mat[562] = ((real_t)(elMat_18_22));
             _data_mat[563] = ((real_t)(elMat_18_23));
             _data_mat[564] = ((real_t)(elMat_18_24));
             _data_mat[565] = ((real_t)(elMat_18_25));
             _data_mat[566] = ((real_t)(elMat_18_26));
             _data_mat[567] = ((real_t)(elMat_18_27));
             _data_mat[568] = ((real_t)(elMat_18_28));
             _data_mat[569] = ((real_t)(elMat_18_29));
             _data_mat[570] = ((real_t)(elMat_19_0));
             _data_mat[571] = ((real_t)(elMat_19_1));
             _data_mat[572] = ((real_t)(elMat_19_2));
             _data_mat[573] = ((real_t)(elMat_19_3));
             _data_mat[574] = ((real_t)(elMat_19_4));
             _data_mat[575] = ((real_t)(elMat_19_5));
             _data_mat[576] = ((real_t)(elMat_19_6));
             _data_mat[577] = ((real_t)(elMat_19_7));
             _data_mat[578] = ((real_t)(elMat_19_8));
             _data_mat[579] = ((real_t)(elMat_19_9));
             _data_mat[580] = ((real_t)(elMat_19_10));
             _data_mat[581] = ((real_t)(elMat_19_11));
             _data_mat[582] = ((real_t)(elMat_19_12));
             _data_mat[583] = ((real_t)(elMat_19_13));
             _data_mat[584] = ((real_t)(elMat_19_14));
             _data_mat[585] = ((real_t)(elMat_19_15));
             _data_mat[586] = ((real_t)(elMat_19_16));
             _data_mat[587] = ((real_t)(elMat_19_17));
             _data_mat[588] = ((real_t)(elMat_19_18));
             _data_mat[589] = ((real_t)(elMat_19_19));
             _data_mat[590] = ((real_t)(elMat_19_20));
             _data_mat[591] = ((real_t)(elMat_19_21));
             _data_mat[592] = ((real_t)(elMat_19_22));
             _data_mat[593] = ((real_t)(elMat_19_23));
             _data_mat[594] = ((real_t)(elMat_19_24));
             _data_mat[595] = ((real_t)(elMat_19_25));
             _data_mat[596] = ((real_t)(elMat_19_26));
             _data_mat[597] = ((real_t)(elMat_19_27));
             _data_mat[598] = ((real_t)(elMat_19_28));
             _data_mat[599] = ((real_t)(elMat_19_29));
             _data_mat[600] = ((real_t)(elMat_20_0));
             _data_mat[601] = ((real_t)(elMat_20_1));
             _data_mat[602] = ((real_t)(elMat_20_2));
             _data_mat[603] = ((real_t)(elMat_20_3));
             _data_mat[604] = ((real_t)(elMat_20_4));
             _data_mat[605] = ((real_t)(elMat_20_5));
             _data_mat[606] = ((real_t)(elMat_20_6));
             _data_mat[607] = ((real_t)(elMat_20_7));
             _data_mat[608] = ((real_t)(elMat_20_8));
             _data_mat[609] = ((real_t)(elMat_20_9));
             _data_mat[610] = ((real_t)(elMat_20_10));
             _data_mat[611] = ((real_t)(elMat_20_11));
             _data_mat[612] = ((real_t)(elMat_20_12));
             _data_mat[613] = ((real_t)(elMat_20_13));
             _data_mat[614] = ((real_t)(elMat_20_14));
             _data_mat[615] = ((real_t)(elMat_20_15));
             _data_mat[616] = ((real_t)(elMat_20_16));
             _data_mat[617] = ((real_t)(elMat_20_17));
             _data_mat[618] = ((real_t)(elMat_20_18));
             _data_mat[619] = ((real_t)(elMat_20_19));
             _data_mat[620] = ((real_t)(elMat_20_20));
             _data_mat[621] = ((real_t)(elMat_20_21));
             _data_mat[622] = ((real_t)(elMat_20_22));
             _data_mat[623] = ((real_t)(elMat_20_23));
             _data_mat[624] = ((real_t)(elMat_20_24));
             _data_mat[625] = ((real_t)(elMat_20_25));
             _data_mat[626] = ((real_t)(elMat_20_26));
             _data_mat[627] = ((real_t)(elMat_20_27));
             _data_mat[628] = ((real_t)(elMat_20_28));
             _data_mat[629] = ((real_t)(elMat_20_29));
             _data_mat[630] = ((real_t)(elMat_21_0));
             _data_mat[631] = ((real_t)(elMat_21_1));
             _data_mat[632] = ((real_t)(elMat_21_2));
             _data_mat[633] = ((real_t)(elMat_21_3));
             _data_mat[634] = ((real_t)(elMat_21_4));
             _data_mat[635] = ((real_t)(elMat_21_5));
             _data_mat[636] = ((real_t)(elMat_21_6));
             _data_mat[637] = ((real_t)(elMat_21_7));
             _data_mat[638] = ((real_t)(elMat_21_8));
             _data_mat[639] = ((real_t)(elMat_21_9));
             _data_mat[640] = ((real_t)(elMat_21_10));
             _data_mat[641] = ((real_t)(elMat_21_11));
             _data_mat[642] = ((real_t)(elMat_21_12));
             _data_mat[643] = ((real_t)(elMat_21_13));
             _data_mat[644] = ((real_t)(elMat_21_14));
             _data_mat[645] = ((real_t)(elMat_21_15));
             _data_mat[646] = ((real_t)(elMat_21_16));
             _data_mat[647] = ((real_t)(elMat_21_17));
             _data_mat[648] = ((real_t)(elMat_21_18));
             _data_mat[649] = ((real_t)(elMat_21_19));
             _data_mat[650] = ((real_t)(elMat_21_20));
             _data_mat[651] = ((real_t)(elMat_21_21));
             _data_mat[652] = ((real_t)(elMat_21_22));
             _data_mat[653] = ((real_t)(elMat_21_23));
             _data_mat[654] = ((real_t)(elMat_21_24));
             _data_mat[655] = ((real_t)(elMat_21_25));
             _data_mat[656] = ((real_t)(elMat_21_26));
             _data_mat[657] = ((real_t)(elMat_21_27));
             _data_mat[658] = ((real_t)(elMat_21_28));
             _data_mat[659] = ((real_t)(elMat_21_29));
             _data_mat[660] = ((real_t)(elMat_22_0));
             _data_mat[661] = ((real_t)(elMat_22_1));
             _data_mat[662] = ((real_t)(elMat_22_2));
             _data_mat[663] = ((real_t)(elMat_22_3));
             _data_mat[664] = ((real_t)(elMat_22_4));
             _data_mat[665] = ((real_t)(elMat_22_5));
             _data_mat[666] = ((real_t)(elMat_22_6));
             _data_mat[667] = ((real_t)(elMat_22_7));
             _data_mat[668] = ((real_t)(elMat_22_8));
             _data_mat[669] = ((real_t)(elMat_22_9));
             _data_mat[670] = ((real_t)(elMat_22_10));
             _data_mat[671] = ((real_t)(elMat_22_11));
             _data_mat[672] = ((real_t)(elMat_22_12));
             _data_mat[673] = ((real_t)(elMat_22_13));
             _data_mat[674] = ((real_t)(elMat_22_14));
             _data_mat[675] = ((real_t)(elMat_22_15));
             _data_mat[676] = ((real_t)(elMat_22_16));
             _data_mat[677] = ((real_t)(elMat_22_17));
             _data_mat[678] = ((real_t)(elMat_22_18));
             _data_mat[679] = ((real_t)(elMat_22_19));
             _data_mat[680] = ((real_t)(elMat_22_20));
             _data_mat[681] = ((real_t)(elMat_22_21));
             _data_mat[682] = ((real_t)(elMat_22_22));
             _data_mat[683] = ((real_t)(elMat_22_23));
             _data_mat[684] = ((real_t)(elMat_22_24));
             _data_mat[685] = ((real_t)(elMat_22_25));
             _data_mat[686] = ((real_t)(elMat_22_26));
             _data_mat[687] = ((real_t)(elMat_22_27));
             _data_mat[688] = ((real_t)(elMat_22_28));
             _data_mat[689] = ((real_t)(elMat_22_29));
             _data_mat[690] = ((real_t)(elMat_23_0));
             _data_mat[691] = ((real_t)(elMat_23_1));
             _data_mat[692] = ((real_t)(elMat_23_2));
             _data_mat[693] = ((real_t)(elMat_23_3));
             _data_mat[694] = ((real_t)(elMat_23_4));
             _data_mat[695] = ((real_t)(elMat_23_5));
             _data_mat[696] = ((real_t)(elMat_23_6));
             _data_mat[697] = ((real_t)(elMat_23_7));
             _data_mat[698] = ((real_t)(elMat_23_8));
             _data_mat[699] = ((real_t)(elMat_23_9));
             _data_mat[700] = ((real_t)(elMat_23_10));
             _data_mat[701] = ((real_t)(elMat_23_11));
             _data_mat[702] = ((real_t)(elMat_23_12));
             _data_mat[703] = ((real_t)(elMat_23_13));
             _data_mat[704] = ((real_t)(elMat_23_14));
             _data_mat[705] = ((real_t)(elMat_23_15));
             _data_mat[706] = ((real_t)(elMat_23_16));
             _data_mat[707] = ((real_t)(elMat_23_17));
             _data_mat[708] = ((real_t)(elMat_23_18));
             _data_mat[709] = ((real_t)(elMat_23_19));
             _data_mat[710] = ((real_t)(elMat_23_20));
             _data_mat[711] = ((real_t)(elMat_23_21));
             _data_mat[712] = ((real_t)(elMat_23_22));
             _data_mat[713] = ((real_t)(elMat_23_23));
             _data_mat[714] = ((real_t)(elMat_23_24));
             _data_mat[715] = ((real_t)(elMat_23_25));
             _data_mat[716] = ((real_t)(elMat_23_26));
             _data_mat[717] = ((real_t)(elMat_23_27));
             _data_mat[718] = ((real_t)(elMat_23_28));
             _data_mat[719] = ((real_t)(elMat_23_29));
             _data_mat[720] = ((real_t)(elMat_24_0));
             _data_mat[721] = ((real_t)(elMat_24_1));
             _data_mat[722] = ((real_t)(elMat_24_2));
             _data_mat[723] = ((real_t)(elMat_24_3));
             _data_mat[724] = ((real_t)(elMat_24_4));
             _data_mat[725] = ((real_t)(elMat_24_5));
             _data_mat[726] = ((real_t)(elMat_24_6));
             _data_mat[727] = ((real_t)(elMat_24_7));
             _data_mat[728] = ((real_t)(elMat_24_8));
             _data_mat[729] = ((real_t)(elMat_24_9));
             _data_mat[730] = ((real_t)(elMat_24_10));
             _data_mat[731] = ((real_t)(elMat_24_11));
             _data_mat[732] = ((real_t)(elMat_24_12));
             _data_mat[733] = ((real_t)(elMat_24_13));
             _data_mat[734] = ((real_t)(elMat_24_14));
             _data_mat[735] = ((real_t)(elMat_24_15));
             _data_mat[736] = ((real_t)(elMat_24_16));
             _data_mat[737] = ((real_t)(elMat_24_17));
             _data_mat[738] = ((real_t)(elMat_24_18));
             _data_mat[739] = ((real_t)(elMat_24_19));
             _data_mat[740] = ((real_t)(elMat_24_20));
             _data_mat[741] = ((real_t)(elMat_24_21));
             _data_mat[742] = ((real_t)(elMat_24_22));
             _data_mat[743] = ((real_t)(elMat_24_23));
             _data_mat[744] = ((real_t)(elMat_24_24));
             _data_mat[745] = ((real_t)(elMat_24_25));
             _data_mat[746] = ((real_t)(elMat_24_26));
             _data_mat[747] = ((real_t)(elMat_24_27));
             _data_mat[748] = ((real_t)(elMat_24_28));
             _data_mat[749] = ((real_t)(elMat_24_29));
             _data_mat[750] = ((real_t)(elMat_25_0));
             _data_mat[751] = ((real_t)(elMat_25_1));
             _data_mat[752] = ((real_t)(elMat_25_2));
             _data_mat[753] = ((real_t)(elMat_25_3));
             _data_mat[754] = ((real_t)(elMat_25_4));
             _data_mat[755] = ((real_t)(elMat_25_5));
             _data_mat[756] = ((real_t)(elMat_25_6));
             _data_mat[757] = ((real_t)(elMat_25_7));
             _data_mat[758] = ((real_t)(elMat_25_8));
             _data_mat[759] = ((real_t)(elMat_25_9));
             _data_mat[760] = ((real_t)(elMat_25_10));
             _data_mat[761] = ((real_t)(elMat_25_11));
             _data_mat[762] = ((real_t)(elMat_25_12));
             _data_mat[763] = ((real_t)(elMat_25_13));
             _data_mat[764] = ((real_t)(elMat_25_14));
             _data_mat[765] = ((real_t)(elMat_25_15));
             _data_mat[766] = ((real_t)(elMat_25_16));
             _data_mat[767] = ((real_t)(elMat_25_17));
             _data_mat[768] = ((real_t)(elMat_25_18));
             _data_mat[769] = ((real_t)(elMat_25_19));
             _data_mat[770] = ((real_t)(elMat_25_20));
             _data_mat[771] = ((real_t)(elMat_25_21));
             _data_mat[772] = ((real_t)(elMat_25_22));
             _data_mat[773] = ((real_t)(elMat_25_23));
             _data_mat[774] = ((real_t)(elMat_25_24));
             _data_mat[775] = ((real_t)(elMat_25_25));
             _data_mat[776] = ((real_t)(elMat_25_26));
             _data_mat[777] = ((real_t)(elMat_25_27));
             _data_mat[778] = ((real_t)(elMat_25_28));
             _data_mat[779] = ((real_t)(elMat_25_29));
             _data_mat[780] = ((real_t)(elMat_26_0));
             _data_mat[781] = ((real_t)(elMat_26_1));
             _data_mat[782] = ((real_t)(elMat_26_2));
             _data_mat[783] = ((real_t)(elMat_26_3));
             _data_mat[784] = ((real_t)(elMat_26_4));
             _data_mat[785] = ((real_t)(elMat_26_5));
             _data_mat[786] = ((real_t)(elMat_26_6));
             _data_mat[787] = ((real_t)(elMat_26_7));
             _data_mat[788] = ((real_t)(elMat_26_8));
             _data_mat[789] = ((real_t)(elMat_26_9));
             _data_mat[790] = ((real_t)(elMat_26_10));
             _data_mat[791] = ((real_t)(elMat_26_11));
             _data_mat[792] = ((real_t)(elMat_26_12));
             _data_mat[793] = ((real_t)(elMat_26_13));
             _data_mat[794] = ((real_t)(elMat_26_14));
             _data_mat[795] = ((real_t)(elMat_26_15));
             _data_mat[796] = ((real_t)(elMat_26_16));
             _data_mat[797] = ((real_t)(elMat_26_17));
             _data_mat[798] = ((real_t)(elMat_26_18));
             _data_mat[799] = ((real_t)(elMat_26_19));
             _data_mat[800] = ((real_t)(elMat_26_20));
             _data_mat[801] = ((real_t)(elMat_26_21));
             _data_mat[802] = ((real_t)(elMat_26_22));
             _data_mat[803] = ((real_t)(elMat_26_23));
             _data_mat[804] = ((real_t)(elMat_26_24));
             _data_mat[805] = ((real_t)(elMat_26_25));
             _data_mat[806] = ((real_t)(elMat_26_26));
             _data_mat[807] = ((real_t)(elMat_26_27));
             _data_mat[808] = ((real_t)(elMat_26_28));
             _data_mat[809] = ((real_t)(elMat_26_29));
             _data_mat[810] = ((real_t)(elMat_27_0));
             _data_mat[811] = ((real_t)(elMat_27_1));
             _data_mat[812] = ((real_t)(elMat_27_2));
             _data_mat[813] = ((real_t)(elMat_27_3));
             _data_mat[814] = ((real_t)(elMat_27_4));
             _data_mat[815] = ((real_t)(elMat_27_5));
             _data_mat[816] = ((real_t)(elMat_27_6));
             _data_mat[817] = ((real_t)(elMat_27_7));
             _data_mat[818] = ((real_t)(elMat_27_8));
             _data_mat[819] = ((real_t)(elMat_27_9));
             _data_mat[820] = ((real_t)(elMat_27_10));
             _data_mat[821] = ((real_t)(elMat_27_11));
             _data_mat[822] = ((real_t)(elMat_27_12));
             _data_mat[823] = ((real_t)(elMat_27_13));
             _data_mat[824] = ((real_t)(elMat_27_14));
             _data_mat[825] = ((real_t)(elMat_27_15));
             _data_mat[826] = ((real_t)(elMat_27_16));
             _data_mat[827] = ((real_t)(elMat_27_17));
             _data_mat[828] = ((real_t)(elMat_27_18));
             _data_mat[829] = ((real_t)(elMat_27_19));
             _data_mat[830] = ((real_t)(elMat_27_20));
             _data_mat[831] = ((real_t)(elMat_27_21));
             _data_mat[832] = ((real_t)(elMat_27_22));
             _data_mat[833] = ((real_t)(elMat_27_23));
             _data_mat[834] = ((real_t)(elMat_27_24));
             _data_mat[835] = ((real_t)(elMat_27_25));
             _data_mat[836] = ((real_t)(elMat_27_26));
             _data_mat[837] = ((real_t)(elMat_27_27));
             _data_mat[838] = ((real_t)(elMat_27_28));
             _data_mat[839] = ((real_t)(elMat_27_29));
             _data_mat[840] = ((real_t)(elMat_28_0));
             _data_mat[841] = ((real_t)(elMat_28_1));
             _data_mat[842] = ((real_t)(elMat_28_2));
             _data_mat[843] = ((real_t)(elMat_28_3));
             _data_mat[844] = ((real_t)(elMat_28_4));
             _data_mat[845] = ((real_t)(elMat_28_5));
             _data_mat[846] = ((real_t)(elMat_28_6));
             _data_mat[847] = ((real_t)(elMat_28_7));
             _data_mat[848] = ((real_t)(elMat_28_8));
             _data_mat[849] = ((real_t)(elMat_28_9));
             _data_mat[850] = ((real_t)(elMat_28_10));
             _data_mat[851] = ((real_t)(elMat_28_11));
             _data_mat[852] = ((real_t)(elMat_28_12));
             _data_mat[853] = ((real_t)(elMat_28_13));
             _data_mat[854] = ((real_t)(elMat_28_14));
             _data_mat[855] = ((real_t)(elMat_28_15));
             _data_mat[856] = ((real_t)(elMat_28_16));
             _data_mat[857] = ((real_t)(elMat_28_17));
             _data_mat[858] = ((real_t)(elMat_28_18));
             _data_mat[859] = ((real_t)(elMat_28_19));
             _data_mat[860] = ((real_t)(elMat_28_20));
             _data_mat[861] = ((real_t)(elMat_28_21));
             _data_mat[862] = ((real_t)(elMat_28_22));
             _data_mat[863] = ((real_t)(elMat_28_23));
             _data_mat[864] = ((real_t)(elMat_28_24));
             _data_mat[865] = ((real_t)(elMat_28_25));
             _data_mat[866] = ((real_t)(elMat_28_26));
             _data_mat[867] = ((real_t)(elMat_28_27));
             _data_mat[868] = ((real_t)(elMat_28_28));
             _data_mat[869] = ((real_t)(elMat_28_29));
             _data_mat[870] = ((real_t)(elMat_29_0));
             _data_mat[871] = ((real_t)(elMat_29_1));
             _data_mat[872] = ((real_t)(elMat_29_2));
             _data_mat[873] = ((real_t)(elMat_29_3));
             _data_mat[874] = ((real_t)(elMat_29_4));
             _data_mat[875] = ((real_t)(elMat_29_5));
             _data_mat[876] = ((real_t)(elMat_29_6));
             _data_mat[877] = ((real_t)(elMat_29_7));
             _data_mat[878] = ((real_t)(elMat_29_8));
             _data_mat[879] = ((real_t)(elMat_29_9));
             _data_mat[880] = ((real_t)(elMat_29_10));
             _data_mat[881] = ((real_t)(elMat_29_11));
             _data_mat[882] = ((real_t)(elMat_29_12));
             _data_mat[883] = ((real_t)(elMat_29_13));
             _data_mat[884] = ((real_t)(elMat_29_14));
             _data_mat[885] = ((real_t)(elMat_29_15));
             _data_mat[886] = ((real_t)(elMat_29_16));
             _data_mat[887] = ((real_t)(elMat_29_17));
             _data_mat[888] = ((real_t)(elMat_29_18));
             _data_mat[889] = ((real_t)(elMat_29_19));
             _data_mat[890] = ((real_t)(elMat_29_20));
             _data_mat[891] = ((real_t)(elMat_29_21));
             _data_mat[892] = ((real_t)(elMat_29_22));
             _data_mat[893] = ((real_t)(elMat_29_23));
             _data_mat[894] = ((real_t)(elMat_29_24));
             _data_mat[895] = ((real_t)(elMat_29_25));
             _data_mat[896] = ((real_t)(elMat_29_26));
             _data_mat[897] = ((real_t)(elMat_29_27));
             _data_mat[898] = ((real_t)(elMat_29_28));
             _data_mat[899] = ((real_t)(elMat_29_29));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_BLUE_UP[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_0_12 = q_acc_0_12;
             const real_t elMat_0_13 = q_acc_0_13;
             const real_t elMat_0_14 = q_acc_0_14;
             const real_t elMat_0_15 = q_acc_0_15;
             const real_t elMat_0_16 = q_acc_0_16;
             const real_t elMat_0_17 = q_acc_0_17;
             const real_t elMat_0_18 = q_acc_0_18;
             const real_t elMat_0_19 = q_acc_0_19;
             const real_t elMat_0_20 = q_acc_0_20;
             const real_t elMat_0_21 = q_acc_0_21;
             const real_t elMat_0_22 = q_acc_0_22;
             const real_t elMat_0_23 = q_acc_0_23;
             const real_t elMat_0_24 = q_acc_0_24;
             const real_t elMat_0_25 = q_acc_0_25;
             const real_t elMat_0_26 = q_acc_0_26;
             const real_t elMat_0_27 = q_acc_0_27;
             const real_t elMat_0_28 = q_acc_0_28;
             const real_t elMat_0_29 = q_acc_0_29;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_1_12 = q_acc_1_12;
             const real_t elMat_1_13 = q_acc_1_13;
             const real_t elMat_1_14 = q_acc_1_14;
             const real_t elMat_1_15 = q_acc_1_15;
             const real_t elMat_1_16 = q_acc_1_16;
             const real_t elMat_1_17 = q_acc_1_17;
             const real_t elMat_1_18 = q_acc_1_18;
             const real_t elMat_1_19 = q_acc_1_19;
             const real_t elMat_1_20 = q_acc_1_20;
             const real_t elMat_1_21 = q_acc_1_21;
             const real_t elMat_1_22 = q_acc_1_22;
             const real_t elMat_1_23 = q_acc_1_23;
             const real_t elMat_1_24 = q_acc_1_24;
             const real_t elMat_1_25 = q_acc_1_25;
             const real_t elMat_1_26 = q_acc_1_26;
             const real_t elMat_1_27 = q_acc_1_27;
             const real_t elMat_1_28 = q_acc_1_28;
             const real_t elMat_1_29 = q_acc_1_29;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_2_12 = q_acc_2_12;
             const real_t elMat_2_13 = q_acc_2_13;
             const real_t elMat_2_14 = q_acc_2_14;
             const real_t elMat_2_15 = q_acc_2_15;
             const real_t elMat_2_16 = q_acc_2_16;
             const real_t elMat_2_17 = q_acc_2_17;
             const real_t elMat_2_18 = q_acc_2_18;
             const real_t elMat_2_19 = q_acc_2_19;
             const real_t elMat_2_20 = q_acc_2_20;
             const real_t elMat_2_21 = q_acc_2_21;
             const real_t elMat_2_22 = q_acc_2_22;
             const real_t elMat_2_23 = q_acc_2_23;
             const real_t elMat_2_24 = q_acc_2_24;
             const real_t elMat_2_25 = q_acc_2_25;
             const real_t elMat_2_26 = q_acc_2_26;
             const real_t elMat_2_27 = q_acc_2_27;
             const real_t elMat_2_28 = q_acc_2_28;
             const real_t elMat_2_29 = q_acc_2_29;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_3_12 = q_acc_3_12;
             const real_t elMat_3_13 = q_acc_3_13;
             const real_t elMat_3_14 = q_acc_3_14;
             const real_t elMat_3_15 = q_acc_3_15;
             const real_t elMat_3_16 = q_acc_3_16;
             const real_t elMat_3_17 = q_acc_3_17;
             const real_t elMat_3_18 = q_acc_3_18;
             const real_t elMat_3_19 = q_acc_3_19;
             const real_t elMat_3_20 = q_acc_3_20;
             const real_t elMat_3_21 = q_acc_3_21;
             const real_t elMat_3_22 = q_acc_3_22;
             const real_t elMat_3_23 = q_acc_3_23;
             const real_t elMat_3_24 = q_acc_3_24;
             const real_t elMat_3_25 = q_acc_3_25;
             const real_t elMat_3_26 = q_acc_3_26;
             const real_t elMat_3_27 = q_acc_3_27;
             const real_t elMat_3_28 = q_acc_3_28;
             const real_t elMat_3_29 = q_acc_3_29;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_4_12 = q_acc_4_12;
             const real_t elMat_4_13 = q_acc_4_13;
             const real_t elMat_4_14 = q_acc_4_14;
             const real_t elMat_4_15 = q_acc_4_15;
             const real_t elMat_4_16 = q_acc_4_16;
             const real_t elMat_4_17 = q_acc_4_17;
             const real_t elMat_4_18 = q_acc_4_18;
             const real_t elMat_4_19 = q_acc_4_19;
             const real_t elMat_4_20 = q_acc_4_20;
             const real_t elMat_4_21 = q_acc_4_21;
             const real_t elMat_4_22 = q_acc_4_22;
             const real_t elMat_4_23 = q_acc_4_23;
             const real_t elMat_4_24 = q_acc_4_24;
             const real_t elMat_4_25 = q_acc_4_25;
             const real_t elMat_4_26 = q_acc_4_26;
             const real_t elMat_4_27 = q_acc_4_27;
             const real_t elMat_4_28 = q_acc_4_28;
             const real_t elMat_4_29 = q_acc_4_29;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_5_12 = q_acc_5_12;
             const real_t elMat_5_13 = q_acc_5_13;
             const real_t elMat_5_14 = q_acc_5_14;
             const real_t elMat_5_15 = q_acc_5_15;
             const real_t elMat_5_16 = q_acc_5_16;
             const real_t elMat_5_17 = q_acc_5_17;
             const real_t elMat_5_18 = q_acc_5_18;
             const real_t elMat_5_19 = q_acc_5_19;
             const real_t elMat_5_20 = q_acc_5_20;
             const real_t elMat_5_21 = q_acc_5_21;
             const real_t elMat_5_22 = q_acc_5_22;
             const real_t elMat_5_23 = q_acc_5_23;
             const real_t elMat_5_24 = q_acc_5_24;
             const real_t elMat_5_25 = q_acc_5_25;
             const real_t elMat_5_26 = q_acc_5_26;
             const real_t elMat_5_27 = q_acc_5_27;
             const real_t elMat_5_28 = q_acc_5_28;
             const real_t elMat_5_29 = q_acc_5_29;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_6_12 = q_acc_6_12;
             const real_t elMat_6_13 = q_acc_6_13;
             const real_t elMat_6_14 = q_acc_6_14;
             const real_t elMat_6_15 = q_acc_6_15;
             const real_t elMat_6_16 = q_acc_6_16;
             const real_t elMat_6_17 = q_acc_6_17;
             const real_t elMat_6_18 = q_acc_6_18;
             const real_t elMat_6_19 = q_acc_6_19;
             const real_t elMat_6_20 = q_acc_6_20;
             const real_t elMat_6_21 = q_acc_6_21;
             const real_t elMat_6_22 = q_acc_6_22;
             const real_t elMat_6_23 = q_acc_6_23;
             const real_t elMat_6_24 = q_acc_6_24;
             const real_t elMat_6_25 = q_acc_6_25;
             const real_t elMat_6_26 = q_acc_6_26;
             const real_t elMat_6_27 = q_acc_6_27;
             const real_t elMat_6_28 = q_acc_6_28;
             const real_t elMat_6_29 = q_acc_6_29;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_7_12 = q_acc_7_12;
             const real_t elMat_7_13 = q_acc_7_13;
             const real_t elMat_7_14 = q_acc_7_14;
             const real_t elMat_7_15 = q_acc_7_15;
             const real_t elMat_7_16 = q_acc_7_16;
             const real_t elMat_7_17 = q_acc_7_17;
             const real_t elMat_7_18 = q_acc_7_18;
             const real_t elMat_7_19 = q_acc_7_19;
             const real_t elMat_7_20 = q_acc_7_20;
             const real_t elMat_7_21 = q_acc_7_21;
             const real_t elMat_7_22 = q_acc_7_22;
             const real_t elMat_7_23 = q_acc_7_23;
             const real_t elMat_7_24 = q_acc_7_24;
             const real_t elMat_7_25 = q_acc_7_25;
             const real_t elMat_7_26 = q_acc_7_26;
             const real_t elMat_7_27 = q_acc_7_27;
             const real_t elMat_7_28 = q_acc_7_28;
             const real_t elMat_7_29 = q_acc_7_29;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_8_12 = q_acc_8_12;
             const real_t elMat_8_13 = q_acc_8_13;
             const real_t elMat_8_14 = q_acc_8_14;
             const real_t elMat_8_15 = q_acc_8_15;
             const real_t elMat_8_16 = q_acc_8_16;
             const real_t elMat_8_17 = q_acc_8_17;
             const real_t elMat_8_18 = q_acc_8_18;
             const real_t elMat_8_19 = q_acc_8_19;
             const real_t elMat_8_20 = q_acc_8_20;
             const real_t elMat_8_21 = q_acc_8_21;
             const real_t elMat_8_22 = q_acc_8_22;
             const real_t elMat_8_23 = q_acc_8_23;
             const real_t elMat_8_24 = q_acc_8_24;
             const real_t elMat_8_25 = q_acc_8_25;
             const real_t elMat_8_26 = q_acc_8_26;
             const real_t elMat_8_27 = q_acc_8_27;
             const real_t elMat_8_28 = q_acc_8_28;
             const real_t elMat_8_29 = q_acc_8_29;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_9_12 = q_acc_9_12;
             const real_t elMat_9_13 = q_acc_9_13;
             const real_t elMat_9_14 = q_acc_9_14;
             const real_t elMat_9_15 = q_acc_9_15;
             const real_t elMat_9_16 = q_acc_9_16;
             const real_t elMat_9_17 = q_acc_9_17;
             const real_t elMat_9_18 = q_acc_9_18;
             const real_t elMat_9_19 = q_acc_9_19;
             const real_t elMat_9_20 = q_acc_9_20;
             const real_t elMat_9_21 = q_acc_9_21;
             const real_t elMat_9_22 = q_acc_9_22;
             const real_t elMat_9_23 = q_acc_9_23;
             const real_t elMat_9_24 = q_acc_9_24;
             const real_t elMat_9_25 = q_acc_9_25;
             const real_t elMat_9_26 = q_acc_9_26;
             const real_t elMat_9_27 = q_acc_9_27;
             const real_t elMat_9_28 = q_acc_9_28;
             const real_t elMat_9_29 = q_acc_9_29;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_10_12 = q_acc_10_12;
             const real_t elMat_10_13 = q_acc_10_13;
             const real_t elMat_10_14 = q_acc_10_14;
             const real_t elMat_10_15 = q_acc_10_15;
             const real_t elMat_10_16 = q_acc_10_16;
             const real_t elMat_10_17 = q_acc_10_17;
             const real_t elMat_10_18 = q_acc_10_18;
             const real_t elMat_10_19 = q_acc_10_19;
             const real_t elMat_10_20 = q_acc_10_20;
             const real_t elMat_10_21 = q_acc_10_21;
             const real_t elMat_10_22 = q_acc_10_22;
             const real_t elMat_10_23 = q_acc_10_23;
             const real_t elMat_10_24 = q_acc_10_24;
             const real_t elMat_10_25 = q_acc_10_25;
             const real_t elMat_10_26 = q_acc_10_26;
             const real_t elMat_10_27 = q_acc_10_27;
             const real_t elMat_10_28 = q_acc_10_28;
             const real_t elMat_10_29 = q_acc_10_29;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
             const real_t elMat_11_12 = q_acc_11_12;
             const real_t elMat_11_13 = q_acc_11_13;
             const real_t elMat_11_14 = q_acc_11_14;
             const real_t elMat_11_15 = q_acc_11_15;
             const real_t elMat_11_16 = q_acc_11_16;
             const real_t elMat_11_17 = q_acc_11_17;
             const real_t elMat_11_18 = q_acc_11_18;
             const real_t elMat_11_19 = q_acc_11_19;
             const real_t elMat_11_20 = q_acc_11_20;
             const real_t elMat_11_21 = q_acc_11_21;
             const real_t elMat_11_22 = q_acc_11_22;
             const real_t elMat_11_23 = q_acc_11_23;
             const real_t elMat_11_24 = q_acc_11_24;
             const real_t elMat_11_25 = q_acc_11_25;
             const real_t elMat_11_26 = q_acc_11_26;
             const real_t elMat_11_27 = q_acc_11_27;
             const real_t elMat_11_28 = q_acc_11_28;
             const real_t elMat_11_29 = q_acc_11_29;
             const real_t elMat_12_0 = q_acc_0_12;
             const real_t elMat_12_1 = q_acc_1_12;
             const real_t elMat_12_2 = q_acc_2_12;
             const real_t elMat_12_3 = q_acc_3_12;
             const real_t elMat_12_4 = q_acc_4_12;
             const real_t elMat_12_5 = q_acc_5_12;
             const real_t elMat_12_6 = q_acc_6_12;
             const real_t elMat_12_7 = q_acc_7_12;
             const real_t elMat_12_8 = q_acc_8_12;
             const real_t elMat_12_9 = q_acc_9_12;
             const real_t elMat_12_10 = q_acc_10_12;
             const real_t elMat_12_11 = q_acc_11_12;
             const real_t elMat_12_12 = q_acc_12_12;
             const real_t elMat_12_13 = q_acc_12_13;
             const real_t elMat_12_14 = q_acc_12_14;
             const real_t elMat_12_15 = q_acc_12_15;
             const real_t elMat_12_16 = q_acc_12_16;
             const real_t elMat_12_17 = q_acc_12_17;
             const real_t elMat_12_18 = q_acc_12_18;
             const real_t elMat_12_19 = q_acc_12_19;
             const real_t elMat_12_20 = q_acc_12_20;
             const real_t elMat_12_21 = q_acc_12_21;
             const real_t elMat_12_22 = q_acc_12_22;
             const real_t elMat_12_23 = q_acc_12_23;
             const real_t elMat_12_24 = q_acc_12_24;
             const real_t elMat_12_25 = q_acc_12_25;
             const real_t elMat_12_26 = q_acc_12_26;
             const real_t elMat_12_27 = q_acc_12_27;
             const real_t elMat_12_28 = q_acc_12_28;
             const real_t elMat_12_29 = q_acc_12_29;
             const real_t elMat_13_0 = q_acc_0_13;
             const real_t elMat_13_1 = q_acc_1_13;
             const real_t elMat_13_2 = q_acc_2_13;
             const real_t elMat_13_3 = q_acc_3_13;
             const real_t elMat_13_4 = q_acc_4_13;
             const real_t elMat_13_5 = q_acc_5_13;
             const real_t elMat_13_6 = q_acc_6_13;
             const real_t elMat_13_7 = q_acc_7_13;
             const real_t elMat_13_8 = q_acc_8_13;
             const real_t elMat_13_9 = q_acc_9_13;
             const real_t elMat_13_10 = q_acc_10_13;
             const real_t elMat_13_11 = q_acc_11_13;
             const real_t elMat_13_12 = q_acc_12_13;
             const real_t elMat_13_13 = q_acc_13_13;
             const real_t elMat_13_14 = q_acc_13_14;
             const real_t elMat_13_15 = q_acc_13_15;
             const real_t elMat_13_16 = q_acc_13_16;
             const real_t elMat_13_17 = q_acc_13_17;
             const real_t elMat_13_18 = q_acc_13_18;
             const real_t elMat_13_19 = q_acc_13_19;
             const real_t elMat_13_20 = q_acc_13_20;
             const real_t elMat_13_21 = q_acc_13_21;
             const real_t elMat_13_22 = q_acc_13_22;
             const real_t elMat_13_23 = q_acc_13_23;
             const real_t elMat_13_24 = q_acc_13_24;
             const real_t elMat_13_25 = q_acc_13_25;
             const real_t elMat_13_26 = q_acc_13_26;
             const real_t elMat_13_27 = q_acc_13_27;
             const real_t elMat_13_28 = q_acc_13_28;
             const real_t elMat_13_29 = q_acc_13_29;
             const real_t elMat_14_0 = q_acc_0_14;
             const real_t elMat_14_1 = q_acc_1_14;
             const real_t elMat_14_2 = q_acc_2_14;
             const real_t elMat_14_3 = q_acc_3_14;
             const real_t elMat_14_4 = q_acc_4_14;
             const real_t elMat_14_5 = q_acc_5_14;
             const real_t elMat_14_6 = q_acc_6_14;
             const real_t elMat_14_7 = q_acc_7_14;
             const real_t elMat_14_8 = q_acc_8_14;
             const real_t elMat_14_9 = q_acc_9_14;
             const real_t elMat_14_10 = q_acc_10_14;
             const real_t elMat_14_11 = q_acc_11_14;
             const real_t elMat_14_12 = q_acc_12_14;
             const real_t elMat_14_13 = q_acc_13_14;
             const real_t elMat_14_14 = q_acc_14_14;
             const real_t elMat_14_15 = q_acc_14_15;
             const real_t elMat_14_16 = q_acc_14_16;
             const real_t elMat_14_17 = q_acc_14_17;
             const real_t elMat_14_18 = q_acc_14_18;
             const real_t elMat_14_19 = q_acc_14_19;
             const real_t elMat_14_20 = q_acc_14_20;
             const real_t elMat_14_21 = q_acc_14_21;
             const real_t elMat_14_22 = q_acc_14_22;
             const real_t elMat_14_23 = q_acc_14_23;
             const real_t elMat_14_24 = q_acc_14_24;
             const real_t elMat_14_25 = q_acc_14_25;
             const real_t elMat_14_26 = q_acc_14_26;
             const real_t elMat_14_27 = q_acc_14_27;
             const real_t elMat_14_28 = q_acc_14_28;
             const real_t elMat_14_29 = q_acc_14_29;
             const real_t elMat_15_0 = q_acc_0_15;
             const real_t elMat_15_1 = q_acc_1_15;
             const real_t elMat_15_2 = q_acc_2_15;
             const real_t elMat_15_3 = q_acc_3_15;
             const real_t elMat_15_4 = q_acc_4_15;
             const real_t elMat_15_5 = q_acc_5_15;
             const real_t elMat_15_6 = q_acc_6_15;
             const real_t elMat_15_7 = q_acc_7_15;
             const real_t elMat_15_8 = q_acc_8_15;
             const real_t elMat_15_9 = q_acc_9_15;
             const real_t elMat_15_10 = q_acc_10_15;
             const real_t elMat_15_11 = q_acc_11_15;
             const real_t elMat_15_12 = q_acc_12_15;
             const real_t elMat_15_13 = q_acc_13_15;
             const real_t elMat_15_14 = q_acc_14_15;
             const real_t elMat_15_15 = q_acc_15_15;
             const real_t elMat_15_16 = q_acc_15_16;
             const real_t elMat_15_17 = q_acc_15_17;
             const real_t elMat_15_18 = q_acc_15_18;
             const real_t elMat_15_19 = q_acc_15_19;
             const real_t elMat_15_20 = q_acc_15_20;
             const real_t elMat_15_21 = q_acc_15_21;
             const real_t elMat_15_22 = q_acc_15_22;
             const real_t elMat_15_23 = q_acc_15_23;
             const real_t elMat_15_24 = q_acc_15_24;
             const real_t elMat_15_25 = q_acc_15_25;
             const real_t elMat_15_26 = q_acc_15_26;
             const real_t elMat_15_27 = q_acc_15_27;
             const real_t elMat_15_28 = q_acc_15_28;
             const real_t elMat_15_29 = q_acc_15_29;
             const real_t elMat_16_0 = q_acc_0_16;
             const real_t elMat_16_1 = q_acc_1_16;
             const real_t elMat_16_2 = q_acc_2_16;
             const real_t elMat_16_3 = q_acc_3_16;
             const real_t elMat_16_4 = q_acc_4_16;
             const real_t elMat_16_5 = q_acc_5_16;
             const real_t elMat_16_6 = q_acc_6_16;
             const real_t elMat_16_7 = q_acc_7_16;
             const real_t elMat_16_8 = q_acc_8_16;
             const real_t elMat_16_9 = q_acc_9_16;
             const real_t elMat_16_10 = q_acc_10_16;
             const real_t elMat_16_11 = q_acc_11_16;
             const real_t elMat_16_12 = q_acc_12_16;
             const real_t elMat_16_13 = q_acc_13_16;
             const real_t elMat_16_14 = q_acc_14_16;
             const real_t elMat_16_15 = q_acc_15_16;
             const real_t elMat_16_16 = q_acc_16_16;
             const real_t elMat_16_17 = q_acc_16_17;
             const real_t elMat_16_18 = q_acc_16_18;
             const real_t elMat_16_19 = q_acc_16_19;
             const real_t elMat_16_20 = q_acc_16_20;
             const real_t elMat_16_21 = q_acc_16_21;
             const real_t elMat_16_22 = q_acc_16_22;
             const real_t elMat_16_23 = q_acc_16_23;
             const real_t elMat_16_24 = q_acc_16_24;
             const real_t elMat_16_25 = q_acc_16_25;
             const real_t elMat_16_26 = q_acc_16_26;
             const real_t elMat_16_27 = q_acc_16_27;
             const real_t elMat_16_28 = q_acc_16_28;
             const real_t elMat_16_29 = q_acc_16_29;
             const real_t elMat_17_0 = q_acc_0_17;
             const real_t elMat_17_1 = q_acc_1_17;
             const real_t elMat_17_2 = q_acc_2_17;
             const real_t elMat_17_3 = q_acc_3_17;
             const real_t elMat_17_4 = q_acc_4_17;
             const real_t elMat_17_5 = q_acc_5_17;
             const real_t elMat_17_6 = q_acc_6_17;
             const real_t elMat_17_7 = q_acc_7_17;
             const real_t elMat_17_8 = q_acc_8_17;
             const real_t elMat_17_9 = q_acc_9_17;
             const real_t elMat_17_10 = q_acc_10_17;
             const real_t elMat_17_11 = q_acc_11_17;
             const real_t elMat_17_12 = q_acc_12_17;
             const real_t elMat_17_13 = q_acc_13_17;
             const real_t elMat_17_14 = q_acc_14_17;
             const real_t elMat_17_15 = q_acc_15_17;
             const real_t elMat_17_16 = q_acc_16_17;
             const real_t elMat_17_17 = q_acc_17_17;
             const real_t elMat_17_18 = q_acc_17_18;
             const real_t elMat_17_19 = q_acc_17_19;
             const real_t elMat_17_20 = q_acc_17_20;
             const real_t elMat_17_21 = q_acc_17_21;
             const real_t elMat_17_22 = q_acc_17_22;
             const real_t elMat_17_23 = q_acc_17_23;
             const real_t elMat_17_24 = q_acc_17_24;
             const real_t elMat_17_25 = q_acc_17_25;
             const real_t elMat_17_26 = q_acc_17_26;
             const real_t elMat_17_27 = q_acc_17_27;
             const real_t elMat_17_28 = q_acc_17_28;
             const real_t elMat_17_29 = q_acc_17_29;
             const real_t elMat_18_0 = q_acc_0_18;
             const real_t elMat_18_1 = q_acc_1_18;
             const real_t elMat_18_2 = q_acc_2_18;
             const real_t elMat_18_3 = q_acc_3_18;
             const real_t elMat_18_4 = q_acc_4_18;
             const real_t elMat_18_5 = q_acc_5_18;
             const real_t elMat_18_6 = q_acc_6_18;
             const real_t elMat_18_7 = q_acc_7_18;
             const real_t elMat_18_8 = q_acc_8_18;
             const real_t elMat_18_9 = q_acc_9_18;
             const real_t elMat_18_10 = q_acc_10_18;
             const real_t elMat_18_11 = q_acc_11_18;
             const real_t elMat_18_12 = q_acc_12_18;
             const real_t elMat_18_13 = q_acc_13_18;
             const real_t elMat_18_14 = q_acc_14_18;
             const real_t elMat_18_15 = q_acc_15_18;
             const real_t elMat_18_16 = q_acc_16_18;
             const real_t elMat_18_17 = q_acc_17_18;
             const real_t elMat_18_18 = q_acc_18_18;
             const real_t elMat_18_19 = q_acc_18_19;
             const real_t elMat_18_20 = q_acc_18_20;
             const real_t elMat_18_21 = q_acc_18_21;
             const real_t elMat_18_22 = q_acc_18_22;
             const real_t elMat_18_23 = q_acc_18_23;
             const real_t elMat_18_24 = q_acc_18_24;
             const real_t elMat_18_25 = q_acc_18_25;
             const real_t elMat_18_26 = q_acc_18_26;
             const real_t elMat_18_27 = q_acc_18_27;
             const real_t elMat_18_28 = q_acc_18_28;
             const real_t elMat_18_29 = q_acc_18_29;
             const real_t elMat_19_0 = q_acc_0_19;
             const real_t elMat_19_1 = q_acc_1_19;
             const real_t elMat_19_2 = q_acc_2_19;
             const real_t elMat_19_3 = q_acc_3_19;
             const real_t elMat_19_4 = q_acc_4_19;
             const real_t elMat_19_5 = q_acc_5_19;
             const real_t elMat_19_6 = q_acc_6_19;
             const real_t elMat_19_7 = q_acc_7_19;
             const real_t elMat_19_8 = q_acc_8_19;
             const real_t elMat_19_9 = q_acc_9_19;
             const real_t elMat_19_10 = q_acc_10_19;
             const real_t elMat_19_11 = q_acc_11_19;
             const real_t elMat_19_12 = q_acc_12_19;
             const real_t elMat_19_13 = q_acc_13_19;
             const real_t elMat_19_14 = q_acc_14_19;
             const real_t elMat_19_15 = q_acc_15_19;
             const real_t elMat_19_16 = q_acc_16_19;
             const real_t elMat_19_17 = q_acc_17_19;
             const real_t elMat_19_18 = q_acc_18_19;
             const real_t elMat_19_19 = q_acc_19_19;
             const real_t elMat_19_20 = q_acc_19_20;
             const real_t elMat_19_21 = q_acc_19_21;
             const real_t elMat_19_22 = q_acc_19_22;
             const real_t elMat_19_23 = q_acc_19_23;
             const real_t elMat_19_24 = q_acc_19_24;
             const real_t elMat_19_25 = q_acc_19_25;
             const real_t elMat_19_26 = q_acc_19_26;
             const real_t elMat_19_27 = q_acc_19_27;
             const real_t elMat_19_28 = q_acc_19_28;
             const real_t elMat_19_29 = q_acc_19_29;
             const real_t elMat_20_0 = q_acc_0_20;
             const real_t elMat_20_1 = q_acc_1_20;
             const real_t elMat_20_2 = q_acc_2_20;
             const real_t elMat_20_3 = q_acc_3_20;
             const real_t elMat_20_4 = q_acc_4_20;
             const real_t elMat_20_5 = q_acc_5_20;
             const real_t elMat_20_6 = q_acc_6_20;
             const real_t elMat_20_7 = q_acc_7_20;
             const real_t elMat_20_8 = q_acc_8_20;
             const real_t elMat_20_9 = q_acc_9_20;
             const real_t elMat_20_10 = q_acc_10_20;
             const real_t elMat_20_11 = q_acc_11_20;
             const real_t elMat_20_12 = q_acc_12_20;
             const real_t elMat_20_13 = q_acc_13_20;
             const real_t elMat_20_14 = q_acc_14_20;
             const real_t elMat_20_15 = q_acc_15_20;
             const real_t elMat_20_16 = q_acc_16_20;
             const real_t elMat_20_17 = q_acc_17_20;
             const real_t elMat_20_18 = q_acc_18_20;
             const real_t elMat_20_19 = q_acc_19_20;
             const real_t elMat_20_20 = q_acc_20_20;
             const real_t elMat_20_21 = q_acc_20_21;
             const real_t elMat_20_22 = q_acc_20_22;
             const real_t elMat_20_23 = q_acc_20_23;
             const real_t elMat_20_24 = q_acc_20_24;
             const real_t elMat_20_25 = q_acc_20_25;
             const real_t elMat_20_26 = q_acc_20_26;
             const real_t elMat_20_27 = q_acc_20_27;
             const real_t elMat_20_28 = q_acc_20_28;
             const real_t elMat_20_29 = q_acc_20_29;
             const real_t elMat_21_0 = q_acc_0_21;
             const real_t elMat_21_1 = q_acc_1_21;
             const real_t elMat_21_2 = q_acc_2_21;
             const real_t elMat_21_3 = q_acc_3_21;
             const real_t elMat_21_4 = q_acc_4_21;
             const real_t elMat_21_5 = q_acc_5_21;
             const real_t elMat_21_6 = q_acc_6_21;
             const real_t elMat_21_7 = q_acc_7_21;
             const real_t elMat_21_8 = q_acc_8_21;
             const real_t elMat_21_9 = q_acc_9_21;
             const real_t elMat_21_10 = q_acc_10_21;
             const real_t elMat_21_11 = q_acc_11_21;
             const real_t elMat_21_12 = q_acc_12_21;
             const real_t elMat_21_13 = q_acc_13_21;
             const real_t elMat_21_14 = q_acc_14_21;
             const real_t elMat_21_15 = q_acc_15_21;
             const real_t elMat_21_16 = q_acc_16_21;
             const real_t elMat_21_17 = q_acc_17_21;
             const real_t elMat_21_18 = q_acc_18_21;
             const real_t elMat_21_19 = q_acc_19_21;
             const real_t elMat_21_20 = q_acc_20_21;
             const real_t elMat_21_21 = q_acc_21_21;
             const real_t elMat_21_22 = q_acc_21_22;
             const real_t elMat_21_23 = q_acc_21_23;
             const real_t elMat_21_24 = q_acc_21_24;
             const real_t elMat_21_25 = q_acc_21_25;
             const real_t elMat_21_26 = q_acc_21_26;
             const real_t elMat_21_27 = q_acc_21_27;
             const real_t elMat_21_28 = q_acc_21_28;
             const real_t elMat_21_29 = q_acc_21_29;
             const real_t elMat_22_0 = q_acc_0_22;
             const real_t elMat_22_1 = q_acc_1_22;
             const real_t elMat_22_2 = q_acc_2_22;
             const real_t elMat_22_3 = q_acc_3_22;
             const real_t elMat_22_4 = q_acc_4_22;
             const real_t elMat_22_5 = q_acc_5_22;
             const real_t elMat_22_6 = q_acc_6_22;
             const real_t elMat_22_7 = q_acc_7_22;
             const real_t elMat_22_8 = q_acc_8_22;
             const real_t elMat_22_9 = q_acc_9_22;
             const real_t elMat_22_10 = q_acc_10_22;
             const real_t elMat_22_11 = q_acc_11_22;
             const real_t elMat_22_12 = q_acc_12_22;
             const real_t elMat_22_13 = q_acc_13_22;
             const real_t elMat_22_14 = q_acc_14_22;
             const real_t elMat_22_15 = q_acc_15_22;
             const real_t elMat_22_16 = q_acc_16_22;
             const real_t elMat_22_17 = q_acc_17_22;
             const real_t elMat_22_18 = q_acc_18_22;
             const real_t elMat_22_19 = q_acc_19_22;
             const real_t elMat_22_20 = q_acc_20_22;
             const real_t elMat_22_21 = q_acc_21_22;
             const real_t elMat_22_22 = q_acc_22_22;
             const real_t elMat_22_23 = q_acc_22_23;
             const real_t elMat_22_24 = q_acc_22_24;
             const real_t elMat_22_25 = q_acc_22_25;
             const real_t elMat_22_26 = q_acc_22_26;
             const real_t elMat_22_27 = q_acc_22_27;
             const real_t elMat_22_28 = q_acc_22_28;
             const real_t elMat_22_29 = q_acc_22_29;
             const real_t elMat_23_0 = q_acc_0_23;
             const real_t elMat_23_1 = q_acc_1_23;
             const real_t elMat_23_2 = q_acc_2_23;
             const real_t elMat_23_3 = q_acc_3_23;
             const real_t elMat_23_4 = q_acc_4_23;
             const real_t elMat_23_5 = q_acc_5_23;
             const real_t elMat_23_6 = q_acc_6_23;
             const real_t elMat_23_7 = q_acc_7_23;
             const real_t elMat_23_8 = q_acc_8_23;
             const real_t elMat_23_9 = q_acc_9_23;
             const real_t elMat_23_10 = q_acc_10_23;
             const real_t elMat_23_11 = q_acc_11_23;
             const real_t elMat_23_12 = q_acc_12_23;
             const real_t elMat_23_13 = q_acc_13_23;
             const real_t elMat_23_14 = q_acc_14_23;
             const real_t elMat_23_15 = q_acc_15_23;
             const real_t elMat_23_16 = q_acc_16_23;
             const real_t elMat_23_17 = q_acc_17_23;
             const real_t elMat_23_18 = q_acc_18_23;
             const real_t elMat_23_19 = q_acc_19_23;
             const real_t elMat_23_20 = q_acc_20_23;
             const real_t elMat_23_21 = q_acc_21_23;
             const real_t elMat_23_22 = q_acc_22_23;
             const real_t elMat_23_23 = q_acc_23_23;
             const real_t elMat_23_24 = q_acc_23_24;
             const real_t elMat_23_25 = q_acc_23_25;
             const real_t elMat_23_26 = q_acc_23_26;
             const real_t elMat_23_27 = q_acc_23_27;
             const real_t elMat_23_28 = q_acc_23_28;
             const real_t elMat_23_29 = q_acc_23_29;
             const real_t elMat_24_0 = q_acc_0_24;
             const real_t elMat_24_1 = q_acc_1_24;
             const real_t elMat_24_2 = q_acc_2_24;
             const real_t elMat_24_3 = q_acc_3_24;
             const real_t elMat_24_4 = q_acc_4_24;
             const real_t elMat_24_5 = q_acc_5_24;
             const real_t elMat_24_6 = q_acc_6_24;
             const real_t elMat_24_7 = q_acc_7_24;
             const real_t elMat_24_8 = q_acc_8_24;
             const real_t elMat_24_9 = q_acc_9_24;
             const real_t elMat_24_10 = q_acc_10_24;
             const real_t elMat_24_11 = q_acc_11_24;
             const real_t elMat_24_12 = q_acc_12_24;
             const real_t elMat_24_13 = q_acc_13_24;
             const real_t elMat_24_14 = q_acc_14_24;
             const real_t elMat_24_15 = q_acc_15_24;
             const real_t elMat_24_16 = q_acc_16_24;
             const real_t elMat_24_17 = q_acc_17_24;
             const real_t elMat_24_18 = q_acc_18_24;
             const real_t elMat_24_19 = q_acc_19_24;
             const real_t elMat_24_20 = q_acc_20_24;
             const real_t elMat_24_21 = q_acc_21_24;
             const real_t elMat_24_22 = q_acc_22_24;
             const real_t elMat_24_23 = q_acc_23_24;
             const real_t elMat_24_24 = q_acc_24_24;
             const real_t elMat_24_25 = q_acc_24_25;
             const real_t elMat_24_26 = q_acc_24_26;
             const real_t elMat_24_27 = q_acc_24_27;
             const real_t elMat_24_28 = q_acc_24_28;
             const real_t elMat_24_29 = q_acc_24_29;
             const real_t elMat_25_0 = q_acc_0_25;
             const real_t elMat_25_1 = q_acc_1_25;
             const real_t elMat_25_2 = q_acc_2_25;
             const real_t elMat_25_3 = q_acc_3_25;
             const real_t elMat_25_4 = q_acc_4_25;
             const real_t elMat_25_5 = q_acc_5_25;
             const real_t elMat_25_6 = q_acc_6_25;
             const real_t elMat_25_7 = q_acc_7_25;
             const real_t elMat_25_8 = q_acc_8_25;
             const real_t elMat_25_9 = q_acc_9_25;
             const real_t elMat_25_10 = q_acc_10_25;
             const real_t elMat_25_11 = q_acc_11_25;
             const real_t elMat_25_12 = q_acc_12_25;
             const real_t elMat_25_13 = q_acc_13_25;
             const real_t elMat_25_14 = q_acc_14_25;
             const real_t elMat_25_15 = q_acc_15_25;
             const real_t elMat_25_16 = q_acc_16_25;
             const real_t elMat_25_17 = q_acc_17_25;
             const real_t elMat_25_18 = q_acc_18_25;
             const real_t elMat_25_19 = q_acc_19_25;
             const real_t elMat_25_20 = q_acc_20_25;
             const real_t elMat_25_21 = q_acc_21_25;
             const real_t elMat_25_22 = q_acc_22_25;
             const real_t elMat_25_23 = q_acc_23_25;
             const real_t elMat_25_24 = q_acc_24_25;
             const real_t elMat_25_25 = q_acc_25_25;
             const real_t elMat_25_26 = q_acc_25_26;
             const real_t elMat_25_27 = q_acc_25_27;
             const real_t elMat_25_28 = q_acc_25_28;
             const real_t elMat_25_29 = q_acc_25_29;
             const real_t elMat_26_0 = q_acc_0_26;
             const real_t elMat_26_1 = q_acc_1_26;
             const real_t elMat_26_2 = q_acc_2_26;
             const real_t elMat_26_3 = q_acc_3_26;
             const real_t elMat_26_4 = q_acc_4_26;
             const real_t elMat_26_5 = q_acc_5_26;
             const real_t elMat_26_6 = q_acc_6_26;
             const real_t elMat_26_7 = q_acc_7_26;
             const real_t elMat_26_8 = q_acc_8_26;
             const real_t elMat_26_9 = q_acc_9_26;
             const real_t elMat_26_10 = q_acc_10_26;
             const real_t elMat_26_11 = q_acc_11_26;
             const real_t elMat_26_12 = q_acc_12_26;
             const real_t elMat_26_13 = q_acc_13_26;
             const real_t elMat_26_14 = q_acc_14_26;
             const real_t elMat_26_15 = q_acc_15_26;
             const real_t elMat_26_16 = q_acc_16_26;
             const real_t elMat_26_17 = q_acc_17_26;
             const real_t elMat_26_18 = q_acc_18_26;
             const real_t elMat_26_19 = q_acc_19_26;
             const real_t elMat_26_20 = q_acc_20_26;
             const real_t elMat_26_21 = q_acc_21_26;
             const real_t elMat_26_22 = q_acc_22_26;
             const real_t elMat_26_23 = q_acc_23_26;
             const real_t elMat_26_24 = q_acc_24_26;
             const real_t elMat_26_25 = q_acc_25_26;
             const real_t elMat_26_26 = q_acc_26_26;
             const real_t elMat_26_27 = q_acc_26_27;
             const real_t elMat_26_28 = q_acc_26_28;
             const real_t elMat_26_29 = q_acc_26_29;
             const real_t elMat_27_0 = q_acc_0_27;
             const real_t elMat_27_1 = q_acc_1_27;
             const real_t elMat_27_2 = q_acc_2_27;
             const real_t elMat_27_3 = q_acc_3_27;
             const real_t elMat_27_4 = q_acc_4_27;
             const real_t elMat_27_5 = q_acc_5_27;
             const real_t elMat_27_6 = q_acc_6_27;
             const real_t elMat_27_7 = q_acc_7_27;
             const real_t elMat_27_8 = q_acc_8_27;
             const real_t elMat_27_9 = q_acc_9_27;
             const real_t elMat_27_10 = q_acc_10_27;
             const real_t elMat_27_11 = q_acc_11_27;
             const real_t elMat_27_12 = q_acc_12_27;
             const real_t elMat_27_13 = q_acc_13_27;
             const real_t elMat_27_14 = q_acc_14_27;
             const real_t elMat_27_15 = q_acc_15_27;
             const real_t elMat_27_16 = q_acc_16_27;
             const real_t elMat_27_17 = q_acc_17_27;
             const real_t elMat_27_18 = q_acc_18_27;
             const real_t elMat_27_19 = q_acc_19_27;
             const real_t elMat_27_20 = q_acc_20_27;
             const real_t elMat_27_21 = q_acc_21_27;
             const real_t elMat_27_22 = q_acc_22_27;
             const real_t elMat_27_23 = q_acc_23_27;
             const real_t elMat_27_24 = q_acc_24_27;
             const real_t elMat_27_25 = q_acc_25_27;
             const real_t elMat_27_26 = q_acc_26_27;
             const real_t elMat_27_27 = q_acc_27_27;
             const real_t elMat_27_28 = q_acc_27_28;
             const real_t elMat_27_29 = q_acc_27_29;
             const real_t elMat_28_0 = q_acc_0_28;
             const real_t elMat_28_1 = q_acc_1_28;
             const real_t elMat_28_2 = q_acc_2_28;
             const real_t elMat_28_3 = q_acc_3_28;
             const real_t elMat_28_4 = q_acc_4_28;
             const real_t elMat_28_5 = q_acc_5_28;
             const real_t elMat_28_6 = q_acc_6_28;
             const real_t elMat_28_7 = q_acc_7_28;
             const real_t elMat_28_8 = q_acc_8_28;
             const real_t elMat_28_9 = q_acc_9_28;
             const real_t elMat_28_10 = q_acc_10_28;
             const real_t elMat_28_11 = q_acc_11_28;
             const real_t elMat_28_12 = q_acc_12_28;
             const real_t elMat_28_13 = q_acc_13_28;
             const real_t elMat_28_14 = q_acc_14_28;
             const real_t elMat_28_15 = q_acc_15_28;
             const real_t elMat_28_16 = q_acc_16_28;
             const real_t elMat_28_17 = q_acc_17_28;
             const real_t elMat_28_18 = q_acc_18_28;
             const real_t elMat_28_19 = q_acc_19_28;
             const real_t elMat_28_20 = q_acc_20_28;
             const real_t elMat_28_21 = q_acc_21_28;
             const real_t elMat_28_22 = q_acc_22_28;
             const real_t elMat_28_23 = q_acc_23_28;
             const real_t elMat_28_24 = q_acc_24_28;
             const real_t elMat_28_25 = q_acc_25_28;
             const real_t elMat_28_26 = q_acc_26_28;
             const real_t elMat_28_27 = q_acc_27_28;
             const real_t elMat_28_28 = q_acc_28_28;
             const real_t elMat_28_29 = q_acc_28_29;
             const real_t elMat_29_0 = q_acc_0_29;
             const real_t elMat_29_1 = q_acc_1_29;
             const real_t elMat_29_2 = q_acc_2_29;
             const real_t elMat_29_3 = q_acc_3_29;
             const real_t elMat_29_4 = q_acc_4_29;
             const real_t elMat_29_5 = q_acc_5_29;
             const real_t elMat_29_6 = q_acc_6_29;
             const real_t elMat_29_7 = q_acc_7_29;
             const real_t elMat_29_8 = q_acc_8_29;
             const real_t elMat_29_9 = q_acc_9_29;
             const real_t elMat_29_10 = q_acc_10_29;
             const real_t elMat_29_11 = q_acc_11_29;
             const real_t elMat_29_12 = q_acc_12_29;
             const real_t elMat_29_13 = q_acc_13_29;
             const real_t elMat_29_14 = q_acc_14_29;
             const real_t elMat_29_15 = q_acc_15_29;
             const real_t elMat_29_16 = q_acc_16_29;
             const real_t elMat_29_17 = q_acc_17_29;
             const real_t elMat_29_18 = q_acc_18_29;
             const real_t elMat_29_19 = q_acc_19_29;
             const real_t elMat_29_20 = q_acc_20_29;
             const real_t elMat_29_21 = q_acc_21_29;
             const real_t elMat_29_22 = q_acc_22_29;
             const real_t elMat_29_23 = q_acc_23_29;
             const real_t elMat_29_24 = q_acc_24_29;
             const real_t elMat_29_25 = q_acc_25_29;
             const real_t elMat_29_26 = q_acc_26_29;
             const real_t elMat_29_27 = q_acc_27_29;
             const real_t elMat_29_28 = q_acc_28_29;
             const real_t elMat_29_29 = q_acc_29_29;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 30 );
             std::vector< real_t > _data_mat( 900 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[11] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[12] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[13] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[14] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[15] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[16] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[17] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[18] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[19] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[20] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[21] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[22] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[23] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[24] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[25] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[26] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[27] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[28] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[29] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_0_12));
             _data_mat[13] = ((real_t)(elMat_0_13));
             _data_mat[14] = ((real_t)(elMat_0_14));
             _data_mat[15] = ((real_t)(elMat_0_15));
             _data_mat[16] = ((real_t)(elMat_0_16));
             _data_mat[17] = ((real_t)(elMat_0_17));
             _data_mat[18] = ((real_t)(elMat_0_18));
             _data_mat[19] = ((real_t)(elMat_0_19));
             _data_mat[20] = ((real_t)(elMat_0_20));
             _data_mat[21] = ((real_t)(elMat_0_21));
             _data_mat[22] = ((real_t)(elMat_0_22));
             _data_mat[23] = ((real_t)(elMat_0_23));
             _data_mat[24] = ((real_t)(elMat_0_24));
             _data_mat[25] = ((real_t)(elMat_0_25));
             _data_mat[26] = ((real_t)(elMat_0_26));
             _data_mat[27] = ((real_t)(elMat_0_27));
             _data_mat[28] = ((real_t)(elMat_0_28));
             _data_mat[29] = ((real_t)(elMat_0_29));
             _data_mat[30] = ((real_t)(elMat_1_0));
             _data_mat[31] = ((real_t)(elMat_1_1));
             _data_mat[32] = ((real_t)(elMat_1_2));
             _data_mat[33] = ((real_t)(elMat_1_3));
             _data_mat[34] = ((real_t)(elMat_1_4));
             _data_mat[35] = ((real_t)(elMat_1_5));
             _data_mat[36] = ((real_t)(elMat_1_6));
             _data_mat[37] = ((real_t)(elMat_1_7));
             _data_mat[38] = ((real_t)(elMat_1_8));
             _data_mat[39] = ((real_t)(elMat_1_9));
             _data_mat[40] = ((real_t)(elMat_1_10));
             _data_mat[41] = ((real_t)(elMat_1_11));
             _data_mat[42] = ((real_t)(elMat_1_12));
             _data_mat[43] = ((real_t)(elMat_1_13));
             _data_mat[44] = ((real_t)(elMat_1_14));
             _data_mat[45] = ((real_t)(elMat_1_15));
             _data_mat[46] = ((real_t)(elMat_1_16));
             _data_mat[47] = ((real_t)(elMat_1_17));
             _data_mat[48] = ((real_t)(elMat_1_18));
             _data_mat[49] = ((real_t)(elMat_1_19));
             _data_mat[50] = ((real_t)(elMat_1_20));
             _data_mat[51] = ((real_t)(elMat_1_21));
             _data_mat[52] = ((real_t)(elMat_1_22));
             _data_mat[53] = ((real_t)(elMat_1_23));
             _data_mat[54] = ((real_t)(elMat_1_24));
             _data_mat[55] = ((real_t)(elMat_1_25));
             _data_mat[56] = ((real_t)(elMat_1_26));
             _data_mat[57] = ((real_t)(elMat_1_27));
             _data_mat[58] = ((real_t)(elMat_1_28));
             _data_mat[59] = ((real_t)(elMat_1_29));
             _data_mat[60] = ((real_t)(elMat_2_0));
             _data_mat[61] = ((real_t)(elMat_2_1));
             _data_mat[62] = ((real_t)(elMat_2_2));
             _data_mat[63] = ((real_t)(elMat_2_3));
             _data_mat[64] = ((real_t)(elMat_2_4));
             _data_mat[65] = ((real_t)(elMat_2_5));
             _data_mat[66] = ((real_t)(elMat_2_6));
             _data_mat[67] = ((real_t)(elMat_2_7));
             _data_mat[68] = ((real_t)(elMat_2_8));
             _data_mat[69] = ((real_t)(elMat_2_9));
             _data_mat[70] = ((real_t)(elMat_2_10));
             _data_mat[71] = ((real_t)(elMat_2_11));
             _data_mat[72] = ((real_t)(elMat_2_12));
             _data_mat[73] = ((real_t)(elMat_2_13));
             _data_mat[74] = ((real_t)(elMat_2_14));
             _data_mat[75] = ((real_t)(elMat_2_15));
             _data_mat[76] = ((real_t)(elMat_2_16));
             _data_mat[77] = ((real_t)(elMat_2_17));
             _data_mat[78] = ((real_t)(elMat_2_18));
             _data_mat[79] = ((real_t)(elMat_2_19));
             _data_mat[80] = ((real_t)(elMat_2_20));
             _data_mat[81] = ((real_t)(elMat_2_21));
             _data_mat[82] = ((real_t)(elMat_2_22));
             _data_mat[83] = ((real_t)(elMat_2_23));
             _data_mat[84] = ((real_t)(elMat_2_24));
             _data_mat[85] = ((real_t)(elMat_2_25));
             _data_mat[86] = ((real_t)(elMat_2_26));
             _data_mat[87] = ((real_t)(elMat_2_27));
             _data_mat[88] = ((real_t)(elMat_2_28));
             _data_mat[89] = ((real_t)(elMat_2_29));
             _data_mat[90] = ((real_t)(elMat_3_0));
             _data_mat[91] = ((real_t)(elMat_3_1));
             _data_mat[92] = ((real_t)(elMat_3_2));
             _data_mat[93] = ((real_t)(elMat_3_3));
             _data_mat[94] = ((real_t)(elMat_3_4));
             _data_mat[95] = ((real_t)(elMat_3_5));
             _data_mat[96] = ((real_t)(elMat_3_6));
             _data_mat[97] = ((real_t)(elMat_3_7));
             _data_mat[98] = ((real_t)(elMat_3_8));
             _data_mat[99] = ((real_t)(elMat_3_9));
             _data_mat[100] = ((real_t)(elMat_3_10));
             _data_mat[101] = ((real_t)(elMat_3_11));
             _data_mat[102] = ((real_t)(elMat_3_12));
             _data_mat[103] = ((real_t)(elMat_3_13));
             _data_mat[104] = ((real_t)(elMat_3_14));
             _data_mat[105] = ((real_t)(elMat_3_15));
             _data_mat[106] = ((real_t)(elMat_3_16));
             _data_mat[107] = ((real_t)(elMat_3_17));
             _data_mat[108] = ((real_t)(elMat_3_18));
             _data_mat[109] = ((real_t)(elMat_3_19));
             _data_mat[110] = ((real_t)(elMat_3_20));
             _data_mat[111] = ((real_t)(elMat_3_21));
             _data_mat[112] = ((real_t)(elMat_3_22));
             _data_mat[113] = ((real_t)(elMat_3_23));
             _data_mat[114] = ((real_t)(elMat_3_24));
             _data_mat[115] = ((real_t)(elMat_3_25));
             _data_mat[116] = ((real_t)(elMat_3_26));
             _data_mat[117] = ((real_t)(elMat_3_27));
             _data_mat[118] = ((real_t)(elMat_3_28));
             _data_mat[119] = ((real_t)(elMat_3_29));
             _data_mat[120] = ((real_t)(elMat_4_0));
             _data_mat[121] = ((real_t)(elMat_4_1));
             _data_mat[122] = ((real_t)(elMat_4_2));
             _data_mat[123] = ((real_t)(elMat_4_3));
             _data_mat[124] = ((real_t)(elMat_4_4));
             _data_mat[125] = ((real_t)(elMat_4_5));
             _data_mat[126] = ((real_t)(elMat_4_6));
             _data_mat[127] = ((real_t)(elMat_4_7));
             _data_mat[128] = ((real_t)(elMat_4_8));
             _data_mat[129] = ((real_t)(elMat_4_9));
             _data_mat[130] = ((real_t)(elMat_4_10));
             _data_mat[131] = ((real_t)(elMat_4_11));
             _data_mat[132] = ((real_t)(elMat_4_12));
             _data_mat[133] = ((real_t)(elMat_4_13));
             _data_mat[134] = ((real_t)(elMat_4_14));
             _data_mat[135] = ((real_t)(elMat_4_15));
             _data_mat[136] = ((real_t)(elMat_4_16));
             _data_mat[137] = ((real_t)(elMat_4_17));
             _data_mat[138] = ((real_t)(elMat_4_18));
             _data_mat[139] = ((real_t)(elMat_4_19));
             _data_mat[140] = ((real_t)(elMat_4_20));
             _data_mat[141] = ((real_t)(elMat_4_21));
             _data_mat[142] = ((real_t)(elMat_4_22));
             _data_mat[143] = ((real_t)(elMat_4_23));
             _data_mat[144] = ((real_t)(elMat_4_24));
             _data_mat[145] = ((real_t)(elMat_4_25));
             _data_mat[146] = ((real_t)(elMat_4_26));
             _data_mat[147] = ((real_t)(elMat_4_27));
             _data_mat[148] = ((real_t)(elMat_4_28));
             _data_mat[149] = ((real_t)(elMat_4_29));
             _data_mat[150] = ((real_t)(elMat_5_0));
             _data_mat[151] = ((real_t)(elMat_5_1));
             _data_mat[152] = ((real_t)(elMat_5_2));
             _data_mat[153] = ((real_t)(elMat_5_3));
             _data_mat[154] = ((real_t)(elMat_5_4));
             _data_mat[155] = ((real_t)(elMat_5_5));
             _data_mat[156] = ((real_t)(elMat_5_6));
             _data_mat[157] = ((real_t)(elMat_5_7));
             _data_mat[158] = ((real_t)(elMat_5_8));
             _data_mat[159] = ((real_t)(elMat_5_9));
             _data_mat[160] = ((real_t)(elMat_5_10));
             _data_mat[161] = ((real_t)(elMat_5_11));
             _data_mat[162] = ((real_t)(elMat_5_12));
             _data_mat[163] = ((real_t)(elMat_5_13));
             _data_mat[164] = ((real_t)(elMat_5_14));
             _data_mat[165] = ((real_t)(elMat_5_15));
             _data_mat[166] = ((real_t)(elMat_5_16));
             _data_mat[167] = ((real_t)(elMat_5_17));
             _data_mat[168] = ((real_t)(elMat_5_18));
             _data_mat[169] = ((real_t)(elMat_5_19));
             _data_mat[170] = ((real_t)(elMat_5_20));
             _data_mat[171] = ((real_t)(elMat_5_21));
             _data_mat[172] = ((real_t)(elMat_5_22));
             _data_mat[173] = ((real_t)(elMat_5_23));
             _data_mat[174] = ((real_t)(elMat_5_24));
             _data_mat[175] = ((real_t)(elMat_5_25));
             _data_mat[176] = ((real_t)(elMat_5_26));
             _data_mat[177] = ((real_t)(elMat_5_27));
             _data_mat[178] = ((real_t)(elMat_5_28));
             _data_mat[179] = ((real_t)(elMat_5_29));
             _data_mat[180] = ((real_t)(elMat_6_0));
             _data_mat[181] = ((real_t)(elMat_6_1));
             _data_mat[182] = ((real_t)(elMat_6_2));
             _data_mat[183] = ((real_t)(elMat_6_3));
             _data_mat[184] = ((real_t)(elMat_6_4));
             _data_mat[185] = ((real_t)(elMat_6_5));
             _data_mat[186] = ((real_t)(elMat_6_6));
             _data_mat[187] = ((real_t)(elMat_6_7));
             _data_mat[188] = ((real_t)(elMat_6_8));
             _data_mat[189] = ((real_t)(elMat_6_9));
             _data_mat[190] = ((real_t)(elMat_6_10));
             _data_mat[191] = ((real_t)(elMat_6_11));
             _data_mat[192] = ((real_t)(elMat_6_12));
             _data_mat[193] = ((real_t)(elMat_6_13));
             _data_mat[194] = ((real_t)(elMat_6_14));
             _data_mat[195] = ((real_t)(elMat_6_15));
             _data_mat[196] = ((real_t)(elMat_6_16));
             _data_mat[197] = ((real_t)(elMat_6_17));
             _data_mat[198] = ((real_t)(elMat_6_18));
             _data_mat[199] = ((real_t)(elMat_6_19));
             _data_mat[200] = ((real_t)(elMat_6_20));
             _data_mat[201] = ((real_t)(elMat_6_21));
             _data_mat[202] = ((real_t)(elMat_6_22));
             _data_mat[203] = ((real_t)(elMat_6_23));
             _data_mat[204] = ((real_t)(elMat_6_24));
             _data_mat[205] = ((real_t)(elMat_6_25));
             _data_mat[206] = ((real_t)(elMat_6_26));
             _data_mat[207] = ((real_t)(elMat_6_27));
             _data_mat[208] = ((real_t)(elMat_6_28));
             _data_mat[209] = ((real_t)(elMat_6_29));
             _data_mat[210] = ((real_t)(elMat_7_0));
             _data_mat[211] = ((real_t)(elMat_7_1));
             _data_mat[212] = ((real_t)(elMat_7_2));
             _data_mat[213] = ((real_t)(elMat_7_3));
             _data_mat[214] = ((real_t)(elMat_7_4));
             _data_mat[215] = ((real_t)(elMat_7_5));
             _data_mat[216] = ((real_t)(elMat_7_6));
             _data_mat[217] = ((real_t)(elMat_7_7));
             _data_mat[218] = ((real_t)(elMat_7_8));
             _data_mat[219] = ((real_t)(elMat_7_9));
             _data_mat[220] = ((real_t)(elMat_7_10));
             _data_mat[221] = ((real_t)(elMat_7_11));
             _data_mat[222] = ((real_t)(elMat_7_12));
             _data_mat[223] = ((real_t)(elMat_7_13));
             _data_mat[224] = ((real_t)(elMat_7_14));
             _data_mat[225] = ((real_t)(elMat_7_15));
             _data_mat[226] = ((real_t)(elMat_7_16));
             _data_mat[227] = ((real_t)(elMat_7_17));
             _data_mat[228] = ((real_t)(elMat_7_18));
             _data_mat[229] = ((real_t)(elMat_7_19));
             _data_mat[230] = ((real_t)(elMat_7_20));
             _data_mat[231] = ((real_t)(elMat_7_21));
             _data_mat[232] = ((real_t)(elMat_7_22));
             _data_mat[233] = ((real_t)(elMat_7_23));
             _data_mat[234] = ((real_t)(elMat_7_24));
             _data_mat[235] = ((real_t)(elMat_7_25));
             _data_mat[236] = ((real_t)(elMat_7_26));
             _data_mat[237] = ((real_t)(elMat_7_27));
             _data_mat[238] = ((real_t)(elMat_7_28));
             _data_mat[239] = ((real_t)(elMat_7_29));
             _data_mat[240] = ((real_t)(elMat_8_0));
             _data_mat[241] = ((real_t)(elMat_8_1));
             _data_mat[242] = ((real_t)(elMat_8_2));
             _data_mat[243] = ((real_t)(elMat_8_3));
             _data_mat[244] = ((real_t)(elMat_8_4));
             _data_mat[245] = ((real_t)(elMat_8_5));
             _data_mat[246] = ((real_t)(elMat_8_6));
             _data_mat[247] = ((real_t)(elMat_8_7));
             _data_mat[248] = ((real_t)(elMat_8_8));
             _data_mat[249] = ((real_t)(elMat_8_9));
             _data_mat[250] = ((real_t)(elMat_8_10));
             _data_mat[251] = ((real_t)(elMat_8_11));
             _data_mat[252] = ((real_t)(elMat_8_12));
             _data_mat[253] = ((real_t)(elMat_8_13));
             _data_mat[254] = ((real_t)(elMat_8_14));
             _data_mat[255] = ((real_t)(elMat_8_15));
             _data_mat[256] = ((real_t)(elMat_8_16));
             _data_mat[257] = ((real_t)(elMat_8_17));
             _data_mat[258] = ((real_t)(elMat_8_18));
             _data_mat[259] = ((real_t)(elMat_8_19));
             _data_mat[260] = ((real_t)(elMat_8_20));
             _data_mat[261] = ((real_t)(elMat_8_21));
             _data_mat[262] = ((real_t)(elMat_8_22));
             _data_mat[263] = ((real_t)(elMat_8_23));
             _data_mat[264] = ((real_t)(elMat_8_24));
             _data_mat[265] = ((real_t)(elMat_8_25));
             _data_mat[266] = ((real_t)(elMat_8_26));
             _data_mat[267] = ((real_t)(elMat_8_27));
             _data_mat[268] = ((real_t)(elMat_8_28));
             _data_mat[269] = ((real_t)(elMat_8_29));
             _data_mat[270] = ((real_t)(elMat_9_0));
             _data_mat[271] = ((real_t)(elMat_9_1));
             _data_mat[272] = ((real_t)(elMat_9_2));
             _data_mat[273] = ((real_t)(elMat_9_3));
             _data_mat[274] = ((real_t)(elMat_9_4));
             _data_mat[275] = ((real_t)(elMat_9_5));
             _data_mat[276] = ((real_t)(elMat_9_6));
             _data_mat[277] = ((real_t)(elMat_9_7));
             _data_mat[278] = ((real_t)(elMat_9_8));
             _data_mat[279] = ((real_t)(elMat_9_9));
             _data_mat[280] = ((real_t)(elMat_9_10));
             _data_mat[281] = ((real_t)(elMat_9_11));
             _data_mat[282] = ((real_t)(elMat_9_12));
             _data_mat[283] = ((real_t)(elMat_9_13));
             _data_mat[284] = ((real_t)(elMat_9_14));
             _data_mat[285] = ((real_t)(elMat_9_15));
             _data_mat[286] = ((real_t)(elMat_9_16));
             _data_mat[287] = ((real_t)(elMat_9_17));
             _data_mat[288] = ((real_t)(elMat_9_18));
             _data_mat[289] = ((real_t)(elMat_9_19));
             _data_mat[290] = ((real_t)(elMat_9_20));
             _data_mat[291] = ((real_t)(elMat_9_21));
             _data_mat[292] = ((real_t)(elMat_9_22));
             _data_mat[293] = ((real_t)(elMat_9_23));
             _data_mat[294] = ((real_t)(elMat_9_24));
             _data_mat[295] = ((real_t)(elMat_9_25));
             _data_mat[296] = ((real_t)(elMat_9_26));
             _data_mat[297] = ((real_t)(elMat_9_27));
             _data_mat[298] = ((real_t)(elMat_9_28));
             _data_mat[299] = ((real_t)(elMat_9_29));
             _data_mat[300] = ((real_t)(elMat_10_0));
             _data_mat[301] = ((real_t)(elMat_10_1));
             _data_mat[302] = ((real_t)(elMat_10_2));
             _data_mat[303] = ((real_t)(elMat_10_3));
             _data_mat[304] = ((real_t)(elMat_10_4));
             _data_mat[305] = ((real_t)(elMat_10_5));
             _data_mat[306] = ((real_t)(elMat_10_6));
             _data_mat[307] = ((real_t)(elMat_10_7));
             _data_mat[308] = ((real_t)(elMat_10_8));
             _data_mat[309] = ((real_t)(elMat_10_9));
             _data_mat[310] = ((real_t)(elMat_10_10));
             _data_mat[311] = ((real_t)(elMat_10_11));
             _data_mat[312] = ((real_t)(elMat_10_12));
             _data_mat[313] = ((real_t)(elMat_10_13));
             _data_mat[314] = ((real_t)(elMat_10_14));
             _data_mat[315] = ((real_t)(elMat_10_15));
             _data_mat[316] = ((real_t)(elMat_10_16));
             _data_mat[317] = ((real_t)(elMat_10_17));
             _data_mat[318] = ((real_t)(elMat_10_18));
             _data_mat[319] = ((real_t)(elMat_10_19));
             _data_mat[320] = ((real_t)(elMat_10_20));
             _data_mat[321] = ((real_t)(elMat_10_21));
             _data_mat[322] = ((real_t)(elMat_10_22));
             _data_mat[323] = ((real_t)(elMat_10_23));
             _data_mat[324] = ((real_t)(elMat_10_24));
             _data_mat[325] = ((real_t)(elMat_10_25));
             _data_mat[326] = ((real_t)(elMat_10_26));
             _data_mat[327] = ((real_t)(elMat_10_27));
             _data_mat[328] = ((real_t)(elMat_10_28));
             _data_mat[329] = ((real_t)(elMat_10_29));
             _data_mat[330] = ((real_t)(elMat_11_0));
             _data_mat[331] = ((real_t)(elMat_11_1));
             _data_mat[332] = ((real_t)(elMat_11_2));
             _data_mat[333] = ((real_t)(elMat_11_3));
             _data_mat[334] = ((real_t)(elMat_11_4));
             _data_mat[335] = ((real_t)(elMat_11_5));
             _data_mat[336] = ((real_t)(elMat_11_6));
             _data_mat[337] = ((real_t)(elMat_11_7));
             _data_mat[338] = ((real_t)(elMat_11_8));
             _data_mat[339] = ((real_t)(elMat_11_9));
             _data_mat[340] = ((real_t)(elMat_11_10));
             _data_mat[341] = ((real_t)(elMat_11_11));
             _data_mat[342] = ((real_t)(elMat_11_12));
             _data_mat[343] = ((real_t)(elMat_11_13));
             _data_mat[344] = ((real_t)(elMat_11_14));
             _data_mat[345] = ((real_t)(elMat_11_15));
             _data_mat[346] = ((real_t)(elMat_11_16));
             _data_mat[347] = ((real_t)(elMat_11_17));
             _data_mat[348] = ((real_t)(elMat_11_18));
             _data_mat[349] = ((real_t)(elMat_11_19));
             _data_mat[350] = ((real_t)(elMat_11_20));
             _data_mat[351] = ((real_t)(elMat_11_21));
             _data_mat[352] = ((real_t)(elMat_11_22));
             _data_mat[353] = ((real_t)(elMat_11_23));
             _data_mat[354] = ((real_t)(elMat_11_24));
             _data_mat[355] = ((real_t)(elMat_11_25));
             _data_mat[356] = ((real_t)(elMat_11_26));
             _data_mat[357] = ((real_t)(elMat_11_27));
             _data_mat[358] = ((real_t)(elMat_11_28));
             _data_mat[359] = ((real_t)(elMat_11_29));
             _data_mat[360] = ((real_t)(elMat_12_0));
             _data_mat[361] = ((real_t)(elMat_12_1));
             _data_mat[362] = ((real_t)(elMat_12_2));
             _data_mat[363] = ((real_t)(elMat_12_3));
             _data_mat[364] = ((real_t)(elMat_12_4));
             _data_mat[365] = ((real_t)(elMat_12_5));
             _data_mat[366] = ((real_t)(elMat_12_6));
             _data_mat[367] = ((real_t)(elMat_12_7));
             _data_mat[368] = ((real_t)(elMat_12_8));
             _data_mat[369] = ((real_t)(elMat_12_9));
             _data_mat[370] = ((real_t)(elMat_12_10));
             _data_mat[371] = ((real_t)(elMat_12_11));
             _data_mat[372] = ((real_t)(elMat_12_12));
             _data_mat[373] = ((real_t)(elMat_12_13));
             _data_mat[374] = ((real_t)(elMat_12_14));
             _data_mat[375] = ((real_t)(elMat_12_15));
             _data_mat[376] = ((real_t)(elMat_12_16));
             _data_mat[377] = ((real_t)(elMat_12_17));
             _data_mat[378] = ((real_t)(elMat_12_18));
             _data_mat[379] = ((real_t)(elMat_12_19));
             _data_mat[380] = ((real_t)(elMat_12_20));
             _data_mat[381] = ((real_t)(elMat_12_21));
             _data_mat[382] = ((real_t)(elMat_12_22));
             _data_mat[383] = ((real_t)(elMat_12_23));
             _data_mat[384] = ((real_t)(elMat_12_24));
             _data_mat[385] = ((real_t)(elMat_12_25));
             _data_mat[386] = ((real_t)(elMat_12_26));
             _data_mat[387] = ((real_t)(elMat_12_27));
             _data_mat[388] = ((real_t)(elMat_12_28));
             _data_mat[389] = ((real_t)(elMat_12_29));
             _data_mat[390] = ((real_t)(elMat_13_0));
             _data_mat[391] = ((real_t)(elMat_13_1));
             _data_mat[392] = ((real_t)(elMat_13_2));
             _data_mat[393] = ((real_t)(elMat_13_3));
             _data_mat[394] = ((real_t)(elMat_13_4));
             _data_mat[395] = ((real_t)(elMat_13_5));
             _data_mat[396] = ((real_t)(elMat_13_6));
             _data_mat[397] = ((real_t)(elMat_13_7));
             _data_mat[398] = ((real_t)(elMat_13_8));
             _data_mat[399] = ((real_t)(elMat_13_9));
             _data_mat[400] = ((real_t)(elMat_13_10));
             _data_mat[401] = ((real_t)(elMat_13_11));
             _data_mat[402] = ((real_t)(elMat_13_12));
             _data_mat[403] = ((real_t)(elMat_13_13));
             _data_mat[404] = ((real_t)(elMat_13_14));
             _data_mat[405] = ((real_t)(elMat_13_15));
             _data_mat[406] = ((real_t)(elMat_13_16));
             _data_mat[407] = ((real_t)(elMat_13_17));
             _data_mat[408] = ((real_t)(elMat_13_18));
             _data_mat[409] = ((real_t)(elMat_13_19));
             _data_mat[410] = ((real_t)(elMat_13_20));
             _data_mat[411] = ((real_t)(elMat_13_21));
             _data_mat[412] = ((real_t)(elMat_13_22));
             _data_mat[413] = ((real_t)(elMat_13_23));
             _data_mat[414] = ((real_t)(elMat_13_24));
             _data_mat[415] = ((real_t)(elMat_13_25));
             _data_mat[416] = ((real_t)(elMat_13_26));
             _data_mat[417] = ((real_t)(elMat_13_27));
             _data_mat[418] = ((real_t)(elMat_13_28));
             _data_mat[419] = ((real_t)(elMat_13_29));
             _data_mat[420] = ((real_t)(elMat_14_0));
             _data_mat[421] = ((real_t)(elMat_14_1));
             _data_mat[422] = ((real_t)(elMat_14_2));
             _data_mat[423] = ((real_t)(elMat_14_3));
             _data_mat[424] = ((real_t)(elMat_14_4));
             _data_mat[425] = ((real_t)(elMat_14_5));
             _data_mat[426] = ((real_t)(elMat_14_6));
             _data_mat[427] = ((real_t)(elMat_14_7));
             _data_mat[428] = ((real_t)(elMat_14_8));
             _data_mat[429] = ((real_t)(elMat_14_9));
             _data_mat[430] = ((real_t)(elMat_14_10));
             _data_mat[431] = ((real_t)(elMat_14_11));
             _data_mat[432] = ((real_t)(elMat_14_12));
             _data_mat[433] = ((real_t)(elMat_14_13));
             _data_mat[434] = ((real_t)(elMat_14_14));
             _data_mat[435] = ((real_t)(elMat_14_15));
             _data_mat[436] = ((real_t)(elMat_14_16));
             _data_mat[437] = ((real_t)(elMat_14_17));
             _data_mat[438] = ((real_t)(elMat_14_18));
             _data_mat[439] = ((real_t)(elMat_14_19));
             _data_mat[440] = ((real_t)(elMat_14_20));
             _data_mat[441] = ((real_t)(elMat_14_21));
             _data_mat[442] = ((real_t)(elMat_14_22));
             _data_mat[443] = ((real_t)(elMat_14_23));
             _data_mat[444] = ((real_t)(elMat_14_24));
             _data_mat[445] = ((real_t)(elMat_14_25));
             _data_mat[446] = ((real_t)(elMat_14_26));
             _data_mat[447] = ((real_t)(elMat_14_27));
             _data_mat[448] = ((real_t)(elMat_14_28));
             _data_mat[449] = ((real_t)(elMat_14_29));
             _data_mat[450] = ((real_t)(elMat_15_0));
             _data_mat[451] = ((real_t)(elMat_15_1));
             _data_mat[452] = ((real_t)(elMat_15_2));
             _data_mat[453] = ((real_t)(elMat_15_3));
             _data_mat[454] = ((real_t)(elMat_15_4));
             _data_mat[455] = ((real_t)(elMat_15_5));
             _data_mat[456] = ((real_t)(elMat_15_6));
             _data_mat[457] = ((real_t)(elMat_15_7));
             _data_mat[458] = ((real_t)(elMat_15_8));
             _data_mat[459] = ((real_t)(elMat_15_9));
             _data_mat[460] = ((real_t)(elMat_15_10));
             _data_mat[461] = ((real_t)(elMat_15_11));
             _data_mat[462] = ((real_t)(elMat_15_12));
             _data_mat[463] = ((real_t)(elMat_15_13));
             _data_mat[464] = ((real_t)(elMat_15_14));
             _data_mat[465] = ((real_t)(elMat_15_15));
             _data_mat[466] = ((real_t)(elMat_15_16));
             _data_mat[467] = ((real_t)(elMat_15_17));
             _data_mat[468] = ((real_t)(elMat_15_18));
             _data_mat[469] = ((real_t)(elMat_15_19));
             _data_mat[470] = ((real_t)(elMat_15_20));
             _data_mat[471] = ((real_t)(elMat_15_21));
             _data_mat[472] = ((real_t)(elMat_15_22));
             _data_mat[473] = ((real_t)(elMat_15_23));
             _data_mat[474] = ((real_t)(elMat_15_24));
             _data_mat[475] = ((real_t)(elMat_15_25));
             _data_mat[476] = ((real_t)(elMat_15_26));
             _data_mat[477] = ((real_t)(elMat_15_27));
             _data_mat[478] = ((real_t)(elMat_15_28));
             _data_mat[479] = ((real_t)(elMat_15_29));
             _data_mat[480] = ((real_t)(elMat_16_0));
             _data_mat[481] = ((real_t)(elMat_16_1));
             _data_mat[482] = ((real_t)(elMat_16_2));
             _data_mat[483] = ((real_t)(elMat_16_3));
             _data_mat[484] = ((real_t)(elMat_16_4));
             _data_mat[485] = ((real_t)(elMat_16_5));
             _data_mat[486] = ((real_t)(elMat_16_6));
             _data_mat[487] = ((real_t)(elMat_16_7));
             _data_mat[488] = ((real_t)(elMat_16_8));
             _data_mat[489] = ((real_t)(elMat_16_9));
             _data_mat[490] = ((real_t)(elMat_16_10));
             _data_mat[491] = ((real_t)(elMat_16_11));
             _data_mat[492] = ((real_t)(elMat_16_12));
             _data_mat[493] = ((real_t)(elMat_16_13));
             _data_mat[494] = ((real_t)(elMat_16_14));
             _data_mat[495] = ((real_t)(elMat_16_15));
             _data_mat[496] = ((real_t)(elMat_16_16));
             _data_mat[497] = ((real_t)(elMat_16_17));
             _data_mat[498] = ((real_t)(elMat_16_18));
             _data_mat[499] = ((real_t)(elMat_16_19));
             _data_mat[500] = ((real_t)(elMat_16_20));
             _data_mat[501] = ((real_t)(elMat_16_21));
             _data_mat[502] = ((real_t)(elMat_16_22));
             _data_mat[503] = ((real_t)(elMat_16_23));
             _data_mat[504] = ((real_t)(elMat_16_24));
             _data_mat[505] = ((real_t)(elMat_16_25));
             _data_mat[506] = ((real_t)(elMat_16_26));
             _data_mat[507] = ((real_t)(elMat_16_27));
             _data_mat[508] = ((real_t)(elMat_16_28));
             _data_mat[509] = ((real_t)(elMat_16_29));
             _data_mat[510] = ((real_t)(elMat_17_0));
             _data_mat[511] = ((real_t)(elMat_17_1));
             _data_mat[512] = ((real_t)(elMat_17_2));
             _data_mat[513] = ((real_t)(elMat_17_3));
             _data_mat[514] = ((real_t)(elMat_17_4));
             _data_mat[515] = ((real_t)(elMat_17_5));
             _data_mat[516] = ((real_t)(elMat_17_6));
             _data_mat[517] = ((real_t)(elMat_17_7));
             _data_mat[518] = ((real_t)(elMat_17_8));
             _data_mat[519] = ((real_t)(elMat_17_9));
             _data_mat[520] = ((real_t)(elMat_17_10));
             _data_mat[521] = ((real_t)(elMat_17_11));
             _data_mat[522] = ((real_t)(elMat_17_12));
             _data_mat[523] = ((real_t)(elMat_17_13));
             _data_mat[524] = ((real_t)(elMat_17_14));
             _data_mat[525] = ((real_t)(elMat_17_15));
             _data_mat[526] = ((real_t)(elMat_17_16));
             _data_mat[527] = ((real_t)(elMat_17_17));
             _data_mat[528] = ((real_t)(elMat_17_18));
             _data_mat[529] = ((real_t)(elMat_17_19));
             _data_mat[530] = ((real_t)(elMat_17_20));
             _data_mat[531] = ((real_t)(elMat_17_21));
             _data_mat[532] = ((real_t)(elMat_17_22));
             _data_mat[533] = ((real_t)(elMat_17_23));
             _data_mat[534] = ((real_t)(elMat_17_24));
             _data_mat[535] = ((real_t)(elMat_17_25));
             _data_mat[536] = ((real_t)(elMat_17_26));
             _data_mat[537] = ((real_t)(elMat_17_27));
             _data_mat[538] = ((real_t)(elMat_17_28));
             _data_mat[539] = ((real_t)(elMat_17_29));
             _data_mat[540] = ((real_t)(elMat_18_0));
             _data_mat[541] = ((real_t)(elMat_18_1));
             _data_mat[542] = ((real_t)(elMat_18_2));
             _data_mat[543] = ((real_t)(elMat_18_3));
             _data_mat[544] = ((real_t)(elMat_18_4));
             _data_mat[545] = ((real_t)(elMat_18_5));
             _data_mat[546] = ((real_t)(elMat_18_6));
             _data_mat[547] = ((real_t)(elMat_18_7));
             _data_mat[548] = ((real_t)(elMat_18_8));
             _data_mat[549] = ((real_t)(elMat_18_9));
             _data_mat[550] = ((real_t)(elMat_18_10));
             _data_mat[551] = ((real_t)(elMat_18_11));
             _data_mat[552] = ((real_t)(elMat_18_12));
             _data_mat[553] = ((real_t)(elMat_18_13));
             _data_mat[554] = ((real_t)(elMat_18_14));
             _data_mat[555] = ((real_t)(elMat_18_15));
             _data_mat[556] = ((real_t)(elMat_18_16));
             _data_mat[557] = ((real_t)(elMat_18_17));
             _data_mat[558] = ((real_t)(elMat_18_18));
             _data_mat[559] = ((real_t)(elMat_18_19));
             _data_mat[560] = ((real_t)(elMat_18_20));
             _data_mat[561] = ((real_t)(elMat_18_21));
             _data_mat[562] = ((real_t)(elMat_18_22));
             _data_mat[563] = ((real_t)(elMat_18_23));
             _data_mat[564] = ((real_t)(elMat_18_24));
             _data_mat[565] = ((real_t)(elMat_18_25));
             _data_mat[566] = ((real_t)(elMat_18_26));
             _data_mat[567] = ((real_t)(elMat_18_27));
             _data_mat[568] = ((real_t)(elMat_18_28));
             _data_mat[569] = ((real_t)(elMat_18_29));
             _data_mat[570] = ((real_t)(elMat_19_0));
             _data_mat[571] = ((real_t)(elMat_19_1));
             _data_mat[572] = ((real_t)(elMat_19_2));
             _data_mat[573] = ((real_t)(elMat_19_3));
             _data_mat[574] = ((real_t)(elMat_19_4));
             _data_mat[575] = ((real_t)(elMat_19_5));
             _data_mat[576] = ((real_t)(elMat_19_6));
             _data_mat[577] = ((real_t)(elMat_19_7));
             _data_mat[578] = ((real_t)(elMat_19_8));
             _data_mat[579] = ((real_t)(elMat_19_9));
             _data_mat[580] = ((real_t)(elMat_19_10));
             _data_mat[581] = ((real_t)(elMat_19_11));
             _data_mat[582] = ((real_t)(elMat_19_12));
             _data_mat[583] = ((real_t)(elMat_19_13));
             _data_mat[584] = ((real_t)(elMat_19_14));
             _data_mat[585] = ((real_t)(elMat_19_15));
             _data_mat[586] = ((real_t)(elMat_19_16));
             _data_mat[587] = ((real_t)(elMat_19_17));
             _data_mat[588] = ((real_t)(elMat_19_18));
             _data_mat[589] = ((real_t)(elMat_19_19));
             _data_mat[590] = ((real_t)(elMat_19_20));
             _data_mat[591] = ((real_t)(elMat_19_21));
             _data_mat[592] = ((real_t)(elMat_19_22));
             _data_mat[593] = ((real_t)(elMat_19_23));
             _data_mat[594] = ((real_t)(elMat_19_24));
             _data_mat[595] = ((real_t)(elMat_19_25));
             _data_mat[596] = ((real_t)(elMat_19_26));
             _data_mat[597] = ((real_t)(elMat_19_27));
             _data_mat[598] = ((real_t)(elMat_19_28));
             _data_mat[599] = ((real_t)(elMat_19_29));
             _data_mat[600] = ((real_t)(elMat_20_0));
             _data_mat[601] = ((real_t)(elMat_20_1));
             _data_mat[602] = ((real_t)(elMat_20_2));
             _data_mat[603] = ((real_t)(elMat_20_3));
             _data_mat[604] = ((real_t)(elMat_20_4));
             _data_mat[605] = ((real_t)(elMat_20_5));
             _data_mat[606] = ((real_t)(elMat_20_6));
             _data_mat[607] = ((real_t)(elMat_20_7));
             _data_mat[608] = ((real_t)(elMat_20_8));
             _data_mat[609] = ((real_t)(elMat_20_9));
             _data_mat[610] = ((real_t)(elMat_20_10));
             _data_mat[611] = ((real_t)(elMat_20_11));
             _data_mat[612] = ((real_t)(elMat_20_12));
             _data_mat[613] = ((real_t)(elMat_20_13));
             _data_mat[614] = ((real_t)(elMat_20_14));
             _data_mat[615] = ((real_t)(elMat_20_15));
             _data_mat[616] = ((real_t)(elMat_20_16));
             _data_mat[617] = ((real_t)(elMat_20_17));
             _data_mat[618] = ((real_t)(elMat_20_18));
             _data_mat[619] = ((real_t)(elMat_20_19));
             _data_mat[620] = ((real_t)(elMat_20_20));
             _data_mat[621] = ((real_t)(elMat_20_21));
             _data_mat[622] = ((real_t)(elMat_20_22));
             _data_mat[623] = ((real_t)(elMat_20_23));
             _data_mat[624] = ((real_t)(elMat_20_24));
             _data_mat[625] = ((real_t)(elMat_20_25));
             _data_mat[626] = ((real_t)(elMat_20_26));
             _data_mat[627] = ((real_t)(elMat_20_27));
             _data_mat[628] = ((real_t)(elMat_20_28));
             _data_mat[629] = ((real_t)(elMat_20_29));
             _data_mat[630] = ((real_t)(elMat_21_0));
             _data_mat[631] = ((real_t)(elMat_21_1));
             _data_mat[632] = ((real_t)(elMat_21_2));
             _data_mat[633] = ((real_t)(elMat_21_3));
             _data_mat[634] = ((real_t)(elMat_21_4));
             _data_mat[635] = ((real_t)(elMat_21_5));
             _data_mat[636] = ((real_t)(elMat_21_6));
             _data_mat[637] = ((real_t)(elMat_21_7));
             _data_mat[638] = ((real_t)(elMat_21_8));
             _data_mat[639] = ((real_t)(elMat_21_9));
             _data_mat[640] = ((real_t)(elMat_21_10));
             _data_mat[641] = ((real_t)(elMat_21_11));
             _data_mat[642] = ((real_t)(elMat_21_12));
             _data_mat[643] = ((real_t)(elMat_21_13));
             _data_mat[644] = ((real_t)(elMat_21_14));
             _data_mat[645] = ((real_t)(elMat_21_15));
             _data_mat[646] = ((real_t)(elMat_21_16));
             _data_mat[647] = ((real_t)(elMat_21_17));
             _data_mat[648] = ((real_t)(elMat_21_18));
             _data_mat[649] = ((real_t)(elMat_21_19));
             _data_mat[650] = ((real_t)(elMat_21_20));
             _data_mat[651] = ((real_t)(elMat_21_21));
             _data_mat[652] = ((real_t)(elMat_21_22));
             _data_mat[653] = ((real_t)(elMat_21_23));
             _data_mat[654] = ((real_t)(elMat_21_24));
             _data_mat[655] = ((real_t)(elMat_21_25));
             _data_mat[656] = ((real_t)(elMat_21_26));
             _data_mat[657] = ((real_t)(elMat_21_27));
             _data_mat[658] = ((real_t)(elMat_21_28));
             _data_mat[659] = ((real_t)(elMat_21_29));
             _data_mat[660] = ((real_t)(elMat_22_0));
             _data_mat[661] = ((real_t)(elMat_22_1));
             _data_mat[662] = ((real_t)(elMat_22_2));
             _data_mat[663] = ((real_t)(elMat_22_3));
             _data_mat[664] = ((real_t)(elMat_22_4));
             _data_mat[665] = ((real_t)(elMat_22_5));
             _data_mat[666] = ((real_t)(elMat_22_6));
             _data_mat[667] = ((real_t)(elMat_22_7));
             _data_mat[668] = ((real_t)(elMat_22_8));
             _data_mat[669] = ((real_t)(elMat_22_9));
             _data_mat[670] = ((real_t)(elMat_22_10));
             _data_mat[671] = ((real_t)(elMat_22_11));
             _data_mat[672] = ((real_t)(elMat_22_12));
             _data_mat[673] = ((real_t)(elMat_22_13));
             _data_mat[674] = ((real_t)(elMat_22_14));
             _data_mat[675] = ((real_t)(elMat_22_15));
             _data_mat[676] = ((real_t)(elMat_22_16));
             _data_mat[677] = ((real_t)(elMat_22_17));
             _data_mat[678] = ((real_t)(elMat_22_18));
             _data_mat[679] = ((real_t)(elMat_22_19));
             _data_mat[680] = ((real_t)(elMat_22_20));
             _data_mat[681] = ((real_t)(elMat_22_21));
             _data_mat[682] = ((real_t)(elMat_22_22));
             _data_mat[683] = ((real_t)(elMat_22_23));
             _data_mat[684] = ((real_t)(elMat_22_24));
             _data_mat[685] = ((real_t)(elMat_22_25));
             _data_mat[686] = ((real_t)(elMat_22_26));
             _data_mat[687] = ((real_t)(elMat_22_27));
             _data_mat[688] = ((real_t)(elMat_22_28));
             _data_mat[689] = ((real_t)(elMat_22_29));
             _data_mat[690] = ((real_t)(elMat_23_0));
             _data_mat[691] = ((real_t)(elMat_23_1));
             _data_mat[692] = ((real_t)(elMat_23_2));
             _data_mat[693] = ((real_t)(elMat_23_3));
             _data_mat[694] = ((real_t)(elMat_23_4));
             _data_mat[695] = ((real_t)(elMat_23_5));
             _data_mat[696] = ((real_t)(elMat_23_6));
             _data_mat[697] = ((real_t)(elMat_23_7));
             _data_mat[698] = ((real_t)(elMat_23_8));
             _data_mat[699] = ((real_t)(elMat_23_9));
             _data_mat[700] = ((real_t)(elMat_23_10));
             _data_mat[701] = ((real_t)(elMat_23_11));
             _data_mat[702] = ((real_t)(elMat_23_12));
             _data_mat[703] = ((real_t)(elMat_23_13));
             _data_mat[704] = ((real_t)(elMat_23_14));
             _data_mat[705] = ((real_t)(elMat_23_15));
             _data_mat[706] = ((real_t)(elMat_23_16));
             _data_mat[707] = ((real_t)(elMat_23_17));
             _data_mat[708] = ((real_t)(elMat_23_18));
             _data_mat[709] = ((real_t)(elMat_23_19));
             _data_mat[710] = ((real_t)(elMat_23_20));
             _data_mat[711] = ((real_t)(elMat_23_21));
             _data_mat[712] = ((real_t)(elMat_23_22));
             _data_mat[713] = ((real_t)(elMat_23_23));
             _data_mat[714] = ((real_t)(elMat_23_24));
             _data_mat[715] = ((real_t)(elMat_23_25));
             _data_mat[716] = ((real_t)(elMat_23_26));
             _data_mat[717] = ((real_t)(elMat_23_27));
             _data_mat[718] = ((real_t)(elMat_23_28));
             _data_mat[719] = ((real_t)(elMat_23_29));
             _data_mat[720] = ((real_t)(elMat_24_0));
             _data_mat[721] = ((real_t)(elMat_24_1));
             _data_mat[722] = ((real_t)(elMat_24_2));
             _data_mat[723] = ((real_t)(elMat_24_3));
             _data_mat[724] = ((real_t)(elMat_24_4));
             _data_mat[725] = ((real_t)(elMat_24_5));
             _data_mat[726] = ((real_t)(elMat_24_6));
             _data_mat[727] = ((real_t)(elMat_24_7));
             _data_mat[728] = ((real_t)(elMat_24_8));
             _data_mat[729] = ((real_t)(elMat_24_9));
             _data_mat[730] = ((real_t)(elMat_24_10));
             _data_mat[731] = ((real_t)(elMat_24_11));
             _data_mat[732] = ((real_t)(elMat_24_12));
             _data_mat[733] = ((real_t)(elMat_24_13));
             _data_mat[734] = ((real_t)(elMat_24_14));
             _data_mat[735] = ((real_t)(elMat_24_15));
             _data_mat[736] = ((real_t)(elMat_24_16));
             _data_mat[737] = ((real_t)(elMat_24_17));
             _data_mat[738] = ((real_t)(elMat_24_18));
             _data_mat[739] = ((real_t)(elMat_24_19));
             _data_mat[740] = ((real_t)(elMat_24_20));
             _data_mat[741] = ((real_t)(elMat_24_21));
             _data_mat[742] = ((real_t)(elMat_24_22));
             _data_mat[743] = ((real_t)(elMat_24_23));
             _data_mat[744] = ((real_t)(elMat_24_24));
             _data_mat[745] = ((real_t)(elMat_24_25));
             _data_mat[746] = ((real_t)(elMat_24_26));
             _data_mat[747] = ((real_t)(elMat_24_27));
             _data_mat[748] = ((real_t)(elMat_24_28));
             _data_mat[749] = ((real_t)(elMat_24_29));
             _data_mat[750] = ((real_t)(elMat_25_0));
             _data_mat[751] = ((real_t)(elMat_25_1));
             _data_mat[752] = ((real_t)(elMat_25_2));
             _data_mat[753] = ((real_t)(elMat_25_3));
             _data_mat[754] = ((real_t)(elMat_25_4));
             _data_mat[755] = ((real_t)(elMat_25_5));
             _data_mat[756] = ((real_t)(elMat_25_6));
             _data_mat[757] = ((real_t)(elMat_25_7));
             _data_mat[758] = ((real_t)(elMat_25_8));
             _data_mat[759] = ((real_t)(elMat_25_9));
             _data_mat[760] = ((real_t)(elMat_25_10));
             _data_mat[761] = ((real_t)(elMat_25_11));
             _data_mat[762] = ((real_t)(elMat_25_12));
             _data_mat[763] = ((real_t)(elMat_25_13));
             _data_mat[764] = ((real_t)(elMat_25_14));
             _data_mat[765] = ((real_t)(elMat_25_15));
             _data_mat[766] = ((real_t)(elMat_25_16));
             _data_mat[767] = ((real_t)(elMat_25_17));
             _data_mat[768] = ((real_t)(elMat_25_18));
             _data_mat[769] = ((real_t)(elMat_25_19));
             _data_mat[770] = ((real_t)(elMat_25_20));
             _data_mat[771] = ((real_t)(elMat_25_21));
             _data_mat[772] = ((real_t)(elMat_25_22));
             _data_mat[773] = ((real_t)(elMat_25_23));
             _data_mat[774] = ((real_t)(elMat_25_24));
             _data_mat[775] = ((real_t)(elMat_25_25));
             _data_mat[776] = ((real_t)(elMat_25_26));
             _data_mat[777] = ((real_t)(elMat_25_27));
             _data_mat[778] = ((real_t)(elMat_25_28));
             _data_mat[779] = ((real_t)(elMat_25_29));
             _data_mat[780] = ((real_t)(elMat_26_0));
             _data_mat[781] = ((real_t)(elMat_26_1));
             _data_mat[782] = ((real_t)(elMat_26_2));
             _data_mat[783] = ((real_t)(elMat_26_3));
             _data_mat[784] = ((real_t)(elMat_26_4));
             _data_mat[785] = ((real_t)(elMat_26_5));
             _data_mat[786] = ((real_t)(elMat_26_6));
             _data_mat[787] = ((real_t)(elMat_26_7));
             _data_mat[788] = ((real_t)(elMat_26_8));
             _data_mat[789] = ((real_t)(elMat_26_9));
             _data_mat[790] = ((real_t)(elMat_26_10));
             _data_mat[791] = ((real_t)(elMat_26_11));
             _data_mat[792] = ((real_t)(elMat_26_12));
             _data_mat[793] = ((real_t)(elMat_26_13));
             _data_mat[794] = ((real_t)(elMat_26_14));
             _data_mat[795] = ((real_t)(elMat_26_15));
             _data_mat[796] = ((real_t)(elMat_26_16));
             _data_mat[797] = ((real_t)(elMat_26_17));
             _data_mat[798] = ((real_t)(elMat_26_18));
             _data_mat[799] = ((real_t)(elMat_26_19));
             _data_mat[800] = ((real_t)(elMat_26_20));
             _data_mat[801] = ((real_t)(elMat_26_21));
             _data_mat[802] = ((real_t)(elMat_26_22));
             _data_mat[803] = ((real_t)(elMat_26_23));
             _data_mat[804] = ((real_t)(elMat_26_24));
             _data_mat[805] = ((real_t)(elMat_26_25));
             _data_mat[806] = ((real_t)(elMat_26_26));
             _data_mat[807] = ((real_t)(elMat_26_27));
             _data_mat[808] = ((real_t)(elMat_26_28));
             _data_mat[809] = ((real_t)(elMat_26_29));
             _data_mat[810] = ((real_t)(elMat_27_0));
             _data_mat[811] = ((real_t)(elMat_27_1));
             _data_mat[812] = ((real_t)(elMat_27_2));
             _data_mat[813] = ((real_t)(elMat_27_3));
             _data_mat[814] = ((real_t)(elMat_27_4));
             _data_mat[815] = ((real_t)(elMat_27_5));
             _data_mat[816] = ((real_t)(elMat_27_6));
             _data_mat[817] = ((real_t)(elMat_27_7));
             _data_mat[818] = ((real_t)(elMat_27_8));
             _data_mat[819] = ((real_t)(elMat_27_9));
             _data_mat[820] = ((real_t)(elMat_27_10));
             _data_mat[821] = ((real_t)(elMat_27_11));
             _data_mat[822] = ((real_t)(elMat_27_12));
             _data_mat[823] = ((real_t)(elMat_27_13));
             _data_mat[824] = ((real_t)(elMat_27_14));
             _data_mat[825] = ((real_t)(elMat_27_15));
             _data_mat[826] = ((real_t)(elMat_27_16));
             _data_mat[827] = ((real_t)(elMat_27_17));
             _data_mat[828] = ((real_t)(elMat_27_18));
             _data_mat[829] = ((real_t)(elMat_27_19));
             _data_mat[830] = ((real_t)(elMat_27_20));
             _data_mat[831] = ((real_t)(elMat_27_21));
             _data_mat[832] = ((real_t)(elMat_27_22));
             _data_mat[833] = ((real_t)(elMat_27_23));
             _data_mat[834] = ((real_t)(elMat_27_24));
             _data_mat[835] = ((real_t)(elMat_27_25));
             _data_mat[836] = ((real_t)(elMat_27_26));
             _data_mat[837] = ((real_t)(elMat_27_27));
             _data_mat[838] = ((real_t)(elMat_27_28));
             _data_mat[839] = ((real_t)(elMat_27_29));
             _data_mat[840] = ((real_t)(elMat_28_0));
             _data_mat[841] = ((real_t)(elMat_28_1));
             _data_mat[842] = ((real_t)(elMat_28_2));
             _data_mat[843] = ((real_t)(elMat_28_3));
             _data_mat[844] = ((real_t)(elMat_28_4));
             _data_mat[845] = ((real_t)(elMat_28_5));
             _data_mat[846] = ((real_t)(elMat_28_6));
             _data_mat[847] = ((real_t)(elMat_28_7));
             _data_mat[848] = ((real_t)(elMat_28_8));
             _data_mat[849] = ((real_t)(elMat_28_9));
             _data_mat[850] = ((real_t)(elMat_28_10));
             _data_mat[851] = ((real_t)(elMat_28_11));
             _data_mat[852] = ((real_t)(elMat_28_12));
             _data_mat[853] = ((real_t)(elMat_28_13));
             _data_mat[854] = ((real_t)(elMat_28_14));
             _data_mat[855] = ((real_t)(elMat_28_15));
             _data_mat[856] = ((real_t)(elMat_28_16));
             _data_mat[857] = ((real_t)(elMat_28_17));
             _data_mat[858] = ((real_t)(elMat_28_18));
             _data_mat[859] = ((real_t)(elMat_28_19));
             _data_mat[860] = ((real_t)(elMat_28_20));
             _data_mat[861] = ((real_t)(elMat_28_21));
             _data_mat[862] = ((real_t)(elMat_28_22));
             _data_mat[863] = ((real_t)(elMat_28_23));
             _data_mat[864] = ((real_t)(elMat_28_24));
             _data_mat[865] = ((real_t)(elMat_28_25));
             _data_mat[866] = ((real_t)(elMat_28_26));
             _data_mat[867] = ((real_t)(elMat_28_27));
             _data_mat[868] = ((real_t)(elMat_28_28));
             _data_mat[869] = ((real_t)(elMat_28_29));
             _data_mat[870] = ((real_t)(elMat_29_0));
             _data_mat[871] = ((real_t)(elMat_29_1));
             _data_mat[872] = ((real_t)(elMat_29_2));
             _data_mat[873] = ((real_t)(elMat_29_3));
             _data_mat[874] = ((real_t)(elMat_29_4));
             _data_mat[875] = ((real_t)(elMat_29_5));
             _data_mat[876] = ((real_t)(elMat_29_6));
             _data_mat[877] = ((real_t)(elMat_29_7));
             _data_mat[878] = ((real_t)(elMat_29_8));
             _data_mat[879] = ((real_t)(elMat_29_9));
             _data_mat[880] = ((real_t)(elMat_29_10));
             _data_mat[881] = ((real_t)(elMat_29_11));
             _data_mat[882] = ((real_t)(elMat_29_12));
             _data_mat[883] = ((real_t)(elMat_29_13));
             _data_mat[884] = ((real_t)(elMat_29_14));
             _data_mat[885] = ((real_t)(elMat_29_15));
             _data_mat[886] = ((real_t)(elMat_29_16));
             _data_mat[887] = ((real_t)(elMat_29_17));
             _data_mat[888] = ((real_t)(elMat_29_18));
             _data_mat[889] = ((real_t)(elMat_29_19));
             _data_mat[890] = ((real_t)(elMat_29_20));
             _data_mat[891] = ((real_t)(elMat_29_21));
             _data_mat[892] = ((real_t)(elMat_29_22));
             _data_mat[893] = ((real_t)(elMat_29_23));
             _data_mat[894] = ((real_t)(elMat_29_24));
             _data_mat[895] = ((real_t)(elMat_29_25));
             _data_mat[896] = ((real_t)(elMat_29_26));
             _data_mat[897] = ((real_t)(elMat_29_27));
             _data_mat[898] = ((real_t)(elMat_29_28));
             _data_mat[899] = ((real_t)(elMat_29_29));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 2)*(micro_edges_per_macro_edge - 1)) / (6)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_BLUE_DOWN[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_0_12 = q_acc_0_12;
             const real_t elMat_0_13 = q_acc_0_13;
             const real_t elMat_0_14 = q_acc_0_14;
             const real_t elMat_0_15 = q_acc_0_15;
             const real_t elMat_0_16 = q_acc_0_16;
             const real_t elMat_0_17 = q_acc_0_17;
             const real_t elMat_0_18 = q_acc_0_18;
             const real_t elMat_0_19 = q_acc_0_19;
             const real_t elMat_0_20 = q_acc_0_20;
             const real_t elMat_0_21 = q_acc_0_21;
             const real_t elMat_0_22 = q_acc_0_22;
             const real_t elMat_0_23 = q_acc_0_23;
             const real_t elMat_0_24 = q_acc_0_24;
             const real_t elMat_0_25 = q_acc_0_25;
             const real_t elMat_0_26 = q_acc_0_26;
             const real_t elMat_0_27 = q_acc_0_27;
             const real_t elMat_0_28 = q_acc_0_28;
             const real_t elMat_0_29 = q_acc_0_29;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_1_12 = q_acc_1_12;
             const real_t elMat_1_13 = q_acc_1_13;
             const real_t elMat_1_14 = q_acc_1_14;
             const real_t elMat_1_15 = q_acc_1_15;
             const real_t elMat_1_16 = q_acc_1_16;
             const real_t elMat_1_17 = q_acc_1_17;
             const real_t elMat_1_18 = q_acc_1_18;
             const real_t elMat_1_19 = q_acc_1_19;
             const real_t elMat_1_20 = q_acc_1_20;
             const real_t elMat_1_21 = q_acc_1_21;
             const real_t elMat_1_22 = q_acc_1_22;
             const real_t elMat_1_23 = q_acc_1_23;
             const real_t elMat_1_24 = q_acc_1_24;
             const real_t elMat_1_25 = q_acc_1_25;
             const real_t elMat_1_26 = q_acc_1_26;
             const real_t elMat_1_27 = q_acc_1_27;
             const real_t elMat_1_28 = q_acc_1_28;
             const real_t elMat_1_29 = q_acc_1_29;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_2_12 = q_acc_2_12;
             const real_t elMat_2_13 = q_acc_2_13;
             const real_t elMat_2_14 = q_acc_2_14;
             const real_t elMat_2_15 = q_acc_2_15;
             const real_t elMat_2_16 = q_acc_2_16;
             const real_t elMat_2_17 = q_acc_2_17;
             const real_t elMat_2_18 = q_acc_2_18;
             const real_t elMat_2_19 = q_acc_2_19;
             const real_t elMat_2_20 = q_acc_2_20;
             const real_t elMat_2_21 = q_acc_2_21;
             const real_t elMat_2_22 = q_acc_2_22;
             const real_t elMat_2_23 = q_acc_2_23;
             const real_t elMat_2_24 = q_acc_2_24;
             const real_t elMat_2_25 = q_acc_2_25;
             const real_t elMat_2_26 = q_acc_2_26;
             const real_t elMat_2_27 = q_acc_2_27;
             const real_t elMat_2_28 = q_acc_2_28;
             const real_t elMat_2_29 = q_acc_2_29;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_3_12 = q_acc_3_12;
             const real_t elMat_3_13 = q_acc_3_13;
             const real_t elMat_3_14 = q_acc_3_14;
             const real_t elMat_3_15 = q_acc_3_15;
             const real_t elMat_3_16 = q_acc_3_16;
             const real_t elMat_3_17 = q_acc_3_17;
             const real_t elMat_3_18 = q_acc_3_18;
             const real_t elMat_3_19 = q_acc_3_19;
             const real_t elMat_3_20 = q_acc_3_20;
             const real_t elMat_3_21 = q_acc_3_21;
             const real_t elMat_3_22 = q_acc_3_22;
             const real_t elMat_3_23 = q_acc_3_23;
             const real_t elMat_3_24 = q_acc_3_24;
             const real_t elMat_3_25 = q_acc_3_25;
             const real_t elMat_3_26 = q_acc_3_26;
             const real_t elMat_3_27 = q_acc_3_27;
             const real_t elMat_3_28 = q_acc_3_28;
             const real_t elMat_3_29 = q_acc_3_29;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_4_12 = q_acc_4_12;
             const real_t elMat_4_13 = q_acc_4_13;
             const real_t elMat_4_14 = q_acc_4_14;
             const real_t elMat_4_15 = q_acc_4_15;
             const real_t elMat_4_16 = q_acc_4_16;
             const real_t elMat_4_17 = q_acc_4_17;
             const real_t elMat_4_18 = q_acc_4_18;
             const real_t elMat_4_19 = q_acc_4_19;
             const real_t elMat_4_20 = q_acc_4_20;
             const real_t elMat_4_21 = q_acc_4_21;
             const real_t elMat_4_22 = q_acc_4_22;
             const real_t elMat_4_23 = q_acc_4_23;
             const real_t elMat_4_24 = q_acc_4_24;
             const real_t elMat_4_25 = q_acc_4_25;
             const real_t elMat_4_26 = q_acc_4_26;
             const real_t elMat_4_27 = q_acc_4_27;
             const real_t elMat_4_28 = q_acc_4_28;
             const real_t elMat_4_29 = q_acc_4_29;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_5_12 = q_acc_5_12;
             const real_t elMat_5_13 = q_acc_5_13;
             const real_t elMat_5_14 = q_acc_5_14;
             const real_t elMat_5_15 = q_acc_5_15;
             const real_t elMat_5_16 = q_acc_5_16;
             const real_t elMat_5_17 = q_acc_5_17;
             const real_t elMat_5_18 = q_acc_5_18;
             const real_t elMat_5_19 = q_acc_5_19;
             const real_t elMat_5_20 = q_acc_5_20;
             const real_t elMat_5_21 = q_acc_5_21;
             const real_t elMat_5_22 = q_acc_5_22;
             const real_t elMat_5_23 = q_acc_5_23;
             const real_t elMat_5_24 = q_acc_5_24;
             const real_t elMat_5_25 = q_acc_5_25;
             const real_t elMat_5_26 = q_acc_5_26;
             const real_t elMat_5_27 = q_acc_5_27;
             const real_t elMat_5_28 = q_acc_5_28;
             const real_t elMat_5_29 = q_acc_5_29;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_6_12 = q_acc_6_12;
             const real_t elMat_6_13 = q_acc_6_13;
             const real_t elMat_6_14 = q_acc_6_14;
             const real_t elMat_6_15 = q_acc_6_15;
             const real_t elMat_6_16 = q_acc_6_16;
             const real_t elMat_6_17 = q_acc_6_17;
             const real_t elMat_6_18 = q_acc_6_18;
             const real_t elMat_6_19 = q_acc_6_19;
             const real_t elMat_6_20 = q_acc_6_20;
             const real_t elMat_6_21 = q_acc_6_21;
             const real_t elMat_6_22 = q_acc_6_22;
             const real_t elMat_6_23 = q_acc_6_23;
             const real_t elMat_6_24 = q_acc_6_24;
             const real_t elMat_6_25 = q_acc_6_25;
             const real_t elMat_6_26 = q_acc_6_26;
             const real_t elMat_6_27 = q_acc_6_27;
             const real_t elMat_6_28 = q_acc_6_28;
             const real_t elMat_6_29 = q_acc_6_29;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_7_12 = q_acc_7_12;
             const real_t elMat_7_13 = q_acc_7_13;
             const real_t elMat_7_14 = q_acc_7_14;
             const real_t elMat_7_15 = q_acc_7_15;
             const real_t elMat_7_16 = q_acc_7_16;
             const real_t elMat_7_17 = q_acc_7_17;
             const real_t elMat_7_18 = q_acc_7_18;
             const real_t elMat_7_19 = q_acc_7_19;
             const real_t elMat_7_20 = q_acc_7_20;
             const real_t elMat_7_21 = q_acc_7_21;
             const real_t elMat_7_22 = q_acc_7_22;
             const real_t elMat_7_23 = q_acc_7_23;
             const real_t elMat_7_24 = q_acc_7_24;
             const real_t elMat_7_25 = q_acc_7_25;
             const real_t elMat_7_26 = q_acc_7_26;
             const real_t elMat_7_27 = q_acc_7_27;
             const real_t elMat_7_28 = q_acc_7_28;
             const real_t elMat_7_29 = q_acc_7_29;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_8_12 = q_acc_8_12;
             const real_t elMat_8_13 = q_acc_8_13;
             const real_t elMat_8_14 = q_acc_8_14;
             const real_t elMat_8_15 = q_acc_8_15;
             const real_t elMat_8_16 = q_acc_8_16;
             const real_t elMat_8_17 = q_acc_8_17;
             const real_t elMat_8_18 = q_acc_8_18;
             const real_t elMat_8_19 = q_acc_8_19;
             const real_t elMat_8_20 = q_acc_8_20;
             const real_t elMat_8_21 = q_acc_8_21;
             const real_t elMat_8_22 = q_acc_8_22;
             const real_t elMat_8_23 = q_acc_8_23;
             const real_t elMat_8_24 = q_acc_8_24;
             const real_t elMat_8_25 = q_acc_8_25;
             const real_t elMat_8_26 = q_acc_8_26;
             const real_t elMat_8_27 = q_acc_8_27;
             const real_t elMat_8_28 = q_acc_8_28;
             const real_t elMat_8_29 = q_acc_8_29;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_9_12 = q_acc_9_12;
             const real_t elMat_9_13 = q_acc_9_13;
             const real_t elMat_9_14 = q_acc_9_14;
             const real_t elMat_9_15 = q_acc_9_15;
             const real_t elMat_9_16 = q_acc_9_16;
             const real_t elMat_9_17 = q_acc_9_17;
             const real_t elMat_9_18 = q_acc_9_18;
             const real_t elMat_9_19 = q_acc_9_19;
             const real_t elMat_9_20 = q_acc_9_20;
             const real_t elMat_9_21 = q_acc_9_21;
             const real_t elMat_9_22 = q_acc_9_22;
             const real_t elMat_9_23 = q_acc_9_23;
             const real_t elMat_9_24 = q_acc_9_24;
             const real_t elMat_9_25 = q_acc_9_25;
             const real_t elMat_9_26 = q_acc_9_26;
             const real_t elMat_9_27 = q_acc_9_27;
             const real_t elMat_9_28 = q_acc_9_28;
             const real_t elMat_9_29 = q_acc_9_29;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_10_12 = q_acc_10_12;
             const real_t elMat_10_13 = q_acc_10_13;
             const real_t elMat_10_14 = q_acc_10_14;
             const real_t elMat_10_15 = q_acc_10_15;
             const real_t elMat_10_16 = q_acc_10_16;
             const real_t elMat_10_17 = q_acc_10_17;
             const real_t elMat_10_18 = q_acc_10_18;
             const real_t elMat_10_19 = q_acc_10_19;
             const real_t elMat_10_20 = q_acc_10_20;
             const real_t elMat_10_21 = q_acc_10_21;
             const real_t elMat_10_22 = q_acc_10_22;
             const real_t elMat_10_23 = q_acc_10_23;
             const real_t elMat_10_24 = q_acc_10_24;
             const real_t elMat_10_25 = q_acc_10_25;
             const real_t elMat_10_26 = q_acc_10_26;
             const real_t elMat_10_27 = q_acc_10_27;
             const real_t elMat_10_28 = q_acc_10_28;
             const real_t elMat_10_29 = q_acc_10_29;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
             const real_t elMat_11_12 = q_acc_11_12;
             const real_t elMat_11_13 = q_acc_11_13;
             const real_t elMat_11_14 = q_acc_11_14;
             const real_t elMat_11_15 = q_acc_11_15;
             const real_t elMat_11_16 = q_acc_11_16;
             const real_t elMat_11_17 = q_acc_11_17;
             const real_t elMat_11_18 = q_acc_11_18;
             const real_t elMat_11_19 = q_acc_11_19;
             const real_t elMat_11_20 = q_acc_11_20;
             const real_t elMat_11_21 = q_acc_11_21;
             const real_t elMat_11_22 = q_acc_11_22;
             const real_t elMat_11_23 = q_acc_11_23;
             const real_t elMat_11_24 = q_acc_11_24;
             const real_t elMat_11_25 = q_acc_11_25;
             const real_t elMat_11_26 = q_acc_11_26;
             const real_t elMat_11_27 = q_acc_11_27;
             const real_t elMat_11_28 = q_acc_11_28;
             const real_t elMat_11_29 = q_acc_11_29;
             const real_t elMat_12_0 = q_acc_0_12;
             const real_t elMat_12_1 = q_acc_1_12;
             const real_t elMat_12_2 = q_acc_2_12;
             const real_t elMat_12_3 = q_acc_3_12;
             const real_t elMat_12_4 = q_acc_4_12;
             const real_t elMat_12_5 = q_acc_5_12;
             const real_t elMat_12_6 = q_acc_6_12;
             const real_t elMat_12_7 = q_acc_7_12;
             const real_t elMat_12_8 = q_acc_8_12;
             const real_t elMat_12_9 = q_acc_9_12;
             const real_t elMat_12_10 = q_acc_10_12;
             const real_t elMat_12_11 = q_acc_11_12;
             const real_t elMat_12_12 = q_acc_12_12;
             const real_t elMat_12_13 = q_acc_12_13;
             const real_t elMat_12_14 = q_acc_12_14;
             const real_t elMat_12_15 = q_acc_12_15;
             const real_t elMat_12_16 = q_acc_12_16;
             const real_t elMat_12_17 = q_acc_12_17;
             const real_t elMat_12_18 = q_acc_12_18;
             const real_t elMat_12_19 = q_acc_12_19;
             const real_t elMat_12_20 = q_acc_12_20;
             const real_t elMat_12_21 = q_acc_12_21;
             const real_t elMat_12_22 = q_acc_12_22;
             const real_t elMat_12_23 = q_acc_12_23;
             const real_t elMat_12_24 = q_acc_12_24;
             const real_t elMat_12_25 = q_acc_12_25;
             const real_t elMat_12_26 = q_acc_12_26;
             const real_t elMat_12_27 = q_acc_12_27;
             const real_t elMat_12_28 = q_acc_12_28;
             const real_t elMat_12_29 = q_acc_12_29;
             const real_t elMat_13_0 = q_acc_0_13;
             const real_t elMat_13_1 = q_acc_1_13;
             const real_t elMat_13_2 = q_acc_2_13;
             const real_t elMat_13_3 = q_acc_3_13;
             const real_t elMat_13_4 = q_acc_4_13;
             const real_t elMat_13_5 = q_acc_5_13;
             const real_t elMat_13_6 = q_acc_6_13;
             const real_t elMat_13_7 = q_acc_7_13;
             const real_t elMat_13_8 = q_acc_8_13;
             const real_t elMat_13_9 = q_acc_9_13;
             const real_t elMat_13_10 = q_acc_10_13;
             const real_t elMat_13_11 = q_acc_11_13;
             const real_t elMat_13_12 = q_acc_12_13;
             const real_t elMat_13_13 = q_acc_13_13;
             const real_t elMat_13_14 = q_acc_13_14;
             const real_t elMat_13_15 = q_acc_13_15;
             const real_t elMat_13_16 = q_acc_13_16;
             const real_t elMat_13_17 = q_acc_13_17;
             const real_t elMat_13_18 = q_acc_13_18;
             const real_t elMat_13_19 = q_acc_13_19;
             const real_t elMat_13_20 = q_acc_13_20;
             const real_t elMat_13_21 = q_acc_13_21;
             const real_t elMat_13_22 = q_acc_13_22;
             const real_t elMat_13_23 = q_acc_13_23;
             const real_t elMat_13_24 = q_acc_13_24;
             const real_t elMat_13_25 = q_acc_13_25;
             const real_t elMat_13_26 = q_acc_13_26;
             const real_t elMat_13_27 = q_acc_13_27;
             const real_t elMat_13_28 = q_acc_13_28;
             const real_t elMat_13_29 = q_acc_13_29;
             const real_t elMat_14_0 = q_acc_0_14;
             const real_t elMat_14_1 = q_acc_1_14;
             const real_t elMat_14_2 = q_acc_2_14;
             const real_t elMat_14_3 = q_acc_3_14;
             const real_t elMat_14_4 = q_acc_4_14;
             const real_t elMat_14_5 = q_acc_5_14;
             const real_t elMat_14_6 = q_acc_6_14;
             const real_t elMat_14_7 = q_acc_7_14;
             const real_t elMat_14_8 = q_acc_8_14;
             const real_t elMat_14_9 = q_acc_9_14;
             const real_t elMat_14_10 = q_acc_10_14;
             const real_t elMat_14_11 = q_acc_11_14;
             const real_t elMat_14_12 = q_acc_12_14;
             const real_t elMat_14_13 = q_acc_13_14;
             const real_t elMat_14_14 = q_acc_14_14;
             const real_t elMat_14_15 = q_acc_14_15;
             const real_t elMat_14_16 = q_acc_14_16;
             const real_t elMat_14_17 = q_acc_14_17;
             const real_t elMat_14_18 = q_acc_14_18;
             const real_t elMat_14_19 = q_acc_14_19;
             const real_t elMat_14_20 = q_acc_14_20;
             const real_t elMat_14_21 = q_acc_14_21;
             const real_t elMat_14_22 = q_acc_14_22;
             const real_t elMat_14_23 = q_acc_14_23;
             const real_t elMat_14_24 = q_acc_14_24;
             const real_t elMat_14_25 = q_acc_14_25;
             const real_t elMat_14_26 = q_acc_14_26;
             const real_t elMat_14_27 = q_acc_14_27;
             const real_t elMat_14_28 = q_acc_14_28;
             const real_t elMat_14_29 = q_acc_14_29;
             const real_t elMat_15_0 = q_acc_0_15;
             const real_t elMat_15_1 = q_acc_1_15;
             const real_t elMat_15_2 = q_acc_2_15;
             const real_t elMat_15_3 = q_acc_3_15;
             const real_t elMat_15_4 = q_acc_4_15;
             const real_t elMat_15_5 = q_acc_5_15;
             const real_t elMat_15_6 = q_acc_6_15;
             const real_t elMat_15_7 = q_acc_7_15;
             const real_t elMat_15_8 = q_acc_8_15;
             const real_t elMat_15_9 = q_acc_9_15;
             const real_t elMat_15_10 = q_acc_10_15;
             const real_t elMat_15_11 = q_acc_11_15;
             const real_t elMat_15_12 = q_acc_12_15;
             const real_t elMat_15_13 = q_acc_13_15;
             const real_t elMat_15_14 = q_acc_14_15;
             const real_t elMat_15_15 = q_acc_15_15;
             const real_t elMat_15_16 = q_acc_15_16;
             const real_t elMat_15_17 = q_acc_15_17;
             const real_t elMat_15_18 = q_acc_15_18;
             const real_t elMat_15_19 = q_acc_15_19;
             const real_t elMat_15_20 = q_acc_15_20;
             const real_t elMat_15_21 = q_acc_15_21;
             const real_t elMat_15_22 = q_acc_15_22;
             const real_t elMat_15_23 = q_acc_15_23;
             const real_t elMat_15_24 = q_acc_15_24;
             const real_t elMat_15_25 = q_acc_15_25;
             const real_t elMat_15_26 = q_acc_15_26;
             const real_t elMat_15_27 = q_acc_15_27;
             const real_t elMat_15_28 = q_acc_15_28;
             const real_t elMat_15_29 = q_acc_15_29;
             const real_t elMat_16_0 = q_acc_0_16;
             const real_t elMat_16_1 = q_acc_1_16;
             const real_t elMat_16_2 = q_acc_2_16;
             const real_t elMat_16_3 = q_acc_3_16;
             const real_t elMat_16_4 = q_acc_4_16;
             const real_t elMat_16_5 = q_acc_5_16;
             const real_t elMat_16_6 = q_acc_6_16;
             const real_t elMat_16_7 = q_acc_7_16;
             const real_t elMat_16_8 = q_acc_8_16;
             const real_t elMat_16_9 = q_acc_9_16;
             const real_t elMat_16_10 = q_acc_10_16;
             const real_t elMat_16_11 = q_acc_11_16;
             const real_t elMat_16_12 = q_acc_12_16;
             const real_t elMat_16_13 = q_acc_13_16;
             const real_t elMat_16_14 = q_acc_14_16;
             const real_t elMat_16_15 = q_acc_15_16;
             const real_t elMat_16_16 = q_acc_16_16;
             const real_t elMat_16_17 = q_acc_16_17;
             const real_t elMat_16_18 = q_acc_16_18;
             const real_t elMat_16_19 = q_acc_16_19;
             const real_t elMat_16_20 = q_acc_16_20;
             const real_t elMat_16_21 = q_acc_16_21;
             const real_t elMat_16_22 = q_acc_16_22;
             const real_t elMat_16_23 = q_acc_16_23;
             const real_t elMat_16_24 = q_acc_16_24;
             const real_t elMat_16_25 = q_acc_16_25;
             const real_t elMat_16_26 = q_acc_16_26;
             const real_t elMat_16_27 = q_acc_16_27;
             const real_t elMat_16_28 = q_acc_16_28;
             const real_t elMat_16_29 = q_acc_16_29;
             const real_t elMat_17_0 = q_acc_0_17;
             const real_t elMat_17_1 = q_acc_1_17;
             const real_t elMat_17_2 = q_acc_2_17;
             const real_t elMat_17_3 = q_acc_3_17;
             const real_t elMat_17_4 = q_acc_4_17;
             const real_t elMat_17_5 = q_acc_5_17;
             const real_t elMat_17_6 = q_acc_6_17;
             const real_t elMat_17_7 = q_acc_7_17;
             const real_t elMat_17_8 = q_acc_8_17;
             const real_t elMat_17_9 = q_acc_9_17;
             const real_t elMat_17_10 = q_acc_10_17;
             const real_t elMat_17_11 = q_acc_11_17;
             const real_t elMat_17_12 = q_acc_12_17;
             const real_t elMat_17_13 = q_acc_13_17;
             const real_t elMat_17_14 = q_acc_14_17;
             const real_t elMat_17_15 = q_acc_15_17;
             const real_t elMat_17_16 = q_acc_16_17;
             const real_t elMat_17_17 = q_acc_17_17;
             const real_t elMat_17_18 = q_acc_17_18;
             const real_t elMat_17_19 = q_acc_17_19;
             const real_t elMat_17_20 = q_acc_17_20;
             const real_t elMat_17_21 = q_acc_17_21;
             const real_t elMat_17_22 = q_acc_17_22;
             const real_t elMat_17_23 = q_acc_17_23;
             const real_t elMat_17_24 = q_acc_17_24;
             const real_t elMat_17_25 = q_acc_17_25;
             const real_t elMat_17_26 = q_acc_17_26;
             const real_t elMat_17_27 = q_acc_17_27;
             const real_t elMat_17_28 = q_acc_17_28;
             const real_t elMat_17_29 = q_acc_17_29;
             const real_t elMat_18_0 = q_acc_0_18;
             const real_t elMat_18_1 = q_acc_1_18;
             const real_t elMat_18_2 = q_acc_2_18;
             const real_t elMat_18_3 = q_acc_3_18;
             const real_t elMat_18_4 = q_acc_4_18;
             const real_t elMat_18_5 = q_acc_5_18;
             const real_t elMat_18_6 = q_acc_6_18;
             const real_t elMat_18_7 = q_acc_7_18;
             const real_t elMat_18_8 = q_acc_8_18;
             const real_t elMat_18_9 = q_acc_9_18;
             const real_t elMat_18_10 = q_acc_10_18;
             const real_t elMat_18_11 = q_acc_11_18;
             const real_t elMat_18_12 = q_acc_12_18;
             const real_t elMat_18_13 = q_acc_13_18;
             const real_t elMat_18_14 = q_acc_14_18;
             const real_t elMat_18_15 = q_acc_15_18;
             const real_t elMat_18_16 = q_acc_16_18;
             const real_t elMat_18_17 = q_acc_17_18;
             const real_t elMat_18_18 = q_acc_18_18;
             const real_t elMat_18_19 = q_acc_18_19;
             const real_t elMat_18_20 = q_acc_18_20;
             const real_t elMat_18_21 = q_acc_18_21;
             const real_t elMat_18_22 = q_acc_18_22;
             const real_t elMat_18_23 = q_acc_18_23;
             const real_t elMat_18_24 = q_acc_18_24;
             const real_t elMat_18_25 = q_acc_18_25;
             const real_t elMat_18_26 = q_acc_18_26;
             const real_t elMat_18_27 = q_acc_18_27;
             const real_t elMat_18_28 = q_acc_18_28;
             const real_t elMat_18_29 = q_acc_18_29;
             const real_t elMat_19_0 = q_acc_0_19;
             const real_t elMat_19_1 = q_acc_1_19;
             const real_t elMat_19_2 = q_acc_2_19;
             const real_t elMat_19_3 = q_acc_3_19;
             const real_t elMat_19_4 = q_acc_4_19;
             const real_t elMat_19_5 = q_acc_5_19;
             const real_t elMat_19_6 = q_acc_6_19;
             const real_t elMat_19_7 = q_acc_7_19;
             const real_t elMat_19_8 = q_acc_8_19;
             const real_t elMat_19_9 = q_acc_9_19;
             const real_t elMat_19_10 = q_acc_10_19;
             const real_t elMat_19_11 = q_acc_11_19;
             const real_t elMat_19_12 = q_acc_12_19;
             const real_t elMat_19_13 = q_acc_13_19;
             const real_t elMat_19_14 = q_acc_14_19;
             const real_t elMat_19_15 = q_acc_15_19;
             const real_t elMat_19_16 = q_acc_16_19;
             const real_t elMat_19_17 = q_acc_17_19;
             const real_t elMat_19_18 = q_acc_18_19;
             const real_t elMat_19_19 = q_acc_19_19;
             const real_t elMat_19_20 = q_acc_19_20;
             const real_t elMat_19_21 = q_acc_19_21;
             const real_t elMat_19_22 = q_acc_19_22;
             const real_t elMat_19_23 = q_acc_19_23;
             const real_t elMat_19_24 = q_acc_19_24;
             const real_t elMat_19_25 = q_acc_19_25;
             const real_t elMat_19_26 = q_acc_19_26;
             const real_t elMat_19_27 = q_acc_19_27;
             const real_t elMat_19_28 = q_acc_19_28;
             const real_t elMat_19_29 = q_acc_19_29;
             const real_t elMat_20_0 = q_acc_0_20;
             const real_t elMat_20_1 = q_acc_1_20;
             const real_t elMat_20_2 = q_acc_2_20;
             const real_t elMat_20_3 = q_acc_3_20;
             const real_t elMat_20_4 = q_acc_4_20;
             const real_t elMat_20_5 = q_acc_5_20;
             const real_t elMat_20_6 = q_acc_6_20;
             const real_t elMat_20_7 = q_acc_7_20;
             const real_t elMat_20_8 = q_acc_8_20;
             const real_t elMat_20_9 = q_acc_9_20;
             const real_t elMat_20_10 = q_acc_10_20;
             const real_t elMat_20_11 = q_acc_11_20;
             const real_t elMat_20_12 = q_acc_12_20;
             const real_t elMat_20_13 = q_acc_13_20;
             const real_t elMat_20_14 = q_acc_14_20;
             const real_t elMat_20_15 = q_acc_15_20;
             const real_t elMat_20_16 = q_acc_16_20;
             const real_t elMat_20_17 = q_acc_17_20;
             const real_t elMat_20_18 = q_acc_18_20;
             const real_t elMat_20_19 = q_acc_19_20;
             const real_t elMat_20_20 = q_acc_20_20;
             const real_t elMat_20_21 = q_acc_20_21;
             const real_t elMat_20_22 = q_acc_20_22;
             const real_t elMat_20_23 = q_acc_20_23;
             const real_t elMat_20_24 = q_acc_20_24;
             const real_t elMat_20_25 = q_acc_20_25;
             const real_t elMat_20_26 = q_acc_20_26;
             const real_t elMat_20_27 = q_acc_20_27;
             const real_t elMat_20_28 = q_acc_20_28;
             const real_t elMat_20_29 = q_acc_20_29;
             const real_t elMat_21_0 = q_acc_0_21;
             const real_t elMat_21_1 = q_acc_1_21;
             const real_t elMat_21_2 = q_acc_2_21;
             const real_t elMat_21_3 = q_acc_3_21;
             const real_t elMat_21_4 = q_acc_4_21;
             const real_t elMat_21_5 = q_acc_5_21;
             const real_t elMat_21_6 = q_acc_6_21;
             const real_t elMat_21_7 = q_acc_7_21;
             const real_t elMat_21_8 = q_acc_8_21;
             const real_t elMat_21_9 = q_acc_9_21;
             const real_t elMat_21_10 = q_acc_10_21;
             const real_t elMat_21_11 = q_acc_11_21;
             const real_t elMat_21_12 = q_acc_12_21;
             const real_t elMat_21_13 = q_acc_13_21;
             const real_t elMat_21_14 = q_acc_14_21;
             const real_t elMat_21_15 = q_acc_15_21;
             const real_t elMat_21_16 = q_acc_16_21;
             const real_t elMat_21_17 = q_acc_17_21;
             const real_t elMat_21_18 = q_acc_18_21;
             const real_t elMat_21_19 = q_acc_19_21;
             const real_t elMat_21_20 = q_acc_20_21;
             const real_t elMat_21_21 = q_acc_21_21;
             const real_t elMat_21_22 = q_acc_21_22;
             const real_t elMat_21_23 = q_acc_21_23;
             const real_t elMat_21_24 = q_acc_21_24;
             const real_t elMat_21_25 = q_acc_21_25;
             const real_t elMat_21_26 = q_acc_21_26;
             const real_t elMat_21_27 = q_acc_21_27;
             const real_t elMat_21_28 = q_acc_21_28;
             const real_t elMat_21_29 = q_acc_21_29;
             const real_t elMat_22_0 = q_acc_0_22;
             const real_t elMat_22_1 = q_acc_1_22;
             const real_t elMat_22_2 = q_acc_2_22;
             const real_t elMat_22_3 = q_acc_3_22;
             const real_t elMat_22_4 = q_acc_4_22;
             const real_t elMat_22_5 = q_acc_5_22;
             const real_t elMat_22_6 = q_acc_6_22;
             const real_t elMat_22_7 = q_acc_7_22;
             const real_t elMat_22_8 = q_acc_8_22;
             const real_t elMat_22_9 = q_acc_9_22;
             const real_t elMat_22_10 = q_acc_10_22;
             const real_t elMat_22_11 = q_acc_11_22;
             const real_t elMat_22_12 = q_acc_12_22;
             const real_t elMat_22_13 = q_acc_13_22;
             const real_t elMat_22_14 = q_acc_14_22;
             const real_t elMat_22_15 = q_acc_15_22;
             const real_t elMat_22_16 = q_acc_16_22;
             const real_t elMat_22_17 = q_acc_17_22;
             const real_t elMat_22_18 = q_acc_18_22;
             const real_t elMat_22_19 = q_acc_19_22;
             const real_t elMat_22_20 = q_acc_20_22;
             const real_t elMat_22_21 = q_acc_21_22;
             const real_t elMat_22_22 = q_acc_22_22;
             const real_t elMat_22_23 = q_acc_22_23;
             const real_t elMat_22_24 = q_acc_22_24;
             const real_t elMat_22_25 = q_acc_22_25;
             const real_t elMat_22_26 = q_acc_22_26;
             const real_t elMat_22_27 = q_acc_22_27;
             const real_t elMat_22_28 = q_acc_22_28;
             const real_t elMat_22_29 = q_acc_22_29;
             const real_t elMat_23_0 = q_acc_0_23;
             const real_t elMat_23_1 = q_acc_1_23;
             const real_t elMat_23_2 = q_acc_2_23;
             const real_t elMat_23_3 = q_acc_3_23;
             const real_t elMat_23_4 = q_acc_4_23;
             const real_t elMat_23_5 = q_acc_5_23;
             const real_t elMat_23_6 = q_acc_6_23;
             const real_t elMat_23_7 = q_acc_7_23;
             const real_t elMat_23_8 = q_acc_8_23;
             const real_t elMat_23_9 = q_acc_9_23;
             const real_t elMat_23_10 = q_acc_10_23;
             const real_t elMat_23_11 = q_acc_11_23;
             const real_t elMat_23_12 = q_acc_12_23;
             const real_t elMat_23_13 = q_acc_13_23;
             const real_t elMat_23_14 = q_acc_14_23;
             const real_t elMat_23_15 = q_acc_15_23;
             const real_t elMat_23_16 = q_acc_16_23;
             const real_t elMat_23_17 = q_acc_17_23;
             const real_t elMat_23_18 = q_acc_18_23;
             const real_t elMat_23_19 = q_acc_19_23;
             const real_t elMat_23_20 = q_acc_20_23;
             const real_t elMat_23_21 = q_acc_21_23;
             const real_t elMat_23_22 = q_acc_22_23;
             const real_t elMat_23_23 = q_acc_23_23;
             const real_t elMat_23_24 = q_acc_23_24;
             const real_t elMat_23_25 = q_acc_23_25;
             const real_t elMat_23_26 = q_acc_23_26;
             const real_t elMat_23_27 = q_acc_23_27;
             const real_t elMat_23_28 = q_acc_23_28;
             const real_t elMat_23_29 = q_acc_23_29;
             const real_t elMat_24_0 = q_acc_0_24;
             const real_t elMat_24_1 = q_acc_1_24;
             const real_t elMat_24_2 = q_acc_2_24;
             const real_t elMat_24_3 = q_acc_3_24;
             const real_t elMat_24_4 = q_acc_4_24;
             const real_t elMat_24_5 = q_acc_5_24;
             const real_t elMat_24_6 = q_acc_6_24;
             const real_t elMat_24_7 = q_acc_7_24;
             const real_t elMat_24_8 = q_acc_8_24;
             const real_t elMat_24_9 = q_acc_9_24;
             const real_t elMat_24_10 = q_acc_10_24;
             const real_t elMat_24_11 = q_acc_11_24;
             const real_t elMat_24_12 = q_acc_12_24;
             const real_t elMat_24_13 = q_acc_13_24;
             const real_t elMat_24_14 = q_acc_14_24;
             const real_t elMat_24_15 = q_acc_15_24;
             const real_t elMat_24_16 = q_acc_16_24;
             const real_t elMat_24_17 = q_acc_17_24;
             const real_t elMat_24_18 = q_acc_18_24;
             const real_t elMat_24_19 = q_acc_19_24;
             const real_t elMat_24_20 = q_acc_20_24;
             const real_t elMat_24_21 = q_acc_21_24;
             const real_t elMat_24_22 = q_acc_22_24;
             const real_t elMat_24_23 = q_acc_23_24;
             const real_t elMat_24_24 = q_acc_24_24;
             const real_t elMat_24_25 = q_acc_24_25;
             const real_t elMat_24_26 = q_acc_24_26;
             const real_t elMat_24_27 = q_acc_24_27;
             const real_t elMat_24_28 = q_acc_24_28;
             const real_t elMat_24_29 = q_acc_24_29;
             const real_t elMat_25_0 = q_acc_0_25;
             const real_t elMat_25_1 = q_acc_1_25;
             const real_t elMat_25_2 = q_acc_2_25;
             const real_t elMat_25_3 = q_acc_3_25;
             const real_t elMat_25_4 = q_acc_4_25;
             const real_t elMat_25_5 = q_acc_5_25;
             const real_t elMat_25_6 = q_acc_6_25;
             const real_t elMat_25_7 = q_acc_7_25;
             const real_t elMat_25_8 = q_acc_8_25;
             const real_t elMat_25_9 = q_acc_9_25;
             const real_t elMat_25_10 = q_acc_10_25;
             const real_t elMat_25_11 = q_acc_11_25;
             const real_t elMat_25_12 = q_acc_12_25;
             const real_t elMat_25_13 = q_acc_13_25;
             const real_t elMat_25_14 = q_acc_14_25;
             const real_t elMat_25_15 = q_acc_15_25;
             const real_t elMat_25_16 = q_acc_16_25;
             const real_t elMat_25_17 = q_acc_17_25;
             const real_t elMat_25_18 = q_acc_18_25;
             const real_t elMat_25_19 = q_acc_19_25;
             const real_t elMat_25_20 = q_acc_20_25;
             const real_t elMat_25_21 = q_acc_21_25;
             const real_t elMat_25_22 = q_acc_22_25;
             const real_t elMat_25_23 = q_acc_23_25;
             const real_t elMat_25_24 = q_acc_24_25;
             const real_t elMat_25_25 = q_acc_25_25;
             const real_t elMat_25_26 = q_acc_25_26;
             const real_t elMat_25_27 = q_acc_25_27;
             const real_t elMat_25_28 = q_acc_25_28;
             const real_t elMat_25_29 = q_acc_25_29;
             const real_t elMat_26_0 = q_acc_0_26;
             const real_t elMat_26_1 = q_acc_1_26;
             const real_t elMat_26_2 = q_acc_2_26;
             const real_t elMat_26_3 = q_acc_3_26;
             const real_t elMat_26_4 = q_acc_4_26;
             const real_t elMat_26_5 = q_acc_5_26;
             const real_t elMat_26_6 = q_acc_6_26;
             const real_t elMat_26_7 = q_acc_7_26;
             const real_t elMat_26_8 = q_acc_8_26;
             const real_t elMat_26_9 = q_acc_9_26;
             const real_t elMat_26_10 = q_acc_10_26;
             const real_t elMat_26_11 = q_acc_11_26;
             const real_t elMat_26_12 = q_acc_12_26;
             const real_t elMat_26_13 = q_acc_13_26;
             const real_t elMat_26_14 = q_acc_14_26;
             const real_t elMat_26_15 = q_acc_15_26;
             const real_t elMat_26_16 = q_acc_16_26;
             const real_t elMat_26_17 = q_acc_17_26;
             const real_t elMat_26_18 = q_acc_18_26;
             const real_t elMat_26_19 = q_acc_19_26;
             const real_t elMat_26_20 = q_acc_20_26;
             const real_t elMat_26_21 = q_acc_21_26;
             const real_t elMat_26_22 = q_acc_22_26;
             const real_t elMat_26_23 = q_acc_23_26;
             const real_t elMat_26_24 = q_acc_24_26;
             const real_t elMat_26_25 = q_acc_25_26;
             const real_t elMat_26_26 = q_acc_26_26;
             const real_t elMat_26_27 = q_acc_26_27;
             const real_t elMat_26_28 = q_acc_26_28;
             const real_t elMat_26_29 = q_acc_26_29;
             const real_t elMat_27_0 = q_acc_0_27;
             const real_t elMat_27_1 = q_acc_1_27;
             const real_t elMat_27_2 = q_acc_2_27;
             const real_t elMat_27_3 = q_acc_3_27;
             const real_t elMat_27_4 = q_acc_4_27;
             const real_t elMat_27_5 = q_acc_5_27;
             const real_t elMat_27_6 = q_acc_6_27;
             const real_t elMat_27_7 = q_acc_7_27;
             const real_t elMat_27_8 = q_acc_8_27;
             const real_t elMat_27_9 = q_acc_9_27;
             const real_t elMat_27_10 = q_acc_10_27;
             const real_t elMat_27_11 = q_acc_11_27;
             const real_t elMat_27_12 = q_acc_12_27;
             const real_t elMat_27_13 = q_acc_13_27;
             const real_t elMat_27_14 = q_acc_14_27;
             const real_t elMat_27_15 = q_acc_15_27;
             const real_t elMat_27_16 = q_acc_16_27;
             const real_t elMat_27_17 = q_acc_17_27;
             const real_t elMat_27_18 = q_acc_18_27;
             const real_t elMat_27_19 = q_acc_19_27;
             const real_t elMat_27_20 = q_acc_20_27;
             const real_t elMat_27_21 = q_acc_21_27;
             const real_t elMat_27_22 = q_acc_22_27;
             const real_t elMat_27_23 = q_acc_23_27;
             const real_t elMat_27_24 = q_acc_24_27;
             const real_t elMat_27_25 = q_acc_25_27;
             const real_t elMat_27_26 = q_acc_26_27;
             const real_t elMat_27_27 = q_acc_27_27;
             const real_t elMat_27_28 = q_acc_27_28;
             const real_t elMat_27_29 = q_acc_27_29;
             const real_t elMat_28_0 = q_acc_0_28;
             const real_t elMat_28_1 = q_acc_1_28;
             const real_t elMat_28_2 = q_acc_2_28;
             const real_t elMat_28_3 = q_acc_3_28;
             const real_t elMat_28_4 = q_acc_4_28;
             const real_t elMat_28_5 = q_acc_5_28;
             const real_t elMat_28_6 = q_acc_6_28;
             const real_t elMat_28_7 = q_acc_7_28;
             const real_t elMat_28_8 = q_acc_8_28;
             const real_t elMat_28_9 = q_acc_9_28;
             const real_t elMat_28_10 = q_acc_10_28;
             const real_t elMat_28_11 = q_acc_11_28;
             const real_t elMat_28_12 = q_acc_12_28;
             const real_t elMat_28_13 = q_acc_13_28;
             const real_t elMat_28_14 = q_acc_14_28;
             const real_t elMat_28_15 = q_acc_15_28;
             const real_t elMat_28_16 = q_acc_16_28;
             const real_t elMat_28_17 = q_acc_17_28;
             const real_t elMat_28_18 = q_acc_18_28;
             const real_t elMat_28_19 = q_acc_19_28;
             const real_t elMat_28_20 = q_acc_20_28;
             const real_t elMat_28_21 = q_acc_21_28;
             const real_t elMat_28_22 = q_acc_22_28;
             const real_t elMat_28_23 = q_acc_23_28;
             const real_t elMat_28_24 = q_acc_24_28;
             const real_t elMat_28_25 = q_acc_25_28;
             const real_t elMat_28_26 = q_acc_26_28;
             const real_t elMat_28_27 = q_acc_27_28;
             const real_t elMat_28_28 = q_acc_28_28;
             const real_t elMat_28_29 = q_acc_28_29;
             const real_t elMat_29_0 = q_acc_0_29;
             const real_t elMat_29_1 = q_acc_1_29;
             const real_t elMat_29_2 = q_acc_2_29;
             const real_t elMat_29_3 = q_acc_3_29;
             const real_t elMat_29_4 = q_acc_4_29;
             const real_t elMat_29_5 = q_acc_5_29;
             const real_t elMat_29_6 = q_acc_6_29;
             const real_t elMat_29_7 = q_acc_7_29;
             const real_t elMat_29_8 = q_acc_8_29;
             const real_t elMat_29_9 = q_acc_9_29;
             const real_t elMat_29_10 = q_acc_10_29;
             const real_t elMat_29_11 = q_acc_11_29;
             const real_t elMat_29_12 = q_acc_12_29;
             const real_t elMat_29_13 = q_acc_13_29;
             const real_t elMat_29_14 = q_acc_14_29;
             const real_t elMat_29_15 = q_acc_15_29;
             const real_t elMat_29_16 = q_acc_16_29;
             const real_t elMat_29_17 = q_acc_17_29;
             const real_t elMat_29_18 = q_acc_18_29;
             const real_t elMat_29_19 = q_acc_19_29;
             const real_t elMat_29_20 = q_acc_20_29;
             const real_t elMat_29_21 = q_acc_21_29;
             const real_t elMat_29_22 = q_acc_22_29;
             const real_t elMat_29_23 = q_acc_23_29;
             const real_t elMat_29_24 = q_acc_24_29;
             const real_t elMat_29_25 = q_acc_25_29;
             const real_t elMat_29_26 = q_acc_26_29;
             const real_t elMat_29_27 = q_acc_27_29;
             const real_t elMat_29_28 = q_acc_28_29;
             const real_t elMat_29_29 = q_acc_29_29;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 30 );
             std::vector< real_t > _data_mat( 900 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[11] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[12] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[13] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[14] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[15] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[16] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[17] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[18] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[19] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[20] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[21] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[22] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[23] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[24] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[25] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[26] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[27] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[28] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[29] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_0_12));
             _data_mat[13] = ((real_t)(elMat_0_13));
             _data_mat[14] = ((real_t)(elMat_0_14));
             _data_mat[15] = ((real_t)(elMat_0_15));
             _data_mat[16] = ((real_t)(elMat_0_16));
             _data_mat[17] = ((real_t)(elMat_0_17));
             _data_mat[18] = ((real_t)(elMat_0_18));
             _data_mat[19] = ((real_t)(elMat_0_19));
             _data_mat[20] = ((real_t)(elMat_0_20));
             _data_mat[21] = ((real_t)(elMat_0_21));
             _data_mat[22] = ((real_t)(elMat_0_22));
             _data_mat[23] = ((real_t)(elMat_0_23));
             _data_mat[24] = ((real_t)(elMat_0_24));
             _data_mat[25] = ((real_t)(elMat_0_25));
             _data_mat[26] = ((real_t)(elMat_0_26));
             _data_mat[27] = ((real_t)(elMat_0_27));
             _data_mat[28] = ((real_t)(elMat_0_28));
             _data_mat[29] = ((real_t)(elMat_0_29));
             _data_mat[30] = ((real_t)(elMat_1_0));
             _data_mat[31] = ((real_t)(elMat_1_1));
             _data_mat[32] = ((real_t)(elMat_1_2));
             _data_mat[33] = ((real_t)(elMat_1_3));
             _data_mat[34] = ((real_t)(elMat_1_4));
             _data_mat[35] = ((real_t)(elMat_1_5));
             _data_mat[36] = ((real_t)(elMat_1_6));
             _data_mat[37] = ((real_t)(elMat_1_7));
             _data_mat[38] = ((real_t)(elMat_1_8));
             _data_mat[39] = ((real_t)(elMat_1_9));
             _data_mat[40] = ((real_t)(elMat_1_10));
             _data_mat[41] = ((real_t)(elMat_1_11));
             _data_mat[42] = ((real_t)(elMat_1_12));
             _data_mat[43] = ((real_t)(elMat_1_13));
             _data_mat[44] = ((real_t)(elMat_1_14));
             _data_mat[45] = ((real_t)(elMat_1_15));
             _data_mat[46] = ((real_t)(elMat_1_16));
             _data_mat[47] = ((real_t)(elMat_1_17));
             _data_mat[48] = ((real_t)(elMat_1_18));
             _data_mat[49] = ((real_t)(elMat_1_19));
             _data_mat[50] = ((real_t)(elMat_1_20));
             _data_mat[51] = ((real_t)(elMat_1_21));
             _data_mat[52] = ((real_t)(elMat_1_22));
             _data_mat[53] = ((real_t)(elMat_1_23));
             _data_mat[54] = ((real_t)(elMat_1_24));
             _data_mat[55] = ((real_t)(elMat_1_25));
             _data_mat[56] = ((real_t)(elMat_1_26));
             _data_mat[57] = ((real_t)(elMat_1_27));
             _data_mat[58] = ((real_t)(elMat_1_28));
             _data_mat[59] = ((real_t)(elMat_1_29));
             _data_mat[60] = ((real_t)(elMat_2_0));
             _data_mat[61] = ((real_t)(elMat_2_1));
             _data_mat[62] = ((real_t)(elMat_2_2));
             _data_mat[63] = ((real_t)(elMat_2_3));
             _data_mat[64] = ((real_t)(elMat_2_4));
             _data_mat[65] = ((real_t)(elMat_2_5));
             _data_mat[66] = ((real_t)(elMat_2_6));
             _data_mat[67] = ((real_t)(elMat_2_7));
             _data_mat[68] = ((real_t)(elMat_2_8));
             _data_mat[69] = ((real_t)(elMat_2_9));
             _data_mat[70] = ((real_t)(elMat_2_10));
             _data_mat[71] = ((real_t)(elMat_2_11));
             _data_mat[72] = ((real_t)(elMat_2_12));
             _data_mat[73] = ((real_t)(elMat_2_13));
             _data_mat[74] = ((real_t)(elMat_2_14));
             _data_mat[75] = ((real_t)(elMat_2_15));
             _data_mat[76] = ((real_t)(elMat_2_16));
             _data_mat[77] = ((real_t)(elMat_2_17));
             _data_mat[78] = ((real_t)(elMat_2_18));
             _data_mat[79] = ((real_t)(elMat_2_19));
             _data_mat[80] = ((real_t)(elMat_2_20));
             _data_mat[81] = ((real_t)(elMat_2_21));
             _data_mat[82] = ((real_t)(elMat_2_22));
             _data_mat[83] = ((real_t)(elMat_2_23));
             _data_mat[84] = ((real_t)(elMat_2_24));
             _data_mat[85] = ((real_t)(elMat_2_25));
             _data_mat[86] = ((real_t)(elMat_2_26));
             _data_mat[87] = ((real_t)(elMat_2_27));
             _data_mat[88] = ((real_t)(elMat_2_28));
             _data_mat[89] = ((real_t)(elMat_2_29));
             _data_mat[90] = ((real_t)(elMat_3_0));
             _data_mat[91] = ((real_t)(elMat_3_1));
             _data_mat[92] = ((real_t)(elMat_3_2));
             _data_mat[93] = ((real_t)(elMat_3_3));
             _data_mat[94] = ((real_t)(elMat_3_4));
             _data_mat[95] = ((real_t)(elMat_3_5));
             _data_mat[96] = ((real_t)(elMat_3_6));
             _data_mat[97] = ((real_t)(elMat_3_7));
             _data_mat[98] = ((real_t)(elMat_3_8));
             _data_mat[99] = ((real_t)(elMat_3_9));
             _data_mat[100] = ((real_t)(elMat_3_10));
             _data_mat[101] = ((real_t)(elMat_3_11));
             _data_mat[102] = ((real_t)(elMat_3_12));
             _data_mat[103] = ((real_t)(elMat_3_13));
             _data_mat[104] = ((real_t)(elMat_3_14));
             _data_mat[105] = ((real_t)(elMat_3_15));
             _data_mat[106] = ((real_t)(elMat_3_16));
             _data_mat[107] = ((real_t)(elMat_3_17));
             _data_mat[108] = ((real_t)(elMat_3_18));
             _data_mat[109] = ((real_t)(elMat_3_19));
             _data_mat[110] = ((real_t)(elMat_3_20));
             _data_mat[111] = ((real_t)(elMat_3_21));
             _data_mat[112] = ((real_t)(elMat_3_22));
             _data_mat[113] = ((real_t)(elMat_3_23));
             _data_mat[114] = ((real_t)(elMat_3_24));
             _data_mat[115] = ((real_t)(elMat_3_25));
             _data_mat[116] = ((real_t)(elMat_3_26));
             _data_mat[117] = ((real_t)(elMat_3_27));
             _data_mat[118] = ((real_t)(elMat_3_28));
             _data_mat[119] = ((real_t)(elMat_3_29));
             _data_mat[120] = ((real_t)(elMat_4_0));
             _data_mat[121] = ((real_t)(elMat_4_1));
             _data_mat[122] = ((real_t)(elMat_4_2));
             _data_mat[123] = ((real_t)(elMat_4_3));
             _data_mat[124] = ((real_t)(elMat_4_4));
             _data_mat[125] = ((real_t)(elMat_4_5));
             _data_mat[126] = ((real_t)(elMat_4_6));
             _data_mat[127] = ((real_t)(elMat_4_7));
             _data_mat[128] = ((real_t)(elMat_4_8));
             _data_mat[129] = ((real_t)(elMat_4_9));
             _data_mat[130] = ((real_t)(elMat_4_10));
             _data_mat[131] = ((real_t)(elMat_4_11));
             _data_mat[132] = ((real_t)(elMat_4_12));
             _data_mat[133] = ((real_t)(elMat_4_13));
             _data_mat[134] = ((real_t)(elMat_4_14));
             _data_mat[135] = ((real_t)(elMat_4_15));
             _data_mat[136] = ((real_t)(elMat_4_16));
             _data_mat[137] = ((real_t)(elMat_4_17));
             _data_mat[138] = ((real_t)(elMat_4_18));
             _data_mat[139] = ((real_t)(elMat_4_19));
             _data_mat[140] = ((real_t)(elMat_4_20));
             _data_mat[141] = ((real_t)(elMat_4_21));
             _data_mat[142] = ((real_t)(elMat_4_22));
             _data_mat[143] = ((real_t)(elMat_4_23));
             _data_mat[144] = ((real_t)(elMat_4_24));
             _data_mat[145] = ((real_t)(elMat_4_25));
             _data_mat[146] = ((real_t)(elMat_4_26));
             _data_mat[147] = ((real_t)(elMat_4_27));
             _data_mat[148] = ((real_t)(elMat_4_28));
             _data_mat[149] = ((real_t)(elMat_4_29));
             _data_mat[150] = ((real_t)(elMat_5_0));
             _data_mat[151] = ((real_t)(elMat_5_1));
             _data_mat[152] = ((real_t)(elMat_5_2));
             _data_mat[153] = ((real_t)(elMat_5_3));
             _data_mat[154] = ((real_t)(elMat_5_4));
             _data_mat[155] = ((real_t)(elMat_5_5));
             _data_mat[156] = ((real_t)(elMat_5_6));
             _data_mat[157] = ((real_t)(elMat_5_7));
             _data_mat[158] = ((real_t)(elMat_5_8));
             _data_mat[159] = ((real_t)(elMat_5_9));
             _data_mat[160] = ((real_t)(elMat_5_10));
             _data_mat[161] = ((real_t)(elMat_5_11));
             _data_mat[162] = ((real_t)(elMat_5_12));
             _data_mat[163] = ((real_t)(elMat_5_13));
             _data_mat[164] = ((real_t)(elMat_5_14));
             _data_mat[165] = ((real_t)(elMat_5_15));
             _data_mat[166] = ((real_t)(elMat_5_16));
             _data_mat[167] = ((real_t)(elMat_5_17));
             _data_mat[168] = ((real_t)(elMat_5_18));
             _data_mat[169] = ((real_t)(elMat_5_19));
             _data_mat[170] = ((real_t)(elMat_5_20));
             _data_mat[171] = ((real_t)(elMat_5_21));
             _data_mat[172] = ((real_t)(elMat_5_22));
             _data_mat[173] = ((real_t)(elMat_5_23));
             _data_mat[174] = ((real_t)(elMat_5_24));
             _data_mat[175] = ((real_t)(elMat_5_25));
             _data_mat[176] = ((real_t)(elMat_5_26));
             _data_mat[177] = ((real_t)(elMat_5_27));
             _data_mat[178] = ((real_t)(elMat_5_28));
             _data_mat[179] = ((real_t)(elMat_5_29));
             _data_mat[180] = ((real_t)(elMat_6_0));
             _data_mat[181] = ((real_t)(elMat_6_1));
             _data_mat[182] = ((real_t)(elMat_6_2));
             _data_mat[183] = ((real_t)(elMat_6_3));
             _data_mat[184] = ((real_t)(elMat_6_4));
             _data_mat[185] = ((real_t)(elMat_6_5));
             _data_mat[186] = ((real_t)(elMat_6_6));
             _data_mat[187] = ((real_t)(elMat_6_7));
             _data_mat[188] = ((real_t)(elMat_6_8));
             _data_mat[189] = ((real_t)(elMat_6_9));
             _data_mat[190] = ((real_t)(elMat_6_10));
             _data_mat[191] = ((real_t)(elMat_6_11));
             _data_mat[192] = ((real_t)(elMat_6_12));
             _data_mat[193] = ((real_t)(elMat_6_13));
             _data_mat[194] = ((real_t)(elMat_6_14));
             _data_mat[195] = ((real_t)(elMat_6_15));
             _data_mat[196] = ((real_t)(elMat_6_16));
             _data_mat[197] = ((real_t)(elMat_6_17));
             _data_mat[198] = ((real_t)(elMat_6_18));
             _data_mat[199] = ((real_t)(elMat_6_19));
             _data_mat[200] = ((real_t)(elMat_6_20));
             _data_mat[201] = ((real_t)(elMat_6_21));
             _data_mat[202] = ((real_t)(elMat_6_22));
             _data_mat[203] = ((real_t)(elMat_6_23));
             _data_mat[204] = ((real_t)(elMat_6_24));
             _data_mat[205] = ((real_t)(elMat_6_25));
             _data_mat[206] = ((real_t)(elMat_6_26));
             _data_mat[207] = ((real_t)(elMat_6_27));
             _data_mat[208] = ((real_t)(elMat_6_28));
             _data_mat[209] = ((real_t)(elMat_6_29));
             _data_mat[210] = ((real_t)(elMat_7_0));
             _data_mat[211] = ((real_t)(elMat_7_1));
             _data_mat[212] = ((real_t)(elMat_7_2));
             _data_mat[213] = ((real_t)(elMat_7_3));
             _data_mat[214] = ((real_t)(elMat_7_4));
             _data_mat[215] = ((real_t)(elMat_7_5));
             _data_mat[216] = ((real_t)(elMat_7_6));
             _data_mat[217] = ((real_t)(elMat_7_7));
             _data_mat[218] = ((real_t)(elMat_7_8));
             _data_mat[219] = ((real_t)(elMat_7_9));
             _data_mat[220] = ((real_t)(elMat_7_10));
             _data_mat[221] = ((real_t)(elMat_7_11));
             _data_mat[222] = ((real_t)(elMat_7_12));
             _data_mat[223] = ((real_t)(elMat_7_13));
             _data_mat[224] = ((real_t)(elMat_7_14));
             _data_mat[225] = ((real_t)(elMat_7_15));
             _data_mat[226] = ((real_t)(elMat_7_16));
             _data_mat[227] = ((real_t)(elMat_7_17));
             _data_mat[228] = ((real_t)(elMat_7_18));
             _data_mat[229] = ((real_t)(elMat_7_19));
             _data_mat[230] = ((real_t)(elMat_7_20));
             _data_mat[231] = ((real_t)(elMat_7_21));
             _data_mat[232] = ((real_t)(elMat_7_22));
             _data_mat[233] = ((real_t)(elMat_7_23));
             _data_mat[234] = ((real_t)(elMat_7_24));
             _data_mat[235] = ((real_t)(elMat_7_25));
             _data_mat[236] = ((real_t)(elMat_7_26));
             _data_mat[237] = ((real_t)(elMat_7_27));
             _data_mat[238] = ((real_t)(elMat_7_28));
             _data_mat[239] = ((real_t)(elMat_7_29));
             _data_mat[240] = ((real_t)(elMat_8_0));
             _data_mat[241] = ((real_t)(elMat_8_1));
             _data_mat[242] = ((real_t)(elMat_8_2));
             _data_mat[243] = ((real_t)(elMat_8_3));
             _data_mat[244] = ((real_t)(elMat_8_4));
             _data_mat[245] = ((real_t)(elMat_8_5));
             _data_mat[246] = ((real_t)(elMat_8_6));
             _data_mat[247] = ((real_t)(elMat_8_7));
             _data_mat[248] = ((real_t)(elMat_8_8));
             _data_mat[249] = ((real_t)(elMat_8_9));
             _data_mat[250] = ((real_t)(elMat_8_10));
             _data_mat[251] = ((real_t)(elMat_8_11));
             _data_mat[252] = ((real_t)(elMat_8_12));
             _data_mat[253] = ((real_t)(elMat_8_13));
             _data_mat[254] = ((real_t)(elMat_8_14));
             _data_mat[255] = ((real_t)(elMat_8_15));
             _data_mat[256] = ((real_t)(elMat_8_16));
             _data_mat[257] = ((real_t)(elMat_8_17));
             _data_mat[258] = ((real_t)(elMat_8_18));
             _data_mat[259] = ((real_t)(elMat_8_19));
             _data_mat[260] = ((real_t)(elMat_8_20));
             _data_mat[261] = ((real_t)(elMat_8_21));
             _data_mat[262] = ((real_t)(elMat_8_22));
             _data_mat[263] = ((real_t)(elMat_8_23));
             _data_mat[264] = ((real_t)(elMat_8_24));
             _data_mat[265] = ((real_t)(elMat_8_25));
             _data_mat[266] = ((real_t)(elMat_8_26));
             _data_mat[267] = ((real_t)(elMat_8_27));
             _data_mat[268] = ((real_t)(elMat_8_28));
             _data_mat[269] = ((real_t)(elMat_8_29));
             _data_mat[270] = ((real_t)(elMat_9_0));
             _data_mat[271] = ((real_t)(elMat_9_1));
             _data_mat[272] = ((real_t)(elMat_9_2));
             _data_mat[273] = ((real_t)(elMat_9_3));
             _data_mat[274] = ((real_t)(elMat_9_4));
             _data_mat[275] = ((real_t)(elMat_9_5));
             _data_mat[276] = ((real_t)(elMat_9_6));
             _data_mat[277] = ((real_t)(elMat_9_7));
             _data_mat[278] = ((real_t)(elMat_9_8));
             _data_mat[279] = ((real_t)(elMat_9_9));
             _data_mat[280] = ((real_t)(elMat_9_10));
             _data_mat[281] = ((real_t)(elMat_9_11));
             _data_mat[282] = ((real_t)(elMat_9_12));
             _data_mat[283] = ((real_t)(elMat_9_13));
             _data_mat[284] = ((real_t)(elMat_9_14));
             _data_mat[285] = ((real_t)(elMat_9_15));
             _data_mat[286] = ((real_t)(elMat_9_16));
             _data_mat[287] = ((real_t)(elMat_9_17));
             _data_mat[288] = ((real_t)(elMat_9_18));
             _data_mat[289] = ((real_t)(elMat_9_19));
             _data_mat[290] = ((real_t)(elMat_9_20));
             _data_mat[291] = ((real_t)(elMat_9_21));
             _data_mat[292] = ((real_t)(elMat_9_22));
             _data_mat[293] = ((real_t)(elMat_9_23));
             _data_mat[294] = ((real_t)(elMat_9_24));
             _data_mat[295] = ((real_t)(elMat_9_25));
             _data_mat[296] = ((real_t)(elMat_9_26));
             _data_mat[297] = ((real_t)(elMat_9_27));
             _data_mat[298] = ((real_t)(elMat_9_28));
             _data_mat[299] = ((real_t)(elMat_9_29));
             _data_mat[300] = ((real_t)(elMat_10_0));
             _data_mat[301] = ((real_t)(elMat_10_1));
             _data_mat[302] = ((real_t)(elMat_10_2));
             _data_mat[303] = ((real_t)(elMat_10_3));
             _data_mat[304] = ((real_t)(elMat_10_4));
             _data_mat[305] = ((real_t)(elMat_10_5));
             _data_mat[306] = ((real_t)(elMat_10_6));
             _data_mat[307] = ((real_t)(elMat_10_7));
             _data_mat[308] = ((real_t)(elMat_10_8));
             _data_mat[309] = ((real_t)(elMat_10_9));
             _data_mat[310] = ((real_t)(elMat_10_10));
             _data_mat[311] = ((real_t)(elMat_10_11));
             _data_mat[312] = ((real_t)(elMat_10_12));
             _data_mat[313] = ((real_t)(elMat_10_13));
             _data_mat[314] = ((real_t)(elMat_10_14));
             _data_mat[315] = ((real_t)(elMat_10_15));
             _data_mat[316] = ((real_t)(elMat_10_16));
             _data_mat[317] = ((real_t)(elMat_10_17));
             _data_mat[318] = ((real_t)(elMat_10_18));
             _data_mat[319] = ((real_t)(elMat_10_19));
             _data_mat[320] = ((real_t)(elMat_10_20));
             _data_mat[321] = ((real_t)(elMat_10_21));
             _data_mat[322] = ((real_t)(elMat_10_22));
             _data_mat[323] = ((real_t)(elMat_10_23));
             _data_mat[324] = ((real_t)(elMat_10_24));
             _data_mat[325] = ((real_t)(elMat_10_25));
             _data_mat[326] = ((real_t)(elMat_10_26));
             _data_mat[327] = ((real_t)(elMat_10_27));
             _data_mat[328] = ((real_t)(elMat_10_28));
             _data_mat[329] = ((real_t)(elMat_10_29));
             _data_mat[330] = ((real_t)(elMat_11_0));
             _data_mat[331] = ((real_t)(elMat_11_1));
             _data_mat[332] = ((real_t)(elMat_11_2));
             _data_mat[333] = ((real_t)(elMat_11_3));
             _data_mat[334] = ((real_t)(elMat_11_4));
             _data_mat[335] = ((real_t)(elMat_11_5));
             _data_mat[336] = ((real_t)(elMat_11_6));
             _data_mat[337] = ((real_t)(elMat_11_7));
             _data_mat[338] = ((real_t)(elMat_11_8));
             _data_mat[339] = ((real_t)(elMat_11_9));
             _data_mat[340] = ((real_t)(elMat_11_10));
             _data_mat[341] = ((real_t)(elMat_11_11));
             _data_mat[342] = ((real_t)(elMat_11_12));
             _data_mat[343] = ((real_t)(elMat_11_13));
             _data_mat[344] = ((real_t)(elMat_11_14));
             _data_mat[345] = ((real_t)(elMat_11_15));
             _data_mat[346] = ((real_t)(elMat_11_16));
             _data_mat[347] = ((real_t)(elMat_11_17));
             _data_mat[348] = ((real_t)(elMat_11_18));
             _data_mat[349] = ((real_t)(elMat_11_19));
             _data_mat[350] = ((real_t)(elMat_11_20));
             _data_mat[351] = ((real_t)(elMat_11_21));
             _data_mat[352] = ((real_t)(elMat_11_22));
             _data_mat[353] = ((real_t)(elMat_11_23));
             _data_mat[354] = ((real_t)(elMat_11_24));
             _data_mat[355] = ((real_t)(elMat_11_25));
             _data_mat[356] = ((real_t)(elMat_11_26));
             _data_mat[357] = ((real_t)(elMat_11_27));
             _data_mat[358] = ((real_t)(elMat_11_28));
             _data_mat[359] = ((real_t)(elMat_11_29));
             _data_mat[360] = ((real_t)(elMat_12_0));
             _data_mat[361] = ((real_t)(elMat_12_1));
             _data_mat[362] = ((real_t)(elMat_12_2));
             _data_mat[363] = ((real_t)(elMat_12_3));
             _data_mat[364] = ((real_t)(elMat_12_4));
             _data_mat[365] = ((real_t)(elMat_12_5));
             _data_mat[366] = ((real_t)(elMat_12_6));
             _data_mat[367] = ((real_t)(elMat_12_7));
             _data_mat[368] = ((real_t)(elMat_12_8));
             _data_mat[369] = ((real_t)(elMat_12_9));
             _data_mat[370] = ((real_t)(elMat_12_10));
             _data_mat[371] = ((real_t)(elMat_12_11));
             _data_mat[372] = ((real_t)(elMat_12_12));
             _data_mat[373] = ((real_t)(elMat_12_13));
             _data_mat[374] = ((real_t)(elMat_12_14));
             _data_mat[375] = ((real_t)(elMat_12_15));
             _data_mat[376] = ((real_t)(elMat_12_16));
             _data_mat[377] = ((real_t)(elMat_12_17));
             _data_mat[378] = ((real_t)(elMat_12_18));
             _data_mat[379] = ((real_t)(elMat_12_19));
             _data_mat[380] = ((real_t)(elMat_12_20));
             _data_mat[381] = ((real_t)(elMat_12_21));
             _data_mat[382] = ((real_t)(elMat_12_22));
             _data_mat[383] = ((real_t)(elMat_12_23));
             _data_mat[384] = ((real_t)(elMat_12_24));
             _data_mat[385] = ((real_t)(elMat_12_25));
             _data_mat[386] = ((real_t)(elMat_12_26));
             _data_mat[387] = ((real_t)(elMat_12_27));
             _data_mat[388] = ((real_t)(elMat_12_28));
             _data_mat[389] = ((real_t)(elMat_12_29));
             _data_mat[390] = ((real_t)(elMat_13_0));
             _data_mat[391] = ((real_t)(elMat_13_1));
             _data_mat[392] = ((real_t)(elMat_13_2));
             _data_mat[393] = ((real_t)(elMat_13_3));
             _data_mat[394] = ((real_t)(elMat_13_4));
             _data_mat[395] = ((real_t)(elMat_13_5));
             _data_mat[396] = ((real_t)(elMat_13_6));
             _data_mat[397] = ((real_t)(elMat_13_7));
             _data_mat[398] = ((real_t)(elMat_13_8));
             _data_mat[399] = ((real_t)(elMat_13_9));
             _data_mat[400] = ((real_t)(elMat_13_10));
             _data_mat[401] = ((real_t)(elMat_13_11));
             _data_mat[402] = ((real_t)(elMat_13_12));
             _data_mat[403] = ((real_t)(elMat_13_13));
             _data_mat[404] = ((real_t)(elMat_13_14));
             _data_mat[405] = ((real_t)(elMat_13_15));
             _data_mat[406] = ((real_t)(elMat_13_16));
             _data_mat[407] = ((real_t)(elMat_13_17));
             _data_mat[408] = ((real_t)(elMat_13_18));
             _data_mat[409] = ((real_t)(elMat_13_19));
             _data_mat[410] = ((real_t)(elMat_13_20));
             _data_mat[411] = ((real_t)(elMat_13_21));
             _data_mat[412] = ((real_t)(elMat_13_22));
             _data_mat[413] = ((real_t)(elMat_13_23));
             _data_mat[414] = ((real_t)(elMat_13_24));
             _data_mat[415] = ((real_t)(elMat_13_25));
             _data_mat[416] = ((real_t)(elMat_13_26));
             _data_mat[417] = ((real_t)(elMat_13_27));
             _data_mat[418] = ((real_t)(elMat_13_28));
             _data_mat[419] = ((real_t)(elMat_13_29));
             _data_mat[420] = ((real_t)(elMat_14_0));
             _data_mat[421] = ((real_t)(elMat_14_1));
             _data_mat[422] = ((real_t)(elMat_14_2));
             _data_mat[423] = ((real_t)(elMat_14_3));
             _data_mat[424] = ((real_t)(elMat_14_4));
             _data_mat[425] = ((real_t)(elMat_14_5));
             _data_mat[426] = ((real_t)(elMat_14_6));
             _data_mat[427] = ((real_t)(elMat_14_7));
             _data_mat[428] = ((real_t)(elMat_14_8));
             _data_mat[429] = ((real_t)(elMat_14_9));
             _data_mat[430] = ((real_t)(elMat_14_10));
             _data_mat[431] = ((real_t)(elMat_14_11));
             _data_mat[432] = ((real_t)(elMat_14_12));
             _data_mat[433] = ((real_t)(elMat_14_13));
             _data_mat[434] = ((real_t)(elMat_14_14));
             _data_mat[435] = ((real_t)(elMat_14_15));
             _data_mat[436] = ((real_t)(elMat_14_16));
             _data_mat[437] = ((real_t)(elMat_14_17));
             _data_mat[438] = ((real_t)(elMat_14_18));
             _data_mat[439] = ((real_t)(elMat_14_19));
             _data_mat[440] = ((real_t)(elMat_14_20));
             _data_mat[441] = ((real_t)(elMat_14_21));
             _data_mat[442] = ((real_t)(elMat_14_22));
             _data_mat[443] = ((real_t)(elMat_14_23));
             _data_mat[444] = ((real_t)(elMat_14_24));
             _data_mat[445] = ((real_t)(elMat_14_25));
             _data_mat[446] = ((real_t)(elMat_14_26));
             _data_mat[447] = ((real_t)(elMat_14_27));
             _data_mat[448] = ((real_t)(elMat_14_28));
             _data_mat[449] = ((real_t)(elMat_14_29));
             _data_mat[450] = ((real_t)(elMat_15_0));
             _data_mat[451] = ((real_t)(elMat_15_1));
             _data_mat[452] = ((real_t)(elMat_15_2));
             _data_mat[453] = ((real_t)(elMat_15_3));
             _data_mat[454] = ((real_t)(elMat_15_4));
             _data_mat[455] = ((real_t)(elMat_15_5));
             _data_mat[456] = ((real_t)(elMat_15_6));
             _data_mat[457] = ((real_t)(elMat_15_7));
             _data_mat[458] = ((real_t)(elMat_15_8));
             _data_mat[459] = ((real_t)(elMat_15_9));
             _data_mat[460] = ((real_t)(elMat_15_10));
             _data_mat[461] = ((real_t)(elMat_15_11));
             _data_mat[462] = ((real_t)(elMat_15_12));
             _data_mat[463] = ((real_t)(elMat_15_13));
             _data_mat[464] = ((real_t)(elMat_15_14));
             _data_mat[465] = ((real_t)(elMat_15_15));
             _data_mat[466] = ((real_t)(elMat_15_16));
             _data_mat[467] = ((real_t)(elMat_15_17));
             _data_mat[468] = ((real_t)(elMat_15_18));
             _data_mat[469] = ((real_t)(elMat_15_19));
             _data_mat[470] = ((real_t)(elMat_15_20));
             _data_mat[471] = ((real_t)(elMat_15_21));
             _data_mat[472] = ((real_t)(elMat_15_22));
             _data_mat[473] = ((real_t)(elMat_15_23));
             _data_mat[474] = ((real_t)(elMat_15_24));
             _data_mat[475] = ((real_t)(elMat_15_25));
             _data_mat[476] = ((real_t)(elMat_15_26));
             _data_mat[477] = ((real_t)(elMat_15_27));
             _data_mat[478] = ((real_t)(elMat_15_28));
             _data_mat[479] = ((real_t)(elMat_15_29));
             _data_mat[480] = ((real_t)(elMat_16_0));
             _data_mat[481] = ((real_t)(elMat_16_1));
             _data_mat[482] = ((real_t)(elMat_16_2));
             _data_mat[483] = ((real_t)(elMat_16_3));
             _data_mat[484] = ((real_t)(elMat_16_4));
             _data_mat[485] = ((real_t)(elMat_16_5));
             _data_mat[486] = ((real_t)(elMat_16_6));
             _data_mat[487] = ((real_t)(elMat_16_7));
             _data_mat[488] = ((real_t)(elMat_16_8));
             _data_mat[489] = ((real_t)(elMat_16_9));
             _data_mat[490] = ((real_t)(elMat_16_10));
             _data_mat[491] = ((real_t)(elMat_16_11));
             _data_mat[492] = ((real_t)(elMat_16_12));
             _data_mat[493] = ((real_t)(elMat_16_13));
             _data_mat[494] = ((real_t)(elMat_16_14));
             _data_mat[495] = ((real_t)(elMat_16_15));
             _data_mat[496] = ((real_t)(elMat_16_16));
             _data_mat[497] = ((real_t)(elMat_16_17));
             _data_mat[498] = ((real_t)(elMat_16_18));
             _data_mat[499] = ((real_t)(elMat_16_19));
             _data_mat[500] = ((real_t)(elMat_16_20));
             _data_mat[501] = ((real_t)(elMat_16_21));
             _data_mat[502] = ((real_t)(elMat_16_22));
             _data_mat[503] = ((real_t)(elMat_16_23));
             _data_mat[504] = ((real_t)(elMat_16_24));
             _data_mat[505] = ((real_t)(elMat_16_25));
             _data_mat[506] = ((real_t)(elMat_16_26));
             _data_mat[507] = ((real_t)(elMat_16_27));
             _data_mat[508] = ((real_t)(elMat_16_28));
             _data_mat[509] = ((real_t)(elMat_16_29));
             _data_mat[510] = ((real_t)(elMat_17_0));
             _data_mat[511] = ((real_t)(elMat_17_1));
             _data_mat[512] = ((real_t)(elMat_17_2));
             _data_mat[513] = ((real_t)(elMat_17_3));
             _data_mat[514] = ((real_t)(elMat_17_4));
             _data_mat[515] = ((real_t)(elMat_17_5));
             _data_mat[516] = ((real_t)(elMat_17_6));
             _data_mat[517] = ((real_t)(elMat_17_7));
             _data_mat[518] = ((real_t)(elMat_17_8));
             _data_mat[519] = ((real_t)(elMat_17_9));
             _data_mat[520] = ((real_t)(elMat_17_10));
             _data_mat[521] = ((real_t)(elMat_17_11));
             _data_mat[522] = ((real_t)(elMat_17_12));
             _data_mat[523] = ((real_t)(elMat_17_13));
             _data_mat[524] = ((real_t)(elMat_17_14));
             _data_mat[525] = ((real_t)(elMat_17_15));
             _data_mat[526] = ((real_t)(elMat_17_16));
             _data_mat[527] = ((real_t)(elMat_17_17));
             _data_mat[528] = ((real_t)(elMat_17_18));
             _data_mat[529] = ((real_t)(elMat_17_19));
             _data_mat[530] = ((real_t)(elMat_17_20));
             _data_mat[531] = ((real_t)(elMat_17_21));
             _data_mat[532] = ((real_t)(elMat_17_22));
             _data_mat[533] = ((real_t)(elMat_17_23));
             _data_mat[534] = ((real_t)(elMat_17_24));
             _data_mat[535] = ((real_t)(elMat_17_25));
             _data_mat[536] = ((real_t)(elMat_17_26));
             _data_mat[537] = ((real_t)(elMat_17_27));
             _data_mat[538] = ((real_t)(elMat_17_28));
             _data_mat[539] = ((real_t)(elMat_17_29));
             _data_mat[540] = ((real_t)(elMat_18_0));
             _data_mat[541] = ((real_t)(elMat_18_1));
             _data_mat[542] = ((real_t)(elMat_18_2));
             _data_mat[543] = ((real_t)(elMat_18_3));
             _data_mat[544] = ((real_t)(elMat_18_4));
             _data_mat[545] = ((real_t)(elMat_18_5));
             _data_mat[546] = ((real_t)(elMat_18_6));
             _data_mat[547] = ((real_t)(elMat_18_7));
             _data_mat[548] = ((real_t)(elMat_18_8));
             _data_mat[549] = ((real_t)(elMat_18_9));
             _data_mat[550] = ((real_t)(elMat_18_10));
             _data_mat[551] = ((real_t)(elMat_18_11));
             _data_mat[552] = ((real_t)(elMat_18_12));
             _data_mat[553] = ((real_t)(elMat_18_13));
             _data_mat[554] = ((real_t)(elMat_18_14));
             _data_mat[555] = ((real_t)(elMat_18_15));
             _data_mat[556] = ((real_t)(elMat_18_16));
             _data_mat[557] = ((real_t)(elMat_18_17));
             _data_mat[558] = ((real_t)(elMat_18_18));
             _data_mat[559] = ((real_t)(elMat_18_19));
             _data_mat[560] = ((real_t)(elMat_18_20));
             _data_mat[561] = ((real_t)(elMat_18_21));
             _data_mat[562] = ((real_t)(elMat_18_22));
             _data_mat[563] = ((real_t)(elMat_18_23));
             _data_mat[564] = ((real_t)(elMat_18_24));
             _data_mat[565] = ((real_t)(elMat_18_25));
             _data_mat[566] = ((real_t)(elMat_18_26));
             _data_mat[567] = ((real_t)(elMat_18_27));
             _data_mat[568] = ((real_t)(elMat_18_28));
             _data_mat[569] = ((real_t)(elMat_18_29));
             _data_mat[570] = ((real_t)(elMat_19_0));
             _data_mat[571] = ((real_t)(elMat_19_1));
             _data_mat[572] = ((real_t)(elMat_19_2));
             _data_mat[573] = ((real_t)(elMat_19_3));
             _data_mat[574] = ((real_t)(elMat_19_4));
             _data_mat[575] = ((real_t)(elMat_19_5));
             _data_mat[576] = ((real_t)(elMat_19_6));
             _data_mat[577] = ((real_t)(elMat_19_7));
             _data_mat[578] = ((real_t)(elMat_19_8));
             _data_mat[579] = ((real_t)(elMat_19_9));
             _data_mat[580] = ((real_t)(elMat_19_10));
             _data_mat[581] = ((real_t)(elMat_19_11));
             _data_mat[582] = ((real_t)(elMat_19_12));
             _data_mat[583] = ((real_t)(elMat_19_13));
             _data_mat[584] = ((real_t)(elMat_19_14));
             _data_mat[585] = ((real_t)(elMat_19_15));
             _data_mat[586] = ((real_t)(elMat_19_16));
             _data_mat[587] = ((real_t)(elMat_19_17));
             _data_mat[588] = ((real_t)(elMat_19_18));
             _data_mat[589] = ((real_t)(elMat_19_19));
             _data_mat[590] = ((real_t)(elMat_19_20));
             _data_mat[591] = ((real_t)(elMat_19_21));
             _data_mat[592] = ((real_t)(elMat_19_22));
             _data_mat[593] = ((real_t)(elMat_19_23));
             _data_mat[594] = ((real_t)(elMat_19_24));
             _data_mat[595] = ((real_t)(elMat_19_25));
             _data_mat[596] = ((real_t)(elMat_19_26));
             _data_mat[597] = ((real_t)(elMat_19_27));
             _data_mat[598] = ((real_t)(elMat_19_28));
             _data_mat[599] = ((real_t)(elMat_19_29));
             _data_mat[600] = ((real_t)(elMat_20_0));
             _data_mat[601] = ((real_t)(elMat_20_1));
             _data_mat[602] = ((real_t)(elMat_20_2));
             _data_mat[603] = ((real_t)(elMat_20_3));
             _data_mat[604] = ((real_t)(elMat_20_4));
             _data_mat[605] = ((real_t)(elMat_20_5));
             _data_mat[606] = ((real_t)(elMat_20_6));
             _data_mat[607] = ((real_t)(elMat_20_7));
             _data_mat[608] = ((real_t)(elMat_20_8));
             _data_mat[609] = ((real_t)(elMat_20_9));
             _data_mat[610] = ((real_t)(elMat_20_10));
             _data_mat[611] = ((real_t)(elMat_20_11));
             _data_mat[612] = ((real_t)(elMat_20_12));
             _data_mat[613] = ((real_t)(elMat_20_13));
             _data_mat[614] = ((real_t)(elMat_20_14));
             _data_mat[615] = ((real_t)(elMat_20_15));
             _data_mat[616] = ((real_t)(elMat_20_16));
             _data_mat[617] = ((real_t)(elMat_20_17));
             _data_mat[618] = ((real_t)(elMat_20_18));
             _data_mat[619] = ((real_t)(elMat_20_19));
             _data_mat[620] = ((real_t)(elMat_20_20));
             _data_mat[621] = ((real_t)(elMat_20_21));
             _data_mat[622] = ((real_t)(elMat_20_22));
             _data_mat[623] = ((real_t)(elMat_20_23));
             _data_mat[624] = ((real_t)(elMat_20_24));
             _data_mat[625] = ((real_t)(elMat_20_25));
             _data_mat[626] = ((real_t)(elMat_20_26));
             _data_mat[627] = ((real_t)(elMat_20_27));
             _data_mat[628] = ((real_t)(elMat_20_28));
             _data_mat[629] = ((real_t)(elMat_20_29));
             _data_mat[630] = ((real_t)(elMat_21_0));
             _data_mat[631] = ((real_t)(elMat_21_1));
             _data_mat[632] = ((real_t)(elMat_21_2));
             _data_mat[633] = ((real_t)(elMat_21_3));
             _data_mat[634] = ((real_t)(elMat_21_4));
             _data_mat[635] = ((real_t)(elMat_21_5));
             _data_mat[636] = ((real_t)(elMat_21_6));
             _data_mat[637] = ((real_t)(elMat_21_7));
             _data_mat[638] = ((real_t)(elMat_21_8));
             _data_mat[639] = ((real_t)(elMat_21_9));
             _data_mat[640] = ((real_t)(elMat_21_10));
             _data_mat[641] = ((real_t)(elMat_21_11));
             _data_mat[642] = ((real_t)(elMat_21_12));
             _data_mat[643] = ((real_t)(elMat_21_13));
             _data_mat[644] = ((real_t)(elMat_21_14));
             _data_mat[645] = ((real_t)(elMat_21_15));
             _data_mat[646] = ((real_t)(elMat_21_16));
             _data_mat[647] = ((real_t)(elMat_21_17));
             _data_mat[648] = ((real_t)(elMat_21_18));
             _data_mat[649] = ((real_t)(elMat_21_19));
             _data_mat[650] = ((real_t)(elMat_21_20));
             _data_mat[651] = ((real_t)(elMat_21_21));
             _data_mat[652] = ((real_t)(elMat_21_22));
             _data_mat[653] = ((real_t)(elMat_21_23));
             _data_mat[654] = ((real_t)(elMat_21_24));
             _data_mat[655] = ((real_t)(elMat_21_25));
             _data_mat[656] = ((real_t)(elMat_21_26));
             _data_mat[657] = ((real_t)(elMat_21_27));
             _data_mat[658] = ((real_t)(elMat_21_28));
             _data_mat[659] = ((real_t)(elMat_21_29));
             _data_mat[660] = ((real_t)(elMat_22_0));
             _data_mat[661] = ((real_t)(elMat_22_1));
             _data_mat[662] = ((real_t)(elMat_22_2));
             _data_mat[663] = ((real_t)(elMat_22_3));
             _data_mat[664] = ((real_t)(elMat_22_4));
             _data_mat[665] = ((real_t)(elMat_22_5));
             _data_mat[666] = ((real_t)(elMat_22_6));
             _data_mat[667] = ((real_t)(elMat_22_7));
             _data_mat[668] = ((real_t)(elMat_22_8));
             _data_mat[669] = ((real_t)(elMat_22_9));
             _data_mat[670] = ((real_t)(elMat_22_10));
             _data_mat[671] = ((real_t)(elMat_22_11));
             _data_mat[672] = ((real_t)(elMat_22_12));
             _data_mat[673] = ((real_t)(elMat_22_13));
             _data_mat[674] = ((real_t)(elMat_22_14));
             _data_mat[675] = ((real_t)(elMat_22_15));
             _data_mat[676] = ((real_t)(elMat_22_16));
             _data_mat[677] = ((real_t)(elMat_22_17));
             _data_mat[678] = ((real_t)(elMat_22_18));
             _data_mat[679] = ((real_t)(elMat_22_19));
             _data_mat[680] = ((real_t)(elMat_22_20));
             _data_mat[681] = ((real_t)(elMat_22_21));
             _data_mat[682] = ((real_t)(elMat_22_22));
             _data_mat[683] = ((real_t)(elMat_22_23));
             _data_mat[684] = ((real_t)(elMat_22_24));
             _data_mat[685] = ((real_t)(elMat_22_25));
             _data_mat[686] = ((real_t)(elMat_22_26));
             _data_mat[687] = ((real_t)(elMat_22_27));
             _data_mat[688] = ((real_t)(elMat_22_28));
             _data_mat[689] = ((real_t)(elMat_22_29));
             _data_mat[690] = ((real_t)(elMat_23_0));
             _data_mat[691] = ((real_t)(elMat_23_1));
             _data_mat[692] = ((real_t)(elMat_23_2));
             _data_mat[693] = ((real_t)(elMat_23_3));
             _data_mat[694] = ((real_t)(elMat_23_4));
             _data_mat[695] = ((real_t)(elMat_23_5));
             _data_mat[696] = ((real_t)(elMat_23_6));
             _data_mat[697] = ((real_t)(elMat_23_7));
             _data_mat[698] = ((real_t)(elMat_23_8));
             _data_mat[699] = ((real_t)(elMat_23_9));
             _data_mat[700] = ((real_t)(elMat_23_10));
             _data_mat[701] = ((real_t)(elMat_23_11));
             _data_mat[702] = ((real_t)(elMat_23_12));
             _data_mat[703] = ((real_t)(elMat_23_13));
             _data_mat[704] = ((real_t)(elMat_23_14));
             _data_mat[705] = ((real_t)(elMat_23_15));
             _data_mat[706] = ((real_t)(elMat_23_16));
             _data_mat[707] = ((real_t)(elMat_23_17));
             _data_mat[708] = ((real_t)(elMat_23_18));
             _data_mat[709] = ((real_t)(elMat_23_19));
             _data_mat[710] = ((real_t)(elMat_23_20));
             _data_mat[711] = ((real_t)(elMat_23_21));
             _data_mat[712] = ((real_t)(elMat_23_22));
             _data_mat[713] = ((real_t)(elMat_23_23));
             _data_mat[714] = ((real_t)(elMat_23_24));
             _data_mat[715] = ((real_t)(elMat_23_25));
             _data_mat[716] = ((real_t)(elMat_23_26));
             _data_mat[717] = ((real_t)(elMat_23_27));
             _data_mat[718] = ((real_t)(elMat_23_28));
             _data_mat[719] = ((real_t)(elMat_23_29));
             _data_mat[720] = ((real_t)(elMat_24_0));
             _data_mat[721] = ((real_t)(elMat_24_1));
             _data_mat[722] = ((real_t)(elMat_24_2));
             _data_mat[723] = ((real_t)(elMat_24_3));
             _data_mat[724] = ((real_t)(elMat_24_4));
             _data_mat[725] = ((real_t)(elMat_24_5));
             _data_mat[726] = ((real_t)(elMat_24_6));
             _data_mat[727] = ((real_t)(elMat_24_7));
             _data_mat[728] = ((real_t)(elMat_24_8));
             _data_mat[729] = ((real_t)(elMat_24_9));
             _data_mat[730] = ((real_t)(elMat_24_10));
             _data_mat[731] = ((real_t)(elMat_24_11));
             _data_mat[732] = ((real_t)(elMat_24_12));
             _data_mat[733] = ((real_t)(elMat_24_13));
             _data_mat[734] = ((real_t)(elMat_24_14));
             _data_mat[735] = ((real_t)(elMat_24_15));
             _data_mat[736] = ((real_t)(elMat_24_16));
             _data_mat[737] = ((real_t)(elMat_24_17));
             _data_mat[738] = ((real_t)(elMat_24_18));
             _data_mat[739] = ((real_t)(elMat_24_19));
             _data_mat[740] = ((real_t)(elMat_24_20));
             _data_mat[741] = ((real_t)(elMat_24_21));
             _data_mat[742] = ((real_t)(elMat_24_22));
             _data_mat[743] = ((real_t)(elMat_24_23));
             _data_mat[744] = ((real_t)(elMat_24_24));
             _data_mat[745] = ((real_t)(elMat_24_25));
             _data_mat[746] = ((real_t)(elMat_24_26));
             _data_mat[747] = ((real_t)(elMat_24_27));
             _data_mat[748] = ((real_t)(elMat_24_28));
             _data_mat[749] = ((real_t)(elMat_24_29));
             _data_mat[750] = ((real_t)(elMat_25_0));
             _data_mat[751] = ((real_t)(elMat_25_1));
             _data_mat[752] = ((real_t)(elMat_25_2));
             _data_mat[753] = ((real_t)(elMat_25_3));
             _data_mat[754] = ((real_t)(elMat_25_4));
             _data_mat[755] = ((real_t)(elMat_25_5));
             _data_mat[756] = ((real_t)(elMat_25_6));
             _data_mat[757] = ((real_t)(elMat_25_7));
             _data_mat[758] = ((real_t)(elMat_25_8));
             _data_mat[759] = ((real_t)(elMat_25_9));
             _data_mat[760] = ((real_t)(elMat_25_10));
             _data_mat[761] = ((real_t)(elMat_25_11));
             _data_mat[762] = ((real_t)(elMat_25_12));
             _data_mat[763] = ((real_t)(elMat_25_13));
             _data_mat[764] = ((real_t)(elMat_25_14));
             _data_mat[765] = ((real_t)(elMat_25_15));
             _data_mat[766] = ((real_t)(elMat_25_16));
             _data_mat[767] = ((real_t)(elMat_25_17));
             _data_mat[768] = ((real_t)(elMat_25_18));
             _data_mat[769] = ((real_t)(elMat_25_19));
             _data_mat[770] = ((real_t)(elMat_25_20));
             _data_mat[771] = ((real_t)(elMat_25_21));
             _data_mat[772] = ((real_t)(elMat_25_22));
             _data_mat[773] = ((real_t)(elMat_25_23));
             _data_mat[774] = ((real_t)(elMat_25_24));
             _data_mat[775] = ((real_t)(elMat_25_25));
             _data_mat[776] = ((real_t)(elMat_25_26));
             _data_mat[777] = ((real_t)(elMat_25_27));
             _data_mat[778] = ((real_t)(elMat_25_28));
             _data_mat[779] = ((real_t)(elMat_25_29));
             _data_mat[780] = ((real_t)(elMat_26_0));
             _data_mat[781] = ((real_t)(elMat_26_1));
             _data_mat[782] = ((real_t)(elMat_26_2));
             _data_mat[783] = ((real_t)(elMat_26_3));
             _data_mat[784] = ((real_t)(elMat_26_4));
             _data_mat[785] = ((real_t)(elMat_26_5));
             _data_mat[786] = ((real_t)(elMat_26_6));
             _data_mat[787] = ((real_t)(elMat_26_7));
             _data_mat[788] = ((real_t)(elMat_26_8));
             _data_mat[789] = ((real_t)(elMat_26_9));
             _data_mat[790] = ((real_t)(elMat_26_10));
             _data_mat[791] = ((real_t)(elMat_26_11));
             _data_mat[792] = ((real_t)(elMat_26_12));
             _data_mat[793] = ((real_t)(elMat_26_13));
             _data_mat[794] = ((real_t)(elMat_26_14));
             _data_mat[795] = ((real_t)(elMat_26_15));
             _data_mat[796] = ((real_t)(elMat_26_16));
             _data_mat[797] = ((real_t)(elMat_26_17));
             _data_mat[798] = ((real_t)(elMat_26_18));
             _data_mat[799] = ((real_t)(elMat_26_19));
             _data_mat[800] = ((real_t)(elMat_26_20));
             _data_mat[801] = ((real_t)(elMat_26_21));
             _data_mat[802] = ((real_t)(elMat_26_22));
             _data_mat[803] = ((real_t)(elMat_26_23));
             _data_mat[804] = ((real_t)(elMat_26_24));
             _data_mat[805] = ((real_t)(elMat_26_25));
             _data_mat[806] = ((real_t)(elMat_26_26));
             _data_mat[807] = ((real_t)(elMat_26_27));
             _data_mat[808] = ((real_t)(elMat_26_28));
             _data_mat[809] = ((real_t)(elMat_26_29));
             _data_mat[810] = ((real_t)(elMat_27_0));
             _data_mat[811] = ((real_t)(elMat_27_1));
             _data_mat[812] = ((real_t)(elMat_27_2));
             _data_mat[813] = ((real_t)(elMat_27_3));
             _data_mat[814] = ((real_t)(elMat_27_4));
             _data_mat[815] = ((real_t)(elMat_27_5));
             _data_mat[816] = ((real_t)(elMat_27_6));
             _data_mat[817] = ((real_t)(elMat_27_7));
             _data_mat[818] = ((real_t)(elMat_27_8));
             _data_mat[819] = ((real_t)(elMat_27_9));
             _data_mat[820] = ((real_t)(elMat_27_10));
             _data_mat[821] = ((real_t)(elMat_27_11));
             _data_mat[822] = ((real_t)(elMat_27_12));
             _data_mat[823] = ((real_t)(elMat_27_13));
             _data_mat[824] = ((real_t)(elMat_27_14));
             _data_mat[825] = ((real_t)(elMat_27_15));
             _data_mat[826] = ((real_t)(elMat_27_16));
             _data_mat[827] = ((real_t)(elMat_27_17));
             _data_mat[828] = ((real_t)(elMat_27_18));
             _data_mat[829] = ((real_t)(elMat_27_19));
             _data_mat[830] = ((real_t)(elMat_27_20));
             _data_mat[831] = ((real_t)(elMat_27_21));
             _data_mat[832] = ((real_t)(elMat_27_22));
             _data_mat[833] = ((real_t)(elMat_27_23));
             _data_mat[834] = ((real_t)(elMat_27_24));
             _data_mat[835] = ((real_t)(elMat_27_25));
             _data_mat[836] = ((real_t)(elMat_27_26));
             _data_mat[837] = ((real_t)(elMat_27_27));
             _data_mat[838] = ((real_t)(elMat_27_28));
             _data_mat[839] = ((real_t)(elMat_27_29));
             _data_mat[840] = ((real_t)(elMat_28_0));
             _data_mat[841] = ((real_t)(elMat_28_1));
             _data_mat[842] = ((real_t)(elMat_28_2));
             _data_mat[843] = ((real_t)(elMat_28_3));
             _data_mat[844] = ((real_t)(elMat_28_4));
             _data_mat[845] = ((real_t)(elMat_28_5));
             _data_mat[846] = ((real_t)(elMat_28_6));
             _data_mat[847] = ((real_t)(elMat_28_7));
             _data_mat[848] = ((real_t)(elMat_28_8));
             _data_mat[849] = ((real_t)(elMat_28_9));
             _data_mat[850] = ((real_t)(elMat_28_10));
             _data_mat[851] = ((real_t)(elMat_28_11));
             _data_mat[852] = ((real_t)(elMat_28_12));
             _data_mat[853] = ((real_t)(elMat_28_13));
             _data_mat[854] = ((real_t)(elMat_28_14));
             _data_mat[855] = ((real_t)(elMat_28_15));
             _data_mat[856] = ((real_t)(elMat_28_16));
             _data_mat[857] = ((real_t)(elMat_28_17));
             _data_mat[858] = ((real_t)(elMat_28_18));
             _data_mat[859] = ((real_t)(elMat_28_19));
             _data_mat[860] = ((real_t)(elMat_28_20));
             _data_mat[861] = ((real_t)(elMat_28_21));
             _data_mat[862] = ((real_t)(elMat_28_22));
             _data_mat[863] = ((real_t)(elMat_28_23));
             _data_mat[864] = ((real_t)(elMat_28_24));
             _data_mat[865] = ((real_t)(elMat_28_25));
             _data_mat[866] = ((real_t)(elMat_28_26));
             _data_mat[867] = ((real_t)(elMat_28_27));
             _data_mat[868] = ((real_t)(elMat_28_28));
             _data_mat[869] = ((real_t)(elMat_28_29));
             _data_mat[870] = ((real_t)(elMat_29_0));
             _data_mat[871] = ((real_t)(elMat_29_1));
             _data_mat[872] = ((real_t)(elMat_29_2));
             _data_mat[873] = ((real_t)(elMat_29_3));
             _data_mat[874] = ((real_t)(elMat_29_4));
             _data_mat[875] = ((real_t)(elMat_29_5));
             _data_mat[876] = ((real_t)(elMat_29_6));
             _data_mat[877] = ((real_t)(elMat_29_7));
             _data_mat[878] = ((real_t)(elMat_29_8));
             _data_mat[879] = ((real_t)(elMat_29_9));
             _data_mat[880] = ((real_t)(elMat_29_10));
             _data_mat[881] = ((real_t)(elMat_29_11));
             _data_mat[882] = ((real_t)(elMat_29_12));
             _data_mat[883] = ((real_t)(elMat_29_13));
             _data_mat[884] = ((real_t)(elMat_29_14));
             _data_mat[885] = ((real_t)(elMat_29_15));
             _data_mat[886] = ((real_t)(elMat_29_16));
             _data_mat[887] = ((real_t)(elMat_29_17));
             _data_mat[888] = ((real_t)(elMat_29_18));
             _data_mat[889] = ((real_t)(elMat_29_19));
             _data_mat[890] = ((real_t)(elMat_29_20));
             _data_mat[891] = ((real_t)(elMat_29_21));
             _data_mat[892] = ((real_t)(elMat_29_22));
             _data_mat[893] = ((real_t)(elMat_29_23));
             _data_mat[894] = ((real_t)(elMat_29_24));
             _data_mat[895] = ((real_t)(elMat_29_25));
             _data_mat[896] = ((real_t)(elMat_29_26));
             _data_mat[897] = ((real_t)(elMat_29_27));
             _data_mat[898] = ((real_t)(elMat_29_28));
             _data_mat[899] = ((real_t)(elMat_29_29));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_GREEN_UP[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_0_12 = q_acc_0_12;
             const real_t elMat_0_13 = q_acc_0_13;
             const real_t elMat_0_14 = q_acc_0_14;
             const real_t elMat_0_15 = q_acc_0_15;
             const real_t elMat_0_16 = q_acc_0_16;
             const real_t elMat_0_17 = q_acc_0_17;
             const real_t elMat_0_18 = q_acc_0_18;
             const real_t elMat_0_19 = q_acc_0_19;
             const real_t elMat_0_20 = q_acc_0_20;
             const real_t elMat_0_21 = q_acc_0_21;
             const real_t elMat_0_22 = q_acc_0_22;
             const real_t elMat_0_23 = q_acc_0_23;
             const real_t elMat_0_24 = q_acc_0_24;
             const real_t elMat_0_25 = q_acc_0_25;
             const real_t elMat_0_26 = q_acc_0_26;
             const real_t elMat_0_27 = q_acc_0_27;
             const real_t elMat_0_28 = q_acc_0_28;
             const real_t elMat_0_29 = q_acc_0_29;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_1_12 = q_acc_1_12;
             const real_t elMat_1_13 = q_acc_1_13;
             const real_t elMat_1_14 = q_acc_1_14;
             const real_t elMat_1_15 = q_acc_1_15;
             const real_t elMat_1_16 = q_acc_1_16;
             const real_t elMat_1_17 = q_acc_1_17;
             const real_t elMat_1_18 = q_acc_1_18;
             const real_t elMat_1_19 = q_acc_1_19;
             const real_t elMat_1_20 = q_acc_1_20;
             const real_t elMat_1_21 = q_acc_1_21;
             const real_t elMat_1_22 = q_acc_1_22;
             const real_t elMat_1_23 = q_acc_1_23;
             const real_t elMat_1_24 = q_acc_1_24;
             const real_t elMat_1_25 = q_acc_1_25;
             const real_t elMat_1_26 = q_acc_1_26;
             const real_t elMat_1_27 = q_acc_1_27;
             const real_t elMat_1_28 = q_acc_1_28;
             const real_t elMat_1_29 = q_acc_1_29;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_2_12 = q_acc_2_12;
             const real_t elMat_2_13 = q_acc_2_13;
             const real_t elMat_2_14 = q_acc_2_14;
             const real_t elMat_2_15 = q_acc_2_15;
             const real_t elMat_2_16 = q_acc_2_16;
             const real_t elMat_2_17 = q_acc_2_17;
             const real_t elMat_2_18 = q_acc_2_18;
             const real_t elMat_2_19 = q_acc_2_19;
             const real_t elMat_2_20 = q_acc_2_20;
             const real_t elMat_2_21 = q_acc_2_21;
             const real_t elMat_2_22 = q_acc_2_22;
             const real_t elMat_2_23 = q_acc_2_23;
             const real_t elMat_2_24 = q_acc_2_24;
             const real_t elMat_2_25 = q_acc_2_25;
             const real_t elMat_2_26 = q_acc_2_26;
             const real_t elMat_2_27 = q_acc_2_27;
             const real_t elMat_2_28 = q_acc_2_28;
             const real_t elMat_2_29 = q_acc_2_29;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_3_12 = q_acc_3_12;
             const real_t elMat_3_13 = q_acc_3_13;
             const real_t elMat_3_14 = q_acc_3_14;
             const real_t elMat_3_15 = q_acc_3_15;
             const real_t elMat_3_16 = q_acc_3_16;
             const real_t elMat_3_17 = q_acc_3_17;
             const real_t elMat_3_18 = q_acc_3_18;
             const real_t elMat_3_19 = q_acc_3_19;
             const real_t elMat_3_20 = q_acc_3_20;
             const real_t elMat_3_21 = q_acc_3_21;
             const real_t elMat_3_22 = q_acc_3_22;
             const real_t elMat_3_23 = q_acc_3_23;
             const real_t elMat_3_24 = q_acc_3_24;
             const real_t elMat_3_25 = q_acc_3_25;
             const real_t elMat_3_26 = q_acc_3_26;
             const real_t elMat_3_27 = q_acc_3_27;
             const real_t elMat_3_28 = q_acc_3_28;
             const real_t elMat_3_29 = q_acc_3_29;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_4_12 = q_acc_4_12;
             const real_t elMat_4_13 = q_acc_4_13;
             const real_t elMat_4_14 = q_acc_4_14;
             const real_t elMat_4_15 = q_acc_4_15;
             const real_t elMat_4_16 = q_acc_4_16;
             const real_t elMat_4_17 = q_acc_4_17;
             const real_t elMat_4_18 = q_acc_4_18;
             const real_t elMat_4_19 = q_acc_4_19;
             const real_t elMat_4_20 = q_acc_4_20;
             const real_t elMat_4_21 = q_acc_4_21;
             const real_t elMat_4_22 = q_acc_4_22;
             const real_t elMat_4_23 = q_acc_4_23;
             const real_t elMat_4_24 = q_acc_4_24;
             const real_t elMat_4_25 = q_acc_4_25;
             const real_t elMat_4_26 = q_acc_4_26;
             const real_t elMat_4_27 = q_acc_4_27;
             const real_t elMat_4_28 = q_acc_4_28;
             const real_t elMat_4_29 = q_acc_4_29;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_5_12 = q_acc_5_12;
             const real_t elMat_5_13 = q_acc_5_13;
             const real_t elMat_5_14 = q_acc_5_14;
             const real_t elMat_5_15 = q_acc_5_15;
             const real_t elMat_5_16 = q_acc_5_16;
             const real_t elMat_5_17 = q_acc_5_17;
             const real_t elMat_5_18 = q_acc_5_18;
             const real_t elMat_5_19 = q_acc_5_19;
             const real_t elMat_5_20 = q_acc_5_20;
             const real_t elMat_5_21 = q_acc_5_21;
             const real_t elMat_5_22 = q_acc_5_22;
             const real_t elMat_5_23 = q_acc_5_23;
             const real_t elMat_5_24 = q_acc_5_24;
             const real_t elMat_5_25 = q_acc_5_25;
             const real_t elMat_5_26 = q_acc_5_26;
             const real_t elMat_5_27 = q_acc_5_27;
             const real_t elMat_5_28 = q_acc_5_28;
             const real_t elMat_5_29 = q_acc_5_29;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_6_12 = q_acc_6_12;
             const real_t elMat_6_13 = q_acc_6_13;
             const real_t elMat_6_14 = q_acc_6_14;
             const real_t elMat_6_15 = q_acc_6_15;
             const real_t elMat_6_16 = q_acc_6_16;
             const real_t elMat_6_17 = q_acc_6_17;
             const real_t elMat_6_18 = q_acc_6_18;
             const real_t elMat_6_19 = q_acc_6_19;
             const real_t elMat_6_20 = q_acc_6_20;
             const real_t elMat_6_21 = q_acc_6_21;
             const real_t elMat_6_22 = q_acc_6_22;
             const real_t elMat_6_23 = q_acc_6_23;
             const real_t elMat_6_24 = q_acc_6_24;
             const real_t elMat_6_25 = q_acc_6_25;
             const real_t elMat_6_26 = q_acc_6_26;
             const real_t elMat_6_27 = q_acc_6_27;
             const real_t elMat_6_28 = q_acc_6_28;
             const real_t elMat_6_29 = q_acc_6_29;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_7_12 = q_acc_7_12;
             const real_t elMat_7_13 = q_acc_7_13;
             const real_t elMat_7_14 = q_acc_7_14;
             const real_t elMat_7_15 = q_acc_7_15;
             const real_t elMat_7_16 = q_acc_7_16;
             const real_t elMat_7_17 = q_acc_7_17;
             const real_t elMat_7_18 = q_acc_7_18;
             const real_t elMat_7_19 = q_acc_7_19;
             const real_t elMat_7_20 = q_acc_7_20;
             const real_t elMat_7_21 = q_acc_7_21;
             const real_t elMat_7_22 = q_acc_7_22;
             const real_t elMat_7_23 = q_acc_7_23;
             const real_t elMat_7_24 = q_acc_7_24;
             const real_t elMat_7_25 = q_acc_7_25;
             const real_t elMat_7_26 = q_acc_7_26;
             const real_t elMat_7_27 = q_acc_7_27;
             const real_t elMat_7_28 = q_acc_7_28;
             const real_t elMat_7_29 = q_acc_7_29;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_8_12 = q_acc_8_12;
             const real_t elMat_8_13 = q_acc_8_13;
             const real_t elMat_8_14 = q_acc_8_14;
             const real_t elMat_8_15 = q_acc_8_15;
             const real_t elMat_8_16 = q_acc_8_16;
             const real_t elMat_8_17 = q_acc_8_17;
             const real_t elMat_8_18 = q_acc_8_18;
             const real_t elMat_8_19 = q_acc_8_19;
             const real_t elMat_8_20 = q_acc_8_20;
             const real_t elMat_8_21 = q_acc_8_21;
             const real_t elMat_8_22 = q_acc_8_22;
             const real_t elMat_8_23 = q_acc_8_23;
             const real_t elMat_8_24 = q_acc_8_24;
             const real_t elMat_8_25 = q_acc_8_25;
             const real_t elMat_8_26 = q_acc_8_26;
             const real_t elMat_8_27 = q_acc_8_27;
             const real_t elMat_8_28 = q_acc_8_28;
             const real_t elMat_8_29 = q_acc_8_29;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_9_12 = q_acc_9_12;
             const real_t elMat_9_13 = q_acc_9_13;
             const real_t elMat_9_14 = q_acc_9_14;
             const real_t elMat_9_15 = q_acc_9_15;
             const real_t elMat_9_16 = q_acc_9_16;
             const real_t elMat_9_17 = q_acc_9_17;
             const real_t elMat_9_18 = q_acc_9_18;
             const real_t elMat_9_19 = q_acc_9_19;
             const real_t elMat_9_20 = q_acc_9_20;
             const real_t elMat_9_21 = q_acc_9_21;
             const real_t elMat_9_22 = q_acc_9_22;
             const real_t elMat_9_23 = q_acc_9_23;
             const real_t elMat_9_24 = q_acc_9_24;
             const real_t elMat_9_25 = q_acc_9_25;
             const real_t elMat_9_26 = q_acc_9_26;
             const real_t elMat_9_27 = q_acc_9_27;
             const real_t elMat_9_28 = q_acc_9_28;
             const real_t elMat_9_29 = q_acc_9_29;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_10_12 = q_acc_10_12;
             const real_t elMat_10_13 = q_acc_10_13;
             const real_t elMat_10_14 = q_acc_10_14;
             const real_t elMat_10_15 = q_acc_10_15;
             const real_t elMat_10_16 = q_acc_10_16;
             const real_t elMat_10_17 = q_acc_10_17;
             const real_t elMat_10_18 = q_acc_10_18;
             const real_t elMat_10_19 = q_acc_10_19;
             const real_t elMat_10_20 = q_acc_10_20;
             const real_t elMat_10_21 = q_acc_10_21;
             const real_t elMat_10_22 = q_acc_10_22;
             const real_t elMat_10_23 = q_acc_10_23;
             const real_t elMat_10_24 = q_acc_10_24;
             const real_t elMat_10_25 = q_acc_10_25;
             const real_t elMat_10_26 = q_acc_10_26;
             const real_t elMat_10_27 = q_acc_10_27;
             const real_t elMat_10_28 = q_acc_10_28;
             const real_t elMat_10_29 = q_acc_10_29;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
             const real_t elMat_11_12 = q_acc_11_12;
             const real_t elMat_11_13 = q_acc_11_13;
             const real_t elMat_11_14 = q_acc_11_14;
             const real_t elMat_11_15 = q_acc_11_15;
             const real_t elMat_11_16 = q_acc_11_16;
             const real_t elMat_11_17 = q_acc_11_17;
             const real_t elMat_11_18 = q_acc_11_18;
             const real_t elMat_11_19 = q_acc_11_19;
             const real_t elMat_11_20 = q_acc_11_20;
             const real_t elMat_11_21 = q_acc_11_21;
             const real_t elMat_11_22 = q_acc_11_22;
             const real_t elMat_11_23 = q_acc_11_23;
             const real_t elMat_11_24 = q_acc_11_24;
             const real_t elMat_11_25 = q_acc_11_25;
             const real_t elMat_11_26 = q_acc_11_26;
             const real_t elMat_11_27 = q_acc_11_27;
             const real_t elMat_11_28 = q_acc_11_28;
             const real_t elMat_11_29 = q_acc_11_29;
             const real_t elMat_12_0 = q_acc_0_12;
             const real_t elMat_12_1 = q_acc_1_12;
             const real_t elMat_12_2 = q_acc_2_12;
             const real_t elMat_12_3 = q_acc_3_12;
             const real_t elMat_12_4 = q_acc_4_12;
             const real_t elMat_12_5 = q_acc_5_12;
             const real_t elMat_12_6 = q_acc_6_12;
             const real_t elMat_12_7 = q_acc_7_12;
             const real_t elMat_12_8 = q_acc_8_12;
             const real_t elMat_12_9 = q_acc_9_12;
             const real_t elMat_12_10 = q_acc_10_12;
             const real_t elMat_12_11 = q_acc_11_12;
             const real_t elMat_12_12 = q_acc_12_12;
             const real_t elMat_12_13 = q_acc_12_13;
             const real_t elMat_12_14 = q_acc_12_14;
             const real_t elMat_12_15 = q_acc_12_15;
             const real_t elMat_12_16 = q_acc_12_16;
             const real_t elMat_12_17 = q_acc_12_17;
             const real_t elMat_12_18 = q_acc_12_18;
             const real_t elMat_12_19 = q_acc_12_19;
             const real_t elMat_12_20 = q_acc_12_20;
             const real_t elMat_12_21 = q_acc_12_21;
             const real_t elMat_12_22 = q_acc_12_22;
             const real_t elMat_12_23 = q_acc_12_23;
             const real_t elMat_12_24 = q_acc_12_24;
             const real_t elMat_12_25 = q_acc_12_25;
             const real_t elMat_12_26 = q_acc_12_26;
             const real_t elMat_12_27 = q_acc_12_27;
             const real_t elMat_12_28 = q_acc_12_28;
             const real_t elMat_12_29 = q_acc_12_29;
             const real_t elMat_13_0 = q_acc_0_13;
             const real_t elMat_13_1 = q_acc_1_13;
             const real_t elMat_13_2 = q_acc_2_13;
             const real_t elMat_13_3 = q_acc_3_13;
             const real_t elMat_13_4 = q_acc_4_13;
             const real_t elMat_13_5 = q_acc_5_13;
             const real_t elMat_13_6 = q_acc_6_13;
             const real_t elMat_13_7 = q_acc_7_13;
             const real_t elMat_13_8 = q_acc_8_13;
             const real_t elMat_13_9 = q_acc_9_13;
             const real_t elMat_13_10 = q_acc_10_13;
             const real_t elMat_13_11 = q_acc_11_13;
             const real_t elMat_13_12 = q_acc_12_13;
             const real_t elMat_13_13 = q_acc_13_13;
             const real_t elMat_13_14 = q_acc_13_14;
             const real_t elMat_13_15 = q_acc_13_15;
             const real_t elMat_13_16 = q_acc_13_16;
             const real_t elMat_13_17 = q_acc_13_17;
             const real_t elMat_13_18 = q_acc_13_18;
             const real_t elMat_13_19 = q_acc_13_19;
             const real_t elMat_13_20 = q_acc_13_20;
             const real_t elMat_13_21 = q_acc_13_21;
             const real_t elMat_13_22 = q_acc_13_22;
             const real_t elMat_13_23 = q_acc_13_23;
             const real_t elMat_13_24 = q_acc_13_24;
             const real_t elMat_13_25 = q_acc_13_25;
             const real_t elMat_13_26 = q_acc_13_26;
             const real_t elMat_13_27 = q_acc_13_27;
             const real_t elMat_13_28 = q_acc_13_28;
             const real_t elMat_13_29 = q_acc_13_29;
             const real_t elMat_14_0 = q_acc_0_14;
             const real_t elMat_14_1 = q_acc_1_14;
             const real_t elMat_14_2 = q_acc_2_14;
             const real_t elMat_14_3 = q_acc_3_14;
             const real_t elMat_14_4 = q_acc_4_14;
             const real_t elMat_14_5 = q_acc_5_14;
             const real_t elMat_14_6 = q_acc_6_14;
             const real_t elMat_14_7 = q_acc_7_14;
             const real_t elMat_14_8 = q_acc_8_14;
             const real_t elMat_14_9 = q_acc_9_14;
             const real_t elMat_14_10 = q_acc_10_14;
             const real_t elMat_14_11 = q_acc_11_14;
             const real_t elMat_14_12 = q_acc_12_14;
             const real_t elMat_14_13 = q_acc_13_14;
             const real_t elMat_14_14 = q_acc_14_14;
             const real_t elMat_14_15 = q_acc_14_15;
             const real_t elMat_14_16 = q_acc_14_16;
             const real_t elMat_14_17 = q_acc_14_17;
             const real_t elMat_14_18 = q_acc_14_18;
             const real_t elMat_14_19 = q_acc_14_19;
             const real_t elMat_14_20 = q_acc_14_20;
             const real_t elMat_14_21 = q_acc_14_21;
             const real_t elMat_14_22 = q_acc_14_22;
             const real_t elMat_14_23 = q_acc_14_23;
             const real_t elMat_14_24 = q_acc_14_24;
             const real_t elMat_14_25 = q_acc_14_25;
             const real_t elMat_14_26 = q_acc_14_26;
             const real_t elMat_14_27 = q_acc_14_27;
             const real_t elMat_14_28 = q_acc_14_28;
             const real_t elMat_14_29 = q_acc_14_29;
             const real_t elMat_15_0 = q_acc_0_15;
             const real_t elMat_15_1 = q_acc_1_15;
             const real_t elMat_15_2 = q_acc_2_15;
             const real_t elMat_15_3 = q_acc_3_15;
             const real_t elMat_15_4 = q_acc_4_15;
             const real_t elMat_15_5 = q_acc_5_15;
             const real_t elMat_15_6 = q_acc_6_15;
             const real_t elMat_15_7 = q_acc_7_15;
             const real_t elMat_15_8 = q_acc_8_15;
             const real_t elMat_15_9 = q_acc_9_15;
             const real_t elMat_15_10 = q_acc_10_15;
             const real_t elMat_15_11 = q_acc_11_15;
             const real_t elMat_15_12 = q_acc_12_15;
             const real_t elMat_15_13 = q_acc_13_15;
             const real_t elMat_15_14 = q_acc_14_15;
             const real_t elMat_15_15 = q_acc_15_15;
             const real_t elMat_15_16 = q_acc_15_16;
             const real_t elMat_15_17 = q_acc_15_17;
             const real_t elMat_15_18 = q_acc_15_18;
             const real_t elMat_15_19 = q_acc_15_19;
             const real_t elMat_15_20 = q_acc_15_20;
             const real_t elMat_15_21 = q_acc_15_21;
             const real_t elMat_15_22 = q_acc_15_22;
             const real_t elMat_15_23 = q_acc_15_23;
             const real_t elMat_15_24 = q_acc_15_24;
             const real_t elMat_15_25 = q_acc_15_25;
             const real_t elMat_15_26 = q_acc_15_26;
             const real_t elMat_15_27 = q_acc_15_27;
             const real_t elMat_15_28 = q_acc_15_28;
             const real_t elMat_15_29 = q_acc_15_29;
             const real_t elMat_16_0 = q_acc_0_16;
             const real_t elMat_16_1 = q_acc_1_16;
             const real_t elMat_16_2 = q_acc_2_16;
             const real_t elMat_16_3 = q_acc_3_16;
             const real_t elMat_16_4 = q_acc_4_16;
             const real_t elMat_16_5 = q_acc_5_16;
             const real_t elMat_16_6 = q_acc_6_16;
             const real_t elMat_16_7 = q_acc_7_16;
             const real_t elMat_16_8 = q_acc_8_16;
             const real_t elMat_16_9 = q_acc_9_16;
             const real_t elMat_16_10 = q_acc_10_16;
             const real_t elMat_16_11 = q_acc_11_16;
             const real_t elMat_16_12 = q_acc_12_16;
             const real_t elMat_16_13 = q_acc_13_16;
             const real_t elMat_16_14 = q_acc_14_16;
             const real_t elMat_16_15 = q_acc_15_16;
             const real_t elMat_16_16 = q_acc_16_16;
             const real_t elMat_16_17 = q_acc_16_17;
             const real_t elMat_16_18 = q_acc_16_18;
             const real_t elMat_16_19 = q_acc_16_19;
             const real_t elMat_16_20 = q_acc_16_20;
             const real_t elMat_16_21 = q_acc_16_21;
             const real_t elMat_16_22 = q_acc_16_22;
             const real_t elMat_16_23 = q_acc_16_23;
             const real_t elMat_16_24 = q_acc_16_24;
             const real_t elMat_16_25 = q_acc_16_25;
             const real_t elMat_16_26 = q_acc_16_26;
             const real_t elMat_16_27 = q_acc_16_27;
             const real_t elMat_16_28 = q_acc_16_28;
             const real_t elMat_16_29 = q_acc_16_29;
             const real_t elMat_17_0 = q_acc_0_17;
             const real_t elMat_17_1 = q_acc_1_17;
             const real_t elMat_17_2 = q_acc_2_17;
             const real_t elMat_17_3 = q_acc_3_17;
             const real_t elMat_17_4 = q_acc_4_17;
             const real_t elMat_17_5 = q_acc_5_17;
             const real_t elMat_17_6 = q_acc_6_17;
             const real_t elMat_17_7 = q_acc_7_17;
             const real_t elMat_17_8 = q_acc_8_17;
             const real_t elMat_17_9 = q_acc_9_17;
             const real_t elMat_17_10 = q_acc_10_17;
             const real_t elMat_17_11 = q_acc_11_17;
             const real_t elMat_17_12 = q_acc_12_17;
             const real_t elMat_17_13 = q_acc_13_17;
             const real_t elMat_17_14 = q_acc_14_17;
             const real_t elMat_17_15 = q_acc_15_17;
             const real_t elMat_17_16 = q_acc_16_17;
             const real_t elMat_17_17 = q_acc_17_17;
             const real_t elMat_17_18 = q_acc_17_18;
             const real_t elMat_17_19 = q_acc_17_19;
             const real_t elMat_17_20 = q_acc_17_20;
             const real_t elMat_17_21 = q_acc_17_21;
             const real_t elMat_17_22 = q_acc_17_22;
             const real_t elMat_17_23 = q_acc_17_23;
             const real_t elMat_17_24 = q_acc_17_24;
             const real_t elMat_17_25 = q_acc_17_25;
             const real_t elMat_17_26 = q_acc_17_26;
             const real_t elMat_17_27 = q_acc_17_27;
             const real_t elMat_17_28 = q_acc_17_28;
             const real_t elMat_17_29 = q_acc_17_29;
             const real_t elMat_18_0 = q_acc_0_18;
             const real_t elMat_18_1 = q_acc_1_18;
             const real_t elMat_18_2 = q_acc_2_18;
             const real_t elMat_18_3 = q_acc_3_18;
             const real_t elMat_18_4 = q_acc_4_18;
             const real_t elMat_18_5 = q_acc_5_18;
             const real_t elMat_18_6 = q_acc_6_18;
             const real_t elMat_18_7 = q_acc_7_18;
             const real_t elMat_18_8 = q_acc_8_18;
             const real_t elMat_18_9 = q_acc_9_18;
             const real_t elMat_18_10 = q_acc_10_18;
             const real_t elMat_18_11 = q_acc_11_18;
             const real_t elMat_18_12 = q_acc_12_18;
             const real_t elMat_18_13 = q_acc_13_18;
             const real_t elMat_18_14 = q_acc_14_18;
             const real_t elMat_18_15 = q_acc_15_18;
             const real_t elMat_18_16 = q_acc_16_18;
             const real_t elMat_18_17 = q_acc_17_18;
             const real_t elMat_18_18 = q_acc_18_18;
             const real_t elMat_18_19 = q_acc_18_19;
             const real_t elMat_18_20 = q_acc_18_20;
             const real_t elMat_18_21 = q_acc_18_21;
             const real_t elMat_18_22 = q_acc_18_22;
             const real_t elMat_18_23 = q_acc_18_23;
             const real_t elMat_18_24 = q_acc_18_24;
             const real_t elMat_18_25 = q_acc_18_25;
             const real_t elMat_18_26 = q_acc_18_26;
             const real_t elMat_18_27 = q_acc_18_27;
             const real_t elMat_18_28 = q_acc_18_28;
             const real_t elMat_18_29 = q_acc_18_29;
             const real_t elMat_19_0 = q_acc_0_19;
             const real_t elMat_19_1 = q_acc_1_19;
             const real_t elMat_19_2 = q_acc_2_19;
             const real_t elMat_19_3 = q_acc_3_19;
             const real_t elMat_19_4 = q_acc_4_19;
             const real_t elMat_19_5 = q_acc_5_19;
             const real_t elMat_19_6 = q_acc_6_19;
             const real_t elMat_19_7 = q_acc_7_19;
             const real_t elMat_19_8 = q_acc_8_19;
             const real_t elMat_19_9 = q_acc_9_19;
             const real_t elMat_19_10 = q_acc_10_19;
             const real_t elMat_19_11 = q_acc_11_19;
             const real_t elMat_19_12 = q_acc_12_19;
             const real_t elMat_19_13 = q_acc_13_19;
             const real_t elMat_19_14 = q_acc_14_19;
             const real_t elMat_19_15 = q_acc_15_19;
             const real_t elMat_19_16 = q_acc_16_19;
             const real_t elMat_19_17 = q_acc_17_19;
             const real_t elMat_19_18 = q_acc_18_19;
             const real_t elMat_19_19 = q_acc_19_19;
             const real_t elMat_19_20 = q_acc_19_20;
             const real_t elMat_19_21 = q_acc_19_21;
             const real_t elMat_19_22 = q_acc_19_22;
             const real_t elMat_19_23 = q_acc_19_23;
             const real_t elMat_19_24 = q_acc_19_24;
             const real_t elMat_19_25 = q_acc_19_25;
             const real_t elMat_19_26 = q_acc_19_26;
             const real_t elMat_19_27 = q_acc_19_27;
             const real_t elMat_19_28 = q_acc_19_28;
             const real_t elMat_19_29 = q_acc_19_29;
             const real_t elMat_20_0 = q_acc_0_20;
             const real_t elMat_20_1 = q_acc_1_20;
             const real_t elMat_20_2 = q_acc_2_20;
             const real_t elMat_20_3 = q_acc_3_20;
             const real_t elMat_20_4 = q_acc_4_20;
             const real_t elMat_20_5 = q_acc_5_20;
             const real_t elMat_20_6 = q_acc_6_20;
             const real_t elMat_20_7 = q_acc_7_20;
             const real_t elMat_20_8 = q_acc_8_20;
             const real_t elMat_20_9 = q_acc_9_20;
             const real_t elMat_20_10 = q_acc_10_20;
             const real_t elMat_20_11 = q_acc_11_20;
             const real_t elMat_20_12 = q_acc_12_20;
             const real_t elMat_20_13 = q_acc_13_20;
             const real_t elMat_20_14 = q_acc_14_20;
             const real_t elMat_20_15 = q_acc_15_20;
             const real_t elMat_20_16 = q_acc_16_20;
             const real_t elMat_20_17 = q_acc_17_20;
             const real_t elMat_20_18 = q_acc_18_20;
             const real_t elMat_20_19 = q_acc_19_20;
             const real_t elMat_20_20 = q_acc_20_20;
             const real_t elMat_20_21 = q_acc_20_21;
             const real_t elMat_20_22 = q_acc_20_22;
             const real_t elMat_20_23 = q_acc_20_23;
             const real_t elMat_20_24 = q_acc_20_24;
             const real_t elMat_20_25 = q_acc_20_25;
             const real_t elMat_20_26 = q_acc_20_26;
             const real_t elMat_20_27 = q_acc_20_27;
             const real_t elMat_20_28 = q_acc_20_28;
             const real_t elMat_20_29 = q_acc_20_29;
             const real_t elMat_21_0 = q_acc_0_21;
             const real_t elMat_21_1 = q_acc_1_21;
             const real_t elMat_21_2 = q_acc_2_21;
             const real_t elMat_21_3 = q_acc_3_21;
             const real_t elMat_21_4 = q_acc_4_21;
             const real_t elMat_21_5 = q_acc_5_21;
             const real_t elMat_21_6 = q_acc_6_21;
             const real_t elMat_21_7 = q_acc_7_21;
             const real_t elMat_21_8 = q_acc_8_21;
             const real_t elMat_21_9 = q_acc_9_21;
             const real_t elMat_21_10 = q_acc_10_21;
             const real_t elMat_21_11 = q_acc_11_21;
             const real_t elMat_21_12 = q_acc_12_21;
             const real_t elMat_21_13 = q_acc_13_21;
             const real_t elMat_21_14 = q_acc_14_21;
             const real_t elMat_21_15 = q_acc_15_21;
             const real_t elMat_21_16 = q_acc_16_21;
             const real_t elMat_21_17 = q_acc_17_21;
             const real_t elMat_21_18 = q_acc_18_21;
             const real_t elMat_21_19 = q_acc_19_21;
             const real_t elMat_21_20 = q_acc_20_21;
             const real_t elMat_21_21 = q_acc_21_21;
             const real_t elMat_21_22 = q_acc_21_22;
             const real_t elMat_21_23 = q_acc_21_23;
             const real_t elMat_21_24 = q_acc_21_24;
             const real_t elMat_21_25 = q_acc_21_25;
             const real_t elMat_21_26 = q_acc_21_26;
             const real_t elMat_21_27 = q_acc_21_27;
             const real_t elMat_21_28 = q_acc_21_28;
             const real_t elMat_21_29 = q_acc_21_29;
             const real_t elMat_22_0 = q_acc_0_22;
             const real_t elMat_22_1 = q_acc_1_22;
             const real_t elMat_22_2 = q_acc_2_22;
             const real_t elMat_22_3 = q_acc_3_22;
             const real_t elMat_22_4 = q_acc_4_22;
             const real_t elMat_22_5 = q_acc_5_22;
             const real_t elMat_22_6 = q_acc_6_22;
             const real_t elMat_22_7 = q_acc_7_22;
             const real_t elMat_22_8 = q_acc_8_22;
             const real_t elMat_22_9 = q_acc_9_22;
             const real_t elMat_22_10 = q_acc_10_22;
             const real_t elMat_22_11 = q_acc_11_22;
             const real_t elMat_22_12 = q_acc_12_22;
             const real_t elMat_22_13 = q_acc_13_22;
             const real_t elMat_22_14 = q_acc_14_22;
             const real_t elMat_22_15 = q_acc_15_22;
             const real_t elMat_22_16 = q_acc_16_22;
             const real_t elMat_22_17 = q_acc_17_22;
             const real_t elMat_22_18 = q_acc_18_22;
             const real_t elMat_22_19 = q_acc_19_22;
             const real_t elMat_22_20 = q_acc_20_22;
             const real_t elMat_22_21 = q_acc_21_22;
             const real_t elMat_22_22 = q_acc_22_22;
             const real_t elMat_22_23 = q_acc_22_23;
             const real_t elMat_22_24 = q_acc_22_24;
             const real_t elMat_22_25 = q_acc_22_25;
             const real_t elMat_22_26 = q_acc_22_26;
             const real_t elMat_22_27 = q_acc_22_27;
             const real_t elMat_22_28 = q_acc_22_28;
             const real_t elMat_22_29 = q_acc_22_29;
             const real_t elMat_23_0 = q_acc_0_23;
             const real_t elMat_23_1 = q_acc_1_23;
             const real_t elMat_23_2 = q_acc_2_23;
             const real_t elMat_23_3 = q_acc_3_23;
             const real_t elMat_23_4 = q_acc_4_23;
             const real_t elMat_23_5 = q_acc_5_23;
             const real_t elMat_23_6 = q_acc_6_23;
             const real_t elMat_23_7 = q_acc_7_23;
             const real_t elMat_23_8 = q_acc_8_23;
             const real_t elMat_23_9 = q_acc_9_23;
             const real_t elMat_23_10 = q_acc_10_23;
             const real_t elMat_23_11 = q_acc_11_23;
             const real_t elMat_23_12 = q_acc_12_23;
             const real_t elMat_23_13 = q_acc_13_23;
             const real_t elMat_23_14 = q_acc_14_23;
             const real_t elMat_23_15 = q_acc_15_23;
             const real_t elMat_23_16 = q_acc_16_23;
             const real_t elMat_23_17 = q_acc_17_23;
             const real_t elMat_23_18 = q_acc_18_23;
             const real_t elMat_23_19 = q_acc_19_23;
             const real_t elMat_23_20 = q_acc_20_23;
             const real_t elMat_23_21 = q_acc_21_23;
             const real_t elMat_23_22 = q_acc_22_23;
             const real_t elMat_23_23 = q_acc_23_23;
             const real_t elMat_23_24 = q_acc_23_24;
             const real_t elMat_23_25 = q_acc_23_25;
             const real_t elMat_23_26 = q_acc_23_26;
             const real_t elMat_23_27 = q_acc_23_27;
             const real_t elMat_23_28 = q_acc_23_28;
             const real_t elMat_23_29 = q_acc_23_29;
             const real_t elMat_24_0 = q_acc_0_24;
             const real_t elMat_24_1 = q_acc_1_24;
             const real_t elMat_24_2 = q_acc_2_24;
             const real_t elMat_24_3 = q_acc_3_24;
             const real_t elMat_24_4 = q_acc_4_24;
             const real_t elMat_24_5 = q_acc_5_24;
             const real_t elMat_24_6 = q_acc_6_24;
             const real_t elMat_24_7 = q_acc_7_24;
             const real_t elMat_24_8 = q_acc_8_24;
             const real_t elMat_24_9 = q_acc_9_24;
             const real_t elMat_24_10 = q_acc_10_24;
             const real_t elMat_24_11 = q_acc_11_24;
             const real_t elMat_24_12 = q_acc_12_24;
             const real_t elMat_24_13 = q_acc_13_24;
             const real_t elMat_24_14 = q_acc_14_24;
             const real_t elMat_24_15 = q_acc_15_24;
             const real_t elMat_24_16 = q_acc_16_24;
             const real_t elMat_24_17 = q_acc_17_24;
             const real_t elMat_24_18 = q_acc_18_24;
             const real_t elMat_24_19 = q_acc_19_24;
             const real_t elMat_24_20 = q_acc_20_24;
             const real_t elMat_24_21 = q_acc_21_24;
             const real_t elMat_24_22 = q_acc_22_24;
             const real_t elMat_24_23 = q_acc_23_24;
             const real_t elMat_24_24 = q_acc_24_24;
             const real_t elMat_24_25 = q_acc_24_25;
             const real_t elMat_24_26 = q_acc_24_26;
             const real_t elMat_24_27 = q_acc_24_27;
             const real_t elMat_24_28 = q_acc_24_28;
             const real_t elMat_24_29 = q_acc_24_29;
             const real_t elMat_25_0 = q_acc_0_25;
             const real_t elMat_25_1 = q_acc_1_25;
             const real_t elMat_25_2 = q_acc_2_25;
             const real_t elMat_25_3 = q_acc_3_25;
             const real_t elMat_25_4 = q_acc_4_25;
             const real_t elMat_25_5 = q_acc_5_25;
             const real_t elMat_25_6 = q_acc_6_25;
             const real_t elMat_25_7 = q_acc_7_25;
             const real_t elMat_25_8 = q_acc_8_25;
             const real_t elMat_25_9 = q_acc_9_25;
             const real_t elMat_25_10 = q_acc_10_25;
             const real_t elMat_25_11 = q_acc_11_25;
             const real_t elMat_25_12 = q_acc_12_25;
             const real_t elMat_25_13 = q_acc_13_25;
             const real_t elMat_25_14 = q_acc_14_25;
             const real_t elMat_25_15 = q_acc_15_25;
             const real_t elMat_25_16 = q_acc_16_25;
             const real_t elMat_25_17 = q_acc_17_25;
             const real_t elMat_25_18 = q_acc_18_25;
             const real_t elMat_25_19 = q_acc_19_25;
             const real_t elMat_25_20 = q_acc_20_25;
             const real_t elMat_25_21 = q_acc_21_25;
             const real_t elMat_25_22 = q_acc_22_25;
             const real_t elMat_25_23 = q_acc_23_25;
             const real_t elMat_25_24 = q_acc_24_25;
             const real_t elMat_25_25 = q_acc_25_25;
             const real_t elMat_25_26 = q_acc_25_26;
             const real_t elMat_25_27 = q_acc_25_27;
             const real_t elMat_25_28 = q_acc_25_28;
             const real_t elMat_25_29 = q_acc_25_29;
             const real_t elMat_26_0 = q_acc_0_26;
             const real_t elMat_26_1 = q_acc_1_26;
             const real_t elMat_26_2 = q_acc_2_26;
             const real_t elMat_26_3 = q_acc_3_26;
             const real_t elMat_26_4 = q_acc_4_26;
             const real_t elMat_26_5 = q_acc_5_26;
             const real_t elMat_26_6 = q_acc_6_26;
             const real_t elMat_26_7 = q_acc_7_26;
             const real_t elMat_26_8 = q_acc_8_26;
             const real_t elMat_26_9 = q_acc_9_26;
             const real_t elMat_26_10 = q_acc_10_26;
             const real_t elMat_26_11 = q_acc_11_26;
             const real_t elMat_26_12 = q_acc_12_26;
             const real_t elMat_26_13 = q_acc_13_26;
             const real_t elMat_26_14 = q_acc_14_26;
             const real_t elMat_26_15 = q_acc_15_26;
             const real_t elMat_26_16 = q_acc_16_26;
             const real_t elMat_26_17 = q_acc_17_26;
             const real_t elMat_26_18 = q_acc_18_26;
             const real_t elMat_26_19 = q_acc_19_26;
             const real_t elMat_26_20 = q_acc_20_26;
             const real_t elMat_26_21 = q_acc_21_26;
             const real_t elMat_26_22 = q_acc_22_26;
             const real_t elMat_26_23 = q_acc_23_26;
             const real_t elMat_26_24 = q_acc_24_26;
             const real_t elMat_26_25 = q_acc_25_26;
             const real_t elMat_26_26 = q_acc_26_26;
             const real_t elMat_26_27 = q_acc_26_27;
             const real_t elMat_26_28 = q_acc_26_28;
             const real_t elMat_26_29 = q_acc_26_29;
             const real_t elMat_27_0 = q_acc_0_27;
             const real_t elMat_27_1 = q_acc_1_27;
             const real_t elMat_27_2 = q_acc_2_27;
             const real_t elMat_27_3 = q_acc_3_27;
             const real_t elMat_27_4 = q_acc_4_27;
             const real_t elMat_27_5 = q_acc_5_27;
             const real_t elMat_27_6 = q_acc_6_27;
             const real_t elMat_27_7 = q_acc_7_27;
             const real_t elMat_27_8 = q_acc_8_27;
             const real_t elMat_27_9 = q_acc_9_27;
             const real_t elMat_27_10 = q_acc_10_27;
             const real_t elMat_27_11 = q_acc_11_27;
             const real_t elMat_27_12 = q_acc_12_27;
             const real_t elMat_27_13 = q_acc_13_27;
             const real_t elMat_27_14 = q_acc_14_27;
             const real_t elMat_27_15 = q_acc_15_27;
             const real_t elMat_27_16 = q_acc_16_27;
             const real_t elMat_27_17 = q_acc_17_27;
             const real_t elMat_27_18 = q_acc_18_27;
             const real_t elMat_27_19 = q_acc_19_27;
             const real_t elMat_27_20 = q_acc_20_27;
             const real_t elMat_27_21 = q_acc_21_27;
             const real_t elMat_27_22 = q_acc_22_27;
             const real_t elMat_27_23 = q_acc_23_27;
             const real_t elMat_27_24 = q_acc_24_27;
             const real_t elMat_27_25 = q_acc_25_27;
             const real_t elMat_27_26 = q_acc_26_27;
             const real_t elMat_27_27 = q_acc_27_27;
             const real_t elMat_27_28 = q_acc_27_28;
             const real_t elMat_27_29 = q_acc_27_29;
             const real_t elMat_28_0 = q_acc_0_28;
             const real_t elMat_28_1 = q_acc_1_28;
             const real_t elMat_28_2 = q_acc_2_28;
             const real_t elMat_28_3 = q_acc_3_28;
             const real_t elMat_28_4 = q_acc_4_28;
             const real_t elMat_28_5 = q_acc_5_28;
             const real_t elMat_28_6 = q_acc_6_28;
             const real_t elMat_28_7 = q_acc_7_28;
             const real_t elMat_28_8 = q_acc_8_28;
             const real_t elMat_28_9 = q_acc_9_28;
             const real_t elMat_28_10 = q_acc_10_28;
             const real_t elMat_28_11 = q_acc_11_28;
             const real_t elMat_28_12 = q_acc_12_28;
             const real_t elMat_28_13 = q_acc_13_28;
             const real_t elMat_28_14 = q_acc_14_28;
             const real_t elMat_28_15 = q_acc_15_28;
             const real_t elMat_28_16 = q_acc_16_28;
             const real_t elMat_28_17 = q_acc_17_28;
             const real_t elMat_28_18 = q_acc_18_28;
             const real_t elMat_28_19 = q_acc_19_28;
             const real_t elMat_28_20 = q_acc_20_28;
             const real_t elMat_28_21 = q_acc_21_28;
             const real_t elMat_28_22 = q_acc_22_28;
             const real_t elMat_28_23 = q_acc_23_28;
             const real_t elMat_28_24 = q_acc_24_28;
             const real_t elMat_28_25 = q_acc_25_28;
             const real_t elMat_28_26 = q_acc_26_28;
             const real_t elMat_28_27 = q_acc_27_28;
             const real_t elMat_28_28 = q_acc_28_28;
             const real_t elMat_28_29 = q_acc_28_29;
             const real_t elMat_29_0 = q_acc_0_29;
             const real_t elMat_29_1 = q_acc_1_29;
             const real_t elMat_29_2 = q_acc_2_29;
             const real_t elMat_29_3 = q_acc_3_29;
             const real_t elMat_29_4 = q_acc_4_29;
             const real_t elMat_29_5 = q_acc_5_29;
             const real_t elMat_29_6 = q_acc_6_29;
             const real_t elMat_29_7 = q_acc_7_29;
             const real_t elMat_29_8 = q_acc_8_29;
             const real_t elMat_29_9 = q_acc_9_29;
             const real_t elMat_29_10 = q_acc_10_29;
             const real_t elMat_29_11 = q_acc_11_29;
             const real_t elMat_29_12 = q_acc_12_29;
             const real_t elMat_29_13 = q_acc_13_29;
             const real_t elMat_29_14 = q_acc_14_29;
             const real_t elMat_29_15 = q_acc_15_29;
             const real_t elMat_29_16 = q_acc_16_29;
             const real_t elMat_29_17 = q_acc_17_29;
             const real_t elMat_29_18 = q_acc_18_29;
             const real_t elMat_29_19 = q_acc_19_29;
             const real_t elMat_29_20 = q_acc_20_29;
             const real_t elMat_29_21 = q_acc_21_29;
             const real_t elMat_29_22 = q_acc_22_29;
             const real_t elMat_29_23 = q_acc_23_29;
             const real_t elMat_29_24 = q_acc_24_29;
             const real_t elMat_29_25 = q_acc_25_29;
             const real_t elMat_29_26 = q_acc_26_29;
             const real_t elMat_29_27 = q_acc_27_29;
             const real_t elMat_29_28 = q_acc_28_29;
             const real_t elMat_29_29 = q_acc_29_29;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 30 );
             std::vector< real_t > _data_mat( 900 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[11] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[12] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[13] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[14] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[15] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[16] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[17] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[18] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[19] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[20] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[21] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[22] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[23] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[24] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[25] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[26] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[27] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[28] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[29] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_0_12));
             _data_mat[13] = ((real_t)(elMat_0_13));
             _data_mat[14] = ((real_t)(elMat_0_14));
             _data_mat[15] = ((real_t)(elMat_0_15));
             _data_mat[16] = ((real_t)(elMat_0_16));
             _data_mat[17] = ((real_t)(elMat_0_17));
             _data_mat[18] = ((real_t)(elMat_0_18));
             _data_mat[19] = ((real_t)(elMat_0_19));
             _data_mat[20] = ((real_t)(elMat_0_20));
             _data_mat[21] = ((real_t)(elMat_0_21));
             _data_mat[22] = ((real_t)(elMat_0_22));
             _data_mat[23] = ((real_t)(elMat_0_23));
             _data_mat[24] = ((real_t)(elMat_0_24));
             _data_mat[25] = ((real_t)(elMat_0_25));
             _data_mat[26] = ((real_t)(elMat_0_26));
             _data_mat[27] = ((real_t)(elMat_0_27));
             _data_mat[28] = ((real_t)(elMat_0_28));
             _data_mat[29] = ((real_t)(elMat_0_29));
             _data_mat[30] = ((real_t)(elMat_1_0));
             _data_mat[31] = ((real_t)(elMat_1_1));
             _data_mat[32] = ((real_t)(elMat_1_2));
             _data_mat[33] = ((real_t)(elMat_1_3));
             _data_mat[34] = ((real_t)(elMat_1_4));
             _data_mat[35] = ((real_t)(elMat_1_5));
             _data_mat[36] = ((real_t)(elMat_1_6));
             _data_mat[37] = ((real_t)(elMat_1_7));
             _data_mat[38] = ((real_t)(elMat_1_8));
             _data_mat[39] = ((real_t)(elMat_1_9));
             _data_mat[40] = ((real_t)(elMat_1_10));
             _data_mat[41] = ((real_t)(elMat_1_11));
             _data_mat[42] = ((real_t)(elMat_1_12));
             _data_mat[43] = ((real_t)(elMat_1_13));
             _data_mat[44] = ((real_t)(elMat_1_14));
             _data_mat[45] = ((real_t)(elMat_1_15));
             _data_mat[46] = ((real_t)(elMat_1_16));
             _data_mat[47] = ((real_t)(elMat_1_17));
             _data_mat[48] = ((real_t)(elMat_1_18));
             _data_mat[49] = ((real_t)(elMat_1_19));
             _data_mat[50] = ((real_t)(elMat_1_20));
             _data_mat[51] = ((real_t)(elMat_1_21));
             _data_mat[52] = ((real_t)(elMat_1_22));
             _data_mat[53] = ((real_t)(elMat_1_23));
             _data_mat[54] = ((real_t)(elMat_1_24));
             _data_mat[55] = ((real_t)(elMat_1_25));
             _data_mat[56] = ((real_t)(elMat_1_26));
             _data_mat[57] = ((real_t)(elMat_1_27));
             _data_mat[58] = ((real_t)(elMat_1_28));
             _data_mat[59] = ((real_t)(elMat_1_29));
             _data_mat[60] = ((real_t)(elMat_2_0));
             _data_mat[61] = ((real_t)(elMat_2_1));
             _data_mat[62] = ((real_t)(elMat_2_2));
             _data_mat[63] = ((real_t)(elMat_2_3));
             _data_mat[64] = ((real_t)(elMat_2_4));
             _data_mat[65] = ((real_t)(elMat_2_5));
             _data_mat[66] = ((real_t)(elMat_2_6));
             _data_mat[67] = ((real_t)(elMat_2_7));
             _data_mat[68] = ((real_t)(elMat_2_8));
             _data_mat[69] = ((real_t)(elMat_2_9));
             _data_mat[70] = ((real_t)(elMat_2_10));
             _data_mat[71] = ((real_t)(elMat_2_11));
             _data_mat[72] = ((real_t)(elMat_2_12));
             _data_mat[73] = ((real_t)(elMat_2_13));
             _data_mat[74] = ((real_t)(elMat_2_14));
             _data_mat[75] = ((real_t)(elMat_2_15));
             _data_mat[76] = ((real_t)(elMat_2_16));
             _data_mat[77] = ((real_t)(elMat_2_17));
             _data_mat[78] = ((real_t)(elMat_2_18));
             _data_mat[79] = ((real_t)(elMat_2_19));
             _data_mat[80] = ((real_t)(elMat_2_20));
             _data_mat[81] = ((real_t)(elMat_2_21));
             _data_mat[82] = ((real_t)(elMat_2_22));
             _data_mat[83] = ((real_t)(elMat_2_23));
             _data_mat[84] = ((real_t)(elMat_2_24));
             _data_mat[85] = ((real_t)(elMat_2_25));
             _data_mat[86] = ((real_t)(elMat_2_26));
             _data_mat[87] = ((real_t)(elMat_2_27));
             _data_mat[88] = ((real_t)(elMat_2_28));
             _data_mat[89] = ((real_t)(elMat_2_29));
             _data_mat[90] = ((real_t)(elMat_3_0));
             _data_mat[91] = ((real_t)(elMat_3_1));
             _data_mat[92] = ((real_t)(elMat_3_2));
             _data_mat[93] = ((real_t)(elMat_3_3));
             _data_mat[94] = ((real_t)(elMat_3_4));
             _data_mat[95] = ((real_t)(elMat_3_5));
             _data_mat[96] = ((real_t)(elMat_3_6));
             _data_mat[97] = ((real_t)(elMat_3_7));
             _data_mat[98] = ((real_t)(elMat_3_8));
             _data_mat[99] = ((real_t)(elMat_3_9));
             _data_mat[100] = ((real_t)(elMat_3_10));
             _data_mat[101] = ((real_t)(elMat_3_11));
             _data_mat[102] = ((real_t)(elMat_3_12));
             _data_mat[103] = ((real_t)(elMat_3_13));
             _data_mat[104] = ((real_t)(elMat_3_14));
             _data_mat[105] = ((real_t)(elMat_3_15));
             _data_mat[106] = ((real_t)(elMat_3_16));
             _data_mat[107] = ((real_t)(elMat_3_17));
             _data_mat[108] = ((real_t)(elMat_3_18));
             _data_mat[109] = ((real_t)(elMat_3_19));
             _data_mat[110] = ((real_t)(elMat_3_20));
             _data_mat[111] = ((real_t)(elMat_3_21));
             _data_mat[112] = ((real_t)(elMat_3_22));
             _data_mat[113] = ((real_t)(elMat_3_23));
             _data_mat[114] = ((real_t)(elMat_3_24));
             _data_mat[115] = ((real_t)(elMat_3_25));
             _data_mat[116] = ((real_t)(elMat_3_26));
             _data_mat[117] = ((real_t)(elMat_3_27));
             _data_mat[118] = ((real_t)(elMat_3_28));
             _data_mat[119] = ((real_t)(elMat_3_29));
             _data_mat[120] = ((real_t)(elMat_4_0));
             _data_mat[121] = ((real_t)(elMat_4_1));
             _data_mat[122] = ((real_t)(elMat_4_2));
             _data_mat[123] = ((real_t)(elMat_4_3));
             _data_mat[124] = ((real_t)(elMat_4_4));
             _data_mat[125] = ((real_t)(elMat_4_5));
             _data_mat[126] = ((real_t)(elMat_4_6));
             _data_mat[127] = ((real_t)(elMat_4_7));
             _data_mat[128] = ((real_t)(elMat_4_8));
             _data_mat[129] = ((real_t)(elMat_4_9));
             _data_mat[130] = ((real_t)(elMat_4_10));
             _data_mat[131] = ((real_t)(elMat_4_11));
             _data_mat[132] = ((real_t)(elMat_4_12));
             _data_mat[133] = ((real_t)(elMat_4_13));
             _data_mat[134] = ((real_t)(elMat_4_14));
             _data_mat[135] = ((real_t)(elMat_4_15));
             _data_mat[136] = ((real_t)(elMat_4_16));
             _data_mat[137] = ((real_t)(elMat_4_17));
             _data_mat[138] = ((real_t)(elMat_4_18));
             _data_mat[139] = ((real_t)(elMat_4_19));
             _data_mat[140] = ((real_t)(elMat_4_20));
             _data_mat[141] = ((real_t)(elMat_4_21));
             _data_mat[142] = ((real_t)(elMat_4_22));
             _data_mat[143] = ((real_t)(elMat_4_23));
             _data_mat[144] = ((real_t)(elMat_4_24));
             _data_mat[145] = ((real_t)(elMat_4_25));
             _data_mat[146] = ((real_t)(elMat_4_26));
             _data_mat[147] = ((real_t)(elMat_4_27));
             _data_mat[148] = ((real_t)(elMat_4_28));
             _data_mat[149] = ((real_t)(elMat_4_29));
             _data_mat[150] = ((real_t)(elMat_5_0));
             _data_mat[151] = ((real_t)(elMat_5_1));
             _data_mat[152] = ((real_t)(elMat_5_2));
             _data_mat[153] = ((real_t)(elMat_5_3));
             _data_mat[154] = ((real_t)(elMat_5_4));
             _data_mat[155] = ((real_t)(elMat_5_5));
             _data_mat[156] = ((real_t)(elMat_5_6));
             _data_mat[157] = ((real_t)(elMat_5_7));
             _data_mat[158] = ((real_t)(elMat_5_8));
             _data_mat[159] = ((real_t)(elMat_5_9));
             _data_mat[160] = ((real_t)(elMat_5_10));
             _data_mat[161] = ((real_t)(elMat_5_11));
             _data_mat[162] = ((real_t)(elMat_5_12));
             _data_mat[163] = ((real_t)(elMat_5_13));
             _data_mat[164] = ((real_t)(elMat_5_14));
             _data_mat[165] = ((real_t)(elMat_5_15));
             _data_mat[166] = ((real_t)(elMat_5_16));
             _data_mat[167] = ((real_t)(elMat_5_17));
             _data_mat[168] = ((real_t)(elMat_5_18));
             _data_mat[169] = ((real_t)(elMat_5_19));
             _data_mat[170] = ((real_t)(elMat_5_20));
             _data_mat[171] = ((real_t)(elMat_5_21));
             _data_mat[172] = ((real_t)(elMat_5_22));
             _data_mat[173] = ((real_t)(elMat_5_23));
             _data_mat[174] = ((real_t)(elMat_5_24));
             _data_mat[175] = ((real_t)(elMat_5_25));
             _data_mat[176] = ((real_t)(elMat_5_26));
             _data_mat[177] = ((real_t)(elMat_5_27));
             _data_mat[178] = ((real_t)(elMat_5_28));
             _data_mat[179] = ((real_t)(elMat_5_29));
             _data_mat[180] = ((real_t)(elMat_6_0));
             _data_mat[181] = ((real_t)(elMat_6_1));
             _data_mat[182] = ((real_t)(elMat_6_2));
             _data_mat[183] = ((real_t)(elMat_6_3));
             _data_mat[184] = ((real_t)(elMat_6_4));
             _data_mat[185] = ((real_t)(elMat_6_5));
             _data_mat[186] = ((real_t)(elMat_6_6));
             _data_mat[187] = ((real_t)(elMat_6_7));
             _data_mat[188] = ((real_t)(elMat_6_8));
             _data_mat[189] = ((real_t)(elMat_6_9));
             _data_mat[190] = ((real_t)(elMat_6_10));
             _data_mat[191] = ((real_t)(elMat_6_11));
             _data_mat[192] = ((real_t)(elMat_6_12));
             _data_mat[193] = ((real_t)(elMat_6_13));
             _data_mat[194] = ((real_t)(elMat_6_14));
             _data_mat[195] = ((real_t)(elMat_6_15));
             _data_mat[196] = ((real_t)(elMat_6_16));
             _data_mat[197] = ((real_t)(elMat_6_17));
             _data_mat[198] = ((real_t)(elMat_6_18));
             _data_mat[199] = ((real_t)(elMat_6_19));
             _data_mat[200] = ((real_t)(elMat_6_20));
             _data_mat[201] = ((real_t)(elMat_6_21));
             _data_mat[202] = ((real_t)(elMat_6_22));
             _data_mat[203] = ((real_t)(elMat_6_23));
             _data_mat[204] = ((real_t)(elMat_6_24));
             _data_mat[205] = ((real_t)(elMat_6_25));
             _data_mat[206] = ((real_t)(elMat_6_26));
             _data_mat[207] = ((real_t)(elMat_6_27));
             _data_mat[208] = ((real_t)(elMat_6_28));
             _data_mat[209] = ((real_t)(elMat_6_29));
             _data_mat[210] = ((real_t)(elMat_7_0));
             _data_mat[211] = ((real_t)(elMat_7_1));
             _data_mat[212] = ((real_t)(elMat_7_2));
             _data_mat[213] = ((real_t)(elMat_7_3));
             _data_mat[214] = ((real_t)(elMat_7_4));
             _data_mat[215] = ((real_t)(elMat_7_5));
             _data_mat[216] = ((real_t)(elMat_7_6));
             _data_mat[217] = ((real_t)(elMat_7_7));
             _data_mat[218] = ((real_t)(elMat_7_8));
             _data_mat[219] = ((real_t)(elMat_7_9));
             _data_mat[220] = ((real_t)(elMat_7_10));
             _data_mat[221] = ((real_t)(elMat_7_11));
             _data_mat[222] = ((real_t)(elMat_7_12));
             _data_mat[223] = ((real_t)(elMat_7_13));
             _data_mat[224] = ((real_t)(elMat_7_14));
             _data_mat[225] = ((real_t)(elMat_7_15));
             _data_mat[226] = ((real_t)(elMat_7_16));
             _data_mat[227] = ((real_t)(elMat_7_17));
             _data_mat[228] = ((real_t)(elMat_7_18));
             _data_mat[229] = ((real_t)(elMat_7_19));
             _data_mat[230] = ((real_t)(elMat_7_20));
             _data_mat[231] = ((real_t)(elMat_7_21));
             _data_mat[232] = ((real_t)(elMat_7_22));
             _data_mat[233] = ((real_t)(elMat_7_23));
             _data_mat[234] = ((real_t)(elMat_7_24));
             _data_mat[235] = ((real_t)(elMat_7_25));
             _data_mat[236] = ((real_t)(elMat_7_26));
             _data_mat[237] = ((real_t)(elMat_7_27));
             _data_mat[238] = ((real_t)(elMat_7_28));
             _data_mat[239] = ((real_t)(elMat_7_29));
             _data_mat[240] = ((real_t)(elMat_8_0));
             _data_mat[241] = ((real_t)(elMat_8_1));
             _data_mat[242] = ((real_t)(elMat_8_2));
             _data_mat[243] = ((real_t)(elMat_8_3));
             _data_mat[244] = ((real_t)(elMat_8_4));
             _data_mat[245] = ((real_t)(elMat_8_5));
             _data_mat[246] = ((real_t)(elMat_8_6));
             _data_mat[247] = ((real_t)(elMat_8_7));
             _data_mat[248] = ((real_t)(elMat_8_8));
             _data_mat[249] = ((real_t)(elMat_8_9));
             _data_mat[250] = ((real_t)(elMat_8_10));
             _data_mat[251] = ((real_t)(elMat_8_11));
             _data_mat[252] = ((real_t)(elMat_8_12));
             _data_mat[253] = ((real_t)(elMat_8_13));
             _data_mat[254] = ((real_t)(elMat_8_14));
             _data_mat[255] = ((real_t)(elMat_8_15));
             _data_mat[256] = ((real_t)(elMat_8_16));
             _data_mat[257] = ((real_t)(elMat_8_17));
             _data_mat[258] = ((real_t)(elMat_8_18));
             _data_mat[259] = ((real_t)(elMat_8_19));
             _data_mat[260] = ((real_t)(elMat_8_20));
             _data_mat[261] = ((real_t)(elMat_8_21));
             _data_mat[262] = ((real_t)(elMat_8_22));
             _data_mat[263] = ((real_t)(elMat_8_23));
             _data_mat[264] = ((real_t)(elMat_8_24));
             _data_mat[265] = ((real_t)(elMat_8_25));
             _data_mat[266] = ((real_t)(elMat_8_26));
             _data_mat[267] = ((real_t)(elMat_8_27));
             _data_mat[268] = ((real_t)(elMat_8_28));
             _data_mat[269] = ((real_t)(elMat_8_29));
             _data_mat[270] = ((real_t)(elMat_9_0));
             _data_mat[271] = ((real_t)(elMat_9_1));
             _data_mat[272] = ((real_t)(elMat_9_2));
             _data_mat[273] = ((real_t)(elMat_9_3));
             _data_mat[274] = ((real_t)(elMat_9_4));
             _data_mat[275] = ((real_t)(elMat_9_5));
             _data_mat[276] = ((real_t)(elMat_9_6));
             _data_mat[277] = ((real_t)(elMat_9_7));
             _data_mat[278] = ((real_t)(elMat_9_8));
             _data_mat[279] = ((real_t)(elMat_9_9));
             _data_mat[280] = ((real_t)(elMat_9_10));
             _data_mat[281] = ((real_t)(elMat_9_11));
             _data_mat[282] = ((real_t)(elMat_9_12));
             _data_mat[283] = ((real_t)(elMat_9_13));
             _data_mat[284] = ((real_t)(elMat_9_14));
             _data_mat[285] = ((real_t)(elMat_9_15));
             _data_mat[286] = ((real_t)(elMat_9_16));
             _data_mat[287] = ((real_t)(elMat_9_17));
             _data_mat[288] = ((real_t)(elMat_9_18));
             _data_mat[289] = ((real_t)(elMat_9_19));
             _data_mat[290] = ((real_t)(elMat_9_20));
             _data_mat[291] = ((real_t)(elMat_9_21));
             _data_mat[292] = ((real_t)(elMat_9_22));
             _data_mat[293] = ((real_t)(elMat_9_23));
             _data_mat[294] = ((real_t)(elMat_9_24));
             _data_mat[295] = ((real_t)(elMat_9_25));
             _data_mat[296] = ((real_t)(elMat_9_26));
             _data_mat[297] = ((real_t)(elMat_9_27));
             _data_mat[298] = ((real_t)(elMat_9_28));
             _data_mat[299] = ((real_t)(elMat_9_29));
             _data_mat[300] = ((real_t)(elMat_10_0));
             _data_mat[301] = ((real_t)(elMat_10_1));
             _data_mat[302] = ((real_t)(elMat_10_2));
             _data_mat[303] = ((real_t)(elMat_10_3));
             _data_mat[304] = ((real_t)(elMat_10_4));
             _data_mat[305] = ((real_t)(elMat_10_5));
             _data_mat[306] = ((real_t)(elMat_10_6));
             _data_mat[307] = ((real_t)(elMat_10_7));
             _data_mat[308] = ((real_t)(elMat_10_8));
             _data_mat[309] = ((real_t)(elMat_10_9));
             _data_mat[310] = ((real_t)(elMat_10_10));
             _data_mat[311] = ((real_t)(elMat_10_11));
             _data_mat[312] = ((real_t)(elMat_10_12));
             _data_mat[313] = ((real_t)(elMat_10_13));
             _data_mat[314] = ((real_t)(elMat_10_14));
             _data_mat[315] = ((real_t)(elMat_10_15));
             _data_mat[316] = ((real_t)(elMat_10_16));
             _data_mat[317] = ((real_t)(elMat_10_17));
             _data_mat[318] = ((real_t)(elMat_10_18));
             _data_mat[319] = ((real_t)(elMat_10_19));
             _data_mat[320] = ((real_t)(elMat_10_20));
             _data_mat[321] = ((real_t)(elMat_10_21));
             _data_mat[322] = ((real_t)(elMat_10_22));
             _data_mat[323] = ((real_t)(elMat_10_23));
             _data_mat[324] = ((real_t)(elMat_10_24));
             _data_mat[325] = ((real_t)(elMat_10_25));
             _data_mat[326] = ((real_t)(elMat_10_26));
             _data_mat[327] = ((real_t)(elMat_10_27));
             _data_mat[328] = ((real_t)(elMat_10_28));
             _data_mat[329] = ((real_t)(elMat_10_29));
             _data_mat[330] = ((real_t)(elMat_11_0));
             _data_mat[331] = ((real_t)(elMat_11_1));
             _data_mat[332] = ((real_t)(elMat_11_2));
             _data_mat[333] = ((real_t)(elMat_11_3));
             _data_mat[334] = ((real_t)(elMat_11_4));
             _data_mat[335] = ((real_t)(elMat_11_5));
             _data_mat[336] = ((real_t)(elMat_11_6));
             _data_mat[337] = ((real_t)(elMat_11_7));
             _data_mat[338] = ((real_t)(elMat_11_8));
             _data_mat[339] = ((real_t)(elMat_11_9));
             _data_mat[340] = ((real_t)(elMat_11_10));
             _data_mat[341] = ((real_t)(elMat_11_11));
             _data_mat[342] = ((real_t)(elMat_11_12));
             _data_mat[343] = ((real_t)(elMat_11_13));
             _data_mat[344] = ((real_t)(elMat_11_14));
             _data_mat[345] = ((real_t)(elMat_11_15));
             _data_mat[346] = ((real_t)(elMat_11_16));
             _data_mat[347] = ((real_t)(elMat_11_17));
             _data_mat[348] = ((real_t)(elMat_11_18));
             _data_mat[349] = ((real_t)(elMat_11_19));
             _data_mat[350] = ((real_t)(elMat_11_20));
             _data_mat[351] = ((real_t)(elMat_11_21));
             _data_mat[352] = ((real_t)(elMat_11_22));
             _data_mat[353] = ((real_t)(elMat_11_23));
             _data_mat[354] = ((real_t)(elMat_11_24));
             _data_mat[355] = ((real_t)(elMat_11_25));
             _data_mat[356] = ((real_t)(elMat_11_26));
             _data_mat[357] = ((real_t)(elMat_11_27));
             _data_mat[358] = ((real_t)(elMat_11_28));
             _data_mat[359] = ((real_t)(elMat_11_29));
             _data_mat[360] = ((real_t)(elMat_12_0));
             _data_mat[361] = ((real_t)(elMat_12_1));
             _data_mat[362] = ((real_t)(elMat_12_2));
             _data_mat[363] = ((real_t)(elMat_12_3));
             _data_mat[364] = ((real_t)(elMat_12_4));
             _data_mat[365] = ((real_t)(elMat_12_5));
             _data_mat[366] = ((real_t)(elMat_12_6));
             _data_mat[367] = ((real_t)(elMat_12_7));
             _data_mat[368] = ((real_t)(elMat_12_8));
             _data_mat[369] = ((real_t)(elMat_12_9));
             _data_mat[370] = ((real_t)(elMat_12_10));
             _data_mat[371] = ((real_t)(elMat_12_11));
             _data_mat[372] = ((real_t)(elMat_12_12));
             _data_mat[373] = ((real_t)(elMat_12_13));
             _data_mat[374] = ((real_t)(elMat_12_14));
             _data_mat[375] = ((real_t)(elMat_12_15));
             _data_mat[376] = ((real_t)(elMat_12_16));
             _data_mat[377] = ((real_t)(elMat_12_17));
             _data_mat[378] = ((real_t)(elMat_12_18));
             _data_mat[379] = ((real_t)(elMat_12_19));
             _data_mat[380] = ((real_t)(elMat_12_20));
             _data_mat[381] = ((real_t)(elMat_12_21));
             _data_mat[382] = ((real_t)(elMat_12_22));
             _data_mat[383] = ((real_t)(elMat_12_23));
             _data_mat[384] = ((real_t)(elMat_12_24));
             _data_mat[385] = ((real_t)(elMat_12_25));
             _data_mat[386] = ((real_t)(elMat_12_26));
             _data_mat[387] = ((real_t)(elMat_12_27));
             _data_mat[388] = ((real_t)(elMat_12_28));
             _data_mat[389] = ((real_t)(elMat_12_29));
             _data_mat[390] = ((real_t)(elMat_13_0));
             _data_mat[391] = ((real_t)(elMat_13_1));
             _data_mat[392] = ((real_t)(elMat_13_2));
             _data_mat[393] = ((real_t)(elMat_13_3));
             _data_mat[394] = ((real_t)(elMat_13_4));
             _data_mat[395] = ((real_t)(elMat_13_5));
             _data_mat[396] = ((real_t)(elMat_13_6));
             _data_mat[397] = ((real_t)(elMat_13_7));
             _data_mat[398] = ((real_t)(elMat_13_8));
             _data_mat[399] = ((real_t)(elMat_13_9));
             _data_mat[400] = ((real_t)(elMat_13_10));
             _data_mat[401] = ((real_t)(elMat_13_11));
             _data_mat[402] = ((real_t)(elMat_13_12));
             _data_mat[403] = ((real_t)(elMat_13_13));
             _data_mat[404] = ((real_t)(elMat_13_14));
             _data_mat[405] = ((real_t)(elMat_13_15));
             _data_mat[406] = ((real_t)(elMat_13_16));
             _data_mat[407] = ((real_t)(elMat_13_17));
             _data_mat[408] = ((real_t)(elMat_13_18));
             _data_mat[409] = ((real_t)(elMat_13_19));
             _data_mat[410] = ((real_t)(elMat_13_20));
             _data_mat[411] = ((real_t)(elMat_13_21));
             _data_mat[412] = ((real_t)(elMat_13_22));
             _data_mat[413] = ((real_t)(elMat_13_23));
             _data_mat[414] = ((real_t)(elMat_13_24));
             _data_mat[415] = ((real_t)(elMat_13_25));
             _data_mat[416] = ((real_t)(elMat_13_26));
             _data_mat[417] = ((real_t)(elMat_13_27));
             _data_mat[418] = ((real_t)(elMat_13_28));
             _data_mat[419] = ((real_t)(elMat_13_29));
             _data_mat[420] = ((real_t)(elMat_14_0));
             _data_mat[421] = ((real_t)(elMat_14_1));
             _data_mat[422] = ((real_t)(elMat_14_2));
             _data_mat[423] = ((real_t)(elMat_14_3));
             _data_mat[424] = ((real_t)(elMat_14_4));
             _data_mat[425] = ((real_t)(elMat_14_5));
             _data_mat[426] = ((real_t)(elMat_14_6));
             _data_mat[427] = ((real_t)(elMat_14_7));
             _data_mat[428] = ((real_t)(elMat_14_8));
             _data_mat[429] = ((real_t)(elMat_14_9));
             _data_mat[430] = ((real_t)(elMat_14_10));
             _data_mat[431] = ((real_t)(elMat_14_11));
             _data_mat[432] = ((real_t)(elMat_14_12));
             _data_mat[433] = ((real_t)(elMat_14_13));
             _data_mat[434] = ((real_t)(elMat_14_14));
             _data_mat[435] = ((real_t)(elMat_14_15));
             _data_mat[436] = ((real_t)(elMat_14_16));
             _data_mat[437] = ((real_t)(elMat_14_17));
             _data_mat[438] = ((real_t)(elMat_14_18));
             _data_mat[439] = ((real_t)(elMat_14_19));
             _data_mat[440] = ((real_t)(elMat_14_20));
             _data_mat[441] = ((real_t)(elMat_14_21));
             _data_mat[442] = ((real_t)(elMat_14_22));
             _data_mat[443] = ((real_t)(elMat_14_23));
             _data_mat[444] = ((real_t)(elMat_14_24));
             _data_mat[445] = ((real_t)(elMat_14_25));
             _data_mat[446] = ((real_t)(elMat_14_26));
             _data_mat[447] = ((real_t)(elMat_14_27));
             _data_mat[448] = ((real_t)(elMat_14_28));
             _data_mat[449] = ((real_t)(elMat_14_29));
             _data_mat[450] = ((real_t)(elMat_15_0));
             _data_mat[451] = ((real_t)(elMat_15_1));
             _data_mat[452] = ((real_t)(elMat_15_2));
             _data_mat[453] = ((real_t)(elMat_15_3));
             _data_mat[454] = ((real_t)(elMat_15_4));
             _data_mat[455] = ((real_t)(elMat_15_5));
             _data_mat[456] = ((real_t)(elMat_15_6));
             _data_mat[457] = ((real_t)(elMat_15_7));
             _data_mat[458] = ((real_t)(elMat_15_8));
             _data_mat[459] = ((real_t)(elMat_15_9));
             _data_mat[460] = ((real_t)(elMat_15_10));
             _data_mat[461] = ((real_t)(elMat_15_11));
             _data_mat[462] = ((real_t)(elMat_15_12));
             _data_mat[463] = ((real_t)(elMat_15_13));
             _data_mat[464] = ((real_t)(elMat_15_14));
             _data_mat[465] = ((real_t)(elMat_15_15));
             _data_mat[466] = ((real_t)(elMat_15_16));
             _data_mat[467] = ((real_t)(elMat_15_17));
             _data_mat[468] = ((real_t)(elMat_15_18));
             _data_mat[469] = ((real_t)(elMat_15_19));
             _data_mat[470] = ((real_t)(elMat_15_20));
             _data_mat[471] = ((real_t)(elMat_15_21));
             _data_mat[472] = ((real_t)(elMat_15_22));
             _data_mat[473] = ((real_t)(elMat_15_23));
             _data_mat[474] = ((real_t)(elMat_15_24));
             _data_mat[475] = ((real_t)(elMat_15_25));
             _data_mat[476] = ((real_t)(elMat_15_26));
             _data_mat[477] = ((real_t)(elMat_15_27));
             _data_mat[478] = ((real_t)(elMat_15_28));
             _data_mat[479] = ((real_t)(elMat_15_29));
             _data_mat[480] = ((real_t)(elMat_16_0));
             _data_mat[481] = ((real_t)(elMat_16_1));
             _data_mat[482] = ((real_t)(elMat_16_2));
             _data_mat[483] = ((real_t)(elMat_16_3));
             _data_mat[484] = ((real_t)(elMat_16_4));
             _data_mat[485] = ((real_t)(elMat_16_5));
             _data_mat[486] = ((real_t)(elMat_16_6));
             _data_mat[487] = ((real_t)(elMat_16_7));
             _data_mat[488] = ((real_t)(elMat_16_8));
             _data_mat[489] = ((real_t)(elMat_16_9));
             _data_mat[490] = ((real_t)(elMat_16_10));
             _data_mat[491] = ((real_t)(elMat_16_11));
             _data_mat[492] = ((real_t)(elMat_16_12));
             _data_mat[493] = ((real_t)(elMat_16_13));
             _data_mat[494] = ((real_t)(elMat_16_14));
             _data_mat[495] = ((real_t)(elMat_16_15));
             _data_mat[496] = ((real_t)(elMat_16_16));
             _data_mat[497] = ((real_t)(elMat_16_17));
             _data_mat[498] = ((real_t)(elMat_16_18));
             _data_mat[499] = ((real_t)(elMat_16_19));
             _data_mat[500] = ((real_t)(elMat_16_20));
             _data_mat[501] = ((real_t)(elMat_16_21));
             _data_mat[502] = ((real_t)(elMat_16_22));
             _data_mat[503] = ((real_t)(elMat_16_23));
             _data_mat[504] = ((real_t)(elMat_16_24));
             _data_mat[505] = ((real_t)(elMat_16_25));
             _data_mat[506] = ((real_t)(elMat_16_26));
             _data_mat[507] = ((real_t)(elMat_16_27));
             _data_mat[508] = ((real_t)(elMat_16_28));
             _data_mat[509] = ((real_t)(elMat_16_29));
             _data_mat[510] = ((real_t)(elMat_17_0));
             _data_mat[511] = ((real_t)(elMat_17_1));
             _data_mat[512] = ((real_t)(elMat_17_2));
             _data_mat[513] = ((real_t)(elMat_17_3));
             _data_mat[514] = ((real_t)(elMat_17_4));
             _data_mat[515] = ((real_t)(elMat_17_5));
             _data_mat[516] = ((real_t)(elMat_17_6));
             _data_mat[517] = ((real_t)(elMat_17_7));
             _data_mat[518] = ((real_t)(elMat_17_8));
             _data_mat[519] = ((real_t)(elMat_17_9));
             _data_mat[520] = ((real_t)(elMat_17_10));
             _data_mat[521] = ((real_t)(elMat_17_11));
             _data_mat[522] = ((real_t)(elMat_17_12));
             _data_mat[523] = ((real_t)(elMat_17_13));
             _data_mat[524] = ((real_t)(elMat_17_14));
             _data_mat[525] = ((real_t)(elMat_17_15));
             _data_mat[526] = ((real_t)(elMat_17_16));
             _data_mat[527] = ((real_t)(elMat_17_17));
             _data_mat[528] = ((real_t)(elMat_17_18));
             _data_mat[529] = ((real_t)(elMat_17_19));
             _data_mat[530] = ((real_t)(elMat_17_20));
             _data_mat[531] = ((real_t)(elMat_17_21));
             _data_mat[532] = ((real_t)(elMat_17_22));
             _data_mat[533] = ((real_t)(elMat_17_23));
             _data_mat[534] = ((real_t)(elMat_17_24));
             _data_mat[535] = ((real_t)(elMat_17_25));
             _data_mat[536] = ((real_t)(elMat_17_26));
             _data_mat[537] = ((real_t)(elMat_17_27));
             _data_mat[538] = ((real_t)(elMat_17_28));
             _data_mat[539] = ((real_t)(elMat_17_29));
             _data_mat[540] = ((real_t)(elMat_18_0));
             _data_mat[541] = ((real_t)(elMat_18_1));
             _data_mat[542] = ((real_t)(elMat_18_2));
             _data_mat[543] = ((real_t)(elMat_18_3));
             _data_mat[544] = ((real_t)(elMat_18_4));
             _data_mat[545] = ((real_t)(elMat_18_5));
             _data_mat[546] = ((real_t)(elMat_18_6));
             _data_mat[547] = ((real_t)(elMat_18_7));
             _data_mat[548] = ((real_t)(elMat_18_8));
             _data_mat[549] = ((real_t)(elMat_18_9));
             _data_mat[550] = ((real_t)(elMat_18_10));
             _data_mat[551] = ((real_t)(elMat_18_11));
             _data_mat[552] = ((real_t)(elMat_18_12));
             _data_mat[553] = ((real_t)(elMat_18_13));
             _data_mat[554] = ((real_t)(elMat_18_14));
             _data_mat[555] = ((real_t)(elMat_18_15));
             _data_mat[556] = ((real_t)(elMat_18_16));
             _data_mat[557] = ((real_t)(elMat_18_17));
             _data_mat[558] = ((real_t)(elMat_18_18));
             _data_mat[559] = ((real_t)(elMat_18_19));
             _data_mat[560] = ((real_t)(elMat_18_20));
             _data_mat[561] = ((real_t)(elMat_18_21));
             _data_mat[562] = ((real_t)(elMat_18_22));
             _data_mat[563] = ((real_t)(elMat_18_23));
             _data_mat[564] = ((real_t)(elMat_18_24));
             _data_mat[565] = ((real_t)(elMat_18_25));
             _data_mat[566] = ((real_t)(elMat_18_26));
             _data_mat[567] = ((real_t)(elMat_18_27));
             _data_mat[568] = ((real_t)(elMat_18_28));
             _data_mat[569] = ((real_t)(elMat_18_29));
             _data_mat[570] = ((real_t)(elMat_19_0));
             _data_mat[571] = ((real_t)(elMat_19_1));
             _data_mat[572] = ((real_t)(elMat_19_2));
             _data_mat[573] = ((real_t)(elMat_19_3));
             _data_mat[574] = ((real_t)(elMat_19_4));
             _data_mat[575] = ((real_t)(elMat_19_5));
             _data_mat[576] = ((real_t)(elMat_19_6));
             _data_mat[577] = ((real_t)(elMat_19_7));
             _data_mat[578] = ((real_t)(elMat_19_8));
             _data_mat[579] = ((real_t)(elMat_19_9));
             _data_mat[580] = ((real_t)(elMat_19_10));
             _data_mat[581] = ((real_t)(elMat_19_11));
             _data_mat[582] = ((real_t)(elMat_19_12));
             _data_mat[583] = ((real_t)(elMat_19_13));
             _data_mat[584] = ((real_t)(elMat_19_14));
             _data_mat[585] = ((real_t)(elMat_19_15));
             _data_mat[586] = ((real_t)(elMat_19_16));
             _data_mat[587] = ((real_t)(elMat_19_17));
             _data_mat[588] = ((real_t)(elMat_19_18));
             _data_mat[589] = ((real_t)(elMat_19_19));
             _data_mat[590] = ((real_t)(elMat_19_20));
             _data_mat[591] = ((real_t)(elMat_19_21));
             _data_mat[592] = ((real_t)(elMat_19_22));
             _data_mat[593] = ((real_t)(elMat_19_23));
             _data_mat[594] = ((real_t)(elMat_19_24));
             _data_mat[595] = ((real_t)(elMat_19_25));
             _data_mat[596] = ((real_t)(elMat_19_26));
             _data_mat[597] = ((real_t)(elMat_19_27));
             _data_mat[598] = ((real_t)(elMat_19_28));
             _data_mat[599] = ((real_t)(elMat_19_29));
             _data_mat[600] = ((real_t)(elMat_20_0));
             _data_mat[601] = ((real_t)(elMat_20_1));
             _data_mat[602] = ((real_t)(elMat_20_2));
             _data_mat[603] = ((real_t)(elMat_20_3));
             _data_mat[604] = ((real_t)(elMat_20_4));
             _data_mat[605] = ((real_t)(elMat_20_5));
             _data_mat[606] = ((real_t)(elMat_20_6));
             _data_mat[607] = ((real_t)(elMat_20_7));
             _data_mat[608] = ((real_t)(elMat_20_8));
             _data_mat[609] = ((real_t)(elMat_20_9));
             _data_mat[610] = ((real_t)(elMat_20_10));
             _data_mat[611] = ((real_t)(elMat_20_11));
             _data_mat[612] = ((real_t)(elMat_20_12));
             _data_mat[613] = ((real_t)(elMat_20_13));
             _data_mat[614] = ((real_t)(elMat_20_14));
             _data_mat[615] = ((real_t)(elMat_20_15));
             _data_mat[616] = ((real_t)(elMat_20_16));
             _data_mat[617] = ((real_t)(elMat_20_17));
             _data_mat[618] = ((real_t)(elMat_20_18));
             _data_mat[619] = ((real_t)(elMat_20_19));
             _data_mat[620] = ((real_t)(elMat_20_20));
             _data_mat[621] = ((real_t)(elMat_20_21));
             _data_mat[622] = ((real_t)(elMat_20_22));
             _data_mat[623] = ((real_t)(elMat_20_23));
             _data_mat[624] = ((real_t)(elMat_20_24));
             _data_mat[625] = ((real_t)(elMat_20_25));
             _data_mat[626] = ((real_t)(elMat_20_26));
             _data_mat[627] = ((real_t)(elMat_20_27));
             _data_mat[628] = ((real_t)(elMat_20_28));
             _data_mat[629] = ((real_t)(elMat_20_29));
             _data_mat[630] = ((real_t)(elMat_21_0));
             _data_mat[631] = ((real_t)(elMat_21_1));
             _data_mat[632] = ((real_t)(elMat_21_2));
             _data_mat[633] = ((real_t)(elMat_21_3));
             _data_mat[634] = ((real_t)(elMat_21_4));
             _data_mat[635] = ((real_t)(elMat_21_5));
             _data_mat[636] = ((real_t)(elMat_21_6));
             _data_mat[637] = ((real_t)(elMat_21_7));
             _data_mat[638] = ((real_t)(elMat_21_8));
             _data_mat[639] = ((real_t)(elMat_21_9));
             _data_mat[640] = ((real_t)(elMat_21_10));
             _data_mat[641] = ((real_t)(elMat_21_11));
             _data_mat[642] = ((real_t)(elMat_21_12));
             _data_mat[643] = ((real_t)(elMat_21_13));
             _data_mat[644] = ((real_t)(elMat_21_14));
             _data_mat[645] = ((real_t)(elMat_21_15));
             _data_mat[646] = ((real_t)(elMat_21_16));
             _data_mat[647] = ((real_t)(elMat_21_17));
             _data_mat[648] = ((real_t)(elMat_21_18));
             _data_mat[649] = ((real_t)(elMat_21_19));
             _data_mat[650] = ((real_t)(elMat_21_20));
             _data_mat[651] = ((real_t)(elMat_21_21));
             _data_mat[652] = ((real_t)(elMat_21_22));
             _data_mat[653] = ((real_t)(elMat_21_23));
             _data_mat[654] = ((real_t)(elMat_21_24));
             _data_mat[655] = ((real_t)(elMat_21_25));
             _data_mat[656] = ((real_t)(elMat_21_26));
             _data_mat[657] = ((real_t)(elMat_21_27));
             _data_mat[658] = ((real_t)(elMat_21_28));
             _data_mat[659] = ((real_t)(elMat_21_29));
             _data_mat[660] = ((real_t)(elMat_22_0));
             _data_mat[661] = ((real_t)(elMat_22_1));
             _data_mat[662] = ((real_t)(elMat_22_2));
             _data_mat[663] = ((real_t)(elMat_22_3));
             _data_mat[664] = ((real_t)(elMat_22_4));
             _data_mat[665] = ((real_t)(elMat_22_5));
             _data_mat[666] = ((real_t)(elMat_22_6));
             _data_mat[667] = ((real_t)(elMat_22_7));
             _data_mat[668] = ((real_t)(elMat_22_8));
             _data_mat[669] = ((real_t)(elMat_22_9));
             _data_mat[670] = ((real_t)(elMat_22_10));
             _data_mat[671] = ((real_t)(elMat_22_11));
             _data_mat[672] = ((real_t)(elMat_22_12));
             _data_mat[673] = ((real_t)(elMat_22_13));
             _data_mat[674] = ((real_t)(elMat_22_14));
             _data_mat[675] = ((real_t)(elMat_22_15));
             _data_mat[676] = ((real_t)(elMat_22_16));
             _data_mat[677] = ((real_t)(elMat_22_17));
             _data_mat[678] = ((real_t)(elMat_22_18));
             _data_mat[679] = ((real_t)(elMat_22_19));
             _data_mat[680] = ((real_t)(elMat_22_20));
             _data_mat[681] = ((real_t)(elMat_22_21));
             _data_mat[682] = ((real_t)(elMat_22_22));
             _data_mat[683] = ((real_t)(elMat_22_23));
             _data_mat[684] = ((real_t)(elMat_22_24));
             _data_mat[685] = ((real_t)(elMat_22_25));
             _data_mat[686] = ((real_t)(elMat_22_26));
             _data_mat[687] = ((real_t)(elMat_22_27));
             _data_mat[688] = ((real_t)(elMat_22_28));
             _data_mat[689] = ((real_t)(elMat_22_29));
             _data_mat[690] = ((real_t)(elMat_23_0));
             _data_mat[691] = ((real_t)(elMat_23_1));
             _data_mat[692] = ((real_t)(elMat_23_2));
             _data_mat[693] = ((real_t)(elMat_23_3));
             _data_mat[694] = ((real_t)(elMat_23_4));
             _data_mat[695] = ((real_t)(elMat_23_5));
             _data_mat[696] = ((real_t)(elMat_23_6));
             _data_mat[697] = ((real_t)(elMat_23_7));
             _data_mat[698] = ((real_t)(elMat_23_8));
             _data_mat[699] = ((real_t)(elMat_23_9));
             _data_mat[700] = ((real_t)(elMat_23_10));
             _data_mat[701] = ((real_t)(elMat_23_11));
             _data_mat[702] = ((real_t)(elMat_23_12));
             _data_mat[703] = ((real_t)(elMat_23_13));
             _data_mat[704] = ((real_t)(elMat_23_14));
             _data_mat[705] = ((real_t)(elMat_23_15));
             _data_mat[706] = ((real_t)(elMat_23_16));
             _data_mat[707] = ((real_t)(elMat_23_17));
             _data_mat[708] = ((real_t)(elMat_23_18));
             _data_mat[709] = ((real_t)(elMat_23_19));
             _data_mat[710] = ((real_t)(elMat_23_20));
             _data_mat[711] = ((real_t)(elMat_23_21));
             _data_mat[712] = ((real_t)(elMat_23_22));
             _data_mat[713] = ((real_t)(elMat_23_23));
             _data_mat[714] = ((real_t)(elMat_23_24));
             _data_mat[715] = ((real_t)(elMat_23_25));
             _data_mat[716] = ((real_t)(elMat_23_26));
             _data_mat[717] = ((real_t)(elMat_23_27));
             _data_mat[718] = ((real_t)(elMat_23_28));
             _data_mat[719] = ((real_t)(elMat_23_29));
             _data_mat[720] = ((real_t)(elMat_24_0));
             _data_mat[721] = ((real_t)(elMat_24_1));
             _data_mat[722] = ((real_t)(elMat_24_2));
             _data_mat[723] = ((real_t)(elMat_24_3));
             _data_mat[724] = ((real_t)(elMat_24_4));
             _data_mat[725] = ((real_t)(elMat_24_5));
             _data_mat[726] = ((real_t)(elMat_24_6));
             _data_mat[727] = ((real_t)(elMat_24_7));
             _data_mat[728] = ((real_t)(elMat_24_8));
             _data_mat[729] = ((real_t)(elMat_24_9));
             _data_mat[730] = ((real_t)(elMat_24_10));
             _data_mat[731] = ((real_t)(elMat_24_11));
             _data_mat[732] = ((real_t)(elMat_24_12));
             _data_mat[733] = ((real_t)(elMat_24_13));
             _data_mat[734] = ((real_t)(elMat_24_14));
             _data_mat[735] = ((real_t)(elMat_24_15));
             _data_mat[736] = ((real_t)(elMat_24_16));
             _data_mat[737] = ((real_t)(elMat_24_17));
             _data_mat[738] = ((real_t)(elMat_24_18));
             _data_mat[739] = ((real_t)(elMat_24_19));
             _data_mat[740] = ((real_t)(elMat_24_20));
             _data_mat[741] = ((real_t)(elMat_24_21));
             _data_mat[742] = ((real_t)(elMat_24_22));
             _data_mat[743] = ((real_t)(elMat_24_23));
             _data_mat[744] = ((real_t)(elMat_24_24));
             _data_mat[745] = ((real_t)(elMat_24_25));
             _data_mat[746] = ((real_t)(elMat_24_26));
             _data_mat[747] = ((real_t)(elMat_24_27));
             _data_mat[748] = ((real_t)(elMat_24_28));
             _data_mat[749] = ((real_t)(elMat_24_29));
             _data_mat[750] = ((real_t)(elMat_25_0));
             _data_mat[751] = ((real_t)(elMat_25_1));
             _data_mat[752] = ((real_t)(elMat_25_2));
             _data_mat[753] = ((real_t)(elMat_25_3));
             _data_mat[754] = ((real_t)(elMat_25_4));
             _data_mat[755] = ((real_t)(elMat_25_5));
             _data_mat[756] = ((real_t)(elMat_25_6));
             _data_mat[757] = ((real_t)(elMat_25_7));
             _data_mat[758] = ((real_t)(elMat_25_8));
             _data_mat[759] = ((real_t)(elMat_25_9));
             _data_mat[760] = ((real_t)(elMat_25_10));
             _data_mat[761] = ((real_t)(elMat_25_11));
             _data_mat[762] = ((real_t)(elMat_25_12));
             _data_mat[763] = ((real_t)(elMat_25_13));
             _data_mat[764] = ((real_t)(elMat_25_14));
             _data_mat[765] = ((real_t)(elMat_25_15));
             _data_mat[766] = ((real_t)(elMat_25_16));
             _data_mat[767] = ((real_t)(elMat_25_17));
             _data_mat[768] = ((real_t)(elMat_25_18));
             _data_mat[769] = ((real_t)(elMat_25_19));
             _data_mat[770] = ((real_t)(elMat_25_20));
             _data_mat[771] = ((real_t)(elMat_25_21));
             _data_mat[772] = ((real_t)(elMat_25_22));
             _data_mat[773] = ((real_t)(elMat_25_23));
             _data_mat[774] = ((real_t)(elMat_25_24));
             _data_mat[775] = ((real_t)(elMat_25_25));
             _data_mat[776] = ((real_t)(elMat_25_26));
             _data_mat[777] = ((real_t)(elMat_25_27));
             _data_mat[778] = ((real_t)(elMat_25_28));
             _data_mat[779] = ((real_t)(elMat_25_29));
             _data_mat[780] = ((real_t)(elMat_26_0));
             _data_mat[781] = ((real_t)(elMat_26_1));
             _data_mat[782] = ((real_t)(elMat_26_2));
             _data_mat[783] = ((real_t)(elMat_26_3));
             _data_mat[784] = ((real_t)(elMat_26_4));
             _data_mat[785] = ((real_t)(elMat_26_5));
             _data_mat[786] = ((real_t)(elMat_26_6));
             _data_mat[787] = ((real_t)(elMat_26_7));
             _data_mat[788] = ((real_t)(elMat_26_8));
             _data_mat[789] = ((real_t)(elMat_26_9));
             _data_mat[790] = ((real_t)(elMat_26_10));
             _data_mat[791] = ((real_t)(elMat_26_11));
             _data_mat[792] = ((real_t)(elMat_26_12));
             _data_mat[793] = ((real_t)(elMat_26_13));
             _data_mat[794] = ((real_t)(elMat_26_14));
             _data_mat[795] = ((real_t)(elMat_26_15));
             _data_mat[796] = ((real_t)(elMat_26_16));
             _data_mat[797] = ((real_t)(elMat_26_17));
             _data_mat[798] = ((real_t)(elMat_26_18));
             _data_mat[799] = ((real_t)(elMat_26_19));
             _data_mat[800] = ((real_t)(elMat_26_20));
             _data_mat[801] = ((real_t)(elMat_26_21));
             _data_mat[802] = ((real_t)(elMat_26_22));
             _data_mat[803] = ((real_t)(elMat_26_23));
             _data_mat[804] = ((real_t)(elMat_26_24));
             _data_mat[805] = ((real_t)(elMat_26_25));
             _data_mat[806] = ((real_t)(elMat_26_26));
             _data_mat[807] = ((real_t)(elMat_26_27));
             _data_mat[808] = ((real_t)(elMat_26_28));
             _data_mat[809] = ((real_t)(elMat_26_29));
             _data_mat[810] = ((real_t)(elMat_27_0));
             _data_mat[811] = ((real_t)(elMat_27_1));
             _data_mat[812] = ((real_t)(elMat_27_2));
             _data_mat[813] = ((real_t)(elMat_27_3));
             _data_mat[814] = ((real_t)(elMat_27_4));
             _data_mat[815] = ((real_t)(elMat_27_5));
             _data_mat[816] = ((real_t)(elMat_27_6));
             _data_mat[817] = ((real_t)(elMat_27_7));
             _data_mat[818] = ((real_t)(elMat_27_8));
             _data_mat[819] = ((real_t)(elMat_27_9));
             _data_mat[820] = ((real_t)(elMat_27_10));
             _data_mat[821] = ((real_t)(elMat_27_11));
             _data_mat[822] = ((real_t)(elMat_27_12));
             _data_mat[823] = ((real_t)(elMat_27_13));
             _data_mat[824] = ((real_t)(elMat_27_14));
             _data_mat[825] = ((real_t)(elMat_27_15));
             _data_mat[826] = ((real_t)(elMat_27_16));
             _data_mat[827] = ((real_t)(elMat_27_17));
             _data_mat[828] = ((real_t)(elMat_27_18));
             _data_mat[829] = ((real_t)(elMat_27_19));
             _data_mat[830] = ((real_t)(elMat_27_20));
             _data_mat[831] = ((real_t)(elMat_27_21));
             _data_mat[832] = ((real_t)(elMat_27_22));
             _data_mat[833] = ((real_t)(elMat_27_23));
             _data_mat[834] = ((real_t)(elMat_27_24));
             _data_mat[835] = ((real_t)(elMat_27_25));
             _data_mat[836] = ((real_t)(elMat_27_26));
             _data_mat[837] = ((real_t)(elMat_27_27));
             _data_mat[838] = ((real_t)(elMat_27_28));
             _data_mat[839] = ((real_t)(elMat_27_29));
             _data_mat[840] = ((real_t)(elMat_28_0));
             _data_mat[841] = ((real_t)(elMat_28_1));
             _data_mat[842] = ((real_t)(elMat_28_2));
             _data_mat[843] = ((real_t)(elMat_28_3));
             _data_mat[844] = ((real_t)(elMat_28_4));
             _data_mat[845] = ((real_t)(elMat_28_5));
             _data_mat[846] = ((real_t)(elMat_28_6));
             _data_mat[847] = ((real_t)(elMat_28_7));
             _data_mat[848] = ((real_t)(elMat_28_8));
             _data_mat[849] = ((real_t)(elMat_28_9));
             _data_mat[850] = ((real_t)(elMat_28_10));
             _data_mat[851] = ((real_t)(elMat_28_11));
             _data_mat[852] = ((real_t)(elMat_28_12));
             _data_mat[853] = ((real_t)(elMat_28_13));
             _data_mat[854] = ((real_t)(elMat_28_14));
             _data_mat[855] = ((real_t)(elMat_28_15));
             _data_mat[856] = ((real_t)(elMat_28_16));
             _data_mat[857] = ((real_t)(elMat_28_17));
             _data_mat[858] = ((real_t)(elMat_28_18));
             _data_mat[859] = ((real_t)(elMat_28_19));
             _data_mat[860] = ((real_t)(elMat_28_20));
             _data_mat[861] = ((real_t)(elMat_28_21));
             _data_mat[862] = ((real_t)(elMat_28_22));
             _data_mat[863] = ((real_t)(elMat_28_23));
             _data_mat[864] = ((real_t)(elMat_28_24));
             _data_mat[865] = ((real_t)(elMat_28_25));
             _data_mat[866] = ((real_t)(elMat_28_26));
             _data_mat[867] = ((real_t)(elMat_28_27));
             _data_mat[868] = ((real_t)(elMat_28_28));
             _data_mat[869] = ((real_t)(elMat_28_29));
             _data_mat[870] = ((real_t)(elMat_29_0));
             _data_mat[871] = ((real_t)(elMat_29_1));
             _data_mat[872] = ((real_t)(elMat_29_2));
             _data_mat[873] = ((real_t)(elMat_29_3));
             _data_mat[874] = ((real_t)(elMat_29_4));
             _data_mat[875] = ((real_t)(elMat_29_5));
             _data_mat[876] = ((real_t)(elMat_29_6));
             _data_mat[877] = ((real_t)(elMat_29_7));
             _data_mat[878] = ((real_t)(elMat_29_8));
             _data_mat[879] = ((real_t)(elMat_29_9));
             _data_mat[880] = ((real_t)(elMat_29_10));
             _data_mat[881] = ((real_t)(elMat_29_11));
             _data_mat[882] = ((real_t)(elMat_29_12));
             _data_mat[883] = ((real_t)(elMat_29_13));
             _data_mat[884] = ((real_t)(elMat_29_14));
             _data_mat[885] = ((real_t)(elMat_29_15));
             _data_mat[886] = ((real_t)(elMat_29_16));
             _data_mat[887] = ((real_t)(elMat_29_17));
             _data_mat[888] = ((real_t)(elMat_29_18));
             _data_mat[889] = ((real_t)(elMat_29_19));
             _data_mat[890] = ((real_t)(elMat_29_20));
             _data_mat[891] = ((real_t)(elMat_29_21));
             _data_mat[892] = ((real_t)(elMat_29_22));
             _data_mat[893] = ((real_t)(elMat_29_23));
             _data_mat[894] = ((real_t)(elMat_29_24));
             _data_mat[895] = ((real_t)(elMat_29_25));
             _data_mat[896] = ((real_t)(elMat_29_26));
             _data_mat[897] = ((real_t)(elMat_29_27));
             _data_mat[898] = ((real_t)(elMat_29_28));
             _data_mat[899] = ((real_t)(elMat_29_29));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 2)*(micro_edges_per_macro_edge - 1)) / (6)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_GREEN_DOWN[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_0_12 = q_acc_0_12;
             const real_t elMat_0_13 = q_acc_0_13;
             const real_t elMat_0_14 = q_acc_0_14;
             const real_t elMat_0_15 = q_acc_0_15;
             const real_t elMat_0_16 = q_acc_0_16;
             const real_t elMat_0_17 = q_acc_0_17;
             const real_t elMat_0_18 = q_acc_0_18;
             const real_t elMat_0_19 = q_acc_0_19;
             const real_t elMat_0_20 = q_acc_0_20;
             const real_t elMat_0_21 = q_acc_0_21;
             const real_t elMat_0_22 = q_acc_0_22;
             const real_t elMat_0_23 = q_acc_0_23;
             const real_t elMat_0_24 = q_acc_0_24;
             const real_t elMat_0_25 = q_acc_0_25;
             const real_t elMat_0_26 = q_acc_0_26;
             const real_t elMat_0_27 = q_acc_0_27;
             const real_t elMat_0_28 = q_acc_0_28;
             const real_t elMat_0_29 = q_acc_0_29;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_1_12 = q_acc_1_12;
             const real_t elMat_1_13 = q_acc_1_13;
             const real_t elMat_1_14 = q_acc_1_14;
             const real_t elMat_1_15 = q_acc_1_15;
             const real_t elMat_1_16 = q_acc_1_16;
             const real_t elMat_1_17 = q_acc_1_17;
             const real_t elMat_1_18 = q_acc_1_18;
             const real_t elMat_1_19 = q_acc_1_19;
             const real_t elMat_1_20 = q_acc_1_20;
             const real_t elMat_1_21 = q_acc_1_21;
             const real_t elMat_1_22 = q_acc_1_22;
             const real_t elMat_1_23 = q_acc_1_23;
             const real_t elMat_1_24 = q_acc_1_24;
             const real_t elMat_1_25 = q_acc_1_25;
             const real_t elMat_1_26 = q_acc_1_26;
             const real_t elMat_1_27 = q_acc_1_27;
             const real_t elMat_1_28 = q_acc_1_28;
             const real_t elMat_1_29 = q_acc_1_29;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_2_12 = q_acc_2_12;
             const real_t elMat_2_13 = q_acc_2_13;
             const real_t elMat_2_14 = q_acc_2_14;
             const real_t elMat_2_15 = q_acc_2_15;
             const real_t elMat_2_16 = q_acc_2_16;
             const real_t elMat_2_17 = q_acc_2_17;
             const real_t elMat_2_18 = q_acc_2_18;
             const real_t elMat_2_19 = q_acc_2_19;
             const real_t elMat_2_20 = q_acc_2_20;
             const real_t elMat_2_21 = q_acc_2_21;
             const real_t elMat_2_22 = q_acc_2_22;
             const real_t elMat_2_23 = q_acc_2_23;
             const real_t elMat_2_24 = q_acc_2_24;
             const real_t elMat_2_25 = q_acc_2_25;
             const real_t elMat_2_26 = q_acc_2_26;
             const real_t elMat_2_27 = q_acc_2_27;
             const real_t elMat_2_28 = q_acc_2_28;
             const real_t elMat_2_29 = q_acc_2_29;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_3_12 = q_acc_3_12;
             const real_t elMat_3_13 = q_acc_3_13;
             const real_t elMat_3_14 = q_acc_3_14;
             const real_t elMat_3_15 = q_acc_3_15;
             const real_t elMat_3_16 = q_acc_3_16;
             const real_t elMat_3_17 = q_acc_3_17;
             const real_t elMat_3_18 = q_acc_3_18;
             const real_t elMat_3_19 = q_acc_3_19;
             const real_t elMat_3_20 = q_acc_3_20;
             const real_t elMat_3_21 = q_acc_3_21;
             const real_t elMat_3_22 = q_acc_3_22;
             const real_t elMat_3_23 = q_acc_3_23;
             const real_t elMat_3_24 = q_acc_3_24;
             const real_t elMat_3_25 = q_acc_3_25;
             const real_t elMat_3_26 = q_acc_3_26;
             const real_t elMat_3_27 = q_acc_3_27;
             const real_t elMat_3_28 = q_acc_3_28;
             const real_t elMat_3_29 = q_acc_3_29;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_4_12 = q_acc_4_12;
             const real_t elMat_4_13 = q_acc_4_13;
             const real_t elMat_4_14 = q_acc_4_14;
             const real_t elMat_4_15 = q_acc_4_15;
             const real_t elMat_4_16 = q_acc_4_16;
             const real_t elMat_4_17 = q_acc_4_17;
             const real_t elMat_4_18 = q_acc_4_18;
             const real_t elMat_4_19 = q_acc_4_19;
             const real_t elMat_4_20 = q_acc_4_20;
             const real_t elMat_4_21 = q_acc_4_21;
             const real_t elMat_4_22 = q_acc_4_22;
             const real_t elMat_4_23 = q_acc_4_23;
             const real_t elMat_4_24 = q_acc_4_24;
             const real_t elMat_4_25 = q_acc_4_25;
             const real_t elMat_4_26 = q_acc_4_26;
             const real_t elMat_4_27 = q_acc_4_27;
             const real_t elMat_4_28 = q_acc_4_28;
             const real_t elMat_4_29 = q_acc_4_29;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_5_12 = q_acc_5_12;
             const real_t elMat_5_13 = q_acc_5_13;
             const real_t elMat_5_14 = q_acc_5_14;
             const real_t elMat_5_15 = q_acc_5_15;
             const real_t elMat_5_16 = q_acc_5_16;
             const real_t elMat_5_17 = q_acc_5_17;
             const real_t elMat_5_18 = q_acc_5_18;
             const real_t elMat_5_19 = q_acc_5_19;
             const real_t elMat_5_20 = q_acc_5_20;
             const real_t elMat_5_21 = q_acc_5_21;
             const real_t elMat_5_22 = q_acc_5_22;
             const real_t elMat_5_23 = q_acc_5_23;
             const real_t elMat_5_24 = q_acc_5_24;
             const real_t elMat_5_25 = q_acc_5_25;
             const real_t elMat_5_26 = q_acc_5_26;
             const real_t elMat_5_27 = q_acc_5_27;
             const real_t elMat_5_28 = q_acc_5_28;
             const real_t elMat_5_29 = q_acc_5_29;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_6_12 = q_acc_6_12;
             const real_t elMat_6_13 = q_acc_6_13;
             const real_t elMat_6_14 = q_acc_6_14;
             const real_t elMat_6_15 = q_acc_6_15;
             const real_t elMat_6_16 = q_acc_6_16;
             const real_t elMat_6_17 = q_acc_6_17;
             const real_t elMat_6_18 = q_acc_6_18;
             const real_t elMat_6_19 = q_acc_6_19;
             const real_t elMat_6_20 = q_acc_6_20;
             const real_t elMat_6_21 = q_acc_6_21;
             const real_t elMat_6_22 = q_acc_6_22;
             const real_t elMat_6_23 = q_acc_6_23;
             const real_t elMat_6_24 = q_acc_6_24;
             const real_t elMat_6_25 = q_acc_6_25;
             const real_t elMat_6_26 = q_acc_6_26;
             const real_t elMat_6_27 = q_acc_6_27;
             const real_t elMat_6_28 = q_acc_6_28;
             const real_t elMat_6_29 = q_acc_6_29;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_7_12 = q_acc_7_12;
             const real_t elMat_7_13 = q_acc_7_13;
             const real_t elMat_7_14 = q_acc_7_14;
             const real_t elMat_7_15 = q_acc_7_15;
             const real_t elMat_7_16 = q_acc_7_16;
             const real_t elMat_7_17 = q_acc_7_17;
             const real_t elMat_7_18 = q_acc_7_18;
             const real_t elMat_7_19 = q_acc_7_19;
             const real_t elMat_7_20 = q_acc_7_20;
             const real_t elMat_7_21 = q_acc_7_21;
             const real_t elMat_7_22 = q_acc_7_22;
             const real_t elMat_7_23 = q_acc_7_23;
             const real_t elMat_7_24 = q_acc_7_24;
             const real_t elMat_7_25 = q_acc_7_25;
             const real_t elMat_7_26 = q_acc_7_26;
             const real_t elMat_7_27 = q_acc_7_27;
             const real_t elMat_7_28 = q_acc_7_28;
             const real_t elMat_7_29 = q_acc_7_29;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_8_12 = q_acc_8_12;
             const real_t elMat_8_13 = q_acc_8_13;
             const real_t elMat_8_14 = q_acc_8_14;
             const real_t elMat_8_15 = q_acc_8_15;
             const real_t elMat_8_16 = q_acc_8_16;
             const real_t elMat_8_17 = q_acc_8_17;
             const real_t elMat_8_18 = q_acc_8_18;
             const real_t elMat_8_19 = q_acc_8_19;
             const real_t elMat_8_20 = q_acc_8_20;
             const real_t elMat_8_21 = q_acc_8_21;
             const real_t elMat_8_22 = q_acc_8_22;
             const real_t elMat_8_23 = q_acc_8_23;
             const real_t elMat_8_24 = q_acc_8_24;
             const real_t elMat_8_25 = q_acc_8_25;
             const real_t elMat_8_26 = q_acc_8_26;
             const real_t elMat_8_27 = q_acc_8_27;
             const real_t elMat_8_28 = q_acc_8_28;
             const real_t elMat_8_29 = q_acc_8_29;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_9_12 = q_acc_9_12;
             const real_t elMat_9_13 = q_acc_9_13;
             const real_t elMat_9_14 = q_acc_9_14;
             const real_t elMat_9_15 = q_acc_9_15;
             const real_t elMat_9_16 = q_acc_9_16;
             const real_t elMat_9_17 = q_acc_9_17;
             const real_t elMat_9_18 = q_acc_9_18;
             const real_t elMat_9_19 = q_acc_9_19;
             const real_t elMat_9_20 = q_acc_9_20;
             const real_t elMat_9_21 = q_acc_9_21;
             const real_t elMat_9_22 = q_acc_9_22;
             const real_t elMat_9_23 = q_acc_9_23;
             const real_t elMat_9_24 = q_acc_9_24;
             const real_t elMat_9_25 = q_acc_9_25;
             const real_t elMat_9_26 = q_acc_9_26;
             const real_t elMat_9_27 = q_acc_9_27;
             const real_t elMat_9_28 = q_acc_9_28;
             const real_t elMat_9_29 = q_acc_9_29;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_10_12 = q_acc_10_12;
             const real_t elMat_10_13 = q_acc_10_13;
             const real_t elMat_10_14 = q_acc_10_14;
             const real_t elMat_10_15 = q_acc_10_15;
             const real_t elMat_10_16 = q_acc_10_16;
             const real_t elMat_10_17 = q_acc_10_17;
             const real_t elMat_10_18 = q_acc_10_18;
             const real_t elMat_10_19 = q_acc_10_19;
             const real_t elMat_10_20 = q_acc_10_20;
             const real_t elMat_10_21 = q_acc_10_21;
             const real_t elMat_10_22 = q_acc_10_22;
             const real_t elMat_10_23 = q_acc_10_23;
             const real_t elMat_10_24 = q_acc_10_24;
             const real_t elMat_10_25 = q_acc_10_25;
             const real_t elMat_10_26 = q_acc_10_26;
             const real_t elMat_10_27 = q_acc_10_27;
             const real_t elMat_10_28 = q_acc_10_28;
             const real_t elMat_10_29 = q_acc_10_29;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
             const real_t elMat_11_12 = q_acc_11_12;
             const real_t elMat_11_13 = q_acc_11_13;
             const real_t elMat_11_14 = q_acc_11_14;
             const real_t elMat_11_15 = q_acc_11_15;
             const real_t elMat_11_16 = q_acc_11_16;
             const real_t elMat_11_17 = q_acc_11_17;
             const real_t elMat_11_18 = q_acc_11_18;
             const real_t elMat_11_19 = q_acc_11_19;
             const real_t elMat_11_20 = q_acc_11_20;
             const real_t elMat_11_21 = q_acc_11_21;
             const real_t elMat_11_22 = q_acc_11_22;
             const real_t elMat_11_23 = q_acc_11_23;
             const real_t elMat_11_24 = q_acc_11_24;
             const real_t elMat_11_25 = q_acc_11_25;
             const real_t elMat_11_26 = q_acc_11_26;
             const real_t elMat_11_27 = q_acc_11_27;
             const real_t elMat_11_28 = q_acc_11_28;
             const real_t elMat_11_29 = q_acc_11_29;
             const real_t elMat_12_0 = q_acc_0_12;
             const real_t elMat_12_1 = q_acc_1_12;
             const real_t elMat_12_2 = q_acc_2_12;
             const real_t elMat_12_3 = q_acc_3_12;
             const real_t elMat_12_4 = q_acc_4_12;
             const real_t elMat_12_5 = q_acc_5_12;
             const real_t elMat_12_6 = q_acc_6_12;
             const real_t elMat_12_7 = q_acc_7_12;
             const real_t elMat_12_8 = q_acc_8_12;
             const real_t elMat_12_9 = q_acc_9_12;
             const real_t elMat_12_10 = q_acc_10_12;
             const real_t elMat_12_11 = q_acc_11_12;
             const real_t elMat_12_12 = q_acc_12_12;
             const real_t elMat_12_13 = q_acc_12_13;
             const real_t elMat_12_14 = q_acc_12_14;
             const real_t elMat_12_15 = q_acc_12_15;
             const real_t elMat_12_16 = q_acc_12_16;
             const real_t elMat_12_17 = q_acc_12_17;
             const real_t elMat_12_18 = q_acc_12_18;
             const real_t elMat_12_19 = q_acc_12_19;
             const real_t elMat_12_20 = q_acc_12_20;
             const real_t elMat_12_21 = q_acc_12_21;
             const real_t elMat_12_22 = q_acc_12_22;
             const real_t elMat_12_23 = q_acc_12_23;
             const real_t elMat_12_24 = q_acc_12_24;
             const real_t elMat_12_25 = q_acc_12_25;
             const real_t elMat_12_26 = q_acc_12_26;
             const real_t elMat_12_27 = q_acc_12_27;
             const real_t elMat_12_28 = q_acc_12_28;
             const real_t elMat_12_29 = q_acc_12_29;
             const real_t elMat_13_0 = q_acc_0_13;
             const real_t elMat_13_1 = q_acc_1_13;
             const real_t elMat_13_2 = q_acc_2_13;
             const real_t elMat_13_3 = q_acc_3_13;
             const real_t elMat_13_4 = q_acc_4_13;
             const real_t elMat_13_5 = q_acc_5_13;
             const real_t elMat_13_6 = q_acc_6_13;
             const real_t elMat_13_7 = q_acc_7_13;
             const real_t elMat_13_8 = q_acc_8_13;
             const real_t elMat_13_9 = q_acc_9_13;
             const real_t elMat_13_10 = q_acc_10_13;
             const real_t elMat_13_11 = q_acc_11_13;
             const real_t elMat_13_12 = q_acc_12_13;
             const real_t elMat_13_13 = q_acc_13_13;
             const real_t elMat_13_14 = q_acc_13_14;
             const real_t elMat_13_15 = q_acc_13_15;
             const real_t elMat_13_16 = q_acc_13_16;
             const real_t elMat_13_17 = q_acc_13_17;
             const real_t elMat_13_18 = q_acc_13_18;
             const real_t elMat_13_19 = q_acc_13_19;
             const real_t elMat_13_20 = q_acc_13_20;
             const real_t elMat_13_21 = q_acc_13_21;
             const real_t elMat_13_22 = q_acc_13_22;
             const real_t elMat_13_23 = q_acc_13_23;
             const real_t elMat_13_24 = q_acc_13_24;
             const real_t elMat_13_25 = q_acc_13_25;
             const real_t elMat_13_26 = q_acc_13_26;
             const real_t elMat_13_27 = q_acc_13_27;
             const real_t elMat_13_28 = q_acc_13_28;
             const real_t elMat_13_29 = q_acc_13_29;
             const real_t elMat_14_0 = q_acc_0_14;
             const real_t elMat_14_1 = q_acc_1_14;
             const real_t elMat_14_2 = q_acc_2_14;
             const real_t elMat_14_3 = q_acc_3_14;
             const real_t elMat_14_4 = q_acc_4_14;
             const real_t elMat_14_5 = q_acc_5_14;
             const real_t elMat_14_6 = q_acc_6_14;
             const real_t elMat_14_7 = q_acc_7_14;
             const real_t elMat_14_8 = q_acc_8_14;
             const real_t elMat_14_9 = q_acc_9_14;
             const real_t elMat_14_10 = q_acc_10_14;
             const real_t elMat_14_11 = q_acc_11_14;
             const real_t elMat_14_12 = q_acc_12_14;
             const real_t elMat_14_13 = q_acc_13_14;
             const real_t elMat_14_14 = q_acc_14_14;
             const real_t elMat_14_15 = q_acc_14_15;
             const real_t elMat_14_16 = q_acc_14_16;
             const real_t elMat_14_17 = q_acc_14_17;
             const real_t elMat_14_18 = q_acc_14_18;
             const real_t elMat_14_19 = q_acc_14_19;
             const real_t elMat_14_20 = q_acc_14_20;
             const real_t elMat_14_21 = q_acc_14_21;
             const real_t elMat_14_22 = q_acc_14_22;
             const real_t elMat_14_23 = q_acc_14_23;
             const real_t elMat_14_24 = q_acc_14_24;
             const real_t elMat_14_25 = q_acc_14_25;
             const real_t elMat_14_26 = q_acc_14_26;
             const real_t elMat_14_27 = q_acc_14_27;
             const real_t elMat_14_28 = q_acc_14_28;
             const real_t elMat_14_29 = q_acc_14_29;
             const real_t elMat_15_0 = q_acc_0_15;
             const real_t elMat_15_1 = q_acc_1_15;
             const real_t elMat_15_2 = q_acc_2_15;
             const real_t elMat_15_3 = q_acc_3_15;
             const real_t elMat_15_4 = q_acc_4_15;
             const real_t elMat_15_5 = q_acc_5_15;
             const real_t elMat_15_6 = q_acc_6_15;
             const real_t elMat_15_7 = q_acc_7_15;
             const real_t elMat_15_8 = q_acc_8_15;
             const real_t elMat_15_9 = q_acc_9_15;
             const real_t elMat_15_10 = q_acc_10_15;
             const real_t elMat_15_11 = q_acc_11_15;
             const real_t elMat_15_12 = q_acc_12_15;
             const real_t elMat_15_13 = q_acc_13_15;
             const real_t elMat_15_14 = q_acc_14_15;
             const real_t elMat_15_15 = q_acc_15_15;
             const real_t elMat_15_16 = q_acc_15_16;
             const real_t elMat_15_17 = q_acc_15_17;
             const real_t elMat_15_18 = q_acc_15_18;
             const real_t elMat_15_19 = q_acc_15_19;
             const real_t elMat_15_20 = q_acc_15_20;
             const real_t elMat_15_21 = q_acc_15_21;
             const real_t elMat_15_22 = q_acc_15_22;
             const real_t elMat_15_23 = q_acc_15_23;
             const real_t elMat_15_24 = q_acc_15_24;
             const real_t elMat_15_25 = q_acc_15_25;
             const real_t elMat_15_26 = q_acc_15_26;
             const real_t elMat_15_27 = q_acc_15_27;
             const real_t elMat_15_28 = q_acc_15_28;
             const real_t elMat_15_29 = q_acc_15_29;
             const real_t elMat_16_0 = q_acc_0_16;
             const real_t elMat_16_1 = q_acc_1_16;
             const real_t elMat_16_2 = q_acc_2_16;
             const real_t elMat_16_3 = q_acc_3_16;
             const real_t elMat_16_4 = q_acc_4_16;
             const real_t elMat_16_5 = q_acc_5_16;
             const real_t elMat_16_6 = q_acc_6_16;
             const real_t elMat_16_7 = q_acc_7_16;
             const real_t elMat_16_8 = q_acc_8_16;
             const real_t elMat_16_9 = q_acc_9_16;
             const real_t elMat_16_10 = q_acc_10_16;
             const real_t elMat_16_11 = q_acc_11_16;
             const real_t elMat_16_12 = q_acc_12_16;
             const real_t elMat_16_13 = q_acc_13_16;
             const real_t elMat_16_14 = q_acc_14_16;
             const real_t elMat_16_15 = q_acc_15_16;
             const real_t elMat_16_16 = q_acc_16_16;
             const real_t elMat_16_17 = q_acc_16_17;
             const real_t elMat_16_18 = q_acc_16_18;
             const real_t elMat_16_19 = q_acc_16_19;
             const real_t elMat_16_20 = q_acc_16_20;
             const real_t elMat_16_21 = q_acc_16_21;
             const real_t elMat_16_22 = q_acc_16_22;
             const real_t elMat_16_23 = q_acc_16_23;
             const real_t elMat_16_24 = q_acc_16_24;
             const real_t elMat_16_25 = q_acc_16_25;
             const real_t elMat_16_26 = q_acc_16_26;
             const real_t elMat_16_27 = q_acc_16_27;
             const real_t elMat_16_28 = q_acc_16_28;
             const real_t elMat_16_29 = q_acc_16_29;
             const real_t elMat_17_0 = q_acc_0_17;
             const real_t elMat_17_1 = q_acc_1_17;
             const real_t elMat_17_2 = q_acc_2_17;
             const real_t elMat_17_3 = q_acc_3_17;
             const real_t elMat_17_4 = q_acc_4_17;
             const real_t elMat_17_5 = q_acc_5_17;
             const real_t elMat_17_6 = q_acc_6_17;
             const real_t elMat_17_7 = q_acc_7_17;
             const real_t elMat_17_8 = q_acc_8_17;
             const real_t elMat_17_9 = q_acc_9_17;
             const real_t elMat_17_10 = q_acc_10_17;
             const real_t elMat_17_11 = q_acc_11_17;
             const real_t elMat_17_12 = q_acc_12_17;
             const real_t elMat_17_13 = q_acc_13_17;
             const real_t elMat_17_14 = q_acc_14_17;
             const real_t elMat_17_15 = q_acc_15_17;
             const real_t elMat_17_16 = q_acc_16_17;
             const real_t elMat_17_17 = q_acc_17_17;
             const real_t elMat_17_18 = q_acc_17_18;
             const real_t elMat_17_19 = q_acc_17_19;
             const real_t elMat_17_20 = q_acc_17_20;
             const real_t elMat_17_21 = q_acc_17_21;
             const real_t elMat_17_22 = q_acc_17_22;
             const real_t elMat_17_23 = q_acc_17_23;
             const real_t elMat_17_24 = q_acc_17_24;
             const real_t elMat_17_25 = q_acc_17_25;
             const real_t elMat_17_26 = q_acc_17_26;
             const real_t elMat_17_27 = q_acc_17_27;
             const real_t elMat_17_28 = q_acc_17_28;
             const real_t elMat_17_29 = q_acc_17_29;
             const real_t elMat_18_0 = q_acc_0_18;
             const real_t elMat_18_1 = q_acc_1_18;
             const real_t elMat_18_2 = q_acc_2_18;
             const real_t elMat_18_3 = q_acc_3_18;
             const real_t elMat_18_4 = q_acc_4_18;
             const real_t elMat_18_5 = q_acc_5_18;
             const real_t elMat_18_6 = q_acc_6_18;
             const real_t elMat_18_7 = q_acc_7_18;
             const real_t elMat_18_8 = q_acc_8_18;
             const real_t elMat_18_9 = q_acc_9_18;
             const real_t elMat_18_10 = q_acc_10_18;
             const real_t elMat_18_11 = q_acc_11_18;
             const real_t elMat_18_12 = q_acc_12_18;
             const real_t elMat_18_13 = q_acc_13_18;
             const real_t elMat_18_14 = q_acc_14_18;
             const real_t elMat_18_15 = q_acc_15_18;
             const real_t elMat_18_16 = q_acc_16_18;
             const real_t elMat_18_17 = q_acc_17_18;
             const real_t elMat_18_18 = q_acc_18_18;
             const real_t elMat_18_19 = q_acc_18_19;
             const real_t elMat_18_20 = q_acc_18_20;
             const real_t elMat_18_21 = q_acc_18_21;
             const real_t elMat_18_22 = q_acc_18_22;
             const real_t elMat_18_23 = q_acc_18_23;
             const real_t elMat_18_24 = q_acc_18_24;
             const real_t elMat_18_25 = q_acc_18_25;
             const real_t elMat_18_26 = q_acc_18_26;
             const real_t elMat_18_27 = q_acc_18_27;
             const real_t elMat_18_28 = q_acc_18_28;
             const real_t elMat_18_29 = q_acc_18_29;
             const real_t elMat_19_0 = q_acc_0_19;
             const real_t elMat_19_1 = q_acc_1_19;
             const real_t elMat_19_2 = q_acc_2_19;
             const real_t elMat_19_3 = q_acc_3_19;
             const real_t elMat_19_4 = q_acc_4_19;
             const real_t elMat_19_5 = q_acc_5_19;
             const real_t elMat_19_6 = q_acc_6_19;
             const real_t elMat_19_7 = q_acc_7_19;
             const real_t elMat_19_8 = q_acc_8_19;
             const real_t elMat_19_9 = q_acc_9_19;
             const real_t elMat_19_10 = q_acc_10_19;
             const real_t elMat_19_11 = q_acc_11_19;
             const real_t elMat_19_12 = q_acc_12_19;
             const real_t elMat_19_13 = q_acc_13_19;
             const real_t elMat_19_14 = q_acc_14_19;
             const real_t elMat_19_15 = q_acc_15_19;
             const real_t elMat_19_16 = q_acc_16_19;
             const real_t elMat_19_17 = q_acc_17_19;
             const real_t elMat_19_18 = q_acc_18_19;
             const real_t elMat_19_19 = q_acc_19_19;
             const real_t elMat_19_20 = q_acc_19_20;
             const real_t elMat_19_21 = q_acc_19_21;
             const real_t elMat_19_22 = q_acc_19_22;
             const real_t elMat_19_23 = q_acc_19_23;
             const real_t elMat_19_24 = q_acc_19_24;
             const real_t elMat_19_25 = q_acc_19_25;
             const real_t elMat_19_26 = q_acc_19_26;
             const real_t elMat_19_27 = q_acc_19_27;
             const real_t elMat_19_28 = q_acc_19_28;
             const real_t elMat_19_29 = q_acc_19_29;
             const real_t elMat_20_0 = q_acc_0_20;
             const real_t elMat_20_1 = q_acc_1_20;
             const real_t elMat_20_2 = q_acc_2_20;
             const real_t elMat_20_3 = q_acc_3_20;
             const real_t elMat_20_4 = q_acc_4_20;
             const real_t elMat_20_5 = q_acc_5_20;
             const real_t elMat_20_6 = q_acc_6_20;
             const real_t elMat_20_7 = q_acc_7_20;
             const real_t elMat_20_8 = q_acc_8_20;
             const real_t elMat_20_9 = q_acc_9_20;
             const real_t elMat_20_10 = q_acc_10_20;
             const real_t elMat_20_11 = q_acc_11_20;
             const real_t elMat_20_12 = q_acc_12_20;
             const real_t elMat_20_13 = q_acc_13_20;
             const real_t elMat_20_14 = q_acc_14_20;
             const real_t elMat_20_15 = q_acc_15_20;
             const real_t elMat_20_16 = q_acc_16_20;
             const real_t elMat_20_17 = q_acc_17_20;
             const real_t elMat_20_18 = q_acc_18_20;
             const real_t elMat_20_19 = q_acc_19_20;
             const real_t elMat_20_20 = q_acc_20_20;
             const real_t elMat_20_21 = q_acc_20_21;
             const real_t elMat_20_22 = q_acc_20_22;
             const real_t elMat_20_23 = q_acc_20_23;
             const real_t elMat_20_24 = q_acc_20_24;
             const real_t elMat_20_25 = q_acc_20_25;
             const real_t elMat_20_26 = q_acc_20_26;
             const real_t elMat_20_27 = q_acc_20_27;
             const real_t elMat_20_28 = q_acc_20_28;
             const real_t elMat_20_29 = q_acc_20_29;
             const real_t elMat_21_0 = q_acc_0_21;
             const real_t elMat_21_1 = q_acc_1_21;
             const real_t elMat_21_2 = q_acc_2_21;
             const real_t elMat_21_3 = q_acc_3_21;
             const real_t elMat_21_4 = q_acc_4_21;
             const real_t elMat_21_5 = q_acc_5_21;
             const real_t elMat_21_6 = q_acc_6_21;
             const real_t elMat_21_7 = q_acc_7_21;
             const real_t elMat_21_8 = q_acc_8_21;
             const real_t elMat_21_9 = q_acc_9_21;
             const real_t elMat_21_10 = q_acc_10_21;
             const real_t elMat_21_11 = q_acc_11_21;
             const real_t elMat_21_12 = q_acc_12_21;
             const real_t elMat_21_13 = q_acc_13_21;
             const real_t elMat_21_14 = q_acc_14_21;
             const real_t elMat_21_15 = q_acc_15_21;
             const real_t elMat_21_16 = q_acc_16_21;
             const real_t elMat_21_17 = q_acc_17_21;
             const real_t elMat_21_18 = q_acc_18_21;
             const real_t elMat_21_19 = q_acc_19_21;
             const real_t elMat_21_20 = q_acc_20_21;
             const real_t elMat_21_21 = q_acc_21_21;
             const real_t elMat_21_22 = q_acc_21_22;
             const real_t elMat_21_23 = q_acc_21_23;
             const real_t elMat_21_24 = q_acc_21_24;
             const real_t elMat_21_25 = q_acc_21_25;
             const real_t elMat_21_26 = q_acc_21_26;
             const real_t elMat_21_27 = q_acc_21_27;
             const real_t elMat_21_28 = q_acc_21_28;
             const real_t elMat_21_29 = q_acc_21_29;
             const real_t elMat_22_0 = q_acc_0_22;
             const real_t elMat_22_1 = q_acc_1_22;
             const real_t elMat_22_2 = q_acc_2_22;
             const real_t elMat_22_3 = q_acc_3_22;
             const real_t elMat_22_4 = q_acc_4_22;
             const real_t elMat_22_5 = q_acc_5_22;
             const real_t elMat_22_6 = q_acc_6_22;
             const real_t elMat_22_7 = q_acc_7_22;
             const real_t elMat_22_8 = q_acc_8_22;
             const real_t elMat_22_9 = q_acc_9_22;
             const real_t elMat_22_10 = q_acc_10_22;
             const real_t elMat_22_11 = q_acc_11_22;
             const real_t elMat_22_12 = q_acc_12_22;
             const real_t elMat_22_13 = q_acc_13_22;
             const real_t elMat_22_14 = q_acc_14_22;
             const real_t elMat_22_15 = q_acc_15_22;
             const real_t elMat_22_16 = q_acc_16_22;
             const real_t elMat_22_17 = q_acc_17_22;
             const real_t elMat_22_18 = q_acc_18_22;
             const real_t elMat_22_19 = q_acc_19_22;
             const real_t elMat_22_20 = q_acc_20_22;
             const real_t elMat_22_21 = q_acc_21_22;
             const real_t elMat_22_22 = q_acc_22_22;
             const real_t elMat_22_23 = q_acc_22_23;
             const real_t elMat_22_24 = q_acc_22_24;
             const real_t elMat_22_25 = q_acc_22_25;
             const real_t elMat_22_26 = q_acc_22_26;
             const real_t elMat_22_27 = q_acc_22_27;
             const real_t elMat_22_28 = q_acc_22_28;
             const real_t elMat_22_29 = q_acc_22_29;
             const real_t elMat_23_0 = q_acc_0_23;
             const real_t elMat_23_1 = q_acc_1_23;
             const real_t elMat_23_2 = q_acc_2_23;
             const real_t elMat_23_3 = q_acc_3_23;
             const real_t elMat_23_4 = q_acc_4_23;
             const real_t elMat_23_5 = q_acc_5_23;
             const real_t elMat_23_6 = q_acc_6_23;
             const real_t elMat_23_7 = q_acc_7_23;
             const real_t elMat_23_8 = q_acc_8_23;
             const real_t elMat_23_9 = q_acc_9_23;
             const real_t elMat_23_10 = q_acc_10_23;
             const real_t elMat_23_11 = q_acc_11_23;
             const real_t elMat_23_12 = q_acc_12_23;
             const real_t elMat_23_13 = q_acc_13_23;
             const real_t elMat_23_14 = q_acc_14_23;
             const real_t elMat_23_15 = q_acc_15_23;
             const real_t elMat_23_16 = q_acc_16_23;
             const real_t elMat_23_17 = q_acc_17_23;
             const real_t elMat_23_18 = q_acc_18_23;
             const real_t elMat_23_19 = q_acc_19_23;
             const real_t elMat_23_20 = q_acc_20_23;
             const real_t elMat_23_21 = q_acc_21_23;
             const real_t elMat_23_22 = q_acc_22_23;
             const real_t elMat_23_23 = q_acc_23_23;
             const real_t elMat_23_24 = q_acc_23_24;
             const real_t elMat_23_25 = q_acc_23_25;
             const real_t elMat_23_26 = q_acc_23_26;
             const real_t elMat_23_27 = q_acc_23_27;
             const real_t elMat_23_28 = q_acc_23_28;
             const real_t elMat_23_29 = q_acc_23_29;
             const real_t elMat_24_0 = q_acc_0_24;
             const real_t elMat_24_1 = q_acc_1_24;
             const real_t elMat_24_2 = q_acc_2_24;
             const real_t elMat_24_3 = q_acc_3_24;
             const real_t elMat_24_4 = q_acc_4_24;
             const real_t elMat_24_5 = q_acc_5_24;
             const real_t elMat_24_6 = q_acc_6_24;
             const real_t elMat_24_7 = q_acc_7_24;
             const real_t elMat_24_8 = q_acc_8_24;
             const real_t elMat_24_9 = q_acc_9_24;
             const real_t elMat_24_10 = q_acc_10_24;
             const real_t elMat_24_11 = q_acc_11_24;
             const real_t elMat_24_12 = q_acc_12_24;
             const real_t elMat_24_13 = q_acc_13_24;
             const real_t elMat_24_14 = q_acc_14_24;
             const real_t elMat_24_15 = q_acc_15_24;
             const real_t elMat_24_16 = q_acc_16_24;
             const real_t elMat_24_17 = q_acc_17_24;
             const real_t elMat_24_18 = q_acc_18_24;
             const real_t elMat_24_19 = q_acc_19_24;
             const real_t elMat_24_20 = q_acc_20_24;
             const real_t elMat_24_21 = q_acc_21_24;
             const real_t elMat_24_22 = q_acc_22_24;
             const real_t elMat_24_23 = q_acc_23_24;
             const real_t elMat_24_24 = q_acc_24_24;
             const real_t elMat_24_25 = q_acc_24_25;
             const real_t elMat_24_26 = q_acc_24_26;
             const real_t elMat_24_27 = q_acc_24_27;
             const real_t elMat_24_28 = q_acc_24_28;
             const real_t elMat_24_29 = q_acc_24_29;
             const real_t elMat_25_0 = q_acc_0_25;
             const real_t elMat_25_1 = q_acc_1_25;
             const real_t elMat_25_2 = q_acc_2_25;
             const real_t elMat_25_3 = q_acc_3_25;
             const real_t elMat_25_4 = q_acc_4_25;
             const real_t elMat_25_5 = q_acc_5_25;
             const real_t elMat_25_6 = q_acc_6_25;
             const real_t elMat_25_7 = q_acc_7_25;
             const real_t elMat_25_8 = q_acc_8_25;
             const real_t elMat_25_9 = q_acc_9_25;
             const real_t elMat_25_10 = q_acc_10_25;
             const real_t elMat_25_11 = q_acc_11_25;
             const real_t elMat_25_12 = q_acc_12_25;
             const real_t elMat_25_13 = q_acc_13_25;
             const real_t elMat_25_14 = q_acc_14_25;
             const real_t elMat_25_15 = q_acc_15_25;
             const real_t elMat_25_16 = q_acc_16_25;
             const real_t elMat_25_17 = q_acc_17_25;
             const real_t elMat_25_18 = q_acc_18_25;
             const real_t elMat_25_19 = q_acc_19_25;
             const real_t elMat_25_20 = q_acc_20_25;
             const real_t elMat_25_21 = q_acc_21_25;
             const real_t elMat_25_22 = q_acc_22_25;
             const real_t elMat_25_23 = q_acc_23_25;
             const real_t elMat_25_24 = q_acc_24_25;
             const real_t elMat_25_25 = q_acc_25_25;
             const real_t elMat_25_26 = q_acc_25_26;
             const real_t elMat_25_27 = q_acc_25_27;
             const real_t elMat_25_28 = q_acc_25_28;
             const real_t elMat_25_29 = q_acc_25_29;
             const real_t elMat_26_0 = q_acc_0_26;
             const real_t elMat_26_1 = q_acc_1_26;
             const real_t elMat_26_2 = q_acc_2_26;
             const real_t elMat_26_3 = q_acc_3_26;
             const real_t elMat_26_4 = q_acc_4_26;
             const real_t elMat_26_5 = q_acc_5_26;
             const real_t elMat_26_6 = q_acc_6_26;
             const real_t elMat_26_7 = q_acc_7_26;
             const real_t elMat_26_8 = q_acc_8_26;
             const real_t elMat_26_9 = q_acc_9_26;
             const real_t elMat_26_10 = q_acc_10_26;
             const real_t elMat_26_11 = q_acc_11_26;
             const real_t elMat_26_12 = q_acc_12_26;
             const real_t elMat_26_13 = q_acc_13_26;
             const real_t elMat_26_14 = q_acc_14_26;
             const real_t elMat_26_15 = q_acc_15_26;
             const real_t elMat_26_16 = q_acc_16_26;
             const real_t elMat_26_17 = q_acc_17_26;
             const real_t elMat_26_18 = q_acc_18_26;
             const real_t elMat_26_19 = q_acc_19_26;
             const real_t elMat_26_20 = q_acc_20_26;
             const real_t elMat_26_21 = q_acc_21_26;
             const real_t elMat_26_22 = q_acc_22_26;
             const real_t elMat_26_23 = q_acc_23_26;
             const real_t elMat_26_24 = q_acc_24_26;
             const real_t elMat_26_25 = q_acc_25_26;
             const real_t elMat_26_26 = q_acc_26_26;
             const real_t elMat_26_27 = q_acc_26_27;
             const real_t elMat_26_28 = q_acc_26_28;
             const real_t elMat_26_29 = q_acc_26_29;
             const real_t elMat_27_0 = q_acc_0_27;
             const real_t elMat_27_1 = q_acc_1_27;
             const real_t elMat_27_2 = q_acc_2_27;
             const real_t elMat_27_3 = q_acc_3_27;
             const real_t elMat_27_4 = q_acc_4_27;
             const real_t elMat_27_5 = q_acc_5_27;
             const real_t elMat_27_6 = q_acc_6_27;
             const real_t elMat_27_7 = q_acc_7_27;
             const real_t elMat_27_8 = q_acc_8_27;
             const real_t elMat_27_9 = q_acc_9_27;
             const real_t elMat_27_10 = q_acc_10_27;
             const real_t elMat_27_11 = q_acc_11_27;
             const real_t elMat_27_12 = q_acc_12_27;
             const real_t elMat_27_13 = q_acc_13_27;
             const real_t elMat_27_14 = q_acc_14_27;
             const real_t elMat_27_15 = q_acc_15_27;
             const real_t elMat_27_16 = q_acc_16_27;
             const real_t elMat_27_17 = q_acc_17_27;
             const real_t elMat_27_18 = q_acc_18_27;
             const real_t elMat_27_19 = q_acc_19_27;
             const real_t elMat_27_20 = q_acc_20_27;
             const real_t elMat_27_21 = q_acc_21_27;
             const real_t elMat_27_22 = q_acc_22_27;
             const real_t elMat_27_23 = q_acc_23_27;
             const real_t elMat_27_24 = q_acc_24_27;
             const real_t elMat_27_25 = q_acc_25_27;
             const real_t elMat_27_26 = q_acc_26_27;
             const real_t elMat_27_27 = q_acc_27_27;
             const real_t elMat_27_28 = q_acc_27_28;
             const real_t elMat_27_29 = q_acc_27_29;
             const real_t elMat_28_0 = q_acc_0_28;
             const real_t elMat_28_1 = q_acc_1_28;
             const real_t elMat_28_2 = q_acc_2_28;
             const real_t elMat_28_3 = q_acc_3_28;
             const real_t elMat_28_4 = q_acc_4_28;
             const real_t elMat_28_5 = q_acc_5_28;
             const real_t elMat_28_6 = q_acc_6_28;
             const real_t elMat_28_7 = q_acc_7_28;
             const real_t elMat_28_8 = q_acc_8_28;
             const real_t elMat_28_9 = q_acc_9_28;
             const real_t elMat_28_10 = q_acc_10_28;
             const real_t elMat_28_11 = q_acc_11_28;
             const real_t elMat_28_12 = q_acc_12_28;
             const real_t elMat_28_13 = q_acc_13_28;
             const real_t elMat_28_14 = q_acc_14_28;
             const real_t elMat_28_15 = q_acc_15_28;
             const real_t elMat_28_16 = q_acc_16_28;
             const real_t elMat_28_17 = q_acc_17_28;
             const real_t elMat_28_18 = q_acc_18_28;
             const real_t elMat_28_19 = q_acc_19_28;
             const real_t elMat_28_20 = q_acc_20_28;
             const real_t elMat_28_21 = q_acc_21_28;
             const real_t elMat_28_22 = q_acc_22_28;
             const real_t elMat_28_23 = q_acc_23_28;
             const real_t elMat_28_24 = q_acc_24_28;
             const real_t elMat_28_25 = q_acc_25_28;
             const real_t elMat_28_26 = q_acc_26_28;
             const real_t elMat_28_27 = q_acc_27_28;
             const real_t elMat_28_28 = q_acc_28_28;
             const real_t elMat_28_29 = q_acc_28_29;
             const real_t elMat_29_0 = q_acc_0_29;
             const real_t elMat_29_1 = q_acc_1_29;
             const real_t elMat_29_2 = q_acc_2_29;
             const real_t elMat_29_3 = q_acc_3_29;
             const real_t elMat_29_4 = q_acc_4_29;
             const real_t elMat_29_5 = q_acc_5_29;
             const real_t elMat_29_6 = q_acc_6_29;
             const real_t elMat_29_7 = q_acc_7_29;
             const real_t elMat_29_8 = q_acc_8_29;
             const real_t elMat_29_9 = q_acc_9_29;
             const real_t elMat_29_10 = q_acc_10_29;
             const real_t elMat_29_11 = q_acc_11_29;
             const real_t elMat_29_12 = q_acc_12_29;
             const real_t elMat_29_13 = q_acc_13_29;
             const real_t elMat_29_14 = q_acc_14_29;
             const real_t elMat_29_15 = q_acc_15_29;
             const real_t elMat_29_16 = q_acc_16_29;
             const real_t elMat_29_17 = q_acc_17_29;
             const real_t elMat_29_18 = q_acc_18_29;
             const real_t elMat_29_19 = q_acc_19_29;
             const real_t elMat_29_20 = q_acc_20_29;
             const real_t elMat_29_21 = q_acc_21_29;
             const real_t elMat_29_22 = q_acc_22_29;
             const real_t elMat_29_23 = q_acc_23_29;
             const real_t elMat_29_24 = q_acc_24_29;
             const real_t elMat_29_25 = q_acc_25_29;
             const real_t elMat_29_26 = q_acc_26_29;
             const real_t elMat_29_27 = q_acc_27_29;
             const real_t elMat_29_28 = q_acc_28_29;
             const real_t elMat_29_29 = q_acc_29_29;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 30 );
             std::vector< real_t > _data_mat( 900 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[7] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[11] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[12] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[13] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[14] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[15] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[16] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[17] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[18] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[19] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[20] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[21] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[22] = ((uint64_t)(_data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[23] = ((uint64_t)(_data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[24] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[25] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[26] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[27] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[28] = ((uint64_t)(_data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[29] = ((uint64_t)(_data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_0_12));
             _data_mat[13] = ((real_t)(elMat_0_13));
             _data_mat[14] = ((real_t)(elMat_0_14));
             _data_mat[15] = ((real_t)(elMat_0_15));
             _data_mat[16] = ((real_t)(elMat_0_16));
             _data_mat[17] = ((real_t)(elMat_0_17));
             _data_mat[18] = ((real_t)(elMat_0_18));
             _data_mat[19] = ((real_t)(elMat_0_19));
             _data_mat[20] = ((real_t)(elMat_0_20));
             _data_mat[21] = ((real_t)(elMat_0_21));
             _data_mat[22] = ((real_t)(elMat_0_22));
             _data_mat[23] = ((real_t)(elMat_0_23));
             _data_mat[24] = ((real_t)(elMat_0_24));
             _data_mat[25] = ((real_t)(elMat_0_25));
             _data_mat[26] = ((real_t)(elMat_0_26));
             _data_mat[27] = ((real_t)(elMat_0_27));
             _data_mat[28] = ((real_t)(elMat_0_28));
             _data_mat[29] = ((real_t)(elMat_0_29));
             _data_mat[30] = ((real_t)(elMat_1_0));
             _data_mat[31] = ((real_t)(elMat_1_1));
             _data_mat[32] = ((real_t)(elMat_1_2));
             _data_mat[33] = ((real_t)(elMat_1_3));
             _data_mat[34] = ((real_t)(elMat_1_4));
             _data_mat[35] = ((real_t)(elMat_1_5));
             _data_mat[36] = ((real_t)(elMat_1_6));
             _data_mat[37] = ((real_t)(elMat_1_7));
             _data_mat[38] = ((real_t)(elMat_1_8));
             _data_mat[39] = ((real_t)(elMat_1_9));
             _data_mat[40] = ((real_t)(elMat_1_10));
             _data_mat[41] = ((real_t)(elMat_1_11));
             _data_mat[42] = ((real_t)(elMat_1_12));
             _data_mat[43] = ((real_t)(elMat_1_13));
             _data_mat[44] = ((real_t)(elMat_1_14));
             _data_mat[45] = ((real_t)(elMat_1_15));
             _data_mat[46] = ((real_t)(elMat_1_16));
             _data_mat[47] = ((real_t)(elMat_1_17));
             _data_mat[48] = ((real_t)(elMat_1_18));
             _data_mat[49] = ((real_t)(elMat_1_19));
             _data_mat[50] = ((real_t)(elMat_1_20));
             _data_mat[51] = ((real_t)(elMat_1_21));
             _data_mat[52] = ((real_t)(elMat_1_22));
             _data_mat[53] = ((real_t)(elMat_1_23));
             _data_mat[54] = ((real_t)(elMat_1_24));
             _data_mat[55] = ((real_t)(elMat_1_25));
             _data_mat[56] = ((real_t)(elMat_1_26));
             _data_mat[57] = ((real_t)(elMat_1_27));
             _data_mat[58] = ((real_t)(elMat_1_28));
             _data_mat[59] = ((real_t)(elMat_1_29));
             _data_mat[60] = ((real_t)(elMat_2_0));
             _data_mat[61] = ((real_t)(elMat_2_1));
             _data_mat[62] = ((real_t)(elMat_2_2));
             _data_mat[63] = ((real_t)(elMat_2_3));
             _data_mat[64] = ((real_t)(elMat_2_4));
             _data_mat[65] = ((real_t)(elMat_2_5));
             _data_mat[66] = ((real_t)(elMat_2_6));
             _data_mat[67] = ((real_t)(elMat_2_7));
             _data_mat[68] = ((real_t)(elMat_2_8));
             _data_mat[69] = ((real_t)(elMat_2_9));
             _data_mat[70] = ((real_t)(elMat_2_10));
             _data_mat[71] = ((real_t)(elMat_2_11));
             _data_mat[72] = ((real_t)(elMat_2_12));
             _data_mat[73] = ((real_t)(elMat_2_13));
             _data_mat[74] = ((real_t)(elMat_2_14));
             _data_mat[75] = ((real_t)(elMat_2_15));
             _data_mat[76] = ((real_t)(elMat_2_16));
             _data_mat[77] = ((real_t)(elMat_2_17));
             _data_mat[78] = ((real_t)(elMat_2_18));
             _data_mat[79] = ((real_t)(elMat_2_19));
             _data_mat[80] = ((real_t)(elMat_2_20));
             _data_mat[81] = ((real_t)(elMat_2_21));
             _data_mat[82] = ((real_t)(elMat_2_22));
             _data_mat[83] = ((real_t)(elMat_2_23));
             _data_mat[84] = ((real_t)(elMat_2_24));
             _data_mat[85] = ((real_t)(elMat_2_25));
             _data_mat[86] = ((real_t)(elMat_2_26));
             _data_mat[87] = ((real_t)(elMat_2_27));
             _data_mat[88] = ((real_t)(elMat_2_28));
             _data_mat[89] = ((real_t)(elMat_2_29));
             _data_mat[90] = ((real_t)(elMat_3_0));
             _data_mat[91] = ((real_t)(elMat_3_1));
             _data_mat[92] = ((real_t)(elMat_3_2));
             _data_mat[93] = ((real_t)(elMat_3_3));
             _data_mat[94] = ((real_t)(elMat_3_4));
             _data_mat[95] = ((real_t)(elMat_3_5));
             _data_mat[96] = ((real_t)(elMat_3_6));
             _data_mat[97] = ((real_t)(elMat_3_7));
             _data_mat[98] = ((real_t)(elMat_3_8));
             _data_mat[99] = ((real_t)(elMat_3_9));
             _data_mat[100] = ((real_t)(elMat_3_10));
             _data_mat[101] = ((real_t)(elMat_3_11));
             _data_mat[102] = ((real_t)(elMat_3_12));
             _data_mat[103] = ((real_t)(elMat_3_13));
             _data_mat[104] = ((real_t)(elMat_3_14));
             _data_mat[105] = ((real_t)(elMat_3_15));
             _data_mat[106] = ((real_t)(elMat_3_16));
             _data_mat[107] = ((real_t)(elMat_3_17));
             _data_mat[108] = ((real_t)(elMat_3_18));
             _data_mat[109] = ((real_t)(elMat_3_19));
             _data_mat[110] = ((real_t)(elMat_3_20));
             _data_mat[111] = ((real_t)(elMat_3_21));
             _data_mat[112] = ((real_t)(elMat_3_22));
             _data_mat[113] = ((real_t)(elMat_3_23));
             _data_mat[114] = ((real_t)(elMat_3_24));
             _data_mat[115] = ((real_t)(elMat_3_25));
             _data_mat[116] = ((real_t)(elMat_3_26));
             _data_mat[117] = ((real_t)(elMat_3_27));
             _data_mat[118] = ((real_t)(elMat_3_28));
             _data_mat[119] = ((real_t)(elMat_3_29));
             _data_mat[120] = ((real_t)(elMat_4_0));
             _data_mat[121] = ((real_t)(elMat_4_1));
             _data_mat[122] = ((real_t)(elMat_4_2));
             _data_mat[123] = ((real_t)(elMat_4_3));
             _data_mat[124] = ((real_t)(elMat_4_4));
             _data_mat[125] = ((real_t)(elMat_4_5));
             _data_mat[126] = ((real_t)(elMat_4_6));
             _data_mat[127] = ((real_t)(elMat_4_7));
             _data_mat[128] = ((real_t)(elMat_4_8));
             _data_mat[129] = ((real_t)(elMat_4_9));
             _data_mat[130] = ((real_t)(elMat_4_10));
             _data_mat[131] = ((real_t)(elMat_4_11));
             _data_mat[132] = ((real_t)(elMat_4_12));
             _data_mat[133] = ((real_t)(elMat_4_13));
             _data_mat[134] = ((real_t)(elMat_4_14));
             _data_mat[135] = ((real_t)(elMat_4_15));
             _data_mat[136] = ((real_t)(elMat_4_16));
             _data_mat[137] = ((real_t)(elMat_4_17));
             _data_mat[138] = ((real_t)(elMat_4_18));
             _data_mat[139] = ((real_t)(elMat_4_19));
             _data_mat[140] = ((real_t)(elMat_4_20));
             _data_mat[141] = ((real_t)(elMat_4_21));
             _data_mat[142] = ((real_t)(elMat_4_22));
             _data_mat[143] = ((real_t)(elMat_4_23));
             _data_mat[144] = ((real_t)(elMat_4_24));
             _data_mat[145] = ((real_t)(elMat_4_25));
             _data_mat[146] = ((real_t)(elMat_4_26));
             _data_mat[147] = ((real_t)(elMat_4_27));
             _data_mat[148] = ((real_t)(elMat_4_28));
             _data_mat[149] = ((real_t)(elMat_4_29));
             _data_mat[150] = ((real_t)(elMat_5_0));
             _data_mat[151] = ((real_t)(elMat_5_1));
             _data_mat[152] = ((real_t)(elMat_5_2));
             _data_mat[153] = ((real_t)(elMat_5_3));
             _data_mat[154] = ((real_t)(elMat_5_4));
             _data_mat[155] = ((real_t)(elMat_5_5));
             _data_mat[156] = ((real_t)(elMat_5_6));
             _data_mat[157] = ((real_t)(elMat_5_7));
             _data_mat[158] = ((real_t)(elMat_5_8));
             _data_mat[159] = ((real_t)(elMat_5_9));
             _data_mat[160] = ((real_t)(elMat_5_10));
             _data_mat[161] = ((real_t)(elMat_5_11));
             _data_mat[162] = ((real_t)(elMat_5_12));
             _data_mat[163] = ((real_t)(elMat_5_13));
             _data_mat[164] = ((real_t)(elMat_5_14));
             _data_mat[165] = ((real_t)(elMat_5_15));
             _data_mat[166] = ((real_t)(elMat_5_16));
             _data_mat[167] = ((real_t)(elMat_5_17));
             _data_mat[168] = ((real_t)(elMat_5_18));
             _data_mat[169] = ((real_t)(elMat_5_19));
             _data_mat[170] = ((real_t)(elMat_5_20));
             _data_mat[171] = ((real_t)(elMat_5_21));
             _data_mat[172] = ((real_t)(elMat_5_22));
             _data_mat[173] = ((real_t)(elMat_5_23));
             _data_mat[174] = ((real_t)(elMat_5_24));
             _data_mat[175] = ((real_t)(elMat_5_25));
             _data_mat[176] = ((real_t)(elMat_5_26));
             _data_mat[177] = ((real_t)(elMat_5_27));
             _data_mat[178] = ((real_t)(elMat_5_28));
             _data_mat[179] = ((real_t)(elMat_5_29));
             _data_mat[180] = ((real_t)(elMat_6_0));
             _data_mat[181] = ((real_t)(elMat_6_1));
             _data_mat[182] = ((real_t)(elMat_6_2));
             _data_mat[183] = ((real_t)(elMat_6_3));
             _data_mat[184] = ((real_t)(elMat_6_4));
             _data_mat[185] = ((real_t)(elMat_6_5));
             _data_mat[186] = ((real_t)(elMat_6_6));
             _data_mat[187] = ((real_t)(elMat_6_7));
             _data_mat[188] = ((real_t)(elMat_6_8));
             _data_mat[189] = ((real_t)(elMat_6_9));
             _data_mat[190] = ((real_t)(elMat_6_10));
             _data_mat[191] = ((real_t)(elMat_6_11));
             _data_mat[192] = ((real_t)(elMat_6_12));
             _data_mat[193] = ((real_t)(elMat_6_13));
             _data_mat[194] = ((real_t)(elMat_6_14));
             _data_mat[195] = ((real_t)(elMat_6_15));
             _data_mat[196] = ((real_t)(elMat_6_16));
             _data_mat[197] = ((real_t)(elMat_6_17));
             _data_mat[198] = ((real_t)(elMat_6_18));
             _data_mat[199] = ((real_t)(elMat_6_19));
             _data_mat[200] = ((real_t)(elMat_6_20));
             _data_mat[201] = ((real_t)(elMat_6_21));
             _data_mat[202] = ((real_t)(elMat_6_22));
             _data_mat[203] = ((real_t)(elMat_6_23));
             _data_mat[204] = ((real_t)(elMat_6_24));
             _data_mat[205] = ((real_t)(elMat_6_25));
             _data_mat[206] = ((real_t)(elMat_6_26));
             _data_mat[207] = ((real_t)(elMat_6_27));
             _data_mat[208] = ((real_t)(elMat_6_28));
             _data_mat[209] = ((real_t)(elMat_6_29));
             _data_mat[210] = ((real_t)(elMat_7_0));
             _data_mat[211] = ((real_t)(elMat_7_1));
             _data_mat[212] = ((real_t)(elMat_7_2));
             _data_mat[213] = ((real_t)(elMat_7_3));
             _data_mat[214] = ((real_t)(elMat_7_4));
             _data_mat[215] = ((real_t)(elMat_7_5));
             _data_mat[216] = ((real_t)(elMat_7_6));
             _data_mat[217] = ((real_t)(elMat_7_7));
             _data_mat[218] = ((real_t)(elMat_7_8));
             _data_mat[219] = ((real_t)(elMat_7_9));
             _data_mat[220] = ((real_t)(elMat_7_10));
             _data_mat[221] = ((real_t)(elMat_7_11));
             _data_mat[222] = ((real_t)(elMat_7_12));
             _data_mat[223] = ((real_t)(elMat_7_13));
             _data_mat[224] = ((real_t)(elMat_7_14));
             _data_mat[225] = ((real_t)(elMat_7_15));
             _data_mat[226] = ((real_t)(elMat_7_16));
             _data_mat[227] = ((real_t)(elMat_7_17));
             _data_mat[228] = ((real_t)(elMat_7_18));
             _data_mat[229] = ((real_t)(elMat_7_19));
             _data_mat[230] = ((real_t)(elMat_7_20));
             _data_mat[231] = ((real_t)(elMat_7_21));
             _data_mat[232] = ((real_t)(elMat_7_22));
             _data_mat[233] = ((real_t)(elMat_7_23));
             _data_mat[234] = ((real_t)(elMat_7_24));
             _data_mat[235] = ((real_t)(elMat_7_25));
             _data_mat[236] = ((real_t)(elMat_7_26));
             _data_mat[237] = ((real_t)(elMat_7_27));
             _data_mat[238] = ((real_t)(elMat_7_28));
             _data_mat[239] = ((real_t)(elMat_7_29));
             _data_mat[240] = ((real_t)(elMat_8_0));
             _data_mat[241] = ((real_t)(elMat_8_1));
             _data_mat[242] = ((real_t)(elMat_8_2));
             _data_mat[243] = ((real_t)(elMat_8_3));
             _data_mat[244] = ((real_t)(elMat_8_4));
             _data_mat[245] = ((real_t)(elMat_8_5));
             _data_mat[246] = ((real_t)(elMat_8_6));
             _data_mat[247] = ((real_t)(elMat_8_7));
             _data_mat[248] = ((real_t)(elMat_8_8));
             _data_mat[249] = ((real_t)(elMat_8_9));
             _data_mat[250] = ((real_t)(elMat_8_10));
             _data_mat[251] = ((real_t)(elMat_8_11));
             _data_mat[252] = ((real_t)(elMat_8_12));
             _data_mat[253] = ((real_t)(elMat_8_13));
             _data_mat[254] = ((real_t)(elMat_8_14));
             _data_mat[255] = ((real_t)(elMat_8_15));
             _data_mat[256] = ((real_t)(elMat_8_16));
             _data_mat[257] = ((real_t)(elMat_8_17));
             _data_mat[258] = ((real_t)(elMat_8_18));
             _data_mat[259] = ((real_t)(elMat_8_19));
             _data_mat[260] = ((real_t)(elMat_8_20));
             _data_mat[261] = ((real_t)(elMat_8_21));
             _data_mat[262] = ((real_t)(elMat_8_22));
             _data_mat[263] = ((real_t)(elMat_8_23));
             _data_mat[264] = ((real_t)(elMat_8_24));
             _data_mat[265] = ((real_t)(elMat_8_25));
             _data_mat[266] = ((real_t)(elMat_8_26));
             _data_mat[267] = ((real_t)(elMat_8_27));
             _data_mat[268] = ((real_t)(elMat_8_28));
             _data_mat[269] = ((real_t)(elMat_8_29));
             _data_mat[270] = ((real_t)(elMat_9_0));
             _data_mat[271] = ((real_t)(elMat_9_1));
             _data_mat[272] = ((real_t)(elMat_9_2));
             _data_mat[273] = ((real_t)(elMat_9_3));
             _data_mat[274] = ((real_t)(elMat_9_4));
             _data_mat[275] = ((real_t)(elMat_9_5));
             _data_mat[276] = ((real_t)(elMat_9_6));
             _data_mat[277] = ((real_t)(elMat_9_7));
             _data_mat[278] = ((real_t)(elMat_9_8));
             _data_mat[279] = ((real_t)(elMat_9_9));
             _data_mat[280] = ((real_t)(elMat_9_10));
             _data_mat[281] = ((real_t)(elMat_9_11));
             _data_mat[282] = ((real_t)(elMat_9_12));
             _data_mat[283] = ((real_t)(elMat_9_13));
             _data_mat[284] = ((real_t)(elMat_9_14));
             _data_mat[285] = ((real_t)(elMat_9_15));
             _data_mat[286] = ((real_t)(elMat_9_16));
             _data_mat[287] = ((real_t)(elMat_9_17));
             _data_mat[288] = ((real_t)(elMat_9_18));
             _data_mat[289] = ((real_t)(elMat_9_19));
             _data_mat[290] = ((real_t)(elMat_9_20));
             _data_mat[291] = ((real_t)(elMat_9_21));
             _data_mat[292] = ((real_t)(elMat_9_22));
             _data_mat[293] = ((real_t)(elMat_9_23));
             _data_mat[294] = ((real_t)(elMat_9_24));
             _data_mat[295] = ((real_t)(elMat_9_25));
             _data_mat[296] = ((real_t)(elMat_9_26));
             _data_mat[297] = ((real_t)(elMat_9_27));
             _data_mat[298] = ((real_t)(elMat_9_28));
             _data_mat[299] = ((real_t)(elMat_9_29));
             _data_mat[300] = ((real_t)(elMat_10_0));
             _data_mat[301] = ((real_t)(elMat_10_1));
             _data_mat[302] = ((real_t)(elMat_10_2));
             _data_mat[303] = ((real_t)(elMat_10_3));
             _data_mat[304] = ((real_t)(elMat_10_4));
             _data_mat[305] = ((real_t)(elMat_10_5));
             _data_mat[306] = ((real_t)(elMat_10_6));
             _data_mat[307] = ((real_t)(elMat_10_7));
             _data_mat[308] = ((real_t)(elMat_10_8));
             _data_mat[309] = ((real_t)(elMat_10_9));
             _data_mat[310] = ((real_t)(elMat_10_10));
             _data_mat[311] = ((real_t)(elMat_10_11));
             _data_mat[312] = ((real_t)(elMat_10_12));
             _data_mat[313] = ((real_t)(elMat_10_13));
             _data_mat[314] = ((real_t)(elMat_10_14));
             _data_mat[315] = ((real_t)(elMat_10_15));
             _data_mat[316] = ((real_t)(elMat_10_16));
             _data_mat[317] = ((real_t)(elMat_10_17));
             _data_mat[318] = ((real_t)(elMat_10_18));
             _data_mat[319] = ((real_t)(elMat_10_19));
             _data_mat[320] = ((real_t)(elMat_10_20));
             _data_mat[321] = ((real_t)(elMat_10_21));
             _data_mat[322] = ((real_t)(elMat_10_22));
             _data_mat[323] = ((real_t)(elMat_10_23));
             _data_mat[324] = ((real_t)(elMat_10_24));
             _data_mat[325] = ((real_t)(elMat_10_25));
             _data_mat[326] = ((real_t)(elMat_10_26));
             _data_mat[327] = ((real_t)(elMat_10_27));
             _data_mat[328] = ((real_t)(elMat_10_28));
             _data_mat[329] = ((real_t)(elMat_10_29));
             _data_mat[330] = ((real_t)(elMat_11_0));
             _data_mat[331] = ((real_t)(elMat_11_1));
             _data_mat[332] = ((real_t)(elMat_11_2));
             _data_mat[333] = ((real_t)(elMat_11_3));
             _data_mat[334] = ((real_t)(elMat_11_4));
             _data_mat[335] = ((real_t)(elMat_11_5));
             _data_mat[336] = ((real_t)(elMat_11_6));
             _data_mat[337] = ((real_t)(elMat_11_7));
             _data_mat[338] = ((real_t)(elMat_11_8));
             _data_mat[339] = ((real_t)(elMat_11_9));
             _data_mat[340] = ((real_t)(elMat_11_10));
             _data_mat[341] = ((real_t)(elMat_11_11));
             _data_mat[342] = ((real_t)(elMat_11_12));
             _data_mat[343] = ((real_t)(elMat_11_13));
             _data_mat[344] = ((real_t)(elMat_11_14));
             _data_mat[345] = ((real_t)(elMat_11_15));
             _data_mat[346] = ((real_t)(elMat_11_16));
             _data_mat[347] = ((real_t)(elMat_11_17));
             _data_mat[348] = ((real_t)(elMat_11_18));
             _data_mat[349] = ((real_t)(elMat_11_19));
             _data_mat[350] = ((real_t)(elMat_11_20));
             _data_mat[351] = ((real_t)(elMat_11_21));
             _data_mat[352] = ((real_t)(elMat_11_22));
             _data_mat[353] = ((real_t)(elMat_11_23));
             _data_mat[354] = ((real_t)(elMat_11_24));
             _data_mat[355] = ((real_t)(elMat_11_25));
             _data_mat[356] = ((real_t)(elMat_11_26));
             _data_mat[357] = ((real_t)(elMat_11_27));
             _data_mat[358] = ((real_t)(elMat_11_28));
             _data_mat[359] = ((real_t)(elMat_11_29));
             _data_mat[360] = ((real_t)(elMat_12_0));
             _data_mat[361] = ((real_t)(elMat_12_1));
             _data_mat[362] = ((real_t)(elMat_12_2));
             _data_mat[363] = ((real_t)(elMat_12_3));
             _data_mat[364] = ((real_t)(elMat_12_4));
             _data_mat[365] = ((real_t)(elMat_12_5));
             _data_mat[366] = ((real_t)(elMat_12_6));
             _data_mat[367] = ((real_t)(elMat_12_7));
             _data_mat[368] = ((real_t)(elMat_12_8));
             _data_mat[369] = ((real_t)(elMat_12_9));
             _data_mat[370] = ((real_t)(elMat_12_10));
             _data_mat[371] = ((real_t)(elMat_12_11));
             _data_mat[372] = ((real_t)(elMat_12_12));
             _data_mat[373] = ((real_t)(elMat_12_13));
             _data_mat[374] = ((real_t)(elMat_12_14));
             _data_mat[375] = ((real_t)(elMat_12_15));
             _data_mat[376] = ((real_t)(elMat_12_16));
             _data_mat[377] = ((real_t)(elMat_12_17));
             _data_mat[378] = ((real_t)(elMat_12_18));
             _data_mat[379] = ((real_t)(elMat_12_19));
             _data_mat[380] = ((real_t)(elMat_12_20));
             _data_mat[381] = ((real_t)(elMat_12_21));
             _data_mat[382] = ((real_t)(elMat_12_22));
             _data_mat[383] = ((real_t)(elMat_12_23));
             _data_mat[384] = ((real_t)(elMat_12_24));
             _data_mat[385] = ((real_t)(elMat_12_25));
             _data_mat[386] = ((real_t)(elMat_12_26));
             _data_mat[387] = ((real_t)(elMat_12_27));
             _data_mat[388] = ((real_t)(elMat_12_28));
             _data_mat[389] = ((real_t)(elMat_12_29));
             _data_mat[390] = ((real_t)(elMat_13_0));
             _data_mat[391] = ((real_t)(elMat_13_1));
             _data_mat[392] = ((real_t)(elMat_13_2));
             _data_mat[393] = ((real_t)(elMat_13_3));
             _data_mat[394] = ((real_t)(elMat_13_4));
             _data_mat[395] = ((real_t)(elMat_13_5));
             _data_mat[396] = ((real_t)(elMat_13_6));
             _data_mat[397] = ((real_t)(elMat_13_7));
             _data_mat[398] = ((real_t)(elMat_13_8));
             _data_mat[399] = ((real_t)(elMat_13_9));
             _data_mat[400] = ((real_t)(elMat_13_10));
             _data_mat[401] = ((real_t)(elMat_13_11));
             _data_mat[402] = ((real_t)(elMat_13_12));
             _data_mat[403] = ((real_t)(elMat_13_13));
             _data_mat[404] = ((real_t)(elMat_13_14));
             _data_mat[405] = ((real_t)(elMat_13_15));
             _data_mat[406] = ((real_t)(elMat_13_16));
             _data_mat[407] = ((real_t)(elMat_13_17));
             _data_mat[408] = ((real_t)(elMat_13_18));
             _data_mat[409] = ((real_t)(elMat_13_19));
             _data_mat[410] = ((real_t)(elMat_13_20));
             _data_mat[411] = ((real_t)(elMat_13_21));
             _data_mat[412] = ((real_t)(elMat_13_22));
             _data_mat[413] = ((real_t)(elMat_13_23));
             _data_mat[414] = ((real_t)(elMat_13_24));
             _data_mat[415] = ((real_t)(elMat_13_25));
             _data_mat[416] = ((real_t)(elMat_13_26));
             _data_mat[417] = ((real_t)(elMat_13_27));
             _data_mat[418] = ((real_t)(elMat_13_28));
             _data_mat[419] = ((real_t)(elMat_13_29));
             _data_mat[420] = ((real_t)(elMat_14_0));
             _data_mat[421] = ((real_t)(elMat_14_1));
             _data_mat[422] = ((real_t)(elMat_14_2));
             _data_mat[423] = ((real_t)(elMat_14_3));
             _data_mat[424] = ((real_t)(elMat_14_4));
             _data_mat[425] = ((real_t)(elMat_14_5));
             _data_mat[426] = ((real_t)(elMat_14_6));
             _data_mat[427] = ((real_t)(elMat_14_7));
             _data_mat[428] = ((real_t)(elMat_14_8));
             _data_mat[429] = ((real_t)(elMat_14_9));
             _data_mat[430] = ((real_t)(elMat_14_10));
             _data_mat[431] = ((real_t)(elMat_14_11));
             _data_mat[432] = ((real_t)(elMat_14_12));
             _data_mat[433] = ((real_t)(elMat_14_13));
             _data_mat[434] = ((real_t)(elMat_14_14));
             _data_mat[435] = ((real_t)(elMat_14_15));
             _data_mat[436] = ((real_t)(elMat_14_16));
             _data_mat[437] = ((real_t)(elMat_14_17));
             _data_mat[438] = ((real_t)(elMat_14_18));
             _data_mat[439] = ((real_t)(elMat_14_19));
             _data_mat[440] = ((real_t)(elMat_14_20));
             _data_mat[441] = ((real_t)(elMat_14_21));
             _data_mat[442] = ((real_t)(elMat_14_22));
             _data_mat[443] = ((real_t)(elMat_14_23));
             _data_mat[444] = ((real_t)(elMat_14_24));
             _data_mat[445] = ((real_t)(elMat_14_25));
             _data_mat[446] = ((real_t)(elMat_14_26));
             _data_mat[447] = ((real_t)(elMat_14_27));
             _data_mat[448] = ((real_t)(elMat_14_28));
             _data_mat[449] = ((real_t)(elMat_14_29));
             _data_mat[450] = ((real_t)(elMat_15_0));
             _data_mat[451] = ((real_t)(elMat_15_1));
             _data_mat[452] = ((real_t)(elMat_15_2));
             _data_mat[453] = ((real_t)(elMat_15_3));
             _data_mat[454] = ((real_t)(elMat_15_4));
             _data_mat[455] = ((real_t)(elMat_15_5));
             _data_mat[456] = ((real_t)(elMat_15_6));
             _data_mat[457] = ((real_t)(elMat_15_7));
             _data_mat[458] = ((real_t)(elMat_15_8));
             _data_mat[459] = ((real_t)(elMat_15_9));
             _data_mat[460] = ((real_t)(elMat_15_10));
             _data_mat[461] = ((real_t)(elMat_15_11));
             _data_mat[462] = ((real_t)(elMat_15_12));
             _data_mat[463] = ((real_t)(elMat_15_13));
             _data_mat[464] = ((real_t)(elMat_15_14));
             _data_mat[465] = ((real_t)(elMat_15_15));
             _data_mat[466] = ((real_t)(elMat_15_16));
             _data_mat[467] = ((real_t)(elMat_15_17));
             _data_mat[468] = ((real_t)(elMat_15_18));
             _data_mat[469] = ((real_t)(elMat_15_19));
             _data_mat[470] = ((real_t)(elMat_15_20));
             _data_mat[471] = ((real_t)(elMat_15_21));
             _data_mat[472] = ((real_t)(elMat_15_22));
             _data_mat[473] = ((real_t)(elMat_15_23));
             _data_mat[474] = ((real_t)(elMat_15_24));
             _data_mat[475] = ((real_t)(elMat_15_25));
             _data_mat[476] = ((real_t)(elMat_15_26));
             _data_mat[477] = ((real_t)(elMat_15_27));
             _data_mat[478] = ((real_t)(elMat_15_28));
             _data_mat[479] = ((real_t)(elMat_15_29));
             _data_mat[480] = ((real_t)(elMat_16_0));
             _data_mat[481] = ((real_t)(elMat_16_1));
             _data_mat[482] = ((real_t)(elMat_16_2));
             _data_mat[483] = ((real_t)(elMat_16_3));
             _data_mat[484] = ((real_t)(elMat_16_4));
             _data_mat[485] = ((real_t)(elMat_16_5));
             _data_mat[486] = ((real_t)(elMat_16_6));
             _data_mat[487] = ((real_t)(elMat_16_7));
             _data_mat[488] = ((real_t)(elMat_16_8));
             _data_mat[489] = ((real_t)(elMat_16_9));
             _data_mat[490] = ((real_t)(elMat_16_10));
             _data_mat[491] = ((real_t)(elMat_16_11));
             _data_mat[492] = ((real_t)(elMat_16_12));
             _data_mat[493] = ((real_t)(elMat_16_13));
             _data_mat[494] = ((real_t)(elMat_16_14));
             _data_mat[495] = ((real_t)(elMat_16_15));
             _data_mat[496] = ((real_t)(elMat_16_16));
             _data_mat[497] = ((real_t)(elMat_16_17));
             _data_mat[498] = ((real_t)(elMat_16_18));
             _data_mat[499] = ((real_t)(elMat_16_19));
             _data_mat[500] = ((real_t)(elMat_16_20));
             _data_mat[501] = ((real_t)(elMat_16_21));
             _data_mat[502] = ((real_t)(elMat_16_22));
             _data_mat[503] = ((real_t)(elMat_16_23));
             _data_mat[504] = ((real_t)(elMat_16_24));
             _data_mat[505] = ((real_t)(elMat_16_25));
             _data_mat[506] = ((real_t)(elMat_16_26));
             _data_mat[507] = ((real_t)(elMat_16_27));
             _data_mat[508] = ((real_t)(elMat_16_28));
             _data_mat[509] = ((real_t)(elMat_16_29));
             _data_mat[510] = ((real_t)(elMat_17_0));
             _data_mat[511] = ((real_t)(elMat_17_1));
             _data_mat[512] = ((real_t)(elMat_17_2));
             _data_mat[513] = ((real_t)(elMat_17_3));
             _data_mat[514] = ((real_t)(elMat_17_4));
             _data_mat[515] = ((real_t)(elMat_17_5));
             _data_mat[516] = ((real_t)(elMat_17_6));
             _data_mat[517] = ((real_t)(elMat_17_7));
             _data_mat[518] = ((real_t)(elMat_17_8));
             _data_mat[519] = ((real_t)(elMat_17_9));
             _data_mat[520] = ((real_t)(elMat_17_10));
             _data_mat[521] = ((real_t)(elMat_17_11));
             _data_mat[522] = ((real_t)(elMat_17_12));
             _data_mat[523] = ((real_t)(elMat_17_13));
             _data_mat[524] = ((real_t)(elMat_17_14));
             _data_mat[525] = ((real_t)(elMat_17_15));
             _data_mat[526] = ((real_t)(elMat_17_16));
             _data_mat[527] = ((real_t)(elMat_17_17));
             _data_mat[528] = ((real_t)(elMat_17_18));
             _data_mat[529] = ((real_t)(elMat_17_19));
             _data_mat[530] = ((real_t)(elMat_17_20));
             _data_mat[531] = ((real_t)(elMat_17_21));
             _data_mat[532] = ((real_t)(elMat_17_22));
             _data_mat[533] = ((real_t)(elMat_17_23));
             _data_mat[534] = ((real_t)(elMat_17_24));
             _data_mat[535] = ((real_t)(elMat_17_25));
             _data_mat[536] = ((real_t)(elMat_17_26));
             _data_mat[537] = ((real_t)(elMat_17_27));
             _data_mat[538] = ((real_t)(elMat_17_28));
             _data_mat[539] = ((real_t)(elMat_17_29));
             _data_mat[540] = ((real_t)(elMat_18_0));
             _data_mat[541] = ((real_t)(elMat_18_1));
             _data_mat[542] = ((real_t)(elMat_18_2));
             _data_mat[543] = ((real_t)(elMat_18_3));
             _data_mat[544] = ((real_t)(elMat_18_4));
             _data_mat[545] = ((real_t)(elMat_18_5));
             _data_mat[546] = ((real_t)(elMat_18_6));
             _data_mat[547] = ((real_t)(elMat_18_7));
             _data_mat[548] = ((real_t)(elMat_18_8));
             _data_mat[549] = ((real_t)(elMat_18_9));
             _data_mat[550] = ((real_t)(elMat_18_10));
             _data_mat[551] = ((real_t)(elMat_18_11));
             _data_mat[552] = ((real_t)(elMat_18_12));
             _data_mat[553] = ((real_t)(elMat_18_13));
             _data_mat[554] = ((real_t)(elMat_18_14));
             _data_mat[555] = ((real_t)(elMat_18_15));
             _data_mat[556] = ((real_t)(elMat_18_16));
             _data_mat[557] = ((real_t)(elMat_18_17));
             _data_mat[558] = ((real_t)(elMat_18_18));
             _data_mat[559] = ((real_t)(elMat_18_19));
             _data_mat[560] = ((real_t)(elMat_18_20));
             _data_mat[561] = ((real_t)(elMat_18_21));
             _data_mat[562] = ((real_t)(elMat_18_22));
             _data_mat[563] = ((real_t)(elMat_18_23));
             _data_mat[564] = ((real_t)(elMat_18_24));
             _data_mat[565] = ((real_t)(elMat_18_25));
             _data_mat[566] = ((real_t)(elMat_18_26));
             _data_mat[567] = ((real_t)(elMat_18_27));
             _data_mat[568] = ((real_t)(elMat_18_28));
             _data_mat[569] = ((real_t)(elMat_18_29));
             _data_mat[570] = ((real_t)(elMat_19_0));
             _data_mat[571] = ((real_t)(elMat_19_1));
             _data_mat[572] = ((real_t)(elMat_19_2));
             _data_mat[573] = ((real_t)(elMat_19_3));
             _data_mat[574] = ((real_t)(elMat_19_4));
             _data_mat[575] = ((real_t)(elMat_19_5));
             _data_mat[576] = ((real_t)(elMat_19_6));
             _data_mat[577] = ((real_t)(elMat_19_7));
             _data_mat[578] = ((real_t)(elMat_19_8));
             _data_mat[579] = ((real_t)(elMat_19_9));
             _data_mat[580] = ((real_t)(elMat_19_10));
             _data_mat[581] = ((real_t)(elMat_19_11));
             _data_mat[582] = ((real_t)(elMat_19_12));
             _data_mat[583] = ((real_t)(elMat_19_13));
             _data_mat[584] = ((real_t)(elMat_19_14));
             _data_mat[585] = ((real_t)(elMat_19_15));
             _data_mat[586] = ((real_t)(elMat_19_16));
             _data_mat[587] = ((real_t)(elMat_19_17));
             _data_mat[588] = ((real_t)(elMat_19_18));
             _data_mat[589] = ((real_t)(elMat_19_19));
             _data_mat[590] = ((real_t)(elMat_19_20));
             _data_mat[591] = ((real_t)(elMat_19_21));
             _data_mat[592] = ((real_t)(elMat_19_22));
             _data_mat[593] = ((real_t)(elMat_19_23));
             _data_mat[594] = ((real_t)(elMat_19_24));
             _data_mat[595] = ((real_t)(elMat_19_25));
             _data_mat[596] = ((real_t)(elMat_19_26));
             _data_mat[597] = ((real_t)(elMat_19_27));
             _data_mat[598] = ((real_t)(elMat_19_28));
             _data_mat[599] = ((real_t)(elMat_19_29));
             _data_mat[600] = ((real_t)(elMat_20_0));
             _data_mat[601] = ((real_t)(elMat_20_1));
             _data_mat[602] = ((real_t)(elMat_20_2));
             _data_mat[603] = ((real_t)(elMat_20_3));
             _data_mat[604] = ((real_t)(elMat_20_4));
             _data_mat[605] = ((real_t)(elMat_20_5));
             _data_mat[606] = ((real_t)(elMat_20_6));
             _data_mat[607] = ((real_t)(elMat_20_7));
             _data_mat[608] = ((real_t)(elMat_20_8));
             _data_mat[609] = ((real_t)(elMat_20_9));
             _data_mat[610] = ((real_t)(elMat_20_10));
             _data_mat[611] = ((real_t)(elMat_20_11));
             _data_mat[612] = ((real_t)(elMat_20_12));
             _data_mat[613] = ((real_t)(elMat_20_13));
             _data_mat[614] = ((real_t)(elMat_20_14));
             _data_mat[615] = ((real_t)(elMat_20_15));
             _data_mat[616] = ((real_t)(elMat_20_16));
             _data_mat[617] = ((real_t)(elMat_20_17));
             _data_mat[618] = ((real_t)(elMat_20_18));
             _data_mat[619] = ((real_t)(elMat_20_19));
             _data_mat[620] = ((real_t)(elMat_20_20));
             _data_mat[621] = ((real_t)(elMat_20_21));
             _data_mat[622] = ((real_t)(elMat_20_22));
             _data_mat[623] = ((real_t)(elMat_20_23));
             _data_mat[624] = ((real_t)(elMat_20_24));
             _data_mat[625] = ((real_t)(elMat_20_25));
             _data_mat[626] = ((real_t)(elMat_20_26));
             _data_mat[627] = ((real_t)(elMat_20_27));
             _data_mat[628] = ((real_t)(elMat_20_28));
             _data_mat[629] = ((real_t)(elMat_20_29));
             _data_mat[630] = ((real_t)(elMat_21_0));
             _data_mat[631] = ((real_t)(elMat_21_1));
             _data_mat[632] = ((real_t)(elMat_21_2));
             _data_mat[633] = ((real_t)(elMat_21_3));
             _data_mat[634] = ((real_t)(elMat_21_4));
             _data_mat[635] = ((real_t)(elMat_21_5));
             _data_mat[636] = ((real_t)(elMat_21_6));
             _data_mat[637] = ((real_t)(elMat_21_7));
             _data_mat[638] = ((real_t)(elMat_21_8));
             _data_mat[639] = ((real_t)(elMat_21_9));
             _data_mat[640] = ((real_t)(elMat_21_10));
             _data_mat[641] = ((real_t)(elMat_21_11));
             _data_mat[642] = ((real_t)(elMat_21_12));
             _data_mat[643] = ((real_t)(elMat_21_13));
             _data_mat[644] = ((real_t)(elMat_21_14));
             _data_mat[645] = ((real_t)(elMat_21_15));
             _data_mat[646] = ((real_t)(elMat_21_16));
             _data_mat[647] = ((real_t)(elMat_21_17));
             _data_mat[648] = ((real_t)(elMat_21_18));
             _data_mat[649] = ((real_t)(elMat_21_19));
             _data_mat[650] = ((real_t)(elMat_21_20));
             _data_mat[651] = ((real_t)(elMat_21_21));
             _data_mat[652] = ((real_t)(elMat_21_22));
             _data_mat[653] = ((real_t)(elMat_21_23));
             _data_mat[654] = ((real_t)(elMat_21_24));
             _data_mat[655] = ((real_t)(elMat_21_25));
             _data_mat[656] = ((real_t)(elMat_21_26));
             _data_mat[657] = ((real_t)(elMat_21_27));
             _data_mat[658] = ((real_t)(elMat_21_28));
             _data_mat[659] = ((real_t)(elMat_21_29));
             _data_mat[660] = ((real_t)(elMat_22_0));
             _data_mat[661] = ((real_t)(elMat_22_1));
             _data_mat[662] = ((real_t)(elMat_22_2));
             _data_mat[663] = ((real_t)(elMat_22_3));
             _data_mat[664] = ((real_t)(elMat_22_4));
             _data_mat[665] = ((real_t)(elMat_22_5));
             _data_mat[666] = ((real_t)(elMat_22_6));
             _data_mat[667] = ((real_t)(elMat_22_7));
             _data_mat[668] = ((real_t)(elMat_22_8));
             _data_mat[669] = ((real_t)(elMat_22_9));
             _data_mat[670] = ((real_t)(elMat_22_10));
             _data_mat[671] = ((real_t)(elMat_22_11));
             _data_mat[672] = ((real_t)(elMat_22_12));
             _data_mat[673] = ((real_t)(elMat_22_13));
             _data_mat[674] = ((real_t)(elMat_22_14));
             _data_mat[675] = ((real_t)(elMat_22_15));
             _data_mat[676] = ((real_t)(elMat_22_16));
             _data_mat[677] = ((real_t)(elMat_22_17));
             _data_mat[678] = ((real_t)(elMat_22_18));
             _data_mat[679] = ((real_t)(elMat_22_19));
             _data_mat[680] = ((real_t)(elMat_22_20));
             _data_mat[681] = ((real_t)(elMat_22_21));
             _data_mat[682] = ((real_t)(elMat_22_22));
             _data_mat[683] = ((real_t)(elMat_22_23));
             _data_mat[684] = ((real_t)(elMat_22_24));
             _data_mat[685] = ((real_t)(elMat_22_25));
             _data_mat[686] = ((real_t)(elMat_22_26));
             _data_mat[687] = ((real_t)(elMat_22_27));
             _data_mat[688] = ((real_t)(elMat_22_28));
             _data_mat[689] = ((real_t)(elMat_22_29));
             _data_mat[690] = ((real_t)(elMat_23_0));
             _data_mat[691] = ((real_t)(elMat_23_1));
             _data_mat[692] = ((real_t)(elMat_23_2));
             _data_mat[693] = ((real_t)(elMat_23_3));
             _data_mat[694] = ((real_t)(elMat_23_4));
             _data_mat[695] = ((real_t)(elMat_23_5));
             _data_mat[696] = ((real_t)(elMat_23_6));
             _data_mat[697] = ((real_t)(elMat_23_7));
             _data_mat[698] = ((real_t)(elMat_23_8));
             _data_mat[699] = ((real_t)(elMat_23_9));
             _data_mat[700] = ((real_t)(elMat_23_10));
             _data_mat[701] = ((real_t)(elMat_23_11));
             _data_mat[702] = ((real_t)(elMat_23_12));
             _data_mat[703] = ((real_t)(elMat_23_13));
             _data_mat[704] = ((real_t)(elMat_23_14));
             _data_mat[705] = ((real_t)(elMat_23_15));
             _data_mat[706] = ((real_t)(elMat_23_16));
             _data_mat[707] = ((real_t)(elMat_23_17));
             _data_mat[708] = ((real_t)(elMat_23_18));
             _data_mat[709] = ((real_t)(elMat_23_19));
             _data_mat[710] = ((real_t)(elMat_23_20));
             _data_mat[711] = ((real_t)(elMat_23_21));
             _data_mat[712] = ((real_t)(elMat_23_22));
             _data_mat[713] = ((real_t)(elMat_23_23));
             _data_mat[714] = ((real_t)(elMat_23_24));
             _data_mat[715] = ((real_t)(elMat_23_25));
             _data_mat[716] = ((real_t)(elMat_23_26));
             _data_mat[717] = ((real_t)(elMat_23_27));
             _data_mat[718] = ((real_t)(elMat_23_28));
             _data_mat[719] = ((real_t)(elMat_23_29));
             _data_mat[720] = ((real_t)(elMat_24_0));
             _data_mat[721] = ((real_t)(elMat_24_1));
             _data_mat[722] = ((real_t)(elMat_24_2));
             _data_mat[723] = ((real_t)(elMat_24_3));
             _data_mat[724] = ((real_t)(elMat_24_4));
             _data_mat[725] = ((real_t)(elMat_24_5));
             _data_mat[726] = ((real_t)(elMat_24_6));
             _data_mat[727] = ((real_t)(elMat_24_7));
             _data_mat[728] = ((real_t)(elMat_24_8));
             _data_mat[729] = ((real_t)(elMat_24_9));
             _data_mat[730] = ((real_t)(elMat_24_10));
             _data_mat[731] = ((real_t)(elMat_24_11));
             _data_mat[732] = ((real_t)(elMat_24_12));
             _data_mat[733] = ((real_t)(elMat_24_13));
             _data_mat[734] = ((real_t)(elMat_24_14));
             _data_mat[735] = ((real_t)(elMat_24_15));
             _data_mat[736] = ((real_t)(elMat_24_16));
             _data_mat[737] = ((real_t)(elMat_24_17));
             _data_mat[738] = ((real_t)(elMat_24_18));
             _data_mat[739] = ((real_t)(elMat_24_19));
             _data_mat[740] = ((real_t)(elMat_24_20));
             _data_mat[741] = ((real_t)(elMat_24_21));
             _data_mat[742] = ((real_t)(elMat_24_22));
             _data_mat[743] = ((real_t)(elMat_24_23));
             _data_mat[744] = ((real_t)(elMat_24_24));
             _data_mat[745] = ((real_t)(elMat_24_25));
             _data_mat[746] = ((real_t)(elMat_24_26));
             _data_mat[747] = ((real_t)(elMat_24_27));
             _data_mat[748] = ((real_t)(elMat_24_28));
             _data_mat[749] = ((real_t)(elMat_24_29));
             _data_mat[750] = ((real_t)(elMat_25_0));
             _data_mat[751] = ((real_t)(elMat_25_1));
             _data_mat[752] = ((real_t)(elMat_25_2));
             _data_mat[753] = ((real_t)(elMat_25_3));
             _data_mat[754] = ((real_t)(elMat_25_4));
             _data_mat[755] = ((real_t)(elMat_25_5));
             _data_mat[756] = ((real_t)(elMat_25_6));
             _data_mat[757] = ((real_t)(elMat_25_7));
             _data_mat[758] = ((real_t)(elMat_25_8));
             _data_mat[759] = ((real_t)(elMat_25_9));
             _data_mat[760] = ((real_t)(elMat_25_10));
             _data_mat[761] = ((real_t)(elMat_25_11));
             _data_mat[762] = ((real_t)(elMat_25_12));
             _data_mat[763] = ((real_t)(elMat_25_13));
             _data_mat[764] = ((real_t)(elMat_25_14));
             _data_mat[765] = ((real_t)(elMat_25_15));
             _data_mat[766] = ((real_t)(elMat_25_16));
             _data_mat[767] = ((real_t)(elMat_25_17));
             _data_mat[768] = ((real_t)(elMat_25_18));
             _data_mat[769] = ((real_t)(elMat_25_19));
             _data_mat[770] = ((real_t)(elMat_25_20));
             _data_mat[771] = ((real_t)(elMat_25_21));
             _data_mat[772] = ((real_t)(elMat_25_22));
             _data_mat[773] = ((real_t)(elMat_25_23));
             _data_mat[774] = ((real_t)(elMat_25_24));
             _data_mat[775] = ((real_t)(elMat_25_25));
             _data_mat[776] = ((real_t)(elMat_25_26));
             _data_mat[777] = ((real_t)(elMat_25_27));
             _data_mat[778] = ((real_t)(elMat_25_28));
             _data_mat[779] = ((real_t)(elMat_25_29));
             _data_mat[780] = ((real_t)(elMat_26_0));
             _data_mat[781] = ((real_t)(elMat_26_1));
             _data_mat[782] = ((real_t)(elMat_26_2));
             _data_mat[783] = ((real_t)(elMat_26_3));
             _data_mat[784] = ((real_t)(elMat_26_4));
             _data_mat[785] = ((real_t)(elMat_26_5));
             _data_mat[786] = ((real_t)(elMat_26_6));
             _data_mat[787] = ((real_t)(elMat_26_7));
             _data_mat[788] = ((real_t)(elMat_26_8));
             _data_mat[789] = ((real_t)(elMat_26_9));
             _data_mat[790] = ((real_t)(elMat_26_10));
             _data_mat[791] = ((real_t)(elMat_26_11));
             _data_mat[792] = ((real_t)(elMat_26_12));
             _data_mat[793] = ((real_t)(elMat_26_13));
             _data_mat[794] = ((real_t)(elMat_26_14));
             _data_mat[795] = ((real_t)(elMat_26_15));
             _data_mat[796] = ((real_t)(elMat_26_16));
             _data_mat[797] = ((real_t)(elMat_26_17));
             _data_mat[798] = ((real_t)(elMat_26_18));
             _data_mat[799] = ((real_t)(elMat_26_19));
             _data_mat[800] = ((real_t)(elMat_26_20));
             _data_mat[801] = ((real_t)(elMat_26_21));
             _data_mat[802] = ((real_t)(elMat_26_22));
             _data_mat[803] = ((real_t)(elMat_26_23));
             _data_mat[804] = ((real_t)(elMat_26_24));
             _data_mat[805] = ((real_t)(elMat_26_25));
             _data_mat[806] = ((real_t)(elMat_26_26));
             _data_mat[807] = ((real_t)(elMat_26_27));
             _data_mat[808] = ((real_t)(elMat_26_28));
             _data_mat[809] = ((real_t)(elMat_26_29));
             _data_mat[810] = ((real_t)(elMat_27_0));
             _data_mat[811] = ((real_t)(elMat_27_1));
             _data_mat[812] = ((real_t)(elMat_27_2));
             _data_mat[813] = ((real_t)(elMat_27_3));
             _data_mat[814] = ((real_t)(elMat_27_4));
             _data_mat[815] = ((real_t)(elMat_27_5));
             _data_mat[816] = ((real_t)(elMat_27_6));
             _data_mat[817] = ((real_t)(elMat_27_7));
             _data_mat[818] = ((real_t)(elMat_27_8));
             _data_mat[819] = ((real_t)(elMat_27_9));
             _data_mat[820] = ((real_t)(elMat_27_10));
             _data_mat[821] = ((real_t)(elMat_27_11));
             _data_mat[822] = ((real_t)(elMat_27_12));
             _data_mat[823] = ((real_t)(elMat_27_13));
             _data_mat[824] = ((real_t)(elMat_27_14));
             _data_mat[825] = ((real_t)(elMat_27_15));
             _data_mat[826] = ((real_t)(elMat_27_16));
             _data_mat[827] = ((real_t)(elMat_27_17));
             _data_mat[828] = ((real_t)(elMat_27_18));
             _data_mat[829] = ((real_t)(elMat_27_19));
             _data_mat[830] = ((real_t)(elMat_27_20));
             _data_mat[831] = ((real_t)(elMat_27_21));
             _data_mat[832] = ((real_t)(elMat_27_22));
             _data_mat[833] = ((real_t)(elMat_27_23));
             _data_mat[834] = ((real_t)(elMat_27_24));
             _data_mat[835] = ((real_t)(elMat_27_25));
             _data_mat[836] = ((real_t)(elMat_27_26));
             _data_mat[837] = ((real_t)(elMat_27_27));
             _data_mat[838] = ((real_t)(elMat_27_28));
             _data_mat[839] = ((real_t)(elMat_27_29));
             _data_mat[840] = ((real_t)(elMat_28_0));
             _data_mat[841] = ((real_t)(elMat_28_1));
             _data_mat[842] = ((real_t)(elMat_28_2));
             _data_mat[843] = ((real_t)(elMat_28_3));
             _data_mat[844] = ((real_t)(elMat_28_4));
             _data_mat[845] = ((real_t)(elMat_28_5));
             _data_mat[846] = ((real_t)(elMat_28_6));
             _data_mat[847] = ((real_t)(elMat_28_7));
             _data_mat[848] = ((real_t)(elMat_28_8));
             _data_mat[849] = ((real_t)(elMat_28_9));
             _data_mat[850] = ((real_t)(elMat_28_10));
             _data_mat[851] = ((real_t)(elMat_28_11));
             _data_mat[852] = ((real_t)(elMat_28_12));
             _data_mat[853] = ((real_t)(elMat_28_13));
             _data_mat[854] = ((real_t)(elMat_28_14));
             _data_mat[855] = ((real_t)(elMat_28_15));
             _data_mat[856] = ((real_t)(elMat_28_16));
             _data_mat[857] = ((real_t)(elMat_28_17));
             _data_mat[858] = ((real_t)(elMat_28_18));
             _data_mat[859] = ((real_t)(elMat_28_19));
             _data_mat[860] = ((real_t)(elMat_28_20));
             _data_mat[861] = ((real_t)(elMat_28_21));
             _data_mat[862] = ((real_t)(elMat_28_22));
             _data_mat[863] = ((real_t)(elMat_28_23));
             _data_mat[864] = ((real_t)(elMat_28_24));
             _data_mat[865] = ((real_t)(elMat_28_25));
             _data_mat[866] = ((real_t)(elMat_28_26));
             _data_mat[867] = ((real_t)(elMat_28_27));
             _data_mat[868] = ((real_t)(elMat_28_28));
             _data_mat[869] = ((real_t)(elMat_28_29));
             _data_mat[870] = ((real_t)(elMat_29_0));
             _data_mat[871] = ((real_t)(elMat_29_1));
             _data_mat[872] = ((real_t)(elMat_29_2));
             _data_mat[873] = ((real_t)(elMat_29_3));
             _data_mat[874] = ((real_t)(elMat_29_4));
             _data_mat[875] = ((real_t)(elMat_29_5));
             _data_mat[876] = ((real_t)(elMat_29_6));
             _data_mat[877] = ((real_t)(elMat_29_7));
             _data_mat[878] = ((real_t)(elMat_29_8));
             _data_mat[879] = ((real_t)(elMat_29_9));
             _data_mat[880] = ((real_t)(elMat_29_10));
             _data_mat[881] = ((real_t)(elMat_29_11));
             _data_mat[882] = ((real_t)(elMat_29_12));
             _data_mat[883] = ((real_t)(elMat_29_13));
             _data_mat[884] = ((real_t)(elMat_29_14));
             _data_mat[885] = ((real_t)(elMat_29_15));
             _data_mat[886] = ((real_t)(elMat_29_16));
             _data_mat[887] = ((real_t)(elMat_29_17));
             _data_mat[888] = ((real_t)(elMat_29_18));
             _data_mat[889] = ((real_t)(elMat_29_19));
             _data_mat[890] = ((real_t)(elMat_29_20));
             _data_mat[891] = ((real_t)(elMat_29_21));
             _data_mat[892] = ((real_t)(elMat_29_22));
             _data_mat[893] = ((real_t)(elMat_29_23));
             _data_mat[894] = ((real_t)(elMat_29_24));
             _data_mat[895] = ((real_t)(elMat_29_25));
             _data_mat[896] = ((real_t)(elMat_29_26));
             _data_mat[897] = ((real_t)(elMat_29_27));
             _data_mat[898] = ((real_t)(elMat_29_28));
             _data_mat[899] = ((real_t)(elMat_29_29));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
